C
C           A T T E N T I O N !!!
C
C !!! THIS FILE EXIST IN source/fcm/ and in source/moldyn/ !!!
C !!! if you modify it do it in both locations             !!!

C $Header: /export/cvs/c34a1/source/fcm/PARAM.FOR,v 1.1.1.1 2006/08/17 02:29:53 brooks Exp $
C
C COPYRIGHT (C) 1993-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C ========================================================================
C
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER STATE
C AND FEDERAL LAWS.  USE, DISCLOSURE, REPRODUCTION OR DUPLICATION IN WHOLE
C OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS WRITTEN CONSENT
C OF MOLDYN, INC.  THE ABOVE COPYRIGHT NOTICE DOES NOT EVIDENCE ANY ACTUAL OR
C INTENDED PUBLICATION OF SUCH SOURCE CODE.
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C
C                MAXIMUM MBO(N)D SIZE PARAMETERS
C                -------------------------------
C
      INTEGER MAXBOD  !  MAXIMUM NUMBER OF MULTI-ATOM BODIES
      INTEGER MXPRTL  !  MAXIMUM TOTAL NUMBER OF ATOMS IN ATOMISTIC REGIONS
      INTEGER MTOTBD  !  MAXIMUM TOTAL NUMBER OF ATOMS WITHIN BODIES
C                        (MXPRTL + MTOTBD = MAXIMUM TOTAL ATOMS IN SYSTEM)
c      INTEGER MPERBD  !  MAXIMUM NUMBER OF ATOMS PER BODY
C                        (MPERBD * MAXBOD) >= MTOTBD
      INTEGER MaxPerBD ! SAME AS MPERBD EXCEPT THIS IS COMPUTED IN 
c                        MBDYNA.F THEN BEING A PARAMETER
c      INTEGER MAXMOD  !  MAXIMUM NUMBER OF FLEX. MODES ALLOWED PER BODY
      INTEGER MaxFlexMod ! same as maxmod except this is computed
c      INTEGER MXLOOP  !  MAXIMUM NUMBER OF LOOPS
      INTEGER MaxLoop  !  MAXIMUM NUMBER OF LOOPS
C                        INCLUDE: SUGAR/AROMATIC RINGS & LOOPS FORMED 
C                                 BY SULPHER BRIDGES, ETC.
C                         DO NOT INCLUDE: RINGS & LOOPS WHOSE ATOMS ARE 
C                                 TOTALLY WITHIN A SINGLE BODY
C
C     Adjust these parameters to change size of statically allocated arrays
      PARAMETER (MAXBOD=500)
      PARAMETER (MXPRTL=2000)
      PARAMETER (MTOTBD=10000)

#ifndef POINTER_KEYWORD
C     These parameters are used for static allocation of heaps.  This is used
C     when SGI style POINTER keyword is not available.
      INTEGER MPERBD  !  MAXIMUM NUMBER OF ATOMS PER BODY
      INTEGER MAXMOD  !  MAXIMUM NUMBER OF FLEX. MODES ALLOWED PER BODY
      INTEGER MXLOOP  !  MAXIMUM NUMBER OF LOOPS
C     Adjust these parameters as well as the MAX_ parameters below to 
C     change size of statically allocated heaps.
      PARAMETER (MPERBD=500)
      PARAMETER (MAXMOD=20)
      PARAMETER (MXLOOP=2)
#endif

C
C
C                MAXIMUM MBO(N)D MULTIPOLE PARAMETERS
C                ------------------------------------
C
      INTEGER MAX_EL    !  MAXIMUM NUMBER OF ELEMENTS IN SYSTEM
      INTEGER MAXDEG    !  MAXIMUM DEGREE OF MULTIPOLE EXPANSION
      INTEGER MAX_LEVEL !  MAXIMUM NUMBER OF LEVELS OF GRID HIERARCHY
      INTEGER MAX_PAIRS !  MAXIMUM NUMBER OF INTERACTION PAIRS PER BOX
C
      PARAMETER (MAX_EL=1)
      PARAMETER (MAXDEG=1)
      PARAMETER (MAX_LEVEL=1)
      PARAMETER (MAX_PAIRS=1)
C
C
C                MAXIMUM MBO(N)D MTS PARAMETERS
C                ------------------------------
C
      INTEGER MAXSTAGES !  MAXIMUM NUMBER OF MULTIPLE TIME SCALE (MTS) STAGES 
C
      PARAMETER (MAXSTAGES=5)
C
C
C     ***** DO NOT TOUCH ANYTHING BELOW THIS LINE (OR ELSE...) *****
C     The above statement refers to the computed parameters which begin
C     with L or cL.  
C
C--------------------------------------------------------------------------
C
C
C          COMPUTED PARAMETERS FOR MULTIBODY DYNAMICS
C
      INTEGER L01    !  MAXIMUM NUMBER OF BODIES AND INDIVIDUAL ATOMS
      INTEGER L03    !  MAXIMUM NUMBER OF ATOMS (SENSOR POINTS) IN SYSTEM
      INTEGER L17    !  NUMBER OF PARTITIONS OF DS ARRAY
      INTEGER L19    !  NUMBER OF ELEMENTS IN LOCU AND LENU
c      INTEGER lintgl !  SIZE OF ARRAY FOR INERTIAL INTEGRALS, ETC.
c 
      INTEGER cL01   !  same as L01 except cl01 is not a parameter
      INTEGER cL02   !  same as L02 except cl02 is not a parameter
      INTEGER cL06   !  same as L06 except cl06 is not a parameter
      INTEGER cL07   !  same as L07 except cL07 is not a parameter
      INTEGER cL08   !  same as L08 except cl08 is not a parameter
      INTEGER cL09   !  same as L09 except cl09 is not a parameter
      INTEGER cL10   !  same as L10 except cl10 is not a parameter
      INTEGER cL11   !  SAME AS L11 
      INTEGER cL12   !  SAME AS L12 
      INTEGER cL15   !  SAME AS L15
      INTEGER cL16   !  SAME AS L16
      INTEGER cL43   !  SAME AS L43 EXCEPT cL43 IS NOT A PARAMETER
      INTEGER cL45   !  SAME AS L45 EXCEPT cL45 IS NOT A PARAMETER
      INTEGER cL63   !  SAME AS L63 EXCEPT cL63 IS NOT A PARAMETER
      INTEGER cL64   !  SAME AS L64 EXCEPT cL64 IS NOT A PARAMETER
      INTEGER cL72   !  SAME AS L72 EXCEPT cL72 IS NOT A PARAMETER
      INTEGER cL76   !  SAME AS L76 EXCEPT cL76 IS NOT A PARAMETER
C
      PARAMETER (L01 = MAXBOD+MXPRTL)
      PARAMETER (L03 = MXPRTL+MTOTBD)
      PARAMETER (L17 = 2*L03)
      PARAMETER (L19 = 2*L01 + 3)



#ifndef POINTER_KEYWORD
C     This section is for static allocation of heaps.  This is used
C     when SGI style POINTER keyword is not available.
      INTEGER L02    !  MAXIMUM NUMBER OF HINGES
      INTEGER L06    !  MAXIMUM NUMBER OF MODES IN ANY BODY
      INTEGER L07    !  SIZE OF Y, YDT AND OTHER RELATED VECTORS
      INTEGER L08    !  MAXIMUM NUMBER OF DOFS IN ANY BODY
      INTEGER L09    !  MAXIMUM NUMBER OF HINGE DOFS IN SYSTEM
      INTEGER L10    !  SIZE OF G, P, PMOM ARRAYS, ETC.
      INTEGER L11    !  SAME AS L08 (USED TO INCLUDE MOMENTUM WHEELS)
      INTEGER L12    !  NUMBER OF PARTITIONS OF BH ARRAY
      INTEGER L13    !  USED IN HANDS.INC, TO BE PHASED OUT
      INTEGER L15    !  NUMBER OF PARTITIONS OF RH ARRAY
      INTEGER L16    !  NUMBER OF PARTITIONS OF DH ARRAY
      INTEGER L21    !  SIZE OF ARRAY FOR MODE SHAPES (HATS)
      INTEGER L43    !  SIZE OF ARRAYS FOR PROCESSING INERTIAL INTEGRALS
c     INTEGER L45    !  SIZE OF ARRAYS FOR PROCESSING INERTIAL INTEGRALS
      INTEGER L59    !  SIZE OF ARRAY FOR INERTIAL INTEGRALS, ETC.
      INTEGER L63    !  SAME AS MXLOOP, SEE ABOVE
      INTEGER L64    !  TOTAL DOFS AT CUT-JOINTS
      INTEGER L72    !  SIZE OF VECTOR FOR LEAST SQ. FIT, TO BE PHASED OUT
      INTEGER L76    !  SIZE OF STRUCTURAL MATRIX FOR SPARSE MATRIX CALCNS
C     Do not adjust these (begin with L) parameters
      PARAMETER (L02 = L01+MXLOOP)
      PARAMETER (L06 = MAXMOD)
      PARAMETER (L07 = (18+2*MAXMOD)*MAXBOD + 9*MXPRTL)
      PARAMETER (L08 = 6+L06)
      PARAMETER (L09 = 6*L02)
      PARAMETER (L10 = L01*(6+L06))
      PARAMETER (L11 = 6+L06)
      PARAMETER (L12 = 2*L02-1)
      PARAMETER (L13 = 2*(L02 - 1))
      PARAMETER (L15 = 6*(L02 - 1))
      PARAMETER (L16 = 7*(L02 - 1))
      PARAMETER (L21 = 3*MAXMOD*MTOTBD)
      PARAMETER (L43 = MPERBD)
C     MAX is not supported on some machines
c     PARAMETER (L45 = MAX(6,L06))
      PARAMETER (L59 = ((L06+6)*(L06+7))/2)
      PARAMETER (L63 = MXLOOP)
      PARAMETER (L64 = 6*L63)
      PARAMETER (L72 = L01*(6+L06)+L02+6)
      PARAMETER (L76 = L02+6)

C     Parameters for static allocation of Heaps.
      INTEGER MAX_BH
      INTEGER MAX_HATS
      INTEGER MAX_HEAP_MB
      INTEGER MAX_intHEAP_MB
      INTEGER MAX_LocalHeap
      INTEGER MAX_intLocalHeap
      INTEGER MAX_mbdynaHeap
      INTEGER MAX_intLoopHeap
      INTEGER MAX_LoopHeap
      INTEGER MAX_logicLoopHeap
      INTEGER MAX_chkbonHeap
      INTEGER MAX_ltemphp
      INTEGER MAX_itemphp
      INTEGER MAX_cmpic2Heap
      INTEGER MAX_AINTGL

C     Adjust these parameters to change size of statically allocated heaps.
      PARAMETER (MAX_BH=6*(6+MAXMOD)*(2*(MAXBOD+MXLOOP)-1))
      PARAMETER (MAX_HATS=0.1*MPERBD*MAXMOD*MAXBOD)
      PARAMETER (MAX_HEAP_MB=1000000)
      PARAMETER (MAX_intHEAP_MB=(MAXBOD+MXPRTL)*(6+MAXMOD))
      PARAMETER (MAX_LocalHeap=(L06*14)+(L07*9)+(L08*(3*L08+135))+
     &          L09+L10+(L11*(2*L11+51+L01))+(L43*(3*L06+25+3*L06))+
     &          (L63*6)+(L64*(L64+2))+L72)
      PARAMETER (MAX_intLocalHeap=(12*(MAXBOD+MXPRTL+MXLOOP))
     &                     + (7+MAXBOD+MXPRTL)*(6+MAXMOD))
      PARAMETER (MAX_mbdynaHeap=3*(MAXBOD+MXPRTL)*(6+MAXMOD))
      PARAMETER (MAX_intLoopHeap=(45*(MAXBOD+MXPRTL+MXLOOP))
     &                            +(7*MXLOOP))
      PARAMETER (MAX_LoopHeap=177*(MAXBOD+MXPRTL+MXLOOP)
     &                        + MXLOOP*(36*MXLOOP+6))
      PARAMETER (MAX_logicLoopHeap=(MXLOOP+2)*(MAXBOD+MXPRTL+MXLOOP))
      PARAMETER (MAX_chkbonHeap=2*(MAXBOD+MXPRTL+MXLOOP))
      PARAMETER (MAX_ltemphp=MAXBOD+MXPRTL+MXLOOP)
      PARAMETER (MAX_itemphp=(17*(MAXBOD+MXPRTL+MXLOOP))+MXLOOP)
      PARAMETER (MAX_cmpic2Heap=70000)
      PARAMETER (MAX_AINTGL=10000)
#endif




c
CBLINK THIS IS THE OFFICIAL SIZE:
c      PARAMETER (lintgl = MAXBOD*MAXMOD*(MAXMOD+1)/2)
C     THE FOLLOWING SIZE IS USED IF MODAL STIFFNESS CALCULATIONS ARE NOT 
C     PERFORMED (REMEMBER TO SET "MBOND ATOM" IN CHARMM INPUT SCRIPT FILE 
C     FOR GENERATION AND LOADING OF MODE SHAPES)
C      PARAMETER (LINTGL = 1)
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     COMPUTED PARAMETERS FOR MULTIPOLE EXPANSION
C
      INTEGER MAXME  !  SIZE OF VECTOR FOR MULTIPOLE EXPANSION COEFFICIENTS
      INTEGER MAXFE  !  SIZE OF VECTOR FOR FORCE EXPANSION COEFFICIENTS
      INTEGER maxnode ! MAXIMUM NUMBER OF NODES IN BINARY TREE OF HBMA
C
      PARAMETER (MAXME=(MAXDEG+1)*(MAXDEG+2)/2)
      PARAMETER (MAXFE=MAXME-1)
CBLINK THIS IS THE OFFICIAL SIZE:
C     PARAMETER (maxnode=2*MAXBOD-1)
C     THE FOLLOWING SIZE IS USED IF HBMA IS NOT UTILIZED
      PARAMETER (MAXNODE=1)
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C     PARAMETERS TO BE MODIFIED BY DEVELOPERS
C
      INTEGER L05     !  MAXIMUM NUMBER OF MOMENTUM WHEELS PER BODY
      INTEGER L22     !  MAXIMUM NUMBER OF OPTIONS THAT CAN BE FLAGGED 
C                        VIA USE OF THE INPUTTED INTEGER ARRAY IPDATA
      INTEGER L56     !  MAXIMUM NUMBER OF CONSTANTS IN CNTDTA ARRAY
      INTEGER L62     !  MAXIMUM NUMBER OF DEBUG CODES IN DEBUG ARRAY
C
      PARAMETER (L05 = 1)
      PARAMETER (L22 = 100)
      PARAMETER (L56 = 10)
      PARAMETER (L62 = 150)

      INTEGER DBPRESZ ! Machine dependent double precision size.
      INTEGER INTGRSZ! Machine dependent integer size.
      INTEGER LGCALSZ! Machine dependent logical size.
      PARAMETER (DBPRESZ = 8)
      PARAMETER (INTGRSZ = 4)
      PARAMETER (LGCALSZ = 4)

      INTEGER BADADDR
      PARAMETER (BADADDR=-99999999)

      DOUBLE PRECISION EPSILON
      PARAMETER (EPSILON=1D-12)


      COMMON /PARAM/ cl43, cl06, cl07, cl08,cl10,cl11,cl45,cl72,
     &               cl02, cl09, cl12, cl15,cl16,cl63,cl64,cl76,
     &               cl01,
     &               maxflexmod, maxperbd,maxloop

      CHARACTER*128  PARAM_RCSID
      DATA           PARAM_RCSID
     &/'$RCSfile: PARAM.FOR,v $$Revision: 1.1.1.1 $'/







