# quantum makefile
# quantum library rules
OBJS_quantum= \
	$(LIB)/quantum.a(addlnat.o) \
	$(LIB)/quantum.a(mpiqub.o) \
	$(LIB)/quantum.a(qmdata.o) \
	$(LIB)/quantum.a(qmene.o) \
	$(LIB)/quantum.a(qmevdw.o) \
	$(LIB)/quantum.a(qmjunc.o) \
	$(LIB)/quantum.a(qmleps.o) \
	$(LIB)/quantum.a(qmnbnd.o) \
	$(LIB)/quantum.a(qmpac.o) \
	$(LIB)/quantum.a(qmset.o) \
	$(LIB)/quantum.a(qubene.o) \
	$(LIB)/quantum.a(qub.o)
#
$(LIB)/quantum.a : $(OBJS_quantum)
	$(RANLIB) $(LIB)/quantum.a
	@echo quantum COMPLETED
#
# quantum source file rules
$(LIB)/quantum.a(addlnat.o)  : $(SRC)/quantum/addlnat.src
	$(FLX) $(SRC)/quantum/addlnat.src
	$(FC0) addlnat.f
	$(AR_COMMAND) $(LIB)/quantum.a addlnat.o
	$(REMOVE_F) addlnat.f
	$(REMOVE_O) addlnat.o
#
$(LIB)/quantum.a(mpiqub.o)  : $(SRC)/quantum/mpiqub.src
	$(FLX) $(SRC)/quantum/mpiqub.src
	$(FC0) mpiqub.f
	$(AR_COMMAND) $(LIB)/quantum.a mpiqub.o
	$(REMOVE_F) mpiqub.f
	$(REMOVE_O) mpiqub.o
#
$(LIB)/quantum.a(qmdata.o)  : $(SRC)/quantum/qmdata.src
	$(FLX) $(SRC)/quantum/qmdata.src
	$(FC0) qmdata.f
	$(AR_COMMAND) $(LIB)/quantum.a qmdata.o
	$(REMOVE_F) qmdata.f
	$(REMOVE_O) qmdata.o
#
$(LIB)/quantum.a(qmene.o)  : $(SRC)/quantum/qmene.src
	$(FLX) $(SRC)/quantum/qmene.src
	$(FC2) qmene.f
	$(AR_COMMAND) $(LIB)/quantum.a qmene.o
	$(REMOVE_F) qmene.f
	$(REMOVE_O) qmene.o
#
$(LIB)/quantum.a(qmevdw.o)  : $(SRC)/quantum/qmevdw.src
	$(FLX) $(SRC)/quantum/qmevdw.src
	$(FC2) qmevdw.f
	$(AR_COMMAND) $(LIB)/quantum.a qmevdw.o
	$(REMOVE_F) qmevdw.f
	$(REMOVE_O) qmevdw.o
#
$(LIB)/quantum.a(qmjunc.o)  : $(SRC)/quantum/qmjunc.src
	$(FLX) $(SRC)/quantum/qmjunc.src
	$(FC1) qmjunc.f
	$(AR_COMMAND) $(LIB)/quantum.a qmjunc.o
	$(REMOVE_F) qmjunc.f
	$(REMOVE_O) qmjunc.o
#
$(LIB)/quantum.a(qmleps.o)  : $(SRC)/quantum/qmleps.src
	$(FLX) $(SRC)/quantum/qmleps.src
	$(FC0) qmleps.f
	$(AR_COMMAND) $(LIB)/quantum.a qmleps.o
	$(REMOVE_F) qmleps.f
	$(REMOVE_O) qmleps.o
#
$(LIB)/quantum.a(qmnbnd.o)  : $(SRC)/quantum/qmnbnd.src
	$(FLX) $(SRC)/quantum/qmnbnd.src
	$(FC0) qmnbnd.f
	$(AR_COMMAND) $(LIB)/quantum.a qmnbnd.o
	$(REMOVE_F) qmnbnd.f
	$(REMOVE_O) qmnbnd.o
#
$(LIB)/quantum.a(qmpac.o)  : $(SRC)/quantum/qmpac.src
	$(FLX) $(SRC)/quantum/qmpac.src
	$(FC1) qmpac.f
	$(AR_COMMAND) $(LIB)/quantum.a qmpac.o
	$(REMOVE_F) qmpac.f
	$(REMOVE_O) qmpac.o
#
$(LIB)/quantum.a(qmset.o)  : $(SRC)/quantum/qmset.src
	$(FLX) $(SRC)/quantum/qmset.src
	$(FC0) qmset.f
	$(AR_COMMAND) $(LIB)/quantum.a qmset.o
	$(REMOVE_F) qmset.f
	$(REMOVE_O) qmset.o
#
$(LIB)/quantum.a(qubene.o)  : $(SRC)/quantum/qubene.src
	$(FLX) $(SRC)/quantum/qubene.src
	$(FC2) qubene.f
	$(AR_COMMAND) $(LIB)/quantum.a qubene.o
	$(REMOVE_F) qubene.f
	$(REMOVE_O) qubene.o
#
$(LIB)/quantum.a(qub.o)  : $(SRC)/quantum/qub.src
	$(FLX) $(SRC)/quantum/qub.src
	$(FC0) qub.f
	$(AR_COMMAND) $(LIB)/quantum.a qub.o
	$(REMOVE_F) qub.f
	$(REMOVE_O) qub.o
#
#
# quantum dependency file
#
$(LIB)/quantum.a(addlnat.o) : cadpac.fcm
$(LIB)/quantum.a(addlnat.o) : comand.fcm
$(LIB)/quantum.a(addlnat.o) : coordc.fcm
$(LIB)/quantum.a(addlnat.o) : coord.fcm
$(LIB)/quantum.a(addlnat.o) : dimens.fcm
$(LIB)/quantum.a(addlnat.o) : exfunc.fcm
$(LIB)/quantum.a(addlnat.o) : gamess.fcm
$(LIB)/quantum.a(addlnat.o) : impnon.fcm
$(LIB)/quantum.a(addlnat.o) : mmff.fcm
$(LIB)/quantum.a(addlnat.o) : mndo97.fcm
$(LIB)/quantum.a(addlnat.o) : number.fcm
$(LIB)/quantum.a(addlnat.o) : param.fcm
$(LIB)/quantum.a(addlnat.o) : psf.fcm
$(LIB)/quantum.a(addlnat.o) : rtf.fcm
$(LIB)/quantum.a(addlnat.o) : sccdftb.fcm
$(LIB)/quantum.a(addlnat.o) : squantm.fcm
$(LIB)/quantum.a(addlnat.o) : stack.fcm
$(LIB)/quantum.a(addlnat.o) : stream.fcm
#
#
$(LIB)/quantum.a(mpiqub.o) : dimens.fcm
$(LIB)/quantum.a(mpiqub.o) : impnon.fcm
$(LIB)/quantum.a(mpiqub.o) : number.fcm
$(LIB)/quantum.a(mpiqub.o) : parallel.fcm
$(LIB)/quantum.a(mpiqub.o) : qubpi.fcm
$(LIB)/quantum.a(mpiqub.o) : sizes.fcm
$(LIB)/quantum.a(mpiqub.o) : stream.fcm
#
#
$(LIB)/quantum.a(qmdata.o) : am1parm.fcm
$(LIB)/quantum.a(qmdata.o) : impnon.fcm
$(LIB)/quantum.a(qmdata.o) : stream.fcm
#
#
$(LIB)/quantum.a(qmene.o) : am1parm.fcm
$(LIB)/quantum.a(qmene.o) : consta.fcm
$(LIB)/quantum.a(qmene.o) : contrl.fcm
$(LIB)/quantum.a(qmene.o) : coordc.fcm
$(LIB)/quantum.a(qmene.o) : dimens.fcm
$(LIB)/quantum.a(qmene.o) : ewald.fcm
$(LIB)/quantum.a(qmene.o) : exfunc.fcm
$(LIB)/quantum.a(qmene.o) : heap.fcm
$(LIB)/quantum.a(qmene.o) : image.fcm
$(LIB)/quantum.a(qmene.o) : impnon.fcm
$(LIB)/quantum.a(qmene.o) : inbnd.fcm
$(LIB)/quantum.a(qmene.o) : leps.fcm
$(LIB)/quantum.a(qmene.o) : nbndqm.fcm
$(LIB)/quantum.a(qmene.o) : number.fcm
$(LIB)/quantum.a(qmene.o) : parallel.fcm
$(LIB)/quantum.a(qmene.o) : pbound.fcm
$(LIB)/quantum.a(qmene.o) : psf.fcm
$(LIB)/quantum.a(qmene.o) : qmlink.fcm
$(LIB)/quantum.a(qmene.o) : quantm.fcm
$(LIB)/quantum.a(qmene.o) : scfblk.fcm
$(LIB)/quantum.a(qmene.o) : sizes.fcm
$(LIB)/quantum.a(qmene.o) : stack.fcm
$(LIB)/quantum.a(qmene.o) : stream.fcm
#
#
$(LIB)/quantum.a(qmevdw.o) : bases.fcm
$(LIB)/quantum.a(qmevdw.o) : dimens.fcm
$(LIB)/quantum.a(qmevdw.o) : exelec.fcm
$(LIB)/quantum.a(qmevdw.o) : exfunc.fcm
$(LIB)/quantum.a(qmevdw.o) : flucq.fcm
$(LIB)/quantum.a(qmevdw.o) : heap.fcm
$(LIB)/quantum.a(qmevdw.o) : image.fcm
$(LIB)/quantum.a(qmevdw.o) : impnon.fcm
$(LIB)/quantum.a(qmevdw.o) : inbnd.fcm
$(LIB)/quantum.a(qmevdw.o) : nbndqm.fcm
$(LIB)/quantum.a(qmevdw.o) : number.fcm
$(LIB)/quantum.a(qmevdw.o) : parallel.fcm
$(LIB)/quantum.a(qmevdw.o) : param.fcm
$(LIB)/quantum.a(qmevdw.o) : pbound.fcm
$(LIB)/quantum.a(qmevdw.o) : psf.fcm
$(LIB)/quantum.a(qmevdw.o) : stack.fcm
#
#
$(LIB)/quantum.a(qmjunc.o) : dimens.fcm
$(LIB)/quantum.a(qmjunc.o) : exfunc.fcm
$(LIB)/quantum.a(qmjunc.o) : heap.fcm
$(LIB)/quantum.a(qmjunc.o) : impnon.fcm
$(LIB)/quantum.a(qmjunc.o) : number.fcm
$(LIB)/quantum.a(qmjunc.o) : parallel.fcm
$(LIB)/quantum.a(qmjunc.o) : psf.fcm
$(LIB)/quantum.a(qmjunc.o) : qmlink.fcm
$(LIB)/quantum.a(qmjunc.o) : quantm.fcm
$(LIB)/quantum.a(qmjunc.o) : scfblk.fcm
$(LIB)/quantum.a(qmjunc.o) : sizes.fcm
$(LIB)/quantum.a(qmjunc.o) : stream.fcm
#
#
$(LIB)/quantum.a(qmleps.o) : exfunc.fcm
$(LIB)/quantum.a(qmleps.o) : impnon.fcm
$(LIB)/quantum.a(qmleps.o) : leps.fcm
$(LIB)/quantum.a(qmleps.o) : stream.fcm
#
#
$(LIB)/quantum.a(qmnbnd.o) : bases.fcm
$(LIB)/quantum.a(qmnbnd.o) : dimens.fcm
$(LIB)/quantum.a(qmnbnd.o) : exfunc.fcm
$(LIB)/quantum.a(qmnbnd.o) : gamess.fcm
$(LIB)/quantum.a(qmnbnd.o) : heap.fcm
$(LIB)/quantum.a(qmnbnd.o) : image.fcm
$(LIB)/quantum.a(qmnbnd.o) : impnon.fcm
$(LIB)/quantum.a(qmnbnd.o) : inbnd.fcm
$(LIB)/quantum.a(qmnbnd.o) : mndgho.fcm
$(LIB)/quantum.a(qmnbnd.o) : mndo97.fcm
$(LIB)/quantum.a(qmnbnd.o) : nbndqm.fcm
$(LIB)/quantum.a(qmnbnd.o) : number.fcm
$(LIB)/quantum.a(qmnbnd.o) : pbound.fcm
$(LIB)/quantum.a(qmnbnd.o) : psf.fcm
$(LIB)/quantum.a(qmnbnd.o) : qmlink.fcm
$(LIB)/quantum.a(qmnbnd.o) : quantm.fcm
$(LIB)/quantum.a(qmnbnd.o) : sizes.fcm
$(LIB)/quantum.a(qmnbnd.o) : squantm.fcm
$(LIB)/quantum.a(qmnbnd.o) : stack.fcm
$(LIB)/quantum.a(qmnbnd.o) : stream.fcm
#
#
$(LIB)/quantum.a(qmpac.o) : consta.fcm
$(LIB)/quantum.a(qmpac.o) : dimens.fcm
$(LIB)/quantum.a(qmpac.o) : impnon.fcm
$(LIB)/quantum.a(qmpac.o) : number.fcm
$(LIB)/quantum.a(qmpac.o) : parallel.fcm
$(LIB)/quantum.a(qmpac.o) : quantm.fcm
$(LIB)/quantum.a(qmpac.o) : sizes.fcm
$(LIB)/quantum.a(qmpac.o) : stream.fcm
#
#
$(LIB)/quantum.a(qmset.o) : am1parm.fcm
$(LIB)/quantum.a(qmset.o) : bases.fcm
$(LIB)/quantum.a(qmset.o) : code.fcm
$(LIB)/quantum.a(qmset.o) : consta.fcm
$(LIB)/quantum.a(qmset.o) : coord.fcm
$(LIB)/quantum.a(qmset.o) : dimens.fcm
$(LIB)/quantum.a(qmset.o) : ewald.fcm
$(LIB)/quantum.a(qmset.o) : exfunc.fcm
$(LIB)/quantum.a(qmset.o) : flucq.fcm
$(LIB)/quantum.a(qmset.o) : gamess.fcm
$(LIB)/quantum.a(qmset.o) : heap.fcm
$(LIB)/quantum.a(qmset.o) : image.fcm
$(LIB)/quantum.a(qmset.o) : impnon.fcm
$(LIB)/quantum.a(qmset.o) : inbnd.fcm
$(LIB)/quantum.a(qmset.o) : leps.fcm
$(LIB)/quantum.a(qmset.o) : nbndqm.fcm
$(LIB)/quantum.a(qmset.o) : number.fcm
$(LIB)/quantum.a(qmset.o) : parallel.fcm
$(LIB)/quantum.a(qmset.o) : param.fcm
$(LIB)/quantum.a(qmset.o) : pbound.fcm
$(LIB)/quantum.a(qmset.o) : psf.fcm
$(LIB)/quantum.a(qmset.o) : qmlink.fcm
$(LIB)/quantum.a(qmset.o) : quantm.fcm
$(LIB)/quantum.a(qmset.o) : rtf.fcm
$(LIB)/quantum.a(qmset.o) : scfblk.fcm
$(LIB)/quantum.a(qmset.o) : sizes.fcm
$(LIB)/quantum.a(qmset.o) : stack.fcm
$(LIB)/quantum.a(qmset.o) : stream.fcm
$(LIB)/quantum.a(qmset.o) : string.fcm
#
#
$(LIB)/quantum.a(qubene.o) : am1parm.fcm
$(LIB)/quantum.a(qubene.o) : consta.fcm
$(LIB)/quantum.a(qubene.o) : contrl.fcm
$(LIB)/quantum.a(qubene.o) : coordc.fcm
$(LIB)/quantum.a(qubene.o) : dimens.fcm
$(LIB)/quantum.a(qubene.o) : exfunc.fcm
$(LIB)/quantum.a(qubene.o) : heap.fcm
$(LIB)/quantum.a(qubene.o) : impnon.fcm
$(LIB)/quantum.a(qubene.o) : inbnd.fcm
$(LIB)/quantum.a(qubene.o) : leps.fcm
$(LIB)/quantum.a(qubene.o) : nbndqm.fcm
$(LIB)/quantum.a(qubene.o) : number.fcm
$(LIB)/quantum.a(qubene.o) : pbound.fcm
$(LIB)/quantum.a(qubene.o) : psf.fcm
$(LIB)/quantum.a(qubene.o) : qmlink.fcm
$(LIB)/quantum.a(qubene.o) : quantm.fcm
$(LIB)/quantum.a(qubene.o) : scfblk.fcm
$(LIB)/quantum.a(qubene.o) : sizes.fcm
$(LIB)/quantum.a(qubene.o) : stack.fcm
$(LIB)/quantum.a(qubene.o) : stream.fcm
#
#
$(LIB)/quantum.a(qub.o) : bases.fcm
$(LIB)/quantum.a(qub.o) : blockscc.fcm
$(LIB)/quantum.a(qub.o) : consta.fcm
$(LIB)/quantum.a(qub.o) : coord.fcm
$(LIB)/quantum.a(qub.o) : ctitla.fcm
$(LIB)/quantum.a(qub.o) : deriv.fcm
$(LIB)/quantum.a(qub.o) : dimens.fcm
$(LIB)/quantum.a(qub.o) : energy.fcm
$(LIB)/quantum.a(qub.o) : ewald.fcm
$(LIB)/quantum.a(qub.o) : exfunc.fcm
$(LIB)/quantum.a(qub.o) : flucq.fcm
$(LIB)/quantum.a(qub.o) : gamess.fcm
$(LIB)/quantum.a(qub.o) : heap.fcm
$(LIB)/quantum.a(qub.o) : impnon.fcm
$(LIB)/quantum.a(qub.o) : number.fcm
$(LIB)/quantum.a(qub.o) : parallel.fcm
$(LIB)/quantum.a(qub.o) : psf.fcm
$(LIB)/quantum.a(qub.o) : qmlink.fcm
$(LIB)/quantum.a(qub.o) : quantm.fcm
$(LIB)/quantum.a(qub.o) : qubpi.fcm
$(LIB)/quantum.a(qub.o) : sccdftb.fcm
$(LIB)/quantum.a(qub.o) : sizes.fcm
$(LIB)/quantum.a(qub.o) : stack.fcm
$(LIB)/quantum.a(qub.o) : stbgho.fcm
$(LIB)/quantum.a(qub.o) : stream.fcm
#
