#
# Build the GAMESS-UK libraries 
#
# Routines for the serial and MPI codes
#
BASESRC = \
 $(SRC)/gukint/GAMESS-UK/m4/mains.m\
 $(SRC)/gukint/GAMESS-UK/m4/omit.m\
 $(SRC)/gukint/GAMESS-UK/m4/anala.m \
 $(SRC)/gukint/GAMESS-UK/m4/analb.m \
 $(SRC)/gukint/GAMESS-UK/m4/analc.m \
 $(SRC)/gukint/GAMESS-UK/m4/analf.m \
 $(SRC)/gukint/GAMESS-UK/m4/analg.m \
 $(SRC)/gukint/GAMESS-UK/m4/basis.m \
 $(SRC)/gukint/GAMESS-UK/m4/dft.m \
 $(SRC)/gukint/GAMESS-UK/m4/drv1e.m \
 $(SRC)/gukint/GAMESS-UK/m4/drv2e.m \
 $(SRC)/gukint/GAMESS-UK/m4/drv80.m \
 $(SRC)/gukint/GAMESS-UK/m4/guess.m \
 $(SRC)/gukint/GAMESS-UK/m4/input.m \
 $(SRC)/gukint/GAMESS-UK/m4/intega.m \
 $(SRC)/gukint/GAMESS-UK/m4/integb.m \
 $(SRC)/gukint/GAMESS-UK/m4/integc.m \
 $(SRC)/gukint/GAMESS-UK/m4/integs.m \
 $(SRC)/gukint/GAMESS-UK/m4/machscf.m \
 $(SRC)/gukint/GAMESS-UK/m4/master.m \
 $(SRC)/gukint/GAMESS-UK/m4/model.m \
 $(SRC)/gukint/GAMESS-UK/m4/optef.m \
 $(SRC)/gukint/GAMESS-UK/m4/optim.m \
 $(SRC)/gukint/GAMESS-UK/m4/scf.m \
 $(SRC)/gukint/GAMESS-UK/m4/server.m \
 $(SRC)/gukint/GAMESS-UK/m4/util1.m \
 $(SRC)/gukint/GAMESS-UK/m4/util2.m \
 $(SRC)/gukint/GAMESS-UK/m4/util3.m \
 $(SRC)/gukint/GAMESS-UK/m4/morokuma.m \
 $(SRC)/gukint/GAMESS-UK/m4/nbo.m \
 $(SRC)/gukint/GAMESS-UK/m4/parallel.m \
 $(SRC)/gukint/GAMESS-UK/m4/mass.m \
 $(SRC)/gukint/GAMESS-UK/m4/c.m \
 $(SRC)/gukint/GAMESS-UK/m4/zora.m


# Routines for the GA-based code.
#
# These routines are not supported by the standard build
# procedures but can be introduced by hand for platforms for
#
# which either 
#  - GA and MPI can coexist
#  - GA is built on a vendor system (e.g. SHMEM) and there is 
#    a charmm port on this same system
#
GASRC = \
$(SRC)/gukint/GAMESS-UK/m4/anald.m \
$(SRC)/gukint/GAMESS-UK/m4/anale.m \
$(SRC)/gukint/GAMESS-UK/m4/blas_d_to_s.m \
$(SRC)/gukint/GAMESS-UK/m4/cphf.m \
$(SRC)/gukint/GAMESS-UK/m4/derdrv.m \
$(SRC)/gukint/GAMESS-UK/m4/dlapack.m \
$(SRC)/gukint/GAMESS-UK/m4/drvmp.m \
$(SRC)/gukint/GAMESS-UK/m4/ga.m \
$(SRC)/gukint/GAMESS-UK/m4/iblas.m \
$(SRC)/gukint/GAMESS-UK/m4/inpci.m \
$(SRC)/gukint/GAMESS-UK/m4/integd.m \
$(SRC)/gukint/GAMESS-UK/m4/intege.m \
$(SRC)/gukint/GAMESS-UK/m4/machci.m \
$(SRC)/gukint/GAMESS-UK/m4/mainci.m \
$(SRC)/gukint/GAMESS-UK/m4/mp2_parallel.m \
$(SRC)/gukint/GAMESS-UK/m4/secd_parallel.m \
$(SRC)/gukint/GAMESS-UK/m4/secdchf.m \
$(SRC)/gukint/GAMESS-UK/m4/optim.m \
$(SRC)/gukint/GAMESS-UK/m4/parallel.m \
$(SRC)/gukint/GAMESS-UK/m4/peigs_interface.m \
$(SRC)/gukint/GAMESS-UK/m4/tran4.m \
$(SRC)/gukint/GAMESS-UK/m4/util4.m \
$(SRC)/gukint/GAMESS-UK/m4/util5.m \
$(SRC)/gukint/GAMESS-UK/m4/util6.m \
$(SRC)/gukint/GAMESS-UK/m4/util7.m \
$(SRC)/gukint/GAMESS-UK/m4/util8.m


DFTSRC = \
$(SRC)/gukint/GAMESS-UK/dft/basis.m \
$(SRC)/gukint/GAMESS-UK/dft/coulomb.m \
$(SRC)/gukint/GAMESS-UK/dft/gamess.m \
$(SRC)/gukint/GAMESS-UK/dft/global.m \
$(SRC)/gukint/GAMESS-UK/dft/interface.m \
$(SRC)/gukint/GAMESS-UK/dft/intpack.m \
$(SRC)/gukint/GAMESS-UK/dft/matpack.m \
$(SRC)/gukint/GAMESS-UK/dft/xc.m \
$(SRC)/gukint/GAMESS-UK/dft/integ_data.m \
$(SRC)/gukint/GAMESS-UK/dft/integ_te2c_norm.m \
$(SRC)/gukint/GAMESS-UK/dft/readbasis.m \
$(SRC)/gukint/GAMESS-UK/dft/jfitg.m \
$(SRC)/gukint/GAMESS-UK/dft/integ2e.m \
$(SRC)/gukint/GAMESS-UK/dft/deriv2e.m \
$(SRC)/gukint/GAMESS-UK/dft/matform.m \
$(SRC)/gukint/GAMESS-UK/dft/gden.m \
$(SRC)/gukint/GAMESS-UK/dft/gadft.m \
$(SRC)/gukint/GAMESS-UK/dft/omit_mpole.m 


$(LIB)/gamessuk.a :	$(BASESRC)
	@(cd $(SRC)/gukint/GAMESS-UK/m4; \
	../utilities/charmm_configure $$chmhost; \
	status=$$?; \
	if test $$status -ne 0; \
	  then echo GAMESS-UK configuration failed; \
	  exit 99; \
	fi; \
	make)

$(LIB)/gamessukga.a :	 $(BASESRC) $(GASRC)
	@(cd $(SRC)/gukint/GAMESS-UK/m4;\
	../utilities/charmm_configure $$chmhost;\
	status=$$?; \
	if test $$status -ne 0; \
	  then echo GAMESS-UK configuration failed;\
	  exit 99; \
	fi; \
	make)

$(LIB)/dft.a :	$(DFTSRC)
	@(cd $(SRC)/gukint/GAMESS-UK/m4;\
	../utilities/charmm_configure $$chmhost;\
	status=$$?; \
	if test $$status -ne 0; \
	  then echo GAMESS-UK configuration failed;\
	  exit 99; \
	fi; \
	make)
