# SCCTB makefile
# SCCTB library rules
# Might modify optimization levels.
# The headfile is handled in install.com
FFLAGS3 = -O2

OBJS_sccdftb= \
	$(LIB)/sccdftb.a(atomen.o) \
	$(LIB)/sccdftb.a(broyden.o) \
	$(LIB)/sccdftb.a(cgrad.o) \
	$(LIB)/sccdftb.a(dispersionread.o) \
	$(LIB)/sccdftb.a(dispersion_egr.o) \
	$(LIB)/sccdftb.a(dylcao.o) \
	$(LIB)/sccdftb.a(eglcao.o) \
	$(LIB)/sccdftb.a(ewevge.o) \
	$(LIB)/sccdftb.a(externalchgrad.o) \
	$(LIB)/sccdftb.a(externalshift.o) \
	$(LIB)/sccdftb.a(fermi.o) \
	$(LIB)/sccdftb.a(gamma.o) \
	$(LIB)/sccdftb.a(gammamat.o) \
	$(LIB)/sccdftb.a(geometries.o) \
	$(LIB)/sccdftb.a(gettab.o) \
	$(LIB)/sccdftb.a(gradient.o) \
	$(LIB)/sccdftb.a(input.o) \
	$(LIB)/sccdftb.a(ktable_ewscc.o) \
	$(LIB)/sccdftb.a(long_range.o) \
	$(LIB)/sccdftb.a(long_sccmm1.o) \
	$(LIB)/sccdftb.a(long_sccmm2.o) \
	$(LIB)/sccdftb.a(mulliken.o) \
	$(LIB)/sccdftb.a(output.o) \
	$(LIB)/sccdftb.a(ranmar.o) \
	$(LIB)/sccdftb.a(repulsiv.o) \
	$(LIB)/sccdftb.a(self.o) \
	$(LIB)/sccdftb.a(shift.o) \
	$(LIB)/sccdftb.a(short_range.o) \
	$(LIB)/sccdftb.a(skpar.o) \
	$(LIB)/sccdftb.a(slkode.o) \
	$(LIB)/sccdftb.a(slktrafo.o) 
#
$(LIB)/sccdftb.a : $(OBJS_sccdftb)
	$(RANLIB) $(LIB)/sccdftb.a
	@echo SCCTB COMPLETED
#
# SCCTB source file rules
$(LIB)/sccdftb.a(atomen.o) : $(SRC)/sccdftbint/sccdftbsrc/atomen.f
	$(FC2) $(FFLAGS3) $(SRC)/sccdftbint/sccdftbsrc/atomen.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a atomen.o
	$(REMOVE_O) atomen.o

$(LIB)/sccdftb.a(broyden.o) : $(SRC)/sccdftbint/sccdftbsrc/broyden.f
	$(FC2) $(FFLAGS3) $(SRC)/sccdftbint/sccdftbsrc/broyden.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a broyden.o
	$(REMOVE_O) broyden.o

$(LIB)/sccdftb.a(cgrad.o) : $(SRC)/sccdftbint/sccdftbsrc/cgrad.f
	$(FC2) $(FFLAGS3) $(SRC)/sccdftbint/sccdftbsrc/cgrad.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a cgrad.o
	$(REMOVE_O) cgrad.o

$(LIB)/sccdftb.a(dispersionread.o) : $(SRC)/sccdftbint/sccdftbsrc/dispersionread.f
	$(FC2) $(FFLAGS3) $(SRC)/sccdftbint/sccdftbsrc/dispersionread.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a dispersionread.o
	$(REMOVE_O) dispersionread.o

$(LIB)/sccdftb.a(dispersion_egr.o) : $(SRC)/sccdftbint/sccdftbsrc/dispersion_egr.f
	$(FC2) $(FFLAGS3) $(SRC)/sccdftbint/sccdftbsrc/dispersion_egr.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a dispersion_egr.o
	$(REMOVE_O) dispersion_egr.o

$(LIB)/sccdftb.a(dylcao.o) : $(SRC)/sccdftbint/sccdftbsrc/dylcao.src
	$(FLX) $(SRC)/sccdftbint/sccdftbsrc/dylcao.src
	$(FC2) $(FFLAGS3) dylcao.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a dylcao.o
	$(REMOVE_F) dylcao.f
	$(REMOVE_O) dylcao.o

$(LIB)/sccdftb.a(eglcao.o) : $(SRC)/sccdftbint/sccdftbsrc/eglcao.f
	$(FC2) $(FFLAGS3) $(SRC)/sccdftbint/sccdftbsrc/eglcao.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a eglcao.o
	$(REMOVE_O) eglcao.o

$(LIB)/sccdftb.a(ewevge.o) : $(SRC)/sccdftbint/sccdftbsrc/ewevge.f
	$(FC2) $(FFLAGS3) $(SRC)/sccdftbint/sccdftbsrc/ewevge.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a ewevge.o
	$(REMOVE_O) ewevge.o

$(LIB)/sccdftb.a(externalchgrad.o) : $(SRC)/sccdftbint/sccdftbsrc/externalchgrad.src
	$(FLX) $(SRC)/sccdftbint/sccdftbsrc/externalchgrad.src
	$(FC2) $(FFLAGS3) externalchgrad.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a externalchgrad.o
	$(REMOVE_F) externalchgrad.f
	$(REMOVE_O) externalchgrad.o

$(LIB)/sccdftb.a(externalshift.o) : $(SRC)/sccdftbint/sccdftbsrc/externalshift.f
	$(FC2) $(FFLAGS3) $(SRC)/sccdftbint/sccdftbsrc/externalshift.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a externalshift.o
	$(REMOVE_O) externalshift.o

$(LIB)/sccdftb.a(fermi.o) : $(SRC)/sccdftbint/sccdftbsrc/fermi.f
	$(FC2) $(FFLAGS3) $(SRC)/sccdftbint/sccdftbsrc/fermi.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a fermi.o
	$(REMOVE_O) fermi.o

$(LIB)/sccdftb.a(gamma.o) : $(SRC)/sccdftbint/sccdftbsrc/gamma.f
	$(FC2) $(FFLAGS3) $(SRC)/sccdftbint/sccdftbsrc/gamma.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a gamma.o
	$(REMOVE_O) gamma.o

$(LIB)/sccdftb.a(gammamat.o) : $(SRC)/sccdftbint/sccdftbsrc/gammamat.f
	$(FC2) $(FFLAGS3) $(SRC)/sccdftbint/sccdftbsrc/gammamat.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a gammamat.o
	$(REMOVE_O) gammamat.o

$(LIB)/sccdftb.a(geometries.o) : $(SRC)/sccdftbint/sccdftbsrc/geometries.f
	$(FC2) $(FFLAGS3) $(SRC)/sccdftbint/sccdftbsrc/geometries.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a geometries.o
#	$(REMOVE_O) geometries.f
	$(REMOVE_O) geometries.o

$(LIB)/sccdftb.a(gettab.o) : $(SRC)/sccdftbint/sccdftbsrc/gettab.f
	$(FC2) $(FFLAGS3) $(SRC)/sccdftbint/sccdftbsrc/gettab.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a gettab.o
	$(REMOVE_O) gettab.o

$(LIB)/sccdftb.a(gradient.o) : $(SRC)/sccdftbint/sccdftbsrc/gradient.f
	$(FC2) $(FFLAGS3) $(SRC)/sccdftbint/sccdftbsrc/gradient.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a gradient.o
	$(REMOVE_O) gradient.o

$(LIB)/sccdftb.a(input.o) : $(SRC)/sccdftbint/sccdftbsrc/input.f
	$(FC2) $(FFLAGS3) $(SRC)/sccdftbint/sccdftbsrc/input.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a input.o
	$(REMOVE_O) input.o

# Treat ktable with FLX 'cause we use the PARALLEL flag
$(LIB)/sccdftb.a(ktable_ewscc.o) : $(SRC)/sccdftbint/sccdftbsrc/ktable_ewscc.src
	$(FLX) $(SRC)/sccdftbint/sccdftbsrc/ktable_ewscc.src
	$(FC2) $(FFLAGS3) ktable_ewscc.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a ktable_ewscc.o
	$(REMOVE_F) ktable_ewscc.f
	$(REMOVE_O) ktable_ewscc.o

$(LIB)/sccdftb.a(long_range.o) : $(SRC)/sccdftbint/sccdftbsrc/long_range.f
	$(FC2) $(FFLAGS3) $(SRC)/sccdftbint/sccdftbsrc/long_range.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a long_range.o
	$(REMOVE_O) long_range.o

$(LIB)/sccdftb.a(long_sccmm1.o) : $(SRC)/sccdftbint/sccdftbsrc/long_sccmm1.src
	$(FLX) $(SRC)/sccdftbint/sccdftbsrc/long_sccmm1.src
	$(FC2) long_sccmm1.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a long_sccmm1.o
	$(REMOVE_F) long_sccmm1.f
	$(REMOVE_O) long_sccmm1.o

$(LIB)/sccdftb.a(long_sccmm2.o) : $(SRC)/sccdftbint/sccdftbsrc/long_sccmm2.src
	$(FLX) $(SRC)/sccdftbint/sccdftbsrc/long_sccmm2.src
	$(FC2) $(FFLAGS3) long_sccmm2.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a long_sccmm2.o
	$(REMOVE_F) long_sccmm2.f
	$(REMOVE_O) long_sccmm2.o

$(LIB)/sccdftb.a(mulliken.o) : $(SRC)/sccdftbint/sccdftbsrc/mulliken.f
	$(FC2) $(FFLAGS3) $(SRC)/sccdftbint/sccdftbsrc/mulliken.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a mulliken.o
	$(REMOVE_O) mulliken.o

$(LIB)/sccdftb.a(output.o) : $(SRC)/sccdftbint/sccdftbsrc/output.f
	$(FC2) $(FFLAGS3) $(SRC)/sccdftbint/sccdftbsrc/output.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a output.o
	$(REMOVE_O) output.o

$(LIB)/sccdftb.a(ranmar.o) : $(SRC)/sccdftbint/sccdftbsrc/ranmar.f
	$(FC2) $(FFLAGS3) $(SRC)/sccdftbint/sccdftbsrc/ranmar.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a ranmar.o
	$(REMOVE_O) ranmar.o

$(LIB)/sccdftb.a(repulsiv.o) : $(SRC)/sccdftbint/sccdftbsrc/repulsiv.f
	$(FC2) $(FFLAGS3) $(SRC)/sccdftbint/sccdftbsrc/repulsiv.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a repulsiv.o
	$(REMOVE_O) repulsiv.o

$(LIB)/sccdftb.a(self.o) : $(SRC)/sccdftbint/sccdftbsrc/self.f
	$(FC2) $(FFLAGS3) $(SRC)/sccdftbint/sccdftbsrc/self.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a self.o
	$(REMOVE_O) self.o

$(LIB)/sccdftb.a(shift.o) : $(SRC)/sccdftbint/sccdftbsrc/shift.f
	$(FC2) $(FFLAGS3) $(SRC)/sccdftbint/sccdftbsrc/shift.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a shift.o
	$(REMOVE_O) shift.o

$(LIB)/sccdftb.a(short_range.o) : $(SRC)/sccdftbint/sccdftbsrc/short_range.f
	$(FC2) $(FFLAGS3) $(SRC)/sccdftbint/sccdftbsrc/short_range.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a short_range.o
	$(REMOVE_O) short_range.o

$(LIB)/sccdftb.a(skpar.o) : $(SRC)/sccdftbint/sccdftbsrc/skpar.f
	$(FC2) $(FFLAGS3) $(SRC)/sccdftbint/sccdftbsrc/skpar.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a skpar.o
	$(REMOVE_O) skpar.o

$(LIB)/sccdftb.a(slkode.o) : $(SRC)/sccdftbint/sccdftbsrc/slkode.f
	$(FC2) $(FFLAGS3) $(SRC)/sccdftbint/sccdftbsrc/slkode.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a slkode.o
	$(REMOVE_O) slkode.o

$(LIB)/sccdftb.a(slktrafo.o) : $(SRC)/sccdftbint/sccdftbsrc/slktrafo.f
	$(FC2) $(FFLAGS3) $(SRC)/sccdftbint/sccdftbsrc/slktrafo.f
	$(AR_COMMAND) $(LIB)/sccdftb\.a slktrafo.o
	$(REMOVE_O) slktrafo.o

#
# SCCTB dependency file
#
