/* CHARMM Element source/emap/emapio.c $Revision: 1.1.1.1 $ */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>   

#if hpux || ibmrs
int emappeek(char *fname,int *lx,int *ly, int *lz)
#else
int emappeek_(char *fname,int *lx,int *ly, int *lz)
#endif
{
  char filename[80];
  int i,j,maperror=0,longbyte;
  FILE *fin;
  long nx, ny, nz; 
  longbyte=4;
    i=0;
    while(fname[i]==' '||fname[i]=='"'||fname[i]=='\'')i++;
    j=0;
    while(fname[i]!=' '&&fname[i]!='"'&&fname[i]!='\''&&
       fname[i]!='\0'&&fname[i]!='\0')filename[j++]=fname[i++];
    filename[j]='\0';
    fin = fopen(filename, "rb");
    if( fin == NULL ) {
      fprintf(stderr, "emappeek> Error: Can't open file %s!\n", fname); 
      exit(1);   
    }
    if (fread(&nx, longbyte, 1, fin)!=1) maperror=1;
    if (fread(&ny, longbyte, 1, fin)!=1) maperror=1;
    if (fread(&nz, longbyte, 1, fin)!=1) maperror=1;
    fclose (fin);
    if (maperror == 1) {
      fprintf(stderr, "emappeek> Error: Could not read header of file %s \n", fname); 
      exit(1);
    }    
   *lx=(int)nx;
   *ly=(int)ny;
   *lz=(int)nz;
    printf("emappeek>       NC = %8d  (# columns)\n",*lx); 
    printf("emappeek>       NR = %8d  (# rows)\n",*ly); 
    printf("emappeek>       NS = %8d  (# sections)\n",*lz); 
  return 0;
  }   


 
#if hpux || ibmrs
int emapread(char *fname,int *nsx,int *nsy,int *nsz, int *lx, int *ly, int *lz,
   double *dx, double *dy, double *dz, float *rho)
#else
int emapread_(char *fname,int *nsx,int *nsy,int *nsz, int *lx, int *ly, int *lz,
   double *dx, double *dy, double *dz, float *rho)
#endif
{
  char filename[80];
  int headlen,maperror,finl,nfloat,longbyte,floatbyte,charbyte;
  FILE *fin;
  long  mx, my, mz;
  long mode,testa, testb, testg;
  float xlen, ylen, zlen, alpha, beta, gamma;
  long mapc, mapr, maps,ispg,lskflg,nsymbt,extra[15];
  float amin, amax, amean, arms,junk;
  float *farr;
  float skwmat[9], skwtrn[3];
  char maplabel[4], machst[4];
  int extx, exty, extz;
  unsigned long count, nvox;
  int ordermode,orom;
  int i, j;
  longbyte=4;
  floatbyte=4;
  charbyte=1;
    i=0;
    while(fname[i]==' '||fname[i]=='"'||fname[i]=='\'')i++;
    j=0;
    while(fname[i]!=' '&&fname[i]!='"'&&fname[i]!='\''&&
          fname[i]!='\0')filename[j++]=fname[i++];
    filename[j]='\0';
    fin = fopen(filename, "rb");
    if( fin == NULL ) {
      fprintf(stderr, "emapread> Error: Can't open file %s! \n", fname); 
      exit(1);   
    }
    finl = 0;
    for( ; ; ) {
      if( fgetc(fin) == EOF ) break;
      ++finl;
    }
    rewind (fin);
    nfloat = finl / floatbyte;
    farr = (float *) malloc(nfloat * floatbyte);
    if (nfloat > fread(farr, floatbyte, nfloat, fin)) {
      fprintf(stderr, "emapread> Error: Could not convert all data from file %s \n", fname); 
      exit(1);
    }     
    rewind (fin);

    printf("emapread> Reading header information from CCP4 file  %s \n", filename); 
    maperror=0;
    if (fread(lx, longbyte, 1, fin)!=1) maperror=1;
    if (fread(ly, longbyte, 1, fin)!=1) maperror=1;
    if (fread(lz, longbyte, 1, fin)!=1) maperror=1;
    if (fread(&mode, longbyte, 1, fin)!=1) maperror=1;
    if (fread(nsx, longbyte, 1, fin)!=1) maperror=1;
    if (fread(nsy, longbyte, 1, fin)!=1) maperror=1;
    if (fread(nsz, longbyte, 1, fin)!=1) maperror=1;
    if (fread(&mx, longbyte, 1, fin)!=1) maperror=1;
    if (fread(&my, longbyte, 1, fin)!=1) maperror=1;
    if (fread(&mz, longbyte, 1, fin)!=1) maperror=1;
    if (fread(&xlen, floatbyte, 1, fin)!=1) maperror=1;
    if (fread(&ylen, floatbyte, 1, fin)!=1) maperror=1;
    if (fread(&zlen, floatbyte, 1, fin)!=1) maperror=1;
    if (fread(&alpha, floatbyte, 1, fin)!=1) maperror=1;
    if (fread(&beta, floatbyte, 1, fin)!=1) maperror=1;
    if (fread(&gamma, floatbyte, 1, fin)!=1) maperror=1;
    if (fread(&mapc, longbyte, 1, fin)!=1) maperror=1;
    if (fread(&mapr, longbyte, 1, fin)!=1) maperror=1;
    if (fread(&maps, longbyte, 1, fin)!=1) maperror=1;
    if (fread(&amin, floatbyte, 1, fin)!=1) maperror=1;
    if (fread(&amax, floatbyte, 1, fin)!=1) maperror=1;
    if (fread(&amean, floatbyte, 1, fin)!=1) maperror=1;
    if (fread(&ispg, longbyte, 1, fin)!=1) maperror=1;
    if (fread(&nsymbt, longbyte, 1, fin)!=1) maperror=1;
    if (fread(&lskflg, longbyte, 1, fin)!=1) maperror=1;
    if (fread(skwmat, floatbyte, 9, fin)!=9) maperror=1;
    if (fread(skwtrn, floatbyte, 3, fin)!=3) maperror=1;
    if (fread(extra, longbyte, 15, fin)!=15) maperror=1;
    if (fread(maplabel, charbyte, 4, fin)!=4) maperror=1;
    if (fread(machst,charbyte, 4, fin)!=4) maperror=1;
    if (fread(&arms, floatbyte, 1, fin)!=1) maperror=1;

    fclose (fin);
    if (maperror == 1) {
      fprintf(stderr, "emapread> Error: Could not read header of file %s \n", fname); 
      exit(1);
    }     

    printf("emapread>       NC = %8d  (# columns)\n",*lx); 
    printf("emapread>       NR = %8d  (# rows)\n",*ly); 
    printf("emapread>       NS = %8d  (# sections)\n",*lz); 
    printf("emapread>     MODE = %8d  (data type: 2 = stored as floats)\n",mode); 
    printf("emapread>  NCSTART = %8d  (index of first column)\n",*nsx); 
    printf("emapread>  NRSTART = %8d  (index of first row)\n",*nsy);
    printf("emapread>  NSSTART = %8d  (index of first section)\n",*nsz);
    printf("emapread>       NX = %8d  (# of X intervals in unit cell)\n",mx); 
    printf("emapread>       NY = %8d  (# of Y intervals in unit cell)\n",my);
    printf("emapread>       NZ = %8d  (# of Z intervals in unit cell)\n",mz);
    printf("emapread> X length = %8.3f  (unit cell dimension)\n",xlen);
    printf("emapread> Y length = %8.3f  (unit cell dimension)\n",ylen);
    printf("emapread> Z length = %8.3f  (unit cell dimension)\n",zlen);
    printf("emapread>    Alpha = %8.3f  (unit cell angle)\n",alpha);
    printf("emapread>     Beta = %8.3f  (unit cell angle)\n",beta);
    printf("emapread>    Gamma = %8.3f  (unit cell angle)\n",gamma);
    printf("emapread>     MAPC = %8d  (columns axis: 1=X)\n",mapc); 
    printf("emapread>     MAPR = %8d  (rows axis: 2=Y)\n",mapr);
    printf("emapread>     MAPS = %8d  (sections axis: 3=Z)\n",maps);
    printf("emapread>     AMIN = %8.3f  (minimum density value)\n",amin);
    printf("emapread>     AMAX = %8.3f  (maximum density value)\n",amax);
    printf("emapread>    AMEAN = %8.3f  (mean density value)\n",amean);
    printf("emapread>     ISPG = %8d  (ignored: space group number)\n",ispg);
    printf("emapread>   NSYMBT = %8d  (ignored: # bytes used for storing symmetry operators)\n",nsymbt);
    printf("emapread>   LSKFLG = %8d  (flag for skew transformation: =0 none)\n",nsymbt);
    printf("emapread>     ARMS = %8.3f  (standard deviation of density)\n",arms);
    extx = *lx; exty = *ly; extz = *lz; nvox = extx*exty*extz;

    /* notes and error checks */
#ifdef Alpha
    if(fabs(alpha-90.0)>0.001||fabs(beta-90.0)>0.001||fabs(gamma-90.0)>0.001)
#else
    if(abs(alpha-90.0)>0.001||abs(beta-90.0)>0.001||abs(gamma-90.0)>0.001)
#endif
    {
      fprintf(stderr, "emapread> Error:  This version only works for rectangle images.  alpha, beta, gamma=%8.2f %8.2f %8.2f\n",alpha,beta,gamma); 
      exit(1);
    }
    if ((int)mode != 2) {
      fprintf(stderr, "emapread> Error: map %s is not in float mode (variable MODE=%d)\n", fname,mode); 
      exit(1);
    }
 
    if ((int)lskflg != 0) {
      fprintf(stderr, "emapread> Error: Skew transformations are not supported (variable LSKFLG) \n"); 
/*      exit(1); */
    }
    headlen=nfloat-nvox;
  printf("emapread>    headlen = %d  (headlengthy)\n",headlen);
    if (headlen>276) {
      fprintf(stderr, "emapread> Error: file %s is too long \n", fname); 
      exit(1);   
    } 
     
    if (headlen<256) {
      fprintf(stderr, "emapread> Error: file %s is too short or data is unreadable \n", fname); 
      exit(1);   
    } 

#if defined(hpux)
    testa = 100*alpha+0.5; testb = 100*beta+0.5; testg = 100*gamma+0.5;
#else
    testa = (long)floor(100*alpha+0.5); testb = (long)floor(100*beta+0.5); testg = (long)floor(100*gamma+0.5);
    if (testa != 9000 || testb != 9000 || testg != 9000) orom = 0;
#endif

    *dx = xlen /  mx;
    *dy = ylen /  my;
    *dz = zlen /  mz;    

    ordermode = 7;
    if ((int)mapc==1 && (int)mapr==2 && (int)maps==3) ordermode = 1;
    if ((int)mapc==1 && (int)mapr==3 && (int)maps==2) ordermode = 2;
    if ((int)mapc==2 && (int)mapr==1 && (int)maps==3) ordermode = 3;
    if ((int)mapc==2 && (int)mapr==3 && (int)maps==1) ordermode = 4;
    if ((int)mapc==3 && (int)mapr==1 && (int)maps==2) ordermode = 5;
    if ((int)mapc==3 && (int)mapr==2 && (int)maps==1) ordermode = 6;
    if (ordermode == 7) {
      fprintf(stderr, "emapread> Error: could not assign axes (variables MAPC,MAPR,MAPS)\n"); 
      exit(1);
    }
    for(count=0;count<nvox;count++)
      {
       junk= *(farr+headlen+conindex(ordermode,count,extx,exty,extz));
       *(rho+count)=junk;
      }
    free (farr);
    printf("\nemapread>   %8d points are read for image grids\n",nvox);
      return 1;
}

#if hpux || ibmrs
int emapwrite(char *fname,int *nsx,int *nsy,int *nsz, int *lx, int *ly, int *lz,
   double *dx, double *dy, double *dz, float *rho)
#else
int emapwrite_(char *fname,int *nsx,int *nsy,int *nsz, int *lx, int *ly, int *lz,
   double *dx, double *dy, double *dz, float *rho)
#endif
{
  char filename[80];
  int nfloat,longbyte,floatbyte,charbyte;
  FILE *fin;
  long nx, ny, nz, mx, my, mz;
  long mode,ljunk;
  float xlen, ylen, zlen, alpha, beta, gamma;
  long mapc, mapr, maps,ispg,lskflg,nsymbt,extra[15];
  float amin, amax, amean, amean2, arms;
  float rhoi;
  float skwmat[9], skwtrn[3];
  char maplabel[4], machst[4];
  int extx, exty, extz;
  unsigned long  nvox;
  int i, j;
  char junkchar;
  int maperror;
  junkchar = '\0';
  longbyte=4;
  floatbyte=4;
  charbyte=1;
  ljunk=0;
    i=0;
    while(fname[i]==' '||fname[i]=='"'||fname[i]=='\'')i++;
    j=0;
    while(fname[i]!=' '&&fname[i]!='"'&&fname[i]!='\''&&
          fname[i]!='\0')filename[j++]=fname[i++];
    filename[j]='\0';
    fin = fopen(filename, "wb");
    if( fin == NULL ) {
      fprintf(stderr, "emapread> Error: Can't open file %s! \n", fname); 
      exit(1);   
    }
    nfloat = (*lx)*(*ly)*(*lz);
    mx=*lx;
    my=*ly;
    mz=*lz;
    nx=mx;
    ny=my;
    nz=mz;
    xlen=(*dx)*(*lx);
    ylen=(*dy)*(*ly);
    zlen=(*dz)*(*lz);
    alpha=90.0;
    beta=90.0;
    gamma=90.0;
    mode=2;
    mapc=1;
    mapr=2;
    maps=3;
    amin=10000;
    amax=-1000;
    amean=0.0;
    amean2=0.0;
    for(i=0;i<nfloat;i++)
      {
      rhoi=rho[i];
      amean+=rhoi;
      amean2+=rhoi*rhoi;
      if(rhoi>amax)amax=rhoi;
      if(rhoi<amin)amin=rhoi;
      }
    amean/=nfloat;
    amean2/=nfloat;
    arms=sqrt(amean2-amean*amean);
    lskflg=0;
    nsymbt=0;
    ispg=1;
    ljunk=0;
    printf("emapwrite>       NC = %8d  (# columns)\n",nx); 
    printf("emapwrite>       NR = %8d  (# rows)\n",ny); 
    printf("emapwrite>       NS = %8d  (# sections)\n",nz); 
    printf("emapwrite>     MODE = %8d  (data type: 2 = stored as floats)\n",mode); 
    printf("emapwrite>  NCSTART = %8d  (index of first column)\n",*nsx); 
    printf("emapwrite>  NRSTART = %8d  (index of first row)\n",*nsy);
    printf("emapwrite>  NSSTART = %8d  (index of first section)\n",*nsz);
    printf("emapwrite>       NX = %8d  (# of X intervals in unit cell)\n",mx); 
    printf("emapwrite>       NY = %8d  (# of Y intervals in unit cell)\n",my);
    printf("emapwrite>       NZ = %8d  (# of Z intervals in unit cell)\n",mz);
    printf("emapwrite> X length = %8.3f  (unit cell dimension)\n",xlen);
    printf("emapwrite> Y length = %8.3f  (unit cell dimension)\n",ylen);
    printf("emapwrite> Z length = %8.3f  (unit cell dimension)\n",zlen);
    printf("emapwrite>    Alpha = %8.3f  (unit cell angle)\n",alpha);
    printf("emapwrite>     Beta = %8.3f  (unit cell angle)\n",beta);
    printf("emapwrite>    Gamma = %8.3f  (unit cell angle)\n",gamma);
    printf("emapwrite>     MAPC = %8d  (columns axis: 1=X)\n",mapc); 
    printf("emapwrite>     MAPR = %8d  (rows axis: 2=Y)\n",mapr);
    printf("emapwrite>     MAPS = %8d  (sections axis: 3=Z)\n",maps);
    printf("emapwrite>     AMIN = %8.3f  (minimum density value)\n",amin);
    printf("emapwrite>     AMAX = %8.3f  (maximum density value)\n",amax);
    printf("emapwrite>    AMEAN = %8.3f  (mean density value)\n",amean);
    printf("emapwrite>     ISPG = %8d  (ignored: space group number)\n",ispg);
    printf("emapwrite>   NSYMBT = %8d  (ignored: # bytes used for storing symmetry operators)\n",nsymbt);
    printf("emapwrite>   LSKFLG = %8d  (flag for skew transformation: =0 none)\n",nsymbt);
    printf("emapwrite>     ARMS = %8.3f  (standard deviation of density)\n",arms);
    extx = nx; exty = ny; extz = nz; nvox = extx*exty*extz;

    /* notes and error checks */
#ifdef Alpha
    if(fabs(alpha-90.0)>0.001||fabs(beta-90.0)>0.001||fabs(gamma-90.0)>0.001)
#else
    if(abs(alpha-90.0)>0.001||abs(beta-90.0)>0.001||abs(gamma-90.0)>0.001)
#endif
    {
      fprintf(stderr, "emapwrite> Error:  This version only works for rectangle images.  alpha, beta, gamma=%8.2f %8.2f %8.2f\n",alpha,beta,gamma); 
      exit(1);
    }

    printf("emapwrite> Write header information from CCP4 file  %s \n", filename); 
    maperror=0;
    if (fwrite(lx, longbyte, 1, fin)!=1) maperror=1;
    if (fwrite(ly, longbyte, 1, fin)!=1) maperror=1;
    if (fwrite(lz, longbyte, 1, fin)!=1) maperror=1;
    if (fwrite(&mode, longbyte, 1, fin)!=1) maperror=1;
    if (fwrite(nsx, longbyte, 1, fin)!=1) maperror=1;
    if (fwrite(nsy, longbyte, 1, fin)!=1) maperror=1;
    if (fwrite(nsz, longbyte, 1, fin)!=1) maperror=1;
    if (fwrite(&mx, longbyte, 1, fin)!=1) maperror=1;
    if (fwrite(&my, longbyte, 1, fin)!=1) maperror=1;
    if (fwrite(&mz, longbyte, 1, fin)!=1) maperror=1;
    if (fwrite(&xlen, floatbyte, 1, fin)!=1) maperror=1;
    if (fwrite(&ylen, floatbyte, 1, fin)!=1) maperror=1;
    if (fwrite(&zlen, floatbyte, 1, fin)!=1) maperror=1;
    if (fwrite(&alpha, floatbyte, 1, fin)!=1) maperror=1;
    if (fwrite(&beta, floatbyte, 1, fin)!=1) maperror=1;
    if (fwrite(&gamma, floatbyte, 1, fin)!=1) maperror=1;
    if (fwrite(&mapc, longbyte, 1, fin)!=1) maperror=1;
    if (fwrite(&mapr, longbyte, 1, fin)!=1) maperror=1;
    if (fwrite(&maps, longbyte, 1, fin)!=1) maperror=1;
    if (fwrite(&amin, floatbyte, 1, fin)!=1) maperror=1;
    if (fwrite(&amax, floatbyte, 1, fin)!=1) maperror=1;
    if (fwrite(&amean, floatbyte, 1, fin)!=1) maperror=1;
    if (fwrite(&ispg, longbyte, 1, fin)!=1) maperror=1;
    if (fwrite(&nsymbt, longbyte, 1, fin)!=1) maperror=1;
    if (fwrite(&lskflg, longbyte, 1, fin)!=1) maperror=1;
    if (fwrite(skwmat, floatbyte, 9, fin)!=9) maperror=1;
    if (fwrite(skwtrn, floatbyte, 3, fin)!=3) maperror=1;
    if (fwrite(extra, longbyte, 15, fin)!=15) maperror=1;
    if (fwrite(maplabel, charbyte, 4, fin)!=4) maperror=1;
    if (fwrite(machst,charbyte, 4, fin)!=4) maperror=1;
    if (fwrite(&arms, floatbyte, 1, fin)!=1) maperror=1;
    if (fwrite(&ljunk, longbyte, 1, fin)!=1) maperror=1;
    for (i=0;i<800;++i) if (fwrite(&junkchar, charbyte, 1, fin)!=1) maperror=1;
    fwrite(rho,floatbyte,nfloat,fin);
    printf("\nemapwrite>   %8d points are written for image grids\n",nfloat);

    if (maperror != 0) {
      fprintf(stderr, "emapwrite> Error: Can't write to CCP4 file \n"); 
      exit(1);   
    }
    fclose(fin);

      return 1;
}


 int conindex (int menumode, unsigned long count, int extx, int exty, int extz)
/* returns the converted index */

{ int i,j,k,q; 

  k = count / (extx*exty);
  q = count - k*extx*exty;
  j = q / extx;
  i = q - j*extx;
  switch (menumode) {
  case 1:
    return i+j*extx+k*extx*exty;
  case 2:
    return i+k*extx+j*extx*extz;
  case 3:
    return j+i*exty+k*exty*extx;
  case 4:
    return j+k*exty+i*exty*extz;
  case 5:
    return k+i*extz+j*extz*extx;
  case 6:
    return k+j*extz+i*extz*exty;
  default:
    fprintf(stderr, "conindwx> Error: Could not identify option \n"); 
    exit(1);   
  }
  return -1;
}
