/* CHARMM Element source/machdep/cstuff.c */

/* include files */

#include <assert.h>
#include <ctype.h>
#include <stdio.h>
#include <signal.h>

#ifndef terra
#include <pwd.h>
#include <sys/param.h>
#include <sys/time.h>
#endif

#ifdef t3x
#include <sys/types.h>
#include <sys/times.h>
#include <stdio.h>
#include <pwd.h>
#endif

#if defined(VMS) || defined(machine_fujitsu) || defined(terra) || defined(hal)
#include <string.h>
#else
#include <strings.h>
#endif

#if gnu
#include <time.h>
#include <sys/times.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/utsname.h>
#include <netdb.h>
#include <sys/file.h>
#include <sys/stat.h>
#endif

#if __convex__ || hpux || ibmrs || cray || machine_aix370 || VM || MVS || defined(machine_hp700)
#include <sys/file.h>
#include <sys/resource.h>
#include <sys/stat.h>
#if t3x || osx
#else
#include <sys/sysinfo.h>
#endif
#include <sys/times.h>
#include <sys/types.h>
#endif

#if cray || t3x
#include <fortran.h>
#include <unistd.h>
#include <time.h>	/* CLK_TCK */
#endif

#ifdef machine_titan
#include <sys/types.h>
#include <sys/times.h>
#endif

#if sgi
#define __stdc__
#include <sys/utsname.h>
#include <netdb.h>
#endif

#if hpux
/* #define machine_hp700 */
#undef __convex__  /* nedded for Convex Exemplar SPP-1000 */
#endif

#ifdef gnu
#undef hpux  /* This is for running GNU compilers on hpux */
#endif

#ifdef i8
#define INT long
#else 
#define INT int
#endif


/******************************************/
/*          start of generic code         */
/******************************************/

/******************** fmalloc *************/
#if ibmrs || hpux || ether
char *fmalloc(reqlen)
#else

#if t3x
char *FMALLOC(reqlen)
#else
char *fmalloc_(reqlen)
#endif

#endif

unsigned INT *reqlen;
{
   char *malloc();
   return malloc(*reqlen);
}    /* fmalloc_*/

/******************** free ****************/
#ifdef ether
void ffree(address)
#else
void ffree_(address)
#endif
INT *address;
{ free(*address); }

/******************** fsystem *************/
/*

This function is better than system() because it does not
replicate program's memory requirements

*/
#ifndef terra
#if t3x
int FSYSTEM(com,ll)
#else
#if hpux || ibmrs
int fsystem(com,ll)
#else
INT fsystem_(com,ll)
#endif
#endif
     char *com ;
     INT *ll;
{
  FILE *a ; char c;
  INT stat;

  com[*ll] = 0x0 ;
  /* AvdV Moved this to machutil.src so we can control it with prnlev
     printf("Invoking: %s\n",com); */
  if ( (a = popen(com,"r")) == NULL ) {
    printf("popen: Cannot create process\n") ;
    exit(-2) ;
  }
  /* Read the shell's stream and put it to the stdout*/
#if sgi
  while ( (c = getc(a) ) != '\377' ) putchar(c) ;
#else
  while ( (c = getc(a) ) != EOF ) putchar(c) ;
#endif
  /* Wait to finish with this command */
  stat=pclose(a) ;
  return(stat);
}
#endif /* terra */

/******************** gethdir *************/
#ifndef terra
#if t3x || cray
void GETHDIR(res, len, env, ll)
#else
#if hpux || ibmrs
void gethdir(res, len, env, ll)
#else
void gethdir_(res, len, env, ll)
#endif
#endif
char *res, *env;
INT *len, *ll;
{
  struct passwd *hdir ; char *tmp, *tmpenv, *malloc() ; INT i;
/* Initialize result in case of error */
  *len = 0; res[0] = 0x0 ;
  tmpenv = malloc( *ll + 1) ;
  strncpy(tmpenv,env, *ll); tmpenv[*ll] = 0x0 ;
  hdir = getpwnam(tmpenv);
  tmp = hdir->pw_dir ;
/* If original string didn't match the username, try
   all lower case letters */
  if ( tmp == NULL ){
    for (i=0;i<strlen(tmpenv);i++)
      tmpenv[i] = tolower(tmpenv[i]) ;
    hdir = getpwnam(tmpenv); tmp = hdir->pw_dir ;
  }
  if ( tmp != NULL ){
    strcpy(res,tmp); i = strlen(res) ;
    res[i] = '/' ; i++ ;
    *len = i ;
  }

/*
  printf ("users %s home directory is %s\n",env, hdir->pw_dir);
  printf ("string is %d long\n",*len);
*/
}
#endif /* terra */

/******************** fgetpid *************/
#if t3x
void FGETPID(pid)
#else
#if hpux || ibmrs
void fgetpid(pid)
#else
void fgetpid_(pid)
#endif
#endif
INT *pid;
{
  *pid=getpid();
}

/******************** fgetenv *************/
#if t3x
void FGETENV(res, len, env)
#else
#if hpux || ibmrs
void fgetenv(res, len, env)
#else
void fgetenv_(res, len, env)
#endif
#endif
char *res, *env;
INT *len;
{
  char *tmp, *getenv() ;
  *len = 0; res[0] = 0x0 ;
  tmp = getenv(env) ;
  if ( tmp != NULL ){
    strcpy(res,tmp);
    *len = strlen(res) ;
  }
/*  printf("strlen(fgetenv(%s)=%s)=%d\n",env,res,*len); */
}


/******************** fputenv *************/
#ifndef terra
#if cray || t3x
void FPUTENV(env,t,ll)
#else
#if hpux || ibmrs
void fputenv(env,ll)
#else
void fputenv_(env,ll)
#endif
#endif
char env[];
INT  *ll ;
#if t3x
int t ;
#endif
{
  INT i; char *malloc() ;
#if __convex__
  int p; char *nam, *val, *pp ;
  pp = strchr(env,'='); p = pp - env ;
  nam = malloc(*ll) ; val = malloc(*ll) ;
  strncat(nam,env,p) ; strcpy(val,&env[p+1]) ;
  nam[p] = 0x0 ; i = setenv(nam,val,1);
#else
#if t3x
  char *p ;
  /* Each call create new string to hold environment! */
  p = malloc(*ll) ; strncat(&p[0],env,*ll) ;
  i=putenv(p);
#else
  char *p ;
  /* Each call creates new string to hold environment! */
  p = malloc(*ll) ; strcpy(p,env) ;
  i=putenv(p);
#endif /* t3x */
#endif /* _convex_ */
  if(i != 0 ) {
    printf("fputenv=%d\n",i);
    perror("fputenv problem"); exit(110);
  }
}
#endif /* terra */

/******************** frealloc ************/
char *frealloc_(ptr,reqlen)
char **ptr;
unsigned *reqlen;
{
   char *realloc();
   return realloc(*ptr,*reqlen);
}    /* frealloc_*/


/******************** filcpy **************/
void filcpy_(from,lfrom,to,lto,errint,nfrom,nto)
char *from,*to;
INT *lfrom,*lto,*errint;
INT nfrom,nto;
{
    char *tfrom,*tto;
    char *malloc();
    FILE *fpto,*fpfrom,*fopen();
/*    void fclose();  */
    INT ch;

/* get memory for temporary file name strings */
    if ( (tfrom = malloc(*lfrom + 1)) == NULL) {
        printf("Error from malloc in filcpy (from)\n");
        *errint = -1;
        return;
    }
    if ( (tto = malloc(*lto + 1)) == NULL) {
        printf("Error from malloc in filcpy (to)\n");
        *errint = -1;
        return;
    }
/* now copy the strings and null terminate them. */
    strncpy(tfrom,from,*lfrom);
    tfrom[*lfrom] = '\0';
    strncpy(tto,to,*lto);
    tto[*lto] = '\0';
/* now open the files */
    if( (fpto = fopen(tto,"w")) == NULL) {
       printf("Error from fopen in filcpy (to)\n");
       *errint = -1;
       return;
    }
    if( (fpfrom = fopen(tfrom,"r")) == NULL) {
       printf("Error from fopen in filcpy (from)\n");
       *errint = -1;
       return;
    }
/* now actually copy the files */
    while ( (ch = getc(fpfrom)) != EOF ) putc(ch,fpto);
/* now close the files, free the memory and return */
    fclose(fpto);
    fclose(fpfrom);
    free(tto);
    free(tfrom);
    *errint = 0;
    return;
}    /* filcpy_*/

/*******************getunamef *************/
#ifndef terra
#if cray || defined(machine_titan) || t3x
void GETUNAMEF(name, namelen)
#else
#if ibmrs || hpux
void getunamef(name, namelen)
#else
void getunamef_(name, namelen)
#endif
#endif
    char        *name;
    INT         *namelen;
{
    char        *getlogin();
/*    struct passwd *getpwuid(),*getpwptr; */
#ifndef __stdc__
    struct passwd *getpwuid(),*getpwptr;
#else
    struct passwd *getpwptr;
#endif
    char        *username;
    INT         usernamelen;

#if VM || MVS
    if ((username = COM_getusername()) == NULL) return;
#else
    if ((username = getlogin()) == NULL) {
       if ( (getpwptr = getpwuid(getuid())) == NULL) return;
       username = getpwptr->pw_name;
    }
#endif
    usernamelen = strlen(username);

    if(usernamelen > *namelen)
        usernamelen = *namelen;

    strncpy(name, username, usernamelen);

}    /* getunamef_*/
#endif /* terra */

/*******************  etime   *************/
#if ibmrs || hpux || cray || machine_aix370 || VM || MVS || defined(machine_hp700) || defined(machine_titan) || gnu || t3x

#if defined(machine_titan)
#define CLK_TCK HZ
#endif
#if defined(CLOCKS_PER_SEC)     /* fix for glibc-2.4 */
#define CLK_TCK CLOCKS_PER_SEC
#endif
#if ibmrs
#include <time.h>
#endif

#if cray || t3x
float ETIME(tarray)
#else /* ibmrs || hpux ... */
#if gnu
float etime_(tarray)
#else
float etime(tarray)
#endif
#endif
float *tarray;
{
   struct tms buffer;
   times(&buffer);
   tarray[0] = (double)(buffer.tms_utime)/CLK_TCK;
   tarray[1] = (double)(buffer.tms_stime)/CLK_TCK;
   return (tarray[0] + tarray[1]);
}    /* etime */
#endif

#if cray || t3x
void UNBUFIO(unit)
#else
#if hpux || ibmrs
void unbufio(unit)
#else
void unbufio_(unit)
#endif
#endif
INT * unit;
{ 
  setvbuf(stdout,(char *)0,_IONBF,0);
}

/*******************************************/
/*          end of generic code            */
/*          start of machine specific code */
/*******************************************/

#ifdef t3x

#include <unistd.h>
int GET_CLK()
{
	return (sysconf(_SC_CLK_TCK));
}
int GET_MY_PE()
{
  extern long int _MPP_MY_PE;
  return (_MPP_MY_PE);
}
int GET_NUM_PES()
{
  extern long int _MPP_N_PES;
  return (_MPP_N_PES);
}
LOG2NPES(void)
{
        extern long int _MPP_LOG2_N_PES;
        return (_MPP_LOG2_N_PES);
}
void PSTART(inode,nodes)
  int *inode, *nodes;
{
  extern long int _MPP_N_PES;
  extern long int _MPP_MY_PE;

  *nodes = _MPP_N_PES;
  *inode = _MPP_MY_PE;
  if (_MPP_MY_PE == 0){
    printf("PSTART: USING PVM3 \n");}
}

void FLUSH()
{
    fflush(stdout);
}

/***********************************************************************/
/*    shmem_get_f: shared memory get for fast communication            */
/*                                                                     */
/***********************************************************************/
/*
void SHMEM_GET_F(a,b,length,npe)
     int  istat;
     int *length,*npe;
     double a[],b[];
{
  istat =  shmem_get(a,b,*length,*npe);
}
*/
/***********************************************************************/
/*    shmem_put_f: shared memory get for fast communication            */
/*                                                                     */
/***********************************************************************/
/*
void SHMEM_PUT_F(a,b,length,npe)
     int  istat;
     int *length,*npe;
     double a[],b[];
{
  istat =  shmem_put(b,a,*length,*npe);
}
*/
#endif /* t3x */

#if terra

#include <Ttimelib.h>
#include <Tmdc.h>

int terra_date_time_(int* month,int *day, int* year,
                    int* hours,int *minutes, int* seconds)
{

time_t current_time;
struct tm current_broken_time;
int    rc;

       Ttime_time(&current_time);
       rc = gmtime_r(&current_time,&current_broken_time);

       *month =  current_broken_time.tm_mon;
       *day   =  current_broken_time.tm_mday;
       *year  =  current_broken_time.tm_year,
       *hours =  current_broken_time.tm_hour;
       *minutes = current_broken_time.tm_min;
       *seconds = current_broken_time.tm_sec;

       return(rc);
}

void
taskdelay_()
{
/*  taskDelay(sysClkRateGet() * 10); */
  int i;
  for (i=0;i<50000000;i++) i*i*i;
}
#endif /* terra */

#if __convex__
/***** getcpu *****/
void getcpu_(int *nthread,int *nthread_max)
{
/*     nthread: number of processors available to the process.
       nthread_max: hardware number of processors.
            nthread <= nthread_max.
*/
        struct  rlimit rlp;
        getrlimit(RLIMIT_CONCUR,&rlp);
        *nthread = rlp.rlim_cur;
        *nthread_max = rlp.rlim_max;
}    /* getcpu_*/

/***** setcpu *****/
int setcpu_(int *nthread)
{
        struct  rlimit rlp;

        getrlimit(RLIMIT_CONCUR,&rlp);
        if (*nthread > rlp.rlim_max) return -1;
        rlp.rlim_cur = *nthread;
        return setrlimit(RLIMIT_CONCUR,&rlp);
}    /* setcpu_*/

/***** setstk *****/
void setstk_()
{
/* set the stacksize to unlimited. */
        struct  rlimit rlp;
        getrlimit(RLIMIT_STACK,&rlp);
        rlp.rlim_cur = RLIM_INFINITY;
        setrlimit(RLIMIT_STACK,&rlp);
        return;
}    /* setstk_*/

/***** getsysinfo *****/
int getsysinfo_(sn,type,ncpus)
int *sn,*type,*ncpus;
{       /* getsysinfo_ */
    int                         i;
    int                         bit;
    time_t                              clock;
    char                                hostname[132];
    struct system_information   sysinfo;
    extern int                  errno;

    if ( getsysinfo(SYSINFO_SIZE, &sysinfo ) == -1 ) {
        fprintf( stderr, "? getsysinfo failed: %d\n", errno );
        return(1);
    }

    *sn = sysinfo.system_sn;
    *type = sysinfo.cpu_type;
    *ncpus = sysinfo.cpu_count;
        return(0);

}    /* getsysinfo_*/

/***** isecond *****/
long isecond_()
{
   struct timeval tp;
   struct timezone tzp;

   if (gettimeofday(&tp,&tzp) != 0)
       return 0;
   else
       return tp.tv_sec;
}    /* isecond_*/

#endif

#if Alpha

/* we use the loc function provided by DU */
#else

#if ibmrs || defined(machine_aix370) || defined(machine_fujitsu) || VM || MVS || gnu
/***** loc *****/
#if machine_aix370 || gnu
int loc_(numb)
#else
INT loc(numb)
#endif
INT *numb;
{
      return (INT) numb;
}    /* loc */
#endif

#endif

#if ibmrs || machine_aix370
/***** chdir_ *****/
#if ibmrs
#define DIR_LEN dir_len
#else /* machine_aix370 */
#define DIR_LEN *dir_len
#endif
INT chdir_(dir, dir_len)
char *dir;
INT  DIR_LEN;
{
        int i;
        char *cwd;
        char *malloc();
        INT result;

        /* get the directory name space */
        cwd = malloc(DIR_LEN+1);

        /* back scan the blanks out */
        for(i=DIR_LEN ; i==0 ;i--) {
                if(dir[i-1] != ' ') break;
        }

        /* copy that many characters and null terminate it */
        strncpy(cwd, dir, i);
        cwd[i] = '\0';

        /* call chdir */
        result = chdir(cwd);

        /* free the memory */
        free(cwd);

        /* tell the caller what happened */
        return(result);
}
#endif


#if hpux || ibmrs || machine_aix370 || VM || MVS || gnu
/***** fdate *****/
#if gnu
void fdate_(s)
#else
void fdate(s)
#endif
char *s;
{
        char *ctime(), *c;
        time_t time(), t;

        t = time(0);
        c = ctime(&t);
        strncpy(s, c, 24);
}    /* fdate */

/***** itime
#if gnu
void itime_(timearray)
#else
void itime(timearray)
#endif
INT *timearray;
{
	struct tm *tp;
	time_t timer;

	time(&timer);
	tp = localtime(&timer);

	timearray[2] = tp->tm_sec;
	timearray[1] = tp->tm_min;
	timearray[0] = tp->tm_hour;
}     itime */
#endif

#if hpux
void cflush(out)
FILE *out ;
{
  setbuf(out, NULL);
}
#endif

/***** chngbuf *****/
#if cray || defined(machine_titan)
void CHNGBUF(lun,pos,error)
#else
#if __convex__ || unix || defined(machine_hp700) || gnu
void chngbuf_(lun,pos,error)
#else
void chngbuf(lun,pos,error)
#endif
#endif
INT *lun, *error, *pos;
{
   extern INT funits_fd();
   char *bufptr, *malloc();
   *error = 0;
#if ! defined(machine_hp700) && ! defined(machine_titan)
   if (*lun == -1 || *lun == -2 || *lun == 6) {
       setlinebuf(stdout);
       return;
   }
   if (*lun == 0) {
       setlinebuf(stderr);
       return;
   }
#endif
   return;
/*
code is commmented out since it doesn't work.
however some of the stuff may be usefull for other
things. shf

   if ( (fd=funits_fd(*lun)) == -1) {
       *error = -1;
       return;
   }
*/
   /* now try to get type of file */
/*
   if ((flag = fcntl(fd,F_GETFL,0)) & O_RDONLY)
       return;
   else if ( flag & O_WRONLY )
       strcpy(type, "w");
   else if ( flag & O_RDWR )
       strcpy(type,"r+");
   else {
       *error = -1;
       return;
   }
   if ( (fp=fdopen(fd,type)) == NULL) {
       *error = -1;
       return;
   }
   printf("chgbuf_: pos: %d\n",*pos);
   if ( (bufptr = malloc(128)) == NULL) {
       *error = -1;
       return;
   }
   setbuffer(fp,bufptr,128);
   if (*pos > 0 ) fseek(fp,*pos,0);
*/
   /*setlinebuf(fp);*/
/*
   fprintf(fp,"chgbuf_: pos: %d\n",*pos);
   return;
*/
}    /* chngbuf_*/

#ifdef cray
#include <unistd.h>
void
GETCPU(ncpu, max_ncpu)
   int  *ncpu;
   int  *max_ncpu;
{
   char *env_value;
   extern long sysconf();
   char *getenv();

   *max_ncpu = sysconf(_SC_CRAY_NCPU);
   if (env_value = getenv("NCPUS")) {
      sscanf(env_value,"%d",ncpu);
      if (*ncpu < 1)
         fprintf(stderr,"Wrong NCPUS=%s\n",env_value);
   }
   else *ncpu=0;

   if (*ncpu > *max_ncpu)
      printf("You have asked for more processors than are physically available\n");
   if (*ncpu < 1 || *ncpu > *max_ncpu)
      *ncpu = *max_ncpu;
   printf("Will be using %d processor%s (maximum is %d)\n",
          *ncpu, ((*ncpu == 1) ? "" : "s"), *max_ncpu);
}

/***** numcpu *****/
/* Returns the number of physical processors on the system. */
NUMCPU()
{
        extern long sysconf();
        return(sysconf(_SC_CRAY_NCPU));
}

#endif

#if defined(VM) || defined(MVS)
void ftxpwrt(message,len)
    char        *message;
    int         *len;
{
    char        *string;
    void        txpwrite();
    int         ii;

    if ((string = malloc((*len)+1)) == NULL)
       fprintf (stderr, "Error in ftxpwrt: no memory\n");
    else
    {
       for (ii=0; ii<*len; ii++)
          *(string+ii) = *(message+ii);
       *(string+ii) = '\0';
       txpwrite(string);
       free (string);
    }
    return;
}

void txpwrite(message)
    char        *message;
{
    fprintf(stderr, "%s\n", message); fflush(stderr);
}
#endif

#ifdef machine_hp700
chdir_(dir,len)
char *dir;
int len;
{
	chdir(dir,len);
}
#endif

#if defined(cray) || defined(machine_aix370) || defined(VM) || defined(MVS)
void
#if defined(cray) || defined(VM) || defined(MVS)
CSYSTEM(command,cmdlen)
#else
csystem_(command,cmdlen)
#endif
#if defined(cray)
_fcd command;
#else
char *command;
#endif
INT  *cmdlen;
{
   char *cstring;
   INT   status;
   void  COM_tolower();

   if ((cstring = malloc(*cmdlen+1)) == NULL) {
      fprintf(stderr, "No memory for %d bytes in CSYSTEM\n", *cmdlen+1);
   }
   else {
#ifdef cray
      strncpy(cstring, _fcdtocp(command), *cmdlen);
#else
      strncpy(cstring, command, *cmdlen);
#endif
      cstring[*cmdlen] = '\0';
      if ((status = system(cstring)) != 0)
         fprintf(stderr, "command '%s' status=%d\n",cstring,status);
      free(cstring);
   }
   *cmdlen = 0;     /* nothing else to process in the command string */
}
#endif

#if gnu || sgi || ibmrs
#if ibmrs
double xsecnds(p)
#else
double xsecnds_(p)
#endif
double *p ;
{
  struct timeval t; struct timezone tz; double r ;
  gettimeofday(&t, &tz) ;
  r = (double) t.tv_sec + (double) t.tv_usec / 1000000.0 ;
/*    printf("R = %f, P = %f\n", r, *p ) ; */
  return ( r - *p ) ;
}
#endif

#ifdef ether

void getlog(name)
char name[];
{
  char *getlogin() ;
  if ( (name = getlogin()) == NULL ) strcpy(name,"hp-par") ;
}

void setlinebuf(i)
int i ;
{
/* empty routine but it should flush buffer after each line
   is written on output
*/
}

#endif

#if apollo
int ieor_(i,j)
int *i, *j ;
{
      return ( *i ^ *j ) ;
}
#endif

#if gnu || sgi

#if parcmd
void uninf_(sy,l,hn,lhn)
     char sy[], hn[];
INT *l, *lhn;
{
  struct hostent *h ;
  struct utsname inf ;
  char lsy[1000];

  uname(&inf) ;
  h = gethostbyname(inf.nodename) ;

  *lhn = strlen(h->h_name) ; 
  *lhn = ( *lhn > 80 ) ? 80 : *lhn ;
  strncpy(hn,h->h_name,*lhn);

  sprintf(lsy,"%s-%s(%s)@%s",
          inf.sysname,inf.release,inf.machine,h->h_name);
  *l = strlen(lsy) ;
  *l = ( *l > 44 ) ? 44 : *l ;
  strncpy(sy,lsy,*l);
}
#else
void uninf_(sy,l)
     char sy[];
INT *l;
{
  struct hostent *h ;
  struct utsname inf ;
  char lsy[1000];

  uname(&inf) ;
  h = gethostbyname(inf.nodename) ;

  sprintf(lsy,"%s-%s(%s)@%s",
          inf.sysname,inf.release,inf.machine,h->h_name);
  *l = strlen(lsy) ;
  *l = ( *l > 44 ) ? 44 : *l ;
  strncpy(sy,lsy,*l);
}
#endif
#endif

#if gnu

unsigned INT ishft_(i,j)
INT *i, *j ;
{
  return ( ( *j > 0 ) ? *i << *j : *i >> *j ) ;
}

unsigned INT iand_(i,j)
     INT *i, *j ;
{
  return ( *i & *j ) ;
}

unsigned INT ior_(i,j)
     INT *i, *j ;
{
  return ( *i | *j ) ;
}
unsigned INT ieor_(i,j)
     INT *i, *j ;
{
  return ( *i ^ *j ) ;
}

/* empty routine but it should flush buffer after each line
   is written on output

   Commented out altogether IAW
*/
/*void setlinebuf(i)
FILE *i ;
{
}*/

/*void malloc_()
{
  printf("malloc() not yet supported with GNU.\n");
  }*/

#endif

#if altix
void malloc_()
{
  printf("malloc() not yet supported with Altix GNU compilers.\n");
}

void timef_()
{
  printf("timef() not yet supported with Altix GNU compilers.\n");
}
#endif

#if TIMESTAMP

#define MAXSTAMP 100

static INT tzero, tpoint ;
static char stamptext[MAXSTAMP][80] ;


INT time_stamp_init__()
{
  struct tm *tm ; time_t tt ;
  time(&tt) ;
  tm = localtime(&tt) ;
  tpoint = 0 ;
  tzero = tm->tm_gmtoff ;
  return tm->tm_gmtoff ;
}


INT time_stamp__(INT *me, char *txt, INT *len)
{
  struct timeval t ; struct timezone z ;
  INT s ;
  gettimeofday( &t, &z );
  s = t.tv_sec ;
  s = (s+tzero) % 86400 ;
  if (tpoint < MAXSTAMP )
    {
      sprintf(stamptext[tpoint++],
	      "ME=%d;%02d:%02d:%02d.%06u %s %d\n",
	      *me, s / 3600, ( s % 3600 ) / 60, s % 60,
	      (unsigned long)t.tv_usec, txt, *len);
    }
  else printf("Time stamp memory exhausted\n");
}

#include <mpi.h>

INT flush_time_stamp__(INT *mynod, INT *numnod)
{
  /*
       This routine is complicated because it avoids overwriting
       from other nodes...
  */
  INT i,k,npoint;
  MPI_Status status ;
  char line[80] ;

  if (*mynod == 0)
    {
      for (i=0;i<tpoint;i++) printf("%s",stamptext[i]);
      for (k=1;k< *numnod;k++)
	{
	  MPI_Recv(&npoint,1,MPI_INT,k,1,MPI_COMM_WORLD,&status) ;
	  for (i=1;i<npoint;i++)
	    {
	      MPI_Recv(line,80,MPI_BYTE,k,1,MPI_COMM_WORLD,&status) ;
	      printf("%s",line);
	    }
	}
    }
  else
    {
      MPI_Send(&tpoint,1,MPI_INT,0,1,MPI_COMM_WORLD) ;
      for (i=0;i<tpoint;i++)
	MPI_Send(&stamptext[i],80,MPI_BYTE,0,1,MPI_COMM_WORLD) ;
    }

  return tpoint ;
}

#endif

#ifdef SCHED
#include <sched.h>
void rtsched_(INT *statpri)
{
  struct sched_param p ;
  p.sched_priority = *statpri ;
  if ( sched_setscheduler(0, SCHED_FIFO, &p) == -1 )
    {
      perror("Kernel Real Time SCHED failed") ;
      exit(201);
    }
}
#endif

#ifdef gnu_oldlib
/* This works only for old RadHat systems: */
/* floating point exception for x86-based GNU system */

#include <fpu_control.h>
void __attribute__ ((constructor))
trapfpe () {
   (void) __setfpucw (_FPU_DEFAULT &
                      ~(_FPU_MASK_IM | _FPU_MASK_ZM | _FPU_MASK_OM));
}
#endif

/****************** TESTENDIAN routines ***********************************/

#define TESTENDIAN_VERBOSE 0
/*=========================================================================
   MFC TSRI 2004
   routines to test for reversed endian binary trajectory files.
   Also tests for files written with 64 bit integers in header records
   In current form, these routines assume that all integers passed
   are 32 bit integers, pointers and everything else is assumed 32 bit.
   Perhaps later we can expand to calling these routines from 64 bit
   machines........mfc
   =======================================================================*/

/**************************************************
           binarytesthdrr
**************************************************/
#if ibmrs || hpux
/*void binarytesthdrr(int *iunit,   char *fname, int *flenf,       FILE **ptrs, 
  int *rev_flag, int *maxun, int *firstreclen, int* prnlev)*/
void binarytesthdrr(INT *iunit,   char *fname, INT *flenf,       FILE **ptrs, 
                    INT *rev_flag, INT *maxun, int *firstreclen, INT* prnlev)
#else
void binarytesthdrr_(int *iunit, char *fname, int *flenf, FILE **ptrs, int *rev_flag,int *maxun, int *firstreclen, int* prnlev)
#endif
{
  FILE *funit;
  typedef union _bytes{
    char a[4];
    int i;
  }bytes;
  bytes h,hrev,htest;
  int j,itest=84,itest8=164,native=1;
  char hdrr[5],filename[256];
  int flen,fnum;

  flen=*flenf;
  fnum=(int)*iunit -1;
  strncpy(filename,fname,flen);
  filename[flen]='\0';
  if(TESTENDIAN_VERBOSE)printf(">>TESTENDIAN file name is %s %d\n",filename,strlen(filename));
  if(TESTENDIAN_VERBOSE)printf(">>TESTENDIAN prnlev is %d\n",*prnlev);
  if(TESTENDIAN_VERBOSE)printf(">>TESTENDIAN iunit is %d\n",*iunit);
  
  htest.i=itest;
  if( (funit=fopen(filename,"r")) == NULL){
    if(*prnlev > 5)printf(">>TESTENDIAN Could not open file %s \n",filename);
    return;
  }
  for(j=0;j<4;j++){
    h.a[j]=fgetc(funit);
    hrev.a[3-j]=h.a[j];
  }
  for(j=0;j<4;j++)hdrr[j]=fgetc(funit);hdrr[4]='\0';
  if(TESTENDIAN_VERBOSE)printf(">>TESTENDIAN read %s %s\n",filename,hdrr);



  if( (strcmp(hdrr,"CORD") == 0 ) || (strcmp(hdrr,"VELO")==0)){
    if(*prnlev > 5)printf(">>TESTENDIAN Trajectory file: %s\n",hdrr);
  }else{
    if(*prnlev > 5)printf(">>TESTENDIAN Not a Trajectory file %s\n",filename);
    if(*prnlev > 5)printf(">>TESTENDIAN Cannot test endian, treating as if native.\n");
    fclose(funit);
    return;
  }

  /*------------------------------------------------------------
       Check byte order and size of first record
    -------------------------------------------------------------*/
  if(*prnlev>5)
    printf(">>TESTENDIAN  comparing (fwd %d, rev %d) to %d\n",
	   h.i,hrev.i,itest);
  if(h.i == itest){
    native=1;
    *firstreclen=itest;
    for(j=0;j<4;j++){
      if(h.a[j] != htest.a[j])
	if(*prnlev > 5)printf(">>TESTENDIAN ints match but byte order different \n");
    }
  }else if(h.i == itest8){
    native=1;
    *firstreclen=itest8;
  }else if(hrev.i == itest){
    native=-1;
    *firstreclen=itest;
  }else if(hrev.i == itest8){
    native=-1;
    *firstreclen=itest8;
  }else{
      if(*prnlev > 5)printf(" Nothing matches \n");
  }
  if(native == 1){
    if(*prnlev > 5)printf(">>TESTENDIAN endian is native, reclen %d\n",
			  *firstreclen);
    if(*prnlev > 5)printf(">>TESTENDIAN Using normal CHARMM i/o\n\n");
    fclose(funit);
    return;
  }else{
    if(*prnlev > 4)printf(">>TESTENDIAN endian is reversed, reclen %d\n",
			  *firstreclen);
    if(*prnlev > 4)printf(">>TESTENDIAN  Reversing byte order in reading file\n\n");
  }
  *rev_flag=1;
  ptrs[fnum]=funit;
    
  rewind(funit);
  return;
}

/**************************************************
           binary read hdrr
 **************************************************/
#if ibmrs || hpux
void binaryreadhdrr(INT *iunit,FILE **funitp, char *hddr, int icntrl[20],INT *error)
#else
void binaryreadhdrr_(int *iunit,FILE **funitp, char *hddr, int icntrl[20],int *error)
#endif
{
  FILE *funit;
  typedef union _bytes{
    char a[4];
    int i;
  }bytes;
  bytes input,h,hrev,htest;
  int j,k,itest=84;
  int fnum;

  fnum=*iunit-1;
  funit=funitp[fnum];

  htest.i=itest;
  /*   Get record length  */
  for(j=0;j<4;j++)h.a[3-j]=fgetc(funit);
  if(h.i != itest){
    if(TESTENDIAN_VERBOSE)printf(">>TESTENDIAN read hdrr ERROR, reversed endian but int does not match\n\n");
    *error=-1;
    return;
  }
  for(j=0;j<4;j++)hddr[j]=fgetc(funit);
  for(k=0;k<20;k++){
    for(j=0;j<4;j++)h.a[3-j]=fgetc(funit);
    icntrl[k]=h.i;
  }
  /*   Get record length  after read */
  for(j=0;j<4;j++)h.a[3-j]=fgetc(funit);
  if(h.i != itest){
    if(TESTENDIAN_VERBOSE)printf(">>TESTENDIAN read ERROR, initial reclen does not match end\n\n");
    *error=-1;
    return;
  }
}
/**************************************************
           binary rd titl
 **************************************************/
#if ibmrs || hpux
void binaryrdtitl(INT *iunit, char *title, INT *ntitle, FILE **fptr, 
                  INT *iwidth, int *error)
#else
void binaryrdtitl_(int *iunit, char *title, int *ntitle, FILE **fptr, int *iwidth, 
		   int *error)
#endif
{
  FILE *funit;
  typedef union _bytes{
    char a[4];
    int i;
  }bytes;
  bytes input,h;
  int i,j,fnum;
  int reclen,nchar;
  long ntitl8;

  fnum=*iunit-1;
  funit=fptr[fnum];
  if(TESTENDIAN_VERBOSE)printf(">>TESTENDIAN BinaryRdTitl\n");
  /* --- get reclen --- */
  for(j=0;j<4;j++)h.a[3-j]=fgetc(funit);
  if(TESTENDIAN_VERBOSE)printf(">>TESTENDIAN rdtitle %d\n",h.i);
  reclen=h.i;

  /* --- get ntitle --- */
  for(j=0;j<4;j++)h.a[3-j]=fgetc(funit); *ntitle=h.i;
  if(TESTENDIAN_VERBOSE)printf(">>TESTENDIAN rdtitle Ntitle: %d\n",*ntitle);
  nchar=*ntitle * *iwidth;
  
  for(i=0;i<nchar;i++)title[i]=fgetc(funit);
  
  /*
  j=0;
  for(i=0;i<*ntitle;i++){
    if(TESTENDIAN_VERBOSE)printf(">>TESTENDIAN %d",i);
    for(k=0;k<*iwidth;k++)putchar(title[j++]);
    putchar('\n');
  }
  */
  /*   Get record length  after read */
  for(j=0;j<4;j++)h.a[3-j]=fgetc(funit);
  if(h.i != reclen){
    if(TESTENDIAN_VERBOSE)printf(">>TESTENDIAN read ERROR, initial reclen does not match end\n\n");
    *error=-1;
    return;
  }


}  /* end binaryreadtitle */

/**************************************************
           binary read ints
 **************************************************/
#if ibmrs || hpux
void binaryreadints(INT *iunit, FILE **fptr, INT *ibuf, INT *numread, 
		   INT *error)
#else
void binaryreadints_(int *iunit, FILE **fptr, int *ibuf, int *numread, 
		   int *error)
#endif
{
  FILE *funit;
  typedef union _bytes{
    char a[4];
    int i;
  }bytes;
  bytes h;
  int i,j,fnum;
  int reclen;

  fnum=(int) (*iunit-1);
  funit=fptr[fnum];
  if(TESTENDIAN_VERBOSE)printf(">>TESTENDIAN BinaryReadints\n");
  /* --- get reclen --- */
  for(j=0;j<4;j++)h.a[3-j]=fgetc(funit);
  reclen=h.i;
  if(TESTENDIAN_VERBOSE)printf(">>TESTENDIAN BinaryReadints reclen %d\n",h.i);
  if(TESTENDIAN_VERBOSE)printf(">>TESTENDIAN BinaryReadints reading %d\n",*numread);

  for(i=0;i<*numread;i++){
    for(j=0;j<4;j++)h.a[3-j]=fgetc(funit);
    ibuf[i]=h.i;
  }
  
  /*   Get record length  after read */
  for(j=0;j<4;j++)h.a[3-j]=fgetc(funit);
  if(h.i != reclen){
    if(TESTENDIAN_VERBOSE)printf(">>TESTENDIAN read ERROR, initial reclen does not match end\n\n");
    *error=-1;
    return;
  }


}

/**************************************************
           binary read floats
 **************************************************/
#if ibmrs || hpux
void binaryreadfloats(INT *iunit,FILE **fptr, float *fbuf, INT *numread, 
		   INT *error)
{
#else
void binaryreadfloats_(int *iunit,FILE **fptr, float *fbuf, int *numread, 
		   int *error)
{
#endif
  FILE *funit;
  typedef union _bytes{
    char a[4];
    int i;
    float f;
  }bytes;
  bytes h;
  int i,j,fnum;
  int reclen;

  fnum=*iunit-1;
  funit=fptr[fnum];
  /*  printf(">>TESTENDIAN BinaryReadFloats\n");*/
  /* --- get reclen --- */
  for(j=0;j<4;j++)h.a[3-j]=fgetc(funit);
  reclen=h.i;

  for(i=0;i<*numread;i++){
    for(j=0;j<4;j++)h.a[3-j]=fgetc(funit);
    fbuf[i]=h.f;
  }
  
  /*   Get record length  after read */
  for(j=0;j<4;j++)h.a[3-j]=fgetc(funit);
  if(h.i != reclen){
    if(TESTENDIAN_VERBOSE)printf(">>TESTENDIAN read ERROR, initial reclen %d does not match end\n    lately reading %d floats\n\n", reclen,*numread);
    *error=-1;
    return;
  }


}
/**************************************************
           binary read doubles
 **************************************************/
#if ibmrs || hpux
void binaryreaddoubles(INT *iunit,FILE **fptr, double *fbuf, INT *numread, 
		   INT *error)
{
#else
void binaryreaddoubles_(int *iunit,FILE **fptr, double *fbuf, int *numread, 
		   int *error)
{
#endif
  FILE *funit;
  typedef union _longbytes{
    char a[8];
    long i;
    double f;
  }longbytes;
  typedef union _bytes{
    char a[4];
    int i;
    float f;
  }bytes;
  bytes h;
  longbytes hh;
  int i,j,fnum;
  int reclen;

  fnum=*iunit-1;
  funit=fptr[fnum];
  /*  printf(">>TESTENDIAN BinaryReadFloats\n");*/
  /* --- get reclen --- */
  for(j=0;j<4;j++)h.a[3-j]=fgetc(funit);
  reclen=h.i;

  for(i=0;i<*numread;i++){
    for(j=0;j<8;j++)hh.a[7-j]=fgetc(funit);
    fbuf[i]=hh.f;
  }
  
  /*   Get record length  after read */
  for(j=0;j<4;j++)h.a[3-j]=fgetc(funit);
  if(h.i != reclen){
    if(TESTENDIAN_VERBOSE)printf(">>TESTENDIAN read ERROR, initial reclen %d does not match end\n    lately reading %d floats\n\n", reclen,*numread);
    *error=-1;
    return;
  }


}
/**************************************************
           binary rewind
 **************************************************/
#if ibmrs || hpux
void binaryrewind(INT *iunit,FILE **fptr)
#else
void binaryrewind_(int *iunit,FILE **fptr)
#endif
{
  FILE *funit;
  int fnum;

  fnum=*iunit-1;

  if(TESTENDIAN_VERBOSE)printf("Trying to rewind %d \n",fnum);
  funit=fptr[fnum];
  rewind(funit);
}
/**************************************************
           binary close
 **************************************************/
#if ibmrs || hpux
void binaryclose(INT *iunit, FILE **fptr)
#else
void binaryclose_(int *iunit, FILE **fptr)
#endif
{
  FILE *funit;

  funit=fptr[*iunit-1];
  fclose(funit);
}

/*********************************************
          osx_g95_getpointer
********************************************/

int osx_g95_getpointer__(double *a)
{
  return (int)&*a;
}
