C $Header: /export/cvs/c34a1/source/moldyn/CSTIFF.INC,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
c
c
c      COMMON BLOCK FOR MOLECULAR SUBSTRUCTURING
c
c      Uses new parameter:  L72 = L01*(6+L06) + L02 + 6
c
c      Let IFB be the body number of the fragment (1 <= IFB <= NFB <= L01)
c
c      Then:  iatoms(1,IFB) = first atom in fragment
c             iatoms(2,IFB) = last atom in fragment
c             iatoms(3,IFB) = number of atoms in fragment
c
c      Notes: iatoms(3,IFB) = iatoms(2,IFB) - iatoms(1,IFB) + 1
c             iatoms(1,IFB+1) = iatoms(2,IFB) + 1
c
c      Let IATM be the atom number (1 <= IATM <= NATOM <= L43*L01)
c
c             rtemp = reference temperature
c
c             gk = stiffness matrix for molecule
c
c             phi(1,1,I) = I-th mode shape for molecule
c
c             freq(I) = I-th modal frequency for molecule
c
c             phibod(1,1,K,L) = K-th kept mode shape for L-th fragment
c
c             (cgnom(I,L),I=1,3) = Center of mass of L-th fragment
c
c             (cgadj(I,L),I=1,3) = Center of mass offset of L-th fragment
c
c             theta(I,L) = Euler rotation (1-2-3) of L-th fragment
c
c             amdamp(K,L) = K-th modal amplitude for L-th fragment
c
c             gvec = vector of initial rigid rates and modal velocities
c                    for all fragments
c
c             rvec(1,M) = bond vector (inertial coords.) for M-th bond
c
c             (ibconn(i,M),i=1,2) = fragment body numbers corresponding to
c                                   M-th bond
c
c             (ihconn(i,M),i=1,2) = hinge numbers corresponding to M-th bond
c
c             nconn = number of interfragment bonds
c
c             nfb = number of fragments
c
c             k0, koff = offsets used in constructing the 'AMAT' matrix
c                              in subroutine CMPIC1
c
c             nummod = number of molecular modes inputted from data file
c
C 
C 
C 
C
c      integer iatoms(3,L01),iaconn(2,L02),ibconn(2,L02),ihconn(2,L02)
      integer iatoms(3,L01)
      integer iiaconnptr,iibconnptr,iihconnptr,iiconnhptr
c      integer iconnh(L02)
      integer nconn,k0(L01),koff,nummod
c      double precision freq(L06*L01)
      double precision cgnom(3,L01+1),cgadj(3,L01),theta(3,L01)
c      double precision amdamp(L06,L01),gvec(L72),rvec(3,L02)
c      double precision rvec(3,L02)
      integer irvecptr
c      double precision uconn(6,L02),rtemp
      double precision rtemp
      integer iuconnptr
c
c    Pointers to location in HEAPMB  
      integer ifreqptr, iamdampptr, igvecptr
c
      common /cstiff/ rtemp, 
     *                cgnom,cgadj,theta,nummod,
     *                iatoms,nconn,k0,koff,
     *		      ifreqptr, iamdampptr,igvecptr,iiaconnptr,
     *                iibconnptr,iihconnptr,iiconnhptr,irvecptr,
     *                iuconnptr
 
      CHARACTER*128  CSTIFF_RCSID
      DATA           CSTIFF_RCSID
     &/'$RCSfile: CSTIFF.INC,v $$Revision: 1.1.1.1 $'/
