C
C           A T T E N T I O N !!!
C
C !!! THIS FILE EXIST IN source/fcm/ and in source/moldyn/ !!!
C !!! if you modify it do it in both locations             !!!

C $Header: /export/cvs/c34a1/source/moldyn/INTGRL.INC,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C              INCLUDE FILE - INTGRL.INC
C
C :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
c     This include file contains the definition for many of the discos
c     storage matricies.  This is the include file for the packed
c     storage version.  Array packing causes the upper triangular part 
c     of symmetric matrices to to be stored by rows and singly
c     subscripted.  For a 4x4 matrix, the storage locations in a
c     single dimensioned array would be:
c
c          1    2    3    4
c          x    5    6    7
c          x    x    8    9
c          x    x    x   10
c 
c     Thus, the length of the vector required to store the symmetric
c     matrix is  n*(n+1)/2 where n = size of the symmtric matrix.
c
c     The pointer definitions are as follows:
c     ainptr(1)  Points to ak(1,1,1)
c     ainptr(2)  Points to ad(1,1,1)
c     ainptr(3)  Points to amu(1,1,1)
c     ainptr(4)  Points to am(1,1)
c     ainptr(5)  Points to acof(1,1,1)
c     ainptr(6)  Points to bcof(1,1,1)
c     ainptr(7)  Points to cof11(1,1,1)
c     ainptr(8)  Points to cof22(1,1,1)
c     ainptr(9)  Points to cof33(1,1,1)
c     ainptr(10) Points to cof12(1,1,1)
c     ainptr(11) Points to cof13(1,1,1)
c     ainptr(12) Points to cof23(1,1,1)
c     ainptr(13) Points to cofxy(1,1,1)
c     ainptr(14) Points to cofxz(1,1,1)
c     ainptr(15) Points to cofyz(1,1,1)
c    
c     masptr(1,ibody) is offset for first element of amu(1,1,ibody)
c     masptr(2,ibody) is offset for first element of packed array 
c      am(1,ibody)
c     masptr(3,ibody) is offset for first element of acof(1,1,ibody)
c     masptr(4,ibody) is offset for first element of bcof(1,1,ibody)
c     masptr(5,ibody) is offset for first element of cofxy(1,1,ibody), 
c                     cof12, etc.
c     masptr(6,ibody) is offset for first element of packed version of 
c      ak(1,1,ibody), ad(1,1,ibody), cof11(1,1,ibody), 
c      etc.
c
c     Variable definitions for new, packed configuration
C     The space for AINTGL is dynamically allocated.  POINTER type 
C     allow the pointer alptr to be associate with the array AINTGL.
c     POINTER (alptr, AINTGL) !moved to HEAPMB.INC
c     DOUBLE PRECISION AINTGL(*)
      INTEGER ainptr(15), masptr(6,l01)
      COMMON /INTPCK/ ainptr, masptr
C
c     Original Storage (from include file INTGRL.INC):
c     double precision am(l59, l01), acof(9, l06, l01),
c    &      bcof(  6, l06, l01), cof11(l06, l06, l01),
c    &     cof22(l06, l06, l01), cof33(l06, l06, l01),
c    &        ak(l06, l06, l01), cof12(l06, l06, l01),
c    &     cof13(l06, l06, l01), cof23(l06, l06, l01),
c    &        ad(l06, l06, l01), cofxy(l06, l06, l01),
c    &     cofxz(l06, l06, l01), cofyz(l06, l06, l01)
c     common /intgrl/
c    &       am, acof, bcof, cof11, cof22, cof33, ak,
c    &       cof12, cof13, cof23, ad, cofxy, cofxz, cofyz
c
c     Remnants of original storage to be replaced at a later date
c
#ifdef AMBER
c
c     This standard version allows arbitrary ordering of bodies and atoms
c
c     These are pointers to the original variables now stored on HEAP_MB.
c
      INTEGER iam_ptr(l01+1),iacfptr(L01+1),
     &  ibcfptr(L01+1)
      INTEGER ic11ptr(L01+1),ic22ptr(L01+1),
     &  ic33ptr(L01+1),ic12ptr(L01+1),
     &  ic13ptr(L01+1),ic23ptr(L01+1),icxyptr(L01+1),
     &  icxzptr(L01+1),icyzptr(L01+1)
#else
C
C     This more efficient version relies on CHARMM ordering of bodies first,
C     then atomistic particles.
C
c     These are pointers to the original variables now stored on HEAP_MB.
c
      INTEGER iam_ptr(l01+1),iacfptr(MAXBOD+1),
     &  ibcfptr(MAXBOD+1)
      INTEGER ic11ptr(MAXBOD+1),ic22ptr(MAXBOD+1),
     &  ic33ptr(MAXBOD+1),ic12ptr(MAXBOD+1),
     &  ic13ptr(MAXBOD+1),ic23ptr(MAXBOD+1),icxyptr(MAXBOD+1),
     &  icxzptr(MAXBOD+1),icyzptr(MAXBOD+1)
#endif
      common /intgrlc/
     &      iam_ptr,iacfptr,ibcfptr,ic11ptr,
     &      ic22ptr,ic33ptr,ic12ptr,ic13ptr,
     &      ic23ptr,icxyptr,icxzptr,icyzptr
 
      CHARACTER*128  INTGRL_RCSID
      DATA           INTGRL_RCSID
     &/'$RCSfile: INTGRL.INC,v $$Revision: 1.1.1.1 $'/
