C $Header: /export/cvs/c34a1/source/moldyn/MULTIPOLE.INC,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C ========================================================================
C
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER 
C STATE AND FEDERAL LAWS.  USE, DISCLOSURE, REPRODUCTION OR DUPLICATION 
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS 
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT 
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
c
c
      LOGICAL idovfma   ! flag to indicate that vfma is used
      LOGICAL internal_atom
      COMMON /vflags/ idovfma, internal_atom
c
      INTEGER noderiv, i1stderiv, i2nderiv       ! Options to gen_Ymn
      PARAMETER (noderiv=0, i1stderiv=1, i2nderiv=2)
c
      DOUBLE PRECISION coulomb       !  Coulomb coefficient in atomic
c
c     The following value is used by AMBER
c
      PARAMETER (coulomb=1D0)        !  Amber internal units
c
c     The following value is used by X-PLOR
c
c      PARAMETER (coulomb=1.389354D5) !  mass units * Ang^3 /(ps^2 * 
c                                     !  electron charge^2)
      DOUBLE PRECISION eps_mac       !  Machine epsilon
      PARAMETER (eps_mac = 1.0D-16)
c
c     master particle list format:
c     number of particles in first box, first atom number, second atom number,
c     ...,
c     number of particles in second box, first atom number in second box, ...,
c     etc.
c     Storage is packed.  Use of this list relies on pointers stored in 
c     list_pointer.
c
c      INTEGER master_particle_list(L03+MAX_EL)
c      INTEGER me_degree        ! Order of the multipole expansions
c      INTEGER mpadd1           ! Order of the multipole expansions+1
c      INTEGER me_ptr_list(MAX_EL),fe_ptr_list(MAX_EL)
c
c      COMMON /MEDATA/ me_degree, mpadd1, master_particle_list,
c     &                me_ptr_list, fe_ptr_list
c
c
c      INTEGER          ibox_head(0:MAX_LEVEL,L01)
c      COMMON /BOXPTRS/ ibox_head
c
c      COMPLEX*16 Mmn(MAXME,MAX_EL) ! Stores the Mmn coefficients 
c      COMPLEX*16 Pot(MAXME,MAX_EL) ! Stores the PE coefficients
c      COMPLEX*16 Lmn(L11,MAXFE,MAX_EL) ! Stores the Lmn coeffs.
c      INTEGER ibndex(MAX_EL)       !
c      INTEGER jbndex(MAX_EL)       ! i,j,k index of box location
c      INTEGER kbndex(MAX_EL)       !
c      INTEGER nchild(MAX_EL)       ! number of non-empty children boxes
c      INTEGER parent(MAX_EL)       ! box number of current box's parent
c      INTEGER list_pointer(MAX_EL) ! pointer into master particle list
c      INTEGER children(8,MAX_EL)   ! box numbers of current box's children
c      INTEGER apply_array(MAX_PAIRS,2), array_short(MAX_PAIRS,2) 
c      INTEGER num_pairs_short, num_atpairs_tot
c      LOGICAL Mmn_flag(MAX_EL)     ! TRUE if ME is already computed
c      LOGICAL Lmn_flag(MAX_EL)     ! TRUE if LE is already computed
c      COMMON /boxdata/ Mmn, Pot, Lmn, ibndex, jbndex, kbndex, nchild,
c     &     parent, list_pointer, children, apply_array, array_short, 
c     &     num_pairs_short, num_atpairs_tot, Mmn_flag, Lmn_flag
c
c
c     Storage location for multipole coefficients
c
c      INTEGER me_size,fe_size
c      COMPLEX*16 cme_coeff(MAX_EL*MAXME)           !  ME coefficients
c      COMPLEX*16 clep(MAX_EL*MAXME)                !  LE to energy transf.
c      COMPLEX*16 clef(3,MAX_EL*MAXFE)              !  LE to force transf.
c      COMPLEX*16 clet(3,MAX_EL*MAXFE)              !  LE to torque transf
c      COMPLEX*16 clem(L06,MAX_EL*MAXFE)            !  LE to modal force transf.
c      COMPLEX*16 cYmn((2*MAXDEG+1)*(MAXDEG+1))     !  Scratch storage for Zmn
c      DOUBLE PRECISION Pmn((2*MAXDEG+1)*(2*MAXDEG+2)/2)  !  Scratch storage
c      COMMON /me_data/ cme_coeff, cYmn, clep, clef, clet, clem, Pmn
c      COMMON /me2dat/  me_size,fe_size
      DOUBLE PRECISION dP((MAXDEG+1)*(MAXDEG+2)/2)
      DOUBLE PRECISION d2P((MAXDEG+1)*(MAXDEG+2)/2)
      COMMON /test_deriv/ dP, d2P
c
      INTEGER lmax(L01)            !  Number of levels in each body
      INTEGER nboxes(0:MAX_LEVEL,L01)!  Number of boxes at each level & body
      INTEGER particle_bound(2,L01)  !  stores the start/end cell for ibody 
      DOUBLE PRECISION  dimen0       !  Physical dimension at all level 0's
      DOUBLE PRECISION  unit         !  box unit, unit = 2**level * dimen0
      DOUBLE PRECISION  d_factor     !  Box distance>d_factor*unit,apply me
      DOUBLE PRECISION  c_factor     !  Separation criteria for throw calls
      DOUBLE PRECISION  c_crit       !  Separation criteria from c_factor
      COMMON /body_dta/ dimen0, unit, d_factor, c_factor, 
     &     c_crit, particle_bound, lmax, nboxes
c
      DOUBLE PRECISION factrl(0:4*MAXDEG)
      DOUBLE PRECISION afunc(-2*MAXDEG:2*MAXDEG,0:2*MAXDEG)
      COMMON /tables/ factrl, afunc
 
      CHARACTER*128  MULTIPOLE_RCSID
      DATA           MULTIPOLE_RCSID
     &/'$RCSfile: MULTIPOLE.INC,v $$Revision: 1.1.1.1 $'/

