C $Header: /export/cvs/c34a1/source/moldyn/TIMING.INC,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
C 
C 
C
c
c  This common block contains the timing variables
c
c
c     Timer(irk4)      = Total time spent in RK integration
c     Timer(ivfma)     = Total time spent in recurring vfma calculations
c     Timer(ivf0)      = Time spent initializing the vfma algorithm
c     Timer(imbond0)   = Time spent initializing MBO(N)D (includes vfma)
c     Timer(inon_vfma) = Total time spent in non-vfma force calcs.
c     Timer(iggv)      = Time spent initializing and accumulating ggv
c     Timer(icenter)   = Time spent computing system configuration
c     Timer(ilocate)   = Time spent determining separations and sizes
c     Timer(igrab)     = Time spent processing grab algorithm
c     Timer(ibuild)    = Time spent building up the ME's
c     Timer(imonkey)   = Time spent in monkey algorithm
c     Timer(iclean)    = Time spent sweeping interactions from root to bodies
c     Timer(ilemer)    = Time spent in lemer
c     Timer(ifbmi)     = Time spent in ME-based fbmi
c     Timer(ifbatom)   = Time spent in atomistic fbmi
c
c (ioutput should be numbered last)
c     Timer(ioutput)   = Total time spent in output between integration steps.
c
      INTEGER irk4, ivfma, ivf0, imbond0, inon_vfma, iggv, icenter
      INTEGER ilocate, ibuild, imonkey, iclean, ilemer, ifbmi, ifbatom
      INTEGER ioutput, igrab
      PARAMETER (irk4=1, ivfma=2, ivf0=3, imbond0=4, inon_vfma=5)
      PARAMETER (iggv=6, icenter=7, ilocate=8, igrab=15, ibuild=9)
      PARAMETER (imonkey=10)
      PARAMETER (iclean=11, ilemer=12, ifbmi=13, ifbatom=14)
      PARAMETER (ioutput=16)
c
      INTEGER nrk4       !  Number of RK4 steps taken
      INTEGER nfrc_call  ! Number of force function evaluations
      DOUBLE PRECISION timer(16)
      COMMON /TIMING/ timer, nrk4, nfrc_call



 
      CHARACTER*128  TIMING_RCSID
      DATA           TIMING_RCSID
     &/'$RCSfile: TIMING.INC,v $$Revision: 1.1.1.1 $'/
