C $Header: /export/cvs/c34a1/source/moldyn/addt.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
      FUNCTION ADDT (IC,T)
CSE
C                                                          DEBUG # 105
CPS        PURPOSE:
C
C                  A USER SUPPLIED FUNCTION. USED TO DEFINE THE
C                  ACCELERATION PROFILE FOR RHENOMICALLY CONSTRAINED
C                  COORDINATE 'IC'. THAT IS, TO PROVIDE THE
C                  ALPHA DOUBLE DOT TERM IN EQUATION II-6, VOL 1
C
C                 BEST APPROACH IS TO SIMPLY DEFINE ADT AND ADDT
C                 DIRECTLY IN FUNCTION STATEMENTS AND TO BE EXTREMELY
C                 CAREFUL WITH JUMP DISCONTINUITIES IN ADT.
C
C
CPE
CIS
C
C         FUNCTIONS ADT & ADDT  DEFINE RHEONOMIC CONSTRAINTS
C         --------------------------------------------------
C
C     ASSUME THAT AT HINGE POINT L, RELATIVE MOTION WITH RESPECT TO
C         DEGREE OF FREEDOM I IS RHEONOMICALLY CONSTRAINED.
C         LET
C                      NN = 6*(L-1) + I
C         THEN
C               ADDT(NN,T) = USER PRESCRIBED MAGNITUDE OF THE SECOND
C                            TIME DERIVATIVE OF BETAH(I,L) AT TIME T
C                ADT(NN,T) = USER PRESCRIBED MAGNITUDE OF THE FIRST
C                            TIME DERIVATIVE OF BETAH(I,L) AT TIME T
C         WHERE BETAH IS DEFINED ABOVE UNDER THE TITLE 'KINEMATIC DATA
C         INPUTTED AND COMPUTED'
C
CIE
      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: addt.f,v $$Revision: 1.1.1.1 $'/
      INTEGER IC
      DOUBLE PRECISION ADDT,T
C
#include "PARAM.FOR"
C
#include "VECTOR.INC"
      ADDT = 0.0
      RETURN
      END
