C $Header: /export/cvs/c34a1/source/moldyn/bh2.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C ========================================================================
C
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER 
C STATE AND FEDERAL LAWS.  USE, DISCLOSURE, REPRODUCTION OR DUPLICATION 
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS 
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT 
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C

      SUBROUTINE BH2(bhq,bhp,hatsq,hatsp,ihinge,ihpvt,pin,itopol,
     &               rh,dh)
c
c     PURPOSE:
c     Assemble the stored parts of BH when called by bhgenr.
c     Anything that is stored elsewhere is not stored in BH.
c
c
c     bhq      Q-frame to be assembled
c     bhp      P-frame to be assmbled
c     hatsq    hats for the qframe
c     hatsp    hats for the qframe
c     ihinge   hinge number
c

      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: bh2.f,v $$Revision: 1.1.1.1 $'/
C
#include "PARAM.FOR"
C
#include "BHBSRD.INC"
#include "LDEBUG.INC"
#include "PARTCL.INC"
#include "PINRP.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
C
C     Passed Variables
C
      INTEGER ihinge
      INTEGER ihpvt(cL02)
      INTEGER itopol(2,cL02)
      DOUBLE PRECISION bhq(3,*), bhp(3,*)
      DOUBLE PRECISION hatsq(3,*), hatsp(3,*)
      DOUBLE PRECISION pin(3,3,cL02)
      DOUBLE PRECISION rh(3,3,cL15)
      DOUBLE PRECISION dh(3,cL16)
C
C     Local Variables
C
      DOUBLE PRECISION W1(3,3),W2(3,3)
      INTEGER I, J
      INTEGER NOBP, NOBQ, NMP, NMQ
      INTEGER LP, LQ
      INTEGER LR3, LR4, LR5, LD3, LD4, LD5
      LOGICAL LEQU

C
C     Equivalences
C
      EQUIVALENCE (LEQU,DEBUG(45))
C
C
      IF(LEQU) WRITE (MBOUT,1000)
 1000 FORMAT (' SUBROUTINE BH2 ')
C
         nobp = itopol(2,ihinge)
         nobq = itopol(1,ihinge)
c
         LQ = 2*ihinge - 2
         LP = LQ + 1
C
C        LQ = 2,4,6,...
C        LP = 3,5,7,...
C        BH(LP) = EQUATION II-82, VOL 1
C        BH(LQ) = EQUATION II-83, VOL 1
C
         LR3 = 6*(ihinge-2) + 3
         LR4 = LR3 + 1
         LR5 = LR3 + 2
         LD3 = 7*(ihinge-2) + 3
         LD4 = LD3 + 1
         LD5 = LD4 + 1
         NMQ = IRGFLX(NOBQ)
         NMP = IRGFLX(NOBP) 
C
         if (nobp .GT. nbdy) go to 19      ! If not, both are bodies
C
C          [qRn]  = W1              [nRq] = RH(LR3) = IDENTITY
C          [qRp]  = W2              [pRq] = RH(LR5)
C         -[pRm]  = Bp(2,2)         [mRp] = IDENTITY
C                                   [C2]**(-1) = RH(LR4)
C
         DO 25 I=1,3
            DO 25 J=1,3
               W2(J,I) = RH(I,J,LR5)
 25      continue

C                 [Bq(2,2)] = [pRq] [qRn]
         if (ihpvt(ihinge) .NE. 0) then
CC@CC
CC@CC ......MULT3 rh(1,1,lr4), rh(1,1,lr5), bhq(1,4)
CC@CC ......3, 3, 3
CC@CC ......3, 3, 3
      bhq(1,4) = rh(1,1,lr4)*rh(1,1,lr5) + rh(1,2,lr4)*rh(2,1,lr5) + rh(
     .1,3,lr4)*rh(3,1,lr5)
      bhq(2,4) = rh(2,1,lr4)*rh(1,1,lr5) + rh(2,2,lr4)*rh(2,1,lr5) + rh(
     .2,3,lr4)*rh(3,1,lr5)
      bhq(3,4) = rh(3,1,lr4)*rh(1,1,lr5) + rh(3,2,lr4)*rh(2,1,lr5) + rh(
     .3,3,lr4)*rh(3,1,lr5)
      bhq(1,5) = rh(1,1,lr4)*rh(1,2,lr5) + rh(1,2,lr4)*rh(2,2,lr5) + rh(
     .1,3,lr4)*rh(3,2,lr5)
      bhq(2,5) = rh(2,1,lr4)*rh(1,2,lr5) + rh(2,2,lr4)*rh(2,2,lr5) + rh(
     .2,3,lr4)*rh(3,2,lr5)
      bhq(3,5) = rh(3,1,lr4)*rh(1,2,lr5) + rh(3,2,lr4)*rh(2,2,lr5) + rh(
     .3,3,lr4)*rh(3,2,lr5)
      bhq(1,6) = rh(1,1,lr4)*rh(1,3,lr5) + rh(1,2,lr4)*rh(2,3,lr5) + rh(
     .1,3,lr4)*rh(3,3,lr5)
      bhq(2,6) = rh(2,1,lr4)*rh(1,3,lr5) + rh(2,2,lr4)*rh(2,3,lr5) + rh(
     .2,3,lr4)*rh(3,3,lr5)
      bhq(3,6) = rh(3,1,lr4)*rh(1,3,lr5) + rh(3,2,lr4)*rh(2,3,lr5) + rh(
     .3,3,lr4)*rh(3,3,lr5)
CC@CC end of expanded call
CC@CC
         end if
C
C                 W1  =  -[qRp][pRm] = -[qRp] = - W2
C
C                                  -1
C                 [Bp(1,1)] = -[PI]  [qRp][pRm]
CC@CC
CC@CC ......MULT3N PIN(1,1,ihinge), W2, BHP(1,1)
CC@CC ......3, 3, 3
CC@CC ......3, 3, 3
      BHP(1,1) = -PIN(1,1,ihinge)*W2(1,1) - PIN(1,2,ihinge)*W2(2,1) - PI
     .N(1,3,ihinge)*W2(3,1)
      BHP(2,1) = -PIN(2,1,ihinge)*W2(1,1) - PIN(2,2,ihinge)*W2(2,1) - PI
     .N(2,3,ihinge)*W2(3,1)
      BHP(3,1) = -PIN(3,1,ihinge)*W2(1,1) - PIN(3,2,ihinge)*W2(2,1) - PI
     .N(3,3,ihinge)*W2(3,1)
      BHP(1,2) = -PIN(1,1,ihinge)*W2(1,2) - PIN(1,2,ihinge)*W2(2,2) - PI
     .N(1,3,ihinge)*W2(3,2)
      BHP(2,2) = -PIN(2,1,ihinge)*W2(1,2) - PIN(2,2,ihinge)*W2(2,2) - PI
     .N(2,3,ihinge)*W2(3,2)
      BHP(3,2) = -PIN(3,1,ihinge)*W2(1,2) - PIN(3,2,ihinge)*W2(2,2) - PI
     .N(3,3,ihinge)*W2(3,2)
      BHP(1,3) = -PIN(1,1,ihinge)*W2(1,3) - PIN(1,2,ihinge)*W2(2,3) - PI
     .N(1,3,ihinge)*W2(3,3)
      BHP(2,3) = -PIN(2,1,ihinge)*W2(1,3) - PIN(2,2,ihinge)*W2(2,3) - PI
     .N(2,3,ihinge)*W2(3,3)
      BHP(3,3) = -PIN(3,1,ihinge)*W2(1,3) - PIN(3,2,ihinge)*W2(2,3) - PI
     .N(3,3,ihinge)*W2(3,3)
CC@CC end of expanded call
CC@CC
C                 W1 = [Snq]
      CALL SKEWV3 (DH(1,LD3),W1,1,3)
C
C                 W2 = [Smp]
C
C                 [Bq(2,1)] = [pRq][qRn][Snq]          (regular hinge)
c
C                 [Bq(2,1)] = [C2inv][pRq][qRn][Snq]   (pivot hinge)
      IF (ihpvt(ihinge) .EQ. 0) THEN
CC@CC
CC@CC ......MULT3 rh(1,1,lr5), W1, BHQ(1,1)
CC@CC ......3, 3, 3
CC@CC ......3, 3, 3
      BHQ(1,1) = rh(1,1,lr5)*W1(1,1) + rh(1,2,lr5)*W1(2,1) + rh(1,3,lr5)
     .*W1(3,1)
      BHQ(2,1) = rh(2,1,lr5)*W1(1,1) + rh(2,2,lr5)*W1(2,1) + rh(2,3,lr5)
     .*W1(3,1)
      BHQ(3,1) = rh(3,1,lr5)*W1(1,1) + rh(3,2,lr5)*W1(2,1) + rh(3,3,lr5)
     .*W1(3,1)
      BHQ(1,2) = rh(1,1,lr5)*W1(1,2) + rh(1,2,lr5)*W1(2,2) + rh(1,3,lr5)
     .*W1(3,2)
      BHQ(2,2) = rh(2,1,lr5)*W1(1,2) + rh(2,2,lr5)*W1(2,2) + rh(2,3,lr5)
     .*W1(3,2)
      BHQ(3,2) = rh(3,1,lr5)*W1(1,2) + rh(3,2,lr5)*W1(2,2) + rh(3,3,lr5)
     .*W1(3,2)
      BHQ(1,3) = rh(1,1,lr5)*W1(1,3) + rh(1,2,lr5)*W1(2,3) + rh(1,3,lr5)
     .*W1(3,3)
      BHQ(2,3) = rh(2,1,lr5)*W1(1,3) + rh(2,2,lr5)*W1(2,3) + rh(2,3,lr5)
     .*W1(3,3)
      BHQ(3,3) = rh(3,1,lr5)*W1(1,3) + rh(3,2,lr5)*W1(2,3) + rh(3,3,lr5)
     .*W1(3,3)
CC@CC end of expanded call
CC@CC
      ELSE
CC@CC
CC@CC ......MULT3 BHQ(1,4), W1, BHQ(1,1)
CC@CC ......3, 3, 3
CC@CC ......3, 3, 3
      BHQ(1,1) = BHQ(1,4)*W1(1,1) + BHQ(1,5)*W1(2,1) + BHQ(1,6)*W1(3,1)
      BHQ(2,1) = BHQ(2,4)*W1(1,1) + BHQ(2,5)*W1(2,1) + BHQ(2,6)*W1(3,1)
      BHQ(3,1) = BHQ(3,4)*W1(1,1) + BHQ(3,5)*W1(2,1) + BHQ(3,6)*W1(3,1)
      BHQ(1,2) = BHQ(1,4)*W1(1,2) + BHQ(1,5)*W1(2,2) + BHQ(1,6)*W1(3,2)
      BHQ(2,2) = BHQ(2,4)*W1(1,2) + BHQ(2,5)*W1(2,2) + BHQ(2,6)*W1(3,2)
      BHQ(3,2) = BHQ(3,4)*W1(1,2) + BHQ(3,5)*W1(2,2) + BHQ(3,6)*W1(3,2)
      BHQ(1,3) = BHQ(1,4)*W1(1,3) + BHQ(1,5)*W1(2,3) + BHQ(1,6)*W1(3,3)
      BHQ(2,3) = BHQ(2,4)*W1(1,3) + BHQ(2,5)*W1(2,3) + BHQ(2,6)*W1(3,3)
      BHQ(3,3) = BHQ(3,4)*W1(1,3) + BHQ(3,5)*W1(2,3) + BHQ(3,6)*W1(3,3)
CC@CC end of expanded call
CC@CC
      END IF
C
C                  W1 = [Spq]
C
C     [Bp(2,1)] = -([Smp] + [Spq])            (regular hinge)
C
C     [Bp(2,1)] = -[C2inv]([Smp] + [Spq])     (pivot hinge)
c
         do i = 1, 3
            w1(i,1) = - dh(i,ld4) - dh(i,ld5)
         end do
C
         if (ihpvt(ihinge) .eq. 0) then
            call skewv3(w1,bhp(1,4),3,3)
         else
            call skewv3(w1,w2,1,3)
CC@CC
CC@CC ......MULT3 rh(1,1,lr4), w2, bhp(1,4)
CC@CC ......3, 3, 3
CC@CC ......3, 3, 3
      bhp(1,4) = rh(1,1,lr4)*w2(1,1) + rh(1,2,lr4)*w2(2,1) + rh(1,3,lr4)
     .*w2(3,1)
      bhp(2,4) = rh(2,1,lr4)*w2(1,1) + rh(2,2,lr4)*w2(2,1) + rh(2,3,lr4)
     .*w2(3,1)
      bhp(3,4) = rh(3,1,lr4)*w2(1,1) + rh(3,2,lr4)*w2(2,1) + rh(3,3,lr4)
     .*w2(3,1)
      bhp(1,5) = rh(1,1,lr4)*w2(1,2) + rh(1,2,lr4)*w2(2,2) + rh(1,3,lr4)
     .*w2(3,2)
      bhp(2,5) = rh(2,1,lr4)*w2(1,2) + rh(2,2,lr4)*w2(2,2) + rh(2,3,lr4)
     .*w2(3,2)
      bhp(3,5) = rh(3,1,lr4)*w2(1,2) + rh(3,2,lr4)*w2(2,2) + rh(3,3,lr4)
     .*w2(3,2)
      bhp(1,6) = rh(1,1,lr4)*w2(1,3) + rh(1,2,lr4)*w2(2,3) + rh(1,3,lr4)
     .*w2(3,3)
      bhp(2,6) = rh(2,1,lr4)*w2(1,3) + rh(2,2,lr4)*w2(2,3) + rh(2,3,lr4)
     .*w2(3,3)
      bhp(3,6) = rh(3,1,lr4)*w2(1,3) + rh(3,2,lr4)*w2(2,3) + rh(3,3,lr4)
     .*w2(3,3)
CC@CC end of expanded call
CC@CC
c
            if (nmp .ne. 0) then
CC@CC
CC@CC ......MULT3N rh(1,1,lr4), hatsp, bhp(1,7)
CC@CC ......3, 3, nmp
CC@CC ......3, 3, 3
      CALL DGEMM ('N','N',3,nmp,3,-1.0d0,rh(1,1,lr4),3,hatsp,3,0.0d0,bhp
     .(1,7),3)
CC@CC end of expanded call
CC@CC
            end if
         end if
C
C        IS Q-FRAME IN A RIGID BODY?
         IF (NMQ .GT. 0) THEN
C
C                 [Bq(1,3)] = [Bq(1,1)][SIGq] = 0, since SIGH = 0
C
C                 [Bq(2,3)] = [Bq(2,2)][Hq]
            IF (ihpvt(ihinge) .EQ. 0) THEN
CC@CC
CC@CC ......MULT3 rh(1,1,lr5), HATSQ, BHQ(1,4)
CC@CC ......3, 3, NMQ
CC@CC ......3, 3, 3
      CALL DGEMM ('N','N',3,NMQ,3,1.0d0,rh(1,1,lr5),3,HATSQ,3,0.0d0,BHQ(
     .1,4),3)
CC@CC end of expanded call
CC@CC
            ELSE
CC@CC
CC@CC ......MULT3 BHQ(1,4), HATSQ, BHQ(1,7)
CC@CC ......3, 3, NMQ
CC@CC ......3, 3, 3
      CALL DGEMM ('N','N',3,NMQ,3,1.0d0,BHQ(1,4),3,HATSQ,3,0.0d0,BHQ(1,7
     .),3)
CC@CC end of expanded call
CC@CC
            END IF
         END IF
         GO TO 20       ! BH is finished if both bodies
c
c     Come here only if one of the bodies is a particle
c
 19   continue
c
      IF (nobq .LE. nbdy) THEN
c        body q is a rigid/flex body
c
         if (ihpvt(ihinge) .eq. 0) then
c
c           Hinge is not bonded
c
            if (nmq .gt. 0) then
CC@CC
CC@CC MULT3 r0l(1,1,nobq), hatsq, bhq(1,4)
CC@CC 3, 3, nmq
CC@CC 3, 3, 3
      CALL DGEMM ('N','N',3,nmq,3,1.0d0,r0l(1,1,nobq),3,hatsq,3,0.0d0,bh
     .q(1,4),3)
CC@CC end of expanded call
CC@CC
            end if
            call skewv3(dh(1,ld3),w1,1,3)
CC@CC
CC@CC MULT3 r0l(1,1,nobq), w1, bhq(1,1)
CC@CC 3, 3, 3
CC@CC 3, 3, 3
      bhq(1,1) = r0l(1,1,nobq)*w1(1,1) + r0l(1,2,nobq)*w1(2,1) + r0l(1,3
     .,nobq)*w1(3,1)
      bhq(2,1) = r0l(2,1,nobq)*w1(1,1) + r0l(2,2,nobq)*w1(2,1) + r0l(2,3
     .,nobq)*w1(3,1)
      bhq(3,1) = r0l(3,1,nobq)*w1(1,1) + r0l(3,2,nobq)*w1(2,1) + r0l(3,3
     .,nobq)*w1(3,1)
      bhq(1,2) = r0l(1,1,nobq)*w1(1,2) + r0l(1,2,nobq)*w1(2,2) + r0l(1,3
     .,nobq)*w1(3,2)
      bhq(2,2) = r0l(2,1,nobq)*w1(1,2) + r0l(2,2,nobq)*w1(2,2) + r0l(2,3
     .,nobq)*w1(3,2)
      bhq(3,2) = r0l(3,1,nobq)*w1(1,2) + r0l(3,2,nobq)*w1(2,2) + r0l(3,3
     .,nobq)*w1(3,2)
      bhq(1,3) = r0l(1,1,nobq)*w1(1,3) + r0l(1,2,nobq)*w1(2,3) + r0l(1,3
     .,nobq)*w1(3,3)
      bhq(2,3) = r0l(2,1,nobq)*w1(1,3) + r0l(2,2,nobq)*w1(2,3) + r0l(2,3
     .,nobq)*w1(3,3)
      bhq(3,3) = r0l(3,1,nobq)*w1(1,3) + r0l(3,2,nobq)*w1(2,3) + r0l(3,3
     .,nobq)*w1(3,3)
CC@CC end of expanded call
CC@CC
         else      ! (ihpvt(ihinge) .ne. 0)
c
c           Hinge is bonded
c
CC@CC
CC@CC ......MULT3 rh(1,1,lr4), r0l(1,1,nobq), bhq(1,4)
CC@CC ......3, 3, 3
CC@CC ......3, 3, 3
      bhq(1,4) = rh(1,1,lr4)*r0l(1,1,nobq) + rh(1,2,lr4)*r0l(2,1,nobq) +
     . rh(1,3,lr4)*r0l(3,1,nobq)
      bhq(2,4) = rh(2,1,lr4)*r0l(1,1,nobq) + rh(2,2,lr4)*r0l(2,1,nobq) +
     . rh(2,3,lr4)*r0l(3,1,nobq)
      bhq(3,4) = rh(3,1,lr4)*r0l(1,1,nobq) + rh(3,2,lr4)*r0l(2,1,nobq) +
     . rh(3,3,lr4)*r0l(3,1,nobq)
      bhq(1,5) = rh(1,1,lr4)*r0l(1,2,nobq) + rh(1,2,lr4)*r0l(2,2,nobq) +
     . rh(1,3,lr4)*r0l(3,2,nobq)
      bhq(2,5) = rh(2,1,lr4)*r0l(1,2,nobq) + rh(2,2,lr4)*r0l(2,2,nobq) +
     . rh(2,3,lr4)*r0l(3,2,nobq)
      bhq(3,5) = rh(3,1,lr4)*r0l(1,2,nobq) + rh(3,2,lr4)*r0l(2,2,nobq) +
     . rh(3,3,lr4)*r0l(3,2,nobq)
      bhq(1,6) = rh(1,1,lr4)*r0l(1,3,nobq) + rh(1,2,lr4)*r0l(2,3,nobq) +
     . rh(1,3,lr4)*r0l(3,3,nobq)
      bhq(2,6) = rh(2,1,lr4)*r0l(1,3,nobq) + rh(2,2,lr4)*r0l(2,3,nobq) +
     . rh(2,3,lr4)*r0l(3,3,nobq)
      bhq(3,6) = rh(3,1,lr4)*r0l(1,3,nobq) + rh(3,2,lr4)*r0l(2,3,nobq) +
     . rh(3,3,lr4)*r0l(3,3,nobq)
CC@CC end of expanded call
CC@CC
c
            if (nmq .gt. 0) then
CC@CC
CC@CC ......MULT3 bhq(1,4), hatsq, bhq(1,7)
CC@CC ......3, 3, nmq
CC@CC ......3, 3, 3
      CALL DGEMM ('N','N',3,nmq,3,1.0d0,bhq(1,4),3,hatsq,3,0.0d0,bhq(1,7
     .),3)
CC@CC end of expanded call
CC@CC
            end if
            call skewv3(dh(1,ld3),w1,3,3)
CC@CC
CC@CC ......MULT3 bhq(1,4), w1, bhq(1,1)
CC@CC ......3, 3, 3
CC@CC ......3, 3, 3
      bhq(1,1) = bhq(1,4)*w1(1,1) + bhq(1,5)*w1(2,1) + bhq(1,6)*w1(3,1)
      bhq(2,1) = bhq(2,4)*w1(1,1) + bhq(2,5)*w1(2,1) + bhq(2,6)*w1(3,1)
      bhq(3,1) = bhq(3,4)*w1(1,1) + bhq(3,5)*w1(2,1) + bhq(3,6)*w1(3,1)
      bhq(1,2) = bhq(1,4)*w1(1,2) + bhq(1,5)*w1(2,2) + bhq(1,6)*w1(3,2)
      bhq(2,2) = bhq(2,4)*w1(1,2) + bhq(2,5)*w1(2,2) + bhq(2,6)*w1(3,2)
      bhq(3,2) = bhq(3,4)*w1(1,2) + bhq(3,5)*w1(2,2) + bhq(3,6)*w1(3,2)
      bhq(1,3) = bhq(1,4)*w1(1,3) + bhq(1,5)*w1(2,3) + bhq(1,6)*w1(3,3)
      bhq(2,3) = bhq(2,4)*w1(1,3) + bhq(2,5)*w1(2,3) + bhq(2,6)*w1(3,3)
      bhq(3,3) = bhq(3,4)*w1(1,3) + bhq(3,5)*w1(2,3) + bhq(3,6)*w1(3,3)
CC@CC end of expanded call
CC@CC
         end if  ! End of IF test for (NMQ > 0)
      end if     ! End of IF test for both particles or one particle one body
      
 20   CONTINUE
C
      RETURN
      END
