C $Header: /export/cvs/c34a1/source/moldyn/branch_out.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C ========================================================================
C
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER 
C STATE AND FEDERAL LAWS.  USE, DISCLOSURE, REPRODUCTION OR DUPLICATION 
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS 
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT 
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C
      SUBROUTINE branch_out(itopol,iop,stats)
c
c     Find outboard bodies of the current body, and save the body number
c     in second row of iop.  First row of iop stores the order of visitation
c     of the outboard body, and a negative sign indicates that the q frame
c     of that hinge resides on the current body.
c
      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: branch_out.f,v $$Revision: 1.1.1.1 $'/
c
c     COMMON blocks
c
#include "PARAM.FOR"
#include "ORDERN.INC"
#include "SPECIF.INC"
c
c     Passed
c
      INTEGER itopol(2,cl02)
      integer stats
c     Local variables
c
      INTEGER i, j, k, n
      INTEGER nop        ! Order of visitaion of outboard body
      INTEGER is         ! Current body
      INTEGER iop(2,cL02) ! Temp array to store body,hinge,& branching info
      INTEGER nbodf(L01) ! Current number of bodies
c
c     Initialize itopw, iop, nbodf, nop, is
c
      DO i = 1, 2
         DO j = 1, nh
            itopw(i,j) = itopol(i,j)
         END DO
      END DO
      itopw(1,1) = 0
      iop(1,1) = 1
      iop(2,1) = 1
c
      nop = 1
      is = 1
      DO n = 1, nb
         nbodf(n) = 0
      END DO
c
 125  CONTINUE
c
c     Search for all outboard bodies of current body 'is'
c
      DO I = 1, 2
         DO J = 1, nh
            IF (itopw(i,j) .EQ. is) THEN  ! There is an outboard body
               nop = nop + 1
               IF (i .EQ. 1) THEN
                  iop(1,j) = -nop         ! Q-frame on current body
                  iop(2,j) = itopw(2,j)
               ELSE
                  iop(1,j) = nop          ! Q-frame on outboard body
                  iop(2,j) = itopw(1,j)
               END IF                     ! iop(2,j) = outboard body #
               nbodf(iop(2,j)) = 1   ! Add outboard bdy to branch tip list
               itopw(1,j) = 0        ! Remove outboard hinge from search list
               itopw(2,j) = 0
            END IF
         END DO
      END DO
c
c     Remove current body from branch tip list
c
      nbodf(is) = 0
c
c     Find the next branch tip to visit
c
      IF (nop .NE. nh) THEN
         DO n = 1, nb
            IF (nbodf(n) .NE. 0) THEN
               is = n       ! Set current body to branch tip 'n'
               GO TO 125
            END IF
         END DO
c
c     If execution reaches this point, not all bodies are connected through
c     by hinges to the inertial frame.  Set up new hinges to connect them.
c
         DO j = 1, nh
            IF (itopw(1,j) .NE. 0) THEN       ! Found on orphaned body
               k = MAX(itopw(1,j),itopw(2,j)) ! k is the orphaned body
               nh = nh + 1		      !  set up a new hinge and connect
c              check if enough memory allocated
               if ( nh .GT. cL02 ) then
                    stats = 0
                    goto 1001
               end if
               nop = nop + 1
               itopol(1, nh) = 1	      !  to body 1
               itopol(2, nh) = k
               iop(1, nh)    = -nop
               iop(2, nh)    = k 
               nbodf(k)      = 1 
               is = k
               GO TO 125
            END IF
         END DO
      END IF
c
c     Re-order the data in iop according to order of visit, and store in itopw
c
      DO j = 1, nh
         k = IABS(iop(1,j))
         itopw(1,k) = SIGN(j,iop(1,j))
         itopw(2,k) = iop(2,j)
      END DO
c
 1001 RETURN
      END
