C $Header: /export/cvs/c34a1/source/moldyn/cbod.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C ========================================================================
C
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER 
C STATE AND FEDERAL LAWS.  USE, DISCLOSURE, REPRODUCTION OR DUPLICATION 
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS 
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT 
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C
C                    SUBROUTINE - CBOD.F
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      subroutine cbod(ic,nh,nconn,ihconn,itopol,nctype,icob)
c
c     CBOD code provides array of #s which define bodies involved in the
c     given constraint
c
c     The inputs are:
c     ic      # of the current constraint.
c     nh      Number of hinges.
c     nconn   Number of all constraints (bonds, angles, dihedrals).
c     ihconn  Matrix of hinge #s for each constraint, size (nctype x nconn).
c     itopol  Matrix of pairs of bodies' #s making a hinge, size (2,nh).
c     nctype  Type of constraints (2 - only bonds, 3 - angles are included,
c             4 - dihedrals are included).   
c
c     The outputs are:
c     icob    Vector of #s of bodies involved in the current constraint
c             (in the growing order, not more than 4). 
c
      IMPLICIT NONE
c
c     Declare variables:
c
      integer ic,nh,nconn,nctype                      ! Inputs
      integer ihconn(nctype,nconn), itopol(2,nh)      ! Inputs
      integer icob(nctype)                            ! Outputs
      integer i,i2,ih,qp,k,j,ii,itake                    
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: cbod.f,v $$Revision: 1.1.1.1 $'/
c
      do i2 = 1, nctype
         icob(i2) = 0
      end do
      k = 1
      do i = 1, nctype
         ih = ihconn(i,ic)
         if (ih .ne. 0) then
            do j = 1, 2
               qp = itopol(j,ih)
               itake = 1        ! Body #qp is not included yet in icob
               do ii = 1, nctype
                  if (qp .eq. icob(ii)) then
                     itake = 0  ! Body #qp has been already included in icob
                     go to 12
                  end if
               end do
 12            continue
               if (qp.ne.0 .and. itake.ne.0) then    
                  icob(k) = qp
                  if (k.gt.1 .and. icob(k-1).gt.qp) then
                     icob(k) = icob(k-1)
                     icob(k-1) = qp
                  end if
                  k = k + 1
               end if
            end do   
         end if
      end do                  
      return
      end











