C $Header: /export/cvs/c34a1/source/moldyn/cgadji.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
      SUBROUTINE cgadji(xloc,ami,xcg,tmas,n,job,imas)
c
c     Compute group mass, group c.g., and re-locate coordinate origin
c     to the c.g. of the group.
c
      IMPLICIT NONE
c
c     Argument list
c
      INTEGER n                     !  Number of atoms in group
      INTEGER job                   !  1:  Compute xcg only
                                    !  2:  Subtract xcg from xloc only
                                    !  other:  Comp. xcg & sub. from xloc
      INTEGER imas                  !  Calculate tmas if equal to 0
      DOUBLE PRECISION tmas         !  Total group mass
      DOUBLE PRECISION xloc(3,n)    !  Input atomic coordinates
      DOUBLE PRECISION ami(n)       !  Atomic mass inverse
      DOUBLE PRECISION xcg(3)       !  Input/Output group c.g.
c
c     Local Variables
c
      INTEGER i, i1                 !  DO loop indices
      DOUBLE PRECISION sum          !  Temp. variable
c 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: cgadji.f,v $$Revision: 1.1.1.1 $'/
c
c
c
      IF (job .NE. 2) THEN
c
c     Calculate group mass
c
         IF (imas .EQ. 0) THEN
            tmas = 0.
            DO i = 1, n
               tmas = tmas + 1./ami(i)
            END DO
         END IF
c
c     Compute group c.g.
c
         DO i1 = 1, 3
            sum = 0.
            DO i = 1, n
               sum = sum + xloc(i1,i)/ami(i)
            END DO
            xcg(i1) = sum/tmas
         END DO

      END IF
c
c     Subtract group c.g. from atomic coordinates
c
      IF (job .NE. 1) THEN
         DO i1 = 1, 3
            DO i = 1, n
               xloc(i1,i) = xloc(i1,i) - xcg(i1)
            END DO
         END DO
      END IF
c
      RETURN
      END
