C $Header: /export/cvs/c34a1/source/moldyn/cgadji2.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
      SUBROUTINE cgadji2(dsarray,ami,xcg,tmas,n,job,imas)
c
c     Compute group mass, group c.g., and re-locate coordinate origin
c     to the c.g. of the group.
c     This version uses the ds array for input coordinates instead of
c     the X array as in cgadji.f
c
      IMPLICIT NONE
c
c     Argument list
c
      INTEGER n                     !  Number of atoms in group
      INTEGER job                   !  1:  Compute xcg only
                                    !  2:  Subtract xcg from xloc only
                                    !  other:  Comp. xcg & sub. from xloc
      INTEGER imas                  !  Calculate tmas if equal to 0
      DOUBLE PRECISION tmas         !  Total group mass
      DOUBLE PRECISION dsarray(3,2*n)  !  Input atomic coordinates
      DOUBLE PRECISION ami(n)       !  Atomic mass inverse
      DOUBLE PRECISION xcg(3)       !  Input/Output group c.g.
c
c     Local Variables
c
      INTEGER i, i1                 !  DO loop indices
      DOUBLE PRECISION sum          !  Temp. variable
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: cgadji2.f,v $$Revision: 1.1.1.1 $'/
c
c
c
      if (job. ne. 2) then
c
c     Calculate group mass
c
         if (imas .eq. 0) then
            tmas = 0.
            do i = 1, n
               tmas = tmas + 1./ami(i)
            end do
         end if
c
c     Compute group c.g.
c
         do i1 = 1, 3
            sum = 0.
            do i = 1, n
               sum = sum + dsarray(i1,2*i)/ami(i)
            end do
            xcg(i1) = sum/tmas
         end do
      end if
c
c     Subtract group c.g. from atomic coordinates
c
      if (job .ne. 1) then
         do i1 = 1, 3
            do i = 1, n
               dsarray(i1,2*i) = dsarray(i1,2*i) - xcg(i1)
            end do
         end do
      end if
c
      return
      end
