C $Header: /export/cvs/c34a1/source/moldyn/check_sng1.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C ========================================================================
C
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER 
C STATE AND FEDERAL LAWS.  USE, DISCLOSURE, REPRODUCTION OR DUPLICATION 
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS 
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT 
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
c
c
      SUBROUTINE check_sng1(reseq,iscut,ihpvt,betah,ihdata)
c
c     Re-sequence the singular Euler sequences if singular
c
      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: check_sng1.f,v $$Revision: 1.1.1.1 $'/
C
#include "PARAM.FOR"
#include "BHBSRD.INC"
#include "CPATHS.INC"
#include "ERRHDL.INC"
#include "ORDERN.INC"
#include "PINRP.INC"
#include "SELECT.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
#include "TIMESS.INC"
#include "VECTOR.INC"
#include "MISCNO.INC"
#include "LDEBUG.INC"
#include "HEAPMB.INC"
C
c     Passed
c
      LOGICAL iscut(cL02)
      INTEGER ihpvt(cL02)
      INTEGER ihdata(7,cL02)
      DOUBLE PRECISION betah(6,cL02)
C
C     Local variables
      LOGICAL LEQU, SFLAG
      EQUIVALENCE (LEQU,DEBUG(44))
      LOGICAL reseq      ! Re-sequence flag used for velocity verlet
      INTEGER J, NBET, IDOF1, IBET, I, I1, IT
      DOUBLE PRECISION time
C
C
      NBET = LOCU(2*NB + 1) - 1
      DO J = 1, NH
         if (iscut(j)) go to 108
         if (ihdata(1,J) .EQ. 0) then
            idof1 = 4
         else
            idof1 = 1
         end if
         ibet = nbet
         DO I = idof1, 6
            I1 = I + 1
            IF (IHDATA(I1,J) .NE. 1) then
               ibet = ibet + 1
            END IF
         end do
C
c        Check hinge for singularity
c
         sflag = .false.
         it = ihdata(1,J)
         if (it .eq. 0) then
         else if (it.eq.1 .OR. it.eq.4 .OR. it.eq.5 .OR.
     +           it.eq.8 .OR. it.eq.9 .OR. it.eq.12) then
C           if (abs(sin(betah(2,j))) .gt. EULER_THRESHOLD .or.
C    &          abs(sin(betahd(2,j)*DELTAT)) .gt. EULER_THRESHOLD)
C    &          sflag = .true.
            if(abs(sin(betah(2,j))) .gt. EULER_THRESHOLD) sflag = .true.
         else
C           if (abs(cos(betah(2,j))) .gt. EULER_THRESHOLD .or.
C    &          abs(cos(betahd(2,j)*DELTAT)) .gt. EULER_THRESHOLD)
C    &          sflag = .true.
            if(abs(cos(betah(2,j))) .gt. EULER_THRESHOLD) sflag = .true.
         end if
         if (sflag) then
            seqflg = .true.
            if (ihdata(3,j) .ne. 0) then
               time = (t-startt)/20.455d0 + startt
               CALL CLEARERR()
               WRITE(MBOUT,2019) ' Hinge', j,
     +              ' is near singular at time ', time,
     +           ' Singular angle is not free.'
               WRITE(ERRMSG,'(1X,A)') 'Error in subroutine.'
               CALL ERRHDL(-5,'<CHECK_SNG1>')
            end if
            IF (reseq) CALL eulseq(j,nbet,HEAP_MB(iyptr),
     +                       LoopHeap(ipimatptr),
     +                       Loopheap(ipinptr),
     +                       LoopHeap(irp2ptr),
     +                       LoopHeap(irp3ptr),
     +                       intLoopHeap(iibetdtptr),
     +                       LoopHeap(ibetahptr),
     +                       LoopHeap(ibetahdptr),
     +                       intLoopheap(iihdataptr))
         end if
         NBET = IBET
 2019 FORMAT(A,I3,A,F10.5,/,A)
 108     continue
      end do
C
      RETURN
      END
