C $Header: /export/cvs/c34a1/source/moldyn/check_sng2.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C ========================================================================
C
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER 
C STATE AND FEDERAL LAWS.  USE, DISCLOSURE, REPRODUCTION OR DUPLICATION 
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS 
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT 
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
c
c
      SUBROUTINE check_sng2(reseq,Y,iscut,ichpvt,ihpvt,ibetdt,betah,
     &                      ihdata,rh,dh)
c
c     Re-sequence the spherical coordinates if singular
c
c              Change the hinge pivoting Euler sequence
c              Following line assumes that bonded hinge is not rheonomically
c              constrained
C              GET CARTESIAN RELATIVE VELOCITIES
c
c
      IMPLICIT NONE
c
#include "PARAM.FOR"
#include "BHBSRD.INC"
#include "CHARMM.INC"
#include "CPATHS.INC"
#include "HEAPMB.INC"
#include "ORDERN.INC"
#include "PARTCL.INC"
#include "PINRP.INC"
#include "SELECT.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
#include "TIMESS.INC"
#include "VECTOR.INC"
#include "MISCNO.INC"
C
c
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: check_sng2.f,v $$Revision: 1.1.1.1 $'/
c
c     Passed variables
      LOGICAL reseq      ! Re-sequence flag used for velocity verlet
      LOGICAL iscut(cL02)
      DOUBLE PRECISION Y(cL07)
      DOUBLE PRECISION BETAH(6,cL02)
      DOUBLE PRECISION RH(3,3,cL15)
      DOUBLE PRECISION DH(3,cL16)
      INTEGER ICHPVT(cL02)
      INTEGER IHPVT(cL02)
      INTEGER IBETDT(cL02)
      INTEGER IHDATA(7,cL02)
c
      INTEGER I, IBT, LR1, LR2, LR4, LD1, LD5, LOCB, I1, I2, I3
      DOUBLE PRECISION blen, DF(3), time
c
c
 2010 format(a,i3,a,i3,a,f10.5)
c
      ibt = locu(2*nb+1) + 3    ! Assume no constraints on first hinge
      IF (ihdata(1,1) .NE. 0) ibt = ibt + 3  ! Count the rotational betas
c
      DO 10 I=2,NH
         if (iscut(i)) go to 10
         LR1 = 1 + 6*(I-2)
         LD1 = 1 + 7*(I-2)
         LR2 = LR1 + 1
         LR4 = LR1 + 3
         LD5 = LD1 + 4
c
         if (ihpvt(I) .ne. 0) then
c                 beta (r,theta,gamma) for translational dofs
            if (ihdata(1,I) .ne. 0) ibt = ibt + 3 ! Count the rotational betas
            blen = betah(4,i)
C
C        CHECK ELEVATION GAMMA AT END OF EACH STEP TO PREVENT SINGULARITY
C

C        IF (ABS(SIN(BETAH(6,I))).GT.EULER_THRESHOLD .OR.
C    &       ABS(SIN(BETAHD(6,I)*DELTAT)).GT.EULER_THRESHOLD) THEN
         IF (ABS(SIN(BETAH(6,I))).GT.EULER_THRESHOLD) THEN
c
c              Change the hinge pivoting Euler sequence
c              Following line assumes that bonded hinge is not rheonomically
c              constrained
C              GET CARTESIAN RELATIVE VELOCITIES
c
            seqflg = .true.
            IF (reseq) THEN
               if (ihdata(1,i) .eq. 0) then
                  locb = ibetdt(i)
               else
                  locb = ibetdt(i) + 3
               end if
CC@CC
CC@CC .........MULT3 RH(1,2,LR2), Y(LOCB), DF
CC@CC .........3, 2, 1
CC@CC .........3, 2, 3
      DF(1) = RH(1,2,LR2)*Y(LOCB+0) + RH(1,3,LR2)*Y(LOCB+1)
      DF(2) = RH(2,2,LR2)*Y(LOCB+0) + RH(2,3,LR2)*Y(LOCB+1)
      DF(3) = RH(3,2,LR2)*Y(LOCB+0) + RH(3,3,LR2)*Y(LOCB+1)
CC@CC end of expanded call
CC@CC
               IF (IHPVT(I) .EQ. 1) THEN
                  IHPVT(I) = 2
                  I1 = 2
                  I2 = 3
                  I3 = 1
               ELSE
                  IHPVT(I) = 1
                  I1 = 1
                  I2 = 2
                  I3 = 3
               END IF
               BETAH(5,I) = ATAN2(DH(I2,LD5),DH(I1,LD5))
               BETAH(6,I) = ASIN(DH(I3,LD5)/BLEN)
               CALL ROTRAN(I,intLoopHeap(iihpvtptr),
     *                     LoopHeap(ibetahptr),Loopheap(irhptr))
C
C     Convert the cartesian relative velocities to the proper Euler
C     rates using the new sequence.
C
CC@CC
CC@CC .........MULT3 RH(2,1,LR4), DF, Y(LOCB)
CC@CC .........2, 3, 1
CC@CC .........3, 3, 2
      Y(LOCB+0) = RH(2,1,LR4)*DF(1) + RH(2,2,LR4)*DF(2) + RH(2,3,LR4)*DF
     .(3)
      Y(LOCB+1) = RH(3,1,LR4)*DF(1) + RH(3,2,LR4)*DF(2) + RH(3,3,LR4)*DF
     .(3)
CC@CC end of expanded call
CC@CC
               Y(IBT)   = BETAH(5,I)
               Y(IBT+1) = BETAH(6,I)
               ichpvt(i) = ichpvt(i) + 1   !keep track of pivot changes
               if (mbplvl .eq. 9) then
                  time = (t-startt)/20.455d0 + startt
                  WRITE(MBOUT,2010) ' PIVOT TYPE CHANGED TO ',IHPVT(I),
     +                 ' FOR HINGE', I, ' AT TIME = ', time
               end if
            END IF
         END IF
         IBT = IBT + 2
      else      !   beta (x,y,z) for translational dofs, which are all free
         if (ihdata(1,I) .eq. 0) then
            ibt = ibt + 3
         else
            ibt = ibt + 6
         end if
      end if
C
   10 CONTINUE
c
      RETURN
      END
