C $Header: /export/cvs/c34a1/source/moldyn/clfor1.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
      SUBROUTINE CLFOR1(y,bhq,bhp,isdof,betahd,itopol,ihcutj)
CSE
C                                                          DEBUG #  85
CPS        PURPOSE:
C
C     FIRST FORWARD PASS FOR THE CLOSED LOOP ORDER N ALGORITHM.  USE
C       VELOCITY TRANSFORMATION ARRAY "BH" INFORMATION, TO COMPUTE
C       THE RELATIVE HINGE VELOCITIES AT EACH CUT JOINT DEGREE OF FREEDOM.
C
CPE
c
      IMPLICIT NONE
c
#include "PARAM.FOR"
C
C     COMMON BLOCKS
#include "BHBSRD.INC"
#include "CPATHS.INC"
#include "HANDS2.INC"
#include "HEAPMB.INC"
#include "SELECT.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
#include "VECTOR.INC"
C
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: clfor1.f,v $$Revision: 1.1.1.1 $'/
C
#include "LDEBUG.INC"
c     Passed variables
c
      DOUBLE PRECISION Y(cL07)
      DOUBLE PRECISION BETAHD(6,cL02)
      INTEGER ISDOF(9,cL02)
      INTEGER ITOPOL(2,cL02)
      INTEGER IHCUTJ(cL63)
c
      LOGICAL LEQU
      EQUIVALENCE (LEQU,DEBUG(85))
c
      INTEGER ICUT, IHINGE, LQ, LP
      INTEGER IBODYP, IBODYQ, NDOF
      INTEGER N0, LOCUQ, LOCUP
      INTEGER I, J
      DOUBLE PRECISION SUM
      DOUBLE PRECISION bhq(6,cL08),bhp(6,cL08)
C
      IF(LEQU) WRITE (MBOUT,1000)
 1000 FORMAT (' SUBROUTINE CLFOR1')
C
C        DO 100 LOOP IS ON CUT JOINTS ONLY, IN/OUT BOARD BODY
C               FLEXIBILITY AND RHEONOMIC CONSTRAINT SPECIFICATION
C               FOR DEGREES OF FREEDOM AT CUT JOINT HINGES ALLOWED.
C
C     FOR EACH CUT JOINT, COMPUTE ALL DOFS
C
      DO 100 ICUT = 1, NCUT
         IHINGE = IHCUTJ(ICUT)
         LQ     = 2*IHINGE - 2
         LP     = 2*IHINGE - 1
C
         IBODYQ = ITOPOL(1,IHINGE)
         IBODYP = ITOPOL(2,IHINGE)
C
         NDOF   = ISDOF(3,IHINGE) + ISDOF(4,IHINGE)
         N0     = 6 - NDOF
C
         LOCUQ  = LOCU(IBODYQ) - 1
         LOCUP  = LOCU(IBODYP) - 1
C
         CALL getbh(ihinge,2,.TRUE.,bhq,ibodyq,irgflx(ibodyq),bhp,
     &         ibodyp,irgflx(ibodyp),intLoopHeap(iibhtypeptr),
     &         intLoopHeap(iihthptrptr),intLoopheap(iibh_ptrptr))
C
         DO 101 I = 1, NDOF
            SUM = 0.0D0
            DO 102 J = 1, LENU(IBODYQ)
               SUM = SUM + BHQ(I,J) * Y(LOCUQ + J)
102         CONTINUE
            DO 103 J = 1, LENU(IBODYP)
               SUM = SUM + BHP(I,J) * Y(LOCUP + J)
103         CONTINUE
            BETAHD(I+N0,IHINGE) = SUM
101      CONTINUE
C
100   CONTINUE
C
      IF(LEQU) THEN
        WRITE (MBOUT,'(a//a)')
     &   ' CLFOR1 FINISHED WITH THE COLUMNS OF BETAHD',
     *   ' ASSOCIATED WITH CUT JOINTS'
        CALL WRITES(BETAHD,6,NH,6)
      END IF
C
      RETURN
      END
