C $Header: /export/cvs/c34a1/source/moldyn/clfr2a.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
      SUBROUTINE CLFR2A(BTILDE,BICDST,SBT,BRN,bhinb,ihpath,isel,isdof,
     &                  BETAHD,ITOPOL,IHDATA,IHCUTJ,RLAMDA,ACLMAT,
     &                  ICLPVT,ACOPY,Z,TEMPV)
C                                                          DEBUG #  86
CSE
      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: clfr2a.f,v $$Revision: 1.1.1.1 $'/
CPS
C     PURPOSE:
C
C         This subroutine is used to make part of the second forward pass for
C     the closed loop order N algorithm.  In this subroutine the variable
C     [b]_star is recursively propagated from the base body
C     towards each of the cut joint end bodies.  The cut-joint
C     Lagrange impulse multipliers are obtained at the end of the recursion,
C     at which point a linear equation solver is invoked to solve for the
C     unknown multipliers.
CPE
CAS                     ARGUMENT LIST
C
C     VC      =  CUT JOINT LAGRANGE MULTIPLIERS STORED IN /CLOOP/
C     RLAMDA  =  VC, NAME CHANGE IN /CLOOP/ OUTSIDE OF SUBROUTINE CLFOR2
C
C             If there is only one closed loop, the cut joint Lagrange
C    multipliers can be sovled for via equation 15.  However if there are
C    multiple closed loops then each of the resulting equations will have
C    terms involving the Lagrange multipliers from each of the cut joints.
C    In such a case, all sets of equations must be solved together to obtain
C    the Lagrange multipliers.  This is done by utlization of Singular Value
C    decomposition methods for the solution of eqaution 21.
C
C  Reference equation numbers from Cambridge Research Memo: Hon Chun to
C    James D. Turner, "Preliminary Order (N) Algorithm for Multiple
C    Closed-Loop Topologies," 16 May 1989
C
C
C       1.  FACT1 - Used in test for singularity as
C                IF (1.0D0+RCOND*FACT1 .EQ. 1.0D0) THEN
C                   Matrix is singular
C           Default value for FACT1 = 1.0/1000.0
C           LINPACK documentation states that if condition is true with
C           FACT1 = 1.0 then matrix is singular to working precision.
C           If the matrix is badly scaled the interpretation and use
C           of RCOND is more delicate and FACT1 less than 1.0 is justifiable
C       2.  FACT2 - Used in test for singular value = 0.0 as
C                   WMIN = WMAX * FACT2
C                   DO J = 1, NCTCON
C                       IF (W(J) .LT. WMIN) W(J) = 0.0D0
C                   END DO
C           For a well scaled problem FACT2 should be equal to
C               machine precision.  For badly scaled matrices larger
C               values for FACT2 are justifable
C           Default value for FACT2 = MACHINE_PRECISION*1000.0
C
CAE
C
#include "PARAM.FOR"
C
C     DISCOS COMMON BLOCKS
C
#include "BHBSRD.INC"
#include "CHARMM.INC"
#include "CINPUT.INC"
#include "CLOOP.INC"
#include "CPATHS.INC"
#include "ERRHDL.INC"
#include "HANDS2.INC"
#include "HEAPMB.INC"
#include "IFIRST.INC"
#include "JILFLG.INC"
#include "LDEBUG.INC"
#include "MISCNO.INC"
#include "MISCN2.INC"
#include "NOUTPT.INC"
#include "ORDERN.INC"
#include "SELECT.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
#include "TIMESS.INC"
C
c     Passed
c
      DOUBLE PRECISION BTILDE(cL11,6,L01,cL63)
      DOUBLE PRECISION BICDST(cL11,6,L01,cL63,cL63)
      DOUBLE PRECISION SBT(cL11,6,L01,cL63)
      DOUBLE PRECISION BRN(cL11,6,MAXBOD)
      DOUBLE PRECISION BETAHD(6,cL02)
      DOUBLE PRECISION RLAMDA(cL64)
      DOUBLE PRECISION ACLMAT(cL64,cL64)
      LOGICAL IHPATH(cL63+1,cL02)
      INTEGER ISEL(6*cL02)
      INTEGER ISDOF(9,cL02)
      INTEGER ITOPOL(2,cL02)
      INTEGER IHDATA(7,cL02)
      INTEGER IHCUTJ(cL63)
      INTEGER ICLPVT(cL64)
     
c
C     Local variables
C
      INTEGER I1ST
      INTEGER I, J, ICUTC, ICUTD, ICONS, IELEM, IBODY, ICBODY, INBODY
      INTEGER IROW, ICOL, ICOL2, ISROW
      INTEGER IHINGE, IHINGC, IHINGD, IBODY1, IBODY2, ithisb
      INTEGER MTSIZE, MTISIZ, MTSIZ1, MTSIZ2, LOCC, NCONS, NCONC, NCOND
      INTEGER NDOF, N0
      INTEGER icprt            ! Pointer for particle arrays
      LOGICAL LEQU, BCKSLV,qin
      DOUBLE PRECISION SUM, RCOND, TIME
      DOUBLE PRECISION bhinb(6,cL08),dumbh(6)
C
C     Local arrays
C
      DOUBLE PRECISION  ACOPY(cL64,cL64), TEMPA(6,6), Z(cL64)
      DOUBLE PRECISION  TEMPV(cL64)
C
C     External functions
C
      DOUBLE PRECISION adt
C
C     Equivalences
C
      EQUIVALENCE (LEQU,DEBUG(86))
      EQUIVALENCE (i1st,i1pass(2))
C
C
      IF(LEQU) WRITE(MBOUT,1000)
 1000 FORMAT (' SUBROUTINE CLFR2A ')
 1010 FORMAT (' CLOSED LOOP TOLERANCE FACTORS FACT1, FACT2 = ',2E15.5)
 1025 FORMAT (//10X,'AT SIMULATION TIME, T = ',1PD10.4,' ps ',32('* '))
C
C  DEFAULT TOLERANCE FACTORS:
C      FACT1 USED IN TEST FOR MATRIX SINGULARITY, ADJUST DEFAULT 1.0 DOWNWARD
C            FOR BADLY SCALED PROBLEMS
C      FACT2 USED TO FIND SINGULAR VALUES = 0.0, ADJUST DEFAULT MACHINE
C            PRECISION UPWARD FOR BADLY SCALED PROBLEMS
C
      IF (I1ST .EQ. 0) THEN
         I1ST = 1
         IF(FACT1.EQ.0.0) FACT1 = 1D-03
         IF(FACT2.EQ.0.0) FACT2 = 1D-03
         IF(LEQU) WRITE(MBOUT,1010) FACT1, FACT2
      END IF
C
C     FIRST DO THE REFERENCE BODY, BODY 1
C     COPY BODY 1'S SBT (SCRIPT B-TRANSPOSED) TO BICDST FOR CUT JOINTS
C
      MTSIZE = LENU(1)
      DO 200 ICUTC = 1, NCUT
         DO 201 ICUTD = 1, NCUT
            DO 202 ICONS = 1, ISDOF(4,IHCUTJ(ICUTD))
               DO 203 IELEM = 1, MTSIZE
                  BICDST(IELEM,ICONS,1,ICUTC,ICUTD) =
     +                   SBT(IELEM,ICONS,1,ICUTD)
 203           CONTINUE
 202        CONTINUE
 201     CONTINUE
 200  CONTINUE
C
C     NOW FOR THE REST OF THE BODIES
C
      DO 600 IBODY = 2, NB
C
         IHINGE = ITOPW(1,IBODY)
         ICBODY = ITOPW(2,IBODY)
         MTSIZE = LENU(ICBODY)
C
         IF (IHINGE .LT. 0) THEN   ! P frame is on this body
            IHINGE = -IHINGE
            INBODY = ITOPOL(1,IHINGE)
            ithisb = 2*ihinge - 1
            qin    = .TRUE.
         ELSE                      ! Q frame is on this body
            INBODY = ITOPOL(2,IHINGE)
            NCONS  = ISDOF(4,IHINGE)
            ithisb = 2*ihinge - 2
            QIN = .FALSE.
         END IF
C
         LOCC   = ISDOF(2,IHINGE) - 1
         NDOF   = NCONS + ISDOF(3,IHINGE)
         NCONS  = ISDOF(4,IHINGE)
         MTISIZ = LENU(INBODY)
         icprt  = icbody - nbdy
C                                                         *T
C        IF THIS HINGE IS ON ANY CUT JOINT PATH, COMPUTE b   .
C                                                         icd
         IF (.NOT. IHPATH(ICOMP,IHINGE)) GO TO 600
C
C            *T       T          ___T           *T
C           b    =   B    -  N   PHI    b      b
C            icd      id      i     Ii   O,i-1  i-1,cd
C
         IF (ncons .GT. 0 ) THEN    ! Generate bhinb if it's used
            if (qin) then
               CALL getbh(ihinge,1,qin,bhinb,icbody,irgflx(icbody),
     &                  dumbh,0,0,intLoopHeap(iibhtypeptr),
     &                  intLoopHeap(iihthptrptr),
     &                   intLoopheap(iibh_ptrptr))
            else
               CALL getbh(ihinge,1,qin,dumbh,0,0,bhinb,icbody,
     &                  irgflx(icbody),intLoopHeap(iibhtypeptr),
     &                  intLoopHeap(iihthptrptr),
     &                   intLoopheap(iibh_ptrptr))
            end if
         END IF
C
         DO 300 ICUTC = 1, NCUT
            IF (.NOT. IHPATH(ICUTC,IHINGE)) GO TO 300
            DO 301 ICUTD = 1, NCUT
               NCOND = ISDOF(4,IHCUTJ(ICUTD))
               IF (NCOND .EQ. 0) GO TO 301
               DO IROW = 1, NCONS
                  ISROW = ISEL(LOCC+IROW)
CC@CC
CC@CC ....MULT3 BHINB(ISROW,1), BICDST(1,1,INBODY,ICUTC,ICUTD), TEMPA(IROW,1)
CC@CC ....1, MTISIZ, NCOND
CC@CC ....6, L11, 6
      CALL DGEMV ('T',MTISIZ,NCOND,1.0d0,BICDST(1,1,INBODY,ICUTC,ICUTD),
     .cL11,BHINB(ISROW,1),6,0.0d0,TEMPA(IROW,1),6)
CC@CC end of expanded call
CC@CC
               END DO
               IF (icbody .le. nbdy) THEN ! Use body rn
                  DO IROW = 1, MTSIZE
                     DO ICOL2 = 1, NCOND
                        SUM = SBT(IROW,ICOL2,ICBODY,ICUTD)
                        DO ICONS = 1, NCONS
                           SUM = SUM - BRN(IROW,ICONS,ICBODY)*
     +                          TEMPA(ICONS,ICOL2)
                        END DO
                        BICDST(IROW,ICOL2,ICBODY,ICUTC,ICUTD) = SUM
                     END DO        ! ICOL2
                  END DO           ! IROW
               ELSE                      ! Use prtcl rn
                  IF (ncons .gt. 3) THEN
                     CALL CLEARERR()
                     WRITE(ERRMSG,100) '> NCONS for particle ',icprt,
     $                ', is greater than 3'
                     CALL ERRHDL(-5,'<CLFR2A>')
                  END IF
 100              FORMAT(1X,A,I9,A)
                  DO IROW = 1, MTSIZE
                     DO ICOL2 = 1, NCOND
                        SUM = SBT(IROW,ICOL2,ICBODY,ICUTD)
                        DO ICONS = 1, NCONS
                           SUM = SUM - PRN(IROW,ICONS,ICPRT)*
     +                          TEMPA(ICONS,ICOL2)
                        END DO
                        BICDST(IROW,ICOL2,ICBODY,ICUTC,ICUTD) = SUM
                     END DO        ! ICOL2
                  END DO           ! IROW
               END IF
 301        CONTINUE            ! ICUTD
 300     CONTINUE
 600  CONTINUE
C
C     NOW COMPUTE A.
C
      IROW = 1
      DO 500 ICUTC = 1, NCUT
         IHINGC = IHCUTJ(ICUTC)
         NCONC  = ISDOF(4,IHINGC)
         IF (NCONC .EQ. 0) GO TO 500
C
         IBODY1 = ITOPOL(1,IHINGC)
         IBODY2 = ITOPOL(2,IHINGC)
         MTSIZ1 = LENU(IBODY1)
         MTSIZ2 = LENU(IBODY2)
C
         LOCC   = ISDOF(2,IHINGC) - 1
         N0     = 6 - NCONC - ISDOF(3,IHINGC)
C
C     COMPUTE THE BETA DOT ERROR AT EACH OF THE CUT-JOINTS
C
         DO I = 1, NCONC
            ISROW = ISEL(LOCC+I) + N0
            IF (IHDATA(ISROW+1,IHINGC) .EQ. 1) THEN
               RLAMDA(IROW+I-1) = - BETAHD(ISROW,IHINGC)
            ELSE
               RLAMDA(IROW+I-1) = ADT(6*(IHINGC-1)+ISROW,T)
     +                          - BETAHD(ISROW,IHINGC)
            END IF
         END DO
C
         ICOL   = 1
         DO 501 ICUTD = 1, NCUT
            IHINGD = IHCUTJ(ICUTD)
            NCOND  = ISDOF(4,IHINGD)
            IF (NCOND .EQ. 0) GO TO 501
C
C                     ~1   1*T    ~2   2*T
C              A   =  b   b     + b   b
C               cd     ec  ecd     ec  ecd
C
C              WHERE THE SUPERSCRIPTS 1 AND 2 STAND FOR THE BODIES AT
C              THE ENDS OF CUT JOINT C.
C
CC@CC
CC@CC ......MULT3T BTILDE(1,1,IBODY1,ICUTC), BICDST(1,1,IBODY1,ICUTC,ICUTD), ACLMAT(IROW,ICOL)
CC@CC ......NCONC, MTSIZ1, NCOND
CC@CC ......L11, L11, L64
      CALL DGEMM('T','N',NCONC,NCOND,MTSIZ1,1.0d0,BTILDE(1,1,IBODY1,ICU
     .TC),cL11,BICDST(1,1,IBODY1,ICUTC,ICUTD),cL11,0.0d0,
     .ACLMAT(IROW,ICOL),cL64)
CC@CC end of expanded call
CC@CC
C
CC@CC
CC@CC ......MLTTAD BTILDE(1,1,IBODY2,ICUTC), BICDST(1,1,IBODY2,ICUTC,ICUTD), ACLMAT(IROW,ICOL)
CC@CC ......NCONC, MTSIZ2, NCOND
CC@CC ......L11, L11, L64
      CALL DGEMM ('T','N',NCONC,NCOND,MTSIZ2,1.0d0,BTILDE(1,1,IBODY2,ICU
     .TC),cL11,BICDST(1,1,IBODY2,ICUTC,ICUTD),cL11,1.0d0,
     .ACLMAT(IROW,ICOL),cL64)
CC@CC end of expanded call
CC@CC
C
            ICOL = ICOL + NCOND
 501     CONTINUE
         IROW = IROW + NCONC
 500  CONTINUE
C
C     NOW USE A AND VC TO COMPUTE THE IMPULSE MULTIPLIER VECTOR RLAMDA
C
C     A   ...  A       RL          v
C      11       1m       1          1
C     .  .     .       .           .
C     .    .   .       .      =    .
C     .      . .       .           .
C     A   ...  A       RL          v
C      m1       mm       m          m
C
C     IF THIS IS NOT BEING BACKSOLVED NOW, CHECK IF NEEDED THIS DELTA T
C      IF (.NOT. BCKSLV) THEN
C        COPY A IN CASE IT IS SINGULAR
         DO J = 1, NCTCON
            DO I = 1, NCTCON
               ACOPY(I,J) = ACLMAT(I,J)
            END DO
         END DO
C
         CALL DGECO(ACLMAT,cL64,NCTCON,ICLPVT,RCOND,Z)
C
         IF (1D0+RCOND*FACT1 .EQ. 1D0) THEN
            BCKSLV = .TRUE.
         ELSE
            BCKSLV = .FALSE.
         ENDIF
C
         IF (((IPRNT.EQ.NOPRNT .AND. JIL.EQ.4) .OR. BCKSLV) 
     *         .and. (mbplvl .eq. 9)) THEN
            call pagehd
            time = (t-startt)/20.455d0 + startt
            write(MBOUT,1025) TIME
            WRITE(MBOUT,*)' The reciprocal condition number is ',rcond
            WRITE (MBOUT,*) 'THE A MATRIX'
            CALL WRITES (ACOPY,NCTCON,NCTCON,cL64)
            WRITE (MBOUT,*) 'THE CUT-JOINT BETA DOT ERROR VECTOR'
            CALL WRITES (RLAMDA,1,NCTCON,1)
         END IF
C
         IF (BCKSLV) THEN
C
C           IF JIL = 4, THIS IS THE START OF AN INTERVAL, SO JUST SET THE
C           BACK SOLVE FLAG TO FORCE SVD USE FOR THE WHOLE INTERVAL; NO
C           NEED TO RETURN TO RKADAM.
            CALL CLEARERR()
            WRITE(ERRMSG,400)
     +        ' Matrix is singular.'
 400        FORMAT(1X,A)
            CALL ERRHDL(-5,'<CLFR2A>')
C            IF (JIL .EQ. 4) THEN
C               WRITE (MBOUT,*) 'BACK SOLVING ACTIVATED: JIL=4,T=',T
C               BCKSLV = .TRUE.
C              GET ORIGINAL A BACK IN CASE I WANT TO CHECK SOLUTION
C               DO J = 1, NCTCON
C                  DO I = 1, NCTCON
C                     A(I,J) = ACOPY(I,J)
C                  END DO
C               END DO
C
C               CALL DSVDC (ACOPY,L64,NCTCON,NCTCON,W,E,U,L64,V,L64,
C     *                     WORK,11,INFO)
C
C               IF (IPRNT .EQ. NOPRNT) THEN
C                  WRITE (MBOUT,*) 'THE SINGULAR VALUES ARE'
C                  CALL WRITES (W,1,NCTCON,1)
C               END IF
C
C               WMAX = 0.0D0
C               DO J = 1, NCTCON
C                  IF (W(J) .GT. WMAX) WMAX = W(J)
C               END DO
C               WMIN = WMAX * FACT2
C               DO J = 1, NCTCON
C                  IF (W(J) .LT. WMIN) W(J) = 0.0D0
C               END DO
C               IF (IPRNT .EQ. NOPRNT) THEN
C                  WRITE (MBOUT,*) 'THE SINGULAR VALUES, ZEROS REMOVED ARE'
C                  CALL WRITES (W,1,NCTCON,1)
C                  WRITE (MBOUT,*) ' Tolerance factor FACT2 in CLFOR2',
C     *                          ' may need adjustment upward'
C               END IF
C               CALL SVBKSB (U,W,V,NCTCON,NCTCON,L64,L64,
C     *                      RLAMDA,RLAMDA,WORK)
C
C               IF (IPRNT .EQ. NOPRNT) THEN
C                  CALL MULT3(A,RLAMDA,TEMPV,NCTCON,NCTCON,1,L64,L64,L64)
C                  WRITE (MBOUT,*) 'A * RLAMDA SHOULD EQUAL VC ABOVE'
C                  CALL WRITES (TEMPV,1,NCTCON,1)
C               END IF   ! This is not the statr of an interval (jil.ne.4)
C            ELSE    
C              THE A MATRIX HAS GONE SINGULAR: GO BACK TO RKADAM, RESTART
C              THIS INTERVAL AT THE DELTA T BEGINNING AND USE SVD.
C               WRITE (MBOUT,*) 'RETRK,BACK SOLVING ACTIVATED: JIL='
C     *                      ,JIL,'T=',T
C               RETRK = .TRUE.
C               RETURN
C            END IF
         ELSE
C           SOLVE FOR LAMDA USING GAUSS ELIMINATION
            CALL DGESL (ACLMAT,cL64,NCTCON,ICLPVT,RLAMDA,0)
C
            IF ((IPRNT .EQ. NOPRNT .AND. JIL .EQ. 4) 
     *          .and. mbplvl .eq. 9) THEN
CC@CC
CC@CC .........MULT3 ACOPY, RLAMDA, TEMPV
CC@CC .........NCTCON, NCTCON, 1
CC@CC .........L64, L64, L64
      CALL DGEMV('N',NCTCON,NCTCON,1.0d0,ACOPY,cL64,RLAMDA,1,0.0d0,TEMPV
     .,1)
CC@CC end of expanded call
CC@CC
               WRITE (MBOUT,*) 'A * RLAMDA SHOULD EQUAL ERROR VECTOR'
               CALL WRITES (TEMPV,1,NCTCON,1)
            END IF
         END IF
C      ELSE    ! Already backsolving (BCKSLV = .TRUE.)
C         CALL DSVDC (A,L64,NCTCON,NCTCON,W,E,U,L64,V,L64,
C     *               WORK,11,INFO)
C
C         IF (IPRNT .EQ. NOPRNT .AND. JIL .EQ. 4) THEN
C            WRITE (MBOUT,*) 'THE SINGULAR VALUES ARE'
C            CALL WRITES (W,1,NCTCON,1)
C         END IF
C
C         WMAX = 0.0D0
C         DO J = 1, NCTCON
C            IF (W(J) .GT. WMAX) WMAX = W(J)
C         END DO
C         WMIN = WMAX * FACT2
C         DO J = 1, NCTCON
C            IF (W(J) .LT. WMIN) W(J) = 0.0D0
C         END DO
C         CALL SVBKSB (U,W,V,NCTCON,NCTCON,L64,L64,RLAMDA,RLAMDA,WORK)
C
C         IF (IPRNT .EQ. NOPRNT .AND. JIL .EQ. 4) THEN
C            CALL MULT3(A,RLAMDA,TEMPV,NCTCON,NCTCON,1,L64,L64,L64)
C            WRITE (MBOUT,*) 'ACOPY * RLAMDA SHOULD EQUAL VC ABOVE'
C            CALL WRITES (TEMPV,1,NCTCON,1)
C         END IF
C
C      END IF
C
      IF(LEQU) THEN
         CALL MWRITE(RLAMDA,1,IROW-1,'RLAMDA',1)
      ENDIF
C
      RETURN
      END
