C $Header: /export/cvs/c34a1/source/moldyn/cmpic2.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C ========================================================================
C
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER 
C STATE AND FEDERAL LAWS.  USE, DISCLOSURE, REPRODUCTION OR DUPLICATION 
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS 
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT 
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C



      SUBROUTINE cmpic2(amdamp,p,gvec,cmat,cmat2,fmat,kpvtm,gmx,sm,
     *                  kpvtal,vsav,iaconn,ibconn,ihconn,rvec,
     *                  rotcoor,modevctr,xmass,itopol,idbl,icbl)
c
C     CoMPute Initial Coordinates for bodies and atoms.  The second of
C     three routines to compute MBO(N)D coordinates from atomistic
C     positions and velocities.
c     This subroutine performs the position fit and velocity fit
c     by the Least Squares algorithm organized in the block form
c
      IMPLICIT NONE
c
#include "PARAM.FOR"
c
#include "CHARMM.INC"
#include "COMPOS.INC"
#include "COREA.INC"
#include "CSTIFF.INC"
#include "ERRHDL.INC"
#include "HANDS2.INC"
#include "HEAPMB.INC"
#include "INFOV.INC"
#include "MEMLB.INC"
#include "MISCNO.INC"
#include "MOMENG.INC"
#include "NUMBRS.INC"
#include "OPTION.INC"
#include "SPECIF.INC"
#include "STATUS.INC" 
#include "TAPENO.INC"
c
c     Passed variable
c
      DOUBLE PRECISION amdamp(cL06,L01)
      DOUBLE PRECISION p(cl10)
      DOUBLE PRECISION gvec(cl72)
      DOUBLE PRECISION rvec(3,cL02)
      INTEGER iaconn(2,cL02)
      INTEGER ibconn(2,cL02)
      INTEGER ihconn(2,cL02)
      INTEGER itopol(2,cL02)

c     Local variables
c
      INTEGER i0,i1,i2,i6,i,ic,ic2,im,i3     !  DO loop index
      INTEGER iat,ifb,ik0,ik1,ik4,iv6
      INTEGER ibup,ifit,iloc,imas,iatm,imo,iter,itype
      INTEGER ibisect                        !  Bisection iteration counter
      INTEGER j,j1,j2,j3,jb6,jj
      INTEGER k,k1,kfirst,ksecnd
      INTEGER lda,ldf,lm,lnc,lnf,lp,lr1,lv
      INTEGER mcolc,nctype,named,namev,nlm,nbytes,np_v
      INTEGER n,na,naa,ne,ng,nx,nfm,lastindx
      INTEGER i62(2),ik02(3)
      DOUBLE PRECISION xcm(3)             !  Body center of mass (i.c.)
      DOUBLE PRECISION cmat(3,cL08),cmat2(3,cL08,2)
      DOUBLE PRECISION tmat(3,3),d(3),b(3),bc(3),s(3),s2(3,2),syscg(3)
      DOUBLE PRECISION fmat(cL08,3),smat(3,3)
      DOUBLE PRECISION wt(L03)

      DOUBLE PRECISION al,amas,dum,fmas,gain
      DOUBLE PRECISION perr,sum,tmas,var,verr,oldsum
      DOUBLE PRECISION vsav(cL72)
c
c     Additional arrays for compressing amat
      INTEGER kpvtm(cL08),kpvtal(cL10)
      INTEGER imbl(3,L01),idbl(3,cL02),icbl(4,cL76)
      DOUBLE PRECISION gmx(cL08),sm(cL08,cL08)

c-epk-edits-------------------------------------------------------------
c     variables for rigid body overlap
      DOUBLE PRECISION rotCoor(3,cL43)
      DOUBLE PRECISION cost, modeVctr(3*cL43*cL06)
      DOUBLE PRECISION rotMatrix(3,3), xMass(cL43)
      INTEGER status, iDum, jDum, iiDum, iiAtom, indxDS, iMode
      DOUBLE PRECISION COST_THRESHOLD
      PARAMETER (COST_THRESHOLD=0.1D-0)
      CHARACTER*4 minimiz_str, debug_str
c-epk-edits-------------------------------------------------------------
c
c
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: cmpic2.f,v $$Revision: 1.1.1.1 $'/
      DATA WT /L03*1D0/

c-epk-edits-------------------------------------------------------------
#if DEBUG
C     Set debug string.
      CALL getenv('DEBUG_CMPIC2',debug_str)
C     Set minimz string. Will enable minimization for hinge off.
      CALL getenv('MINIMIZ_CMPIC2',minimiz_str)
#endif
c-epk-edits-------------------------------------------------------------
c
      amt = 0.d0
C     Initialize theta to zero
      CALL ZERO(theta,3,nbdy,3)

      DO i = 1, nb
         lr1 = 2*iatoms(1,i) - 1
         iloc = M30 + 3*(iatoms(1,i)-1)
         imas = M20 + iatoms(1,i) - 1
         iatm = iatoms(3,i)
c
c     Define cgnom to be the same as xcm, so that the body's nominal 
c     center of mass (cgnom) is coincident with the initial coordinates'
c     center of mass (xcm).  Note that cgnom is now in inertial coordinates.
c
         call cgadji(X(iloc),X(imas),xcm,tmas,iatm,1,0)
         amt = amt + tmas

         DO i1 = 1, 3
            cgnom(i1,i) = xcm(i1)
         END DO
c
c     Take out the rotational offset.
c     (Do this iteratively, Newton's method.)

         IF (i .LE. nbdy) THEN

c-epk-edits-start-------------------------------------------------------
c           CALL rtadj(ds(1,lr1),X(iloc),X(imas),theta(1,i),iatm,i)
C
C           If the body is flexible perform rigid body overlap and modal
C           decomposition of remaining difference.  Currently rigid bodies
C           are not fit.
            IF (irgflx(i) .GT. 0) THEN 
C              Copy coordinates of current body's atoms (body
C              frame) and compute mass from inverse mass for
C              rigid body overlap 
               DO iiAtom = 1, iatm
                  xMass(iiAtom) = 1.D+0/X(imas+iiAtom-1)
                  indxDS = lr1 + (2*(iiAtom-1))
                  rotCoor(1,iiAtom) = ds(1,indxDS)
                  rotCoor(2,iiAtom) = ds(2,indxDS)
                  rotCoor(3,iiAtom) = ds(3,indxDS)
               END DO

C              Initialize to zero the block for flex modes and
C              copy modal eigenvectors (modes shapes) from HATS
               jDum = 1
               DO iMode = 1, irgflx(i)
                  amdamp(iMode,i) = ZRO
                  DO iiAtom = iatoms(1,i),iatoms(2,i)
                     iDum = 3*(iMode-1) + ihtsptr(iiAtom)
                     modeVctr(jDum) = HATS(iDum+1)
                     modeVctr(jDum+1) = HATS(iDum+2)
                     modeVctr(jDum+2) = HATS(iDum+3)
                     jDum = jDum + 3
                  END DO
               END DO

C              perform rigid body overlap and modal decomposition.
               CALL bodyFit(MBOUT,iatm,irgflx(i),xMass,amdamp(1,i),
     &                      modeVctr,rotCoor,X(iloc),COST_THRESHOLD,
     &                      theta(1,i),rotMatrix, cost, status,
     &                      LocalHeap(itmpampptr),LocalHeap(
     &                      ierrorptr))
               IF (status .EQ. FAILURE .OR. cost .GE. COST_THRESHOLD) 
     &          WRITE(MBOUT,'(a,i4,a,d10.3,a,d8.1)')
     &          'CMPIC2> Warning bodyFit cost for body',i, ' is',cost,
     &          ' threshold is ', COST_THRESHOLD
#if DEBUG
               IF (debug_str .NE. '') THEN
C                 Check the second Euler angle to see if it is approaching
C                 gimbol lock.
                  IF (ABS(SIN(theta(2,i))) .GT. EULER_THRESHOLD) THEN
                     WRITE(MBOUT,*) ' '
                     WRITE(MBOUT,'(2a,i4)') 'CMPIC2> Over Euler ',
     &                'threshold, need to resequence body ', i
                  ENDIF
               ENDIF
#endif
            ENDIF
         ENDIF
      END DO

#if DEBUG
      IF (debug_str .NE. '') THEN
         call posrms(cost,1)
         write(MBOUT,'(f6.3,a)') cost,' cost from posrms'
      ENDIF
#endif
c-epk-edits-end---------------------------------------------------------


c
c ------------------------------------- 
c     Iterate to determine initial modal amplitudes and rigid
c     rotations and translations for all fragments, while
c     maintaining bond length constraints.
c
c     Assemble and solve the following set of linear equations
c
c     [  M    D**T ] {   dx   }     {   g   }
c     [            ] {        }  =  {       }
c     [  D     0   ] { lambda }     { -L/2  }
c
c        amat       *  unknown   =    gvec
c
c     The algorithm accounts for the partition of the matrix AMAT
c     as well as the partition of its blocks M and D (see dlespa.f)
c
c ------------------------------------- 
c
      imo = 1               !  = 1 if momentums are fitted
                            !  = 0 if momentums are not fitted 
      nctype = 2            !  for bond-length constraints

      gain = 0.3d0

      na = koff + nconn
      ik1 = na + 1
      ik4 = ik1 + 3
      lda = cL72
      lnc = cL76
      lnf = cL08
      mcolc = cL08
      ldf = mcolc
      itype = 1
      iter = 1
c
c     Compute the A matrix and the g vector for the unconstrained part of the
c     position fitting problem
c
c     Determine all sizes of amat's blocks for packing amat into 1D array
c     (position fitting)
      call sizes_amat(0,nb,nh,nconn,2,IRGFLX,iatoms,
     &ihconn,itopol,naa,ng,nx,nfm,named,namev,imbl,idbl)
c
c     Perform allocation for amat
c     Note:  extended by 6*nx to account for velocity fit (next)
      if (imo .eq. 1) then
         lastindx = naa+(6*nx)
      else
         lastindx = naa
      end if
      nbytes = DBPRESZ*lastindx
#ifdef POINTER_KEYWORD
      CALL mbAlcPtr(naa_p, nbytes)
      CALL cmpic2_1(pre_amat,
     &     amdamp,p,gvec,rvec,iaconn,ibconn,ihconn,itopol,
     &     i0,i1,i2,i6,i,ic,ic2,im,i3,     !  DO loop index
     &     iat,ifb,ik0,ik1,ik4,iv6,
     &     ibup,ifit,iloc,imas,iatm,imo,iter,itype,
     &     ibisect,                        !  Bisection iteration counter
     &     j,j1,j2,j3,jb6,jj,
     &     k,k1,kfirst,ksecnd,
     &     lda,ldf,lm,lnc,lnf,lp,lr1,lv,
     &     mcolc,nctype,named,namev,nlm,nbytes,np_v,
     &     n,na,naa,ne,ng,nx,nfm,
     &     i62,ik02,
     &     xcm,               !  Body center of mass (i.c.)
     &     cmat,cmat2,
     &     tmat,d,b,bc,s,s2,syscg,
     &     fmat,smat,
     &     wt,
     &     al,amas,dum,fmas,gain,
     &     perr,sum,tmas,var,verr,oldsum,
     &     vsav,
     &     kpvtm,kpvtal,
     &     imbl,idbl,icbl,
     &     gmx,sm,
     &     rotCoor,
     &     cost, modeVctr,
     &     rotMatrix, xMass,
     &     status, iDum, jDum, iiDum, iiAtom, indxDS, iMode,
     &     COST_THRESHOLD,
     &     minimiz_str, debug_str)

c     Free dynamically allocated memory for amat
      CALL mbFrePtr(naa_p)
c
#else
      lsqfit_ptr = lastindx
      if ( lastIndx .GT. MAX_cmpic2Heap ) then
         WRITE(MBOUT,*)
     +     'Do not have enough memory allocated for cmpic2Heap
     + in source/moldyn/PARAM.FOR'
         CALL CLEARERR()
         WRITE(ERRMSG,'(1X,A,I9,A)')
     + 'Increase MAX_cmpic2Heap to > ', lastIndx,
     +     ' in PARAM.FOR'
         CALL ERRHDL(-5,'<CMPIC2>')
      end if

      CALL cmpic2_1(heap_lsqfit(1),
     &     amdamp,p,gvec,rvec,iaconn,ibconn,ihconn,itopol,
     &     i0,i1,i2,i6,i,ic,ic2,im,i3,     !  DO loop index
     &     iat,ifb,ik0,ik1,ik4,iv6,
     &     ibup,ifit,iloc,imas,iatm,imo,iter,itype,
     &     ibisect,                        !  Bisection iteration counter
     &     j,j1,j2,j3,jb6,jj,
     &     k,k1,kfirst,ksecnd,
     &     lda,ldf,lm,lnc,lnf,lp,lr1,lv,
     &     mcolc,nctype,named,namev,nlm,nbytes,np_v,
     &     n,na,naa,ne,ng,nx,nfm,
     &     i62,ik02,
     &     xcm,               !  Body center of mass (i.c.)
     &     cmat,cmat2,
     &     tmat,d,b,bc,s,s2,syscg,
     &     fmat,smat,
     &     wt,
     &     al,amas,dum,fmas,gain,
     &     perr,sum,tmas,var,verr,oldsum,
     &     vsav,
     &     kpvtm,kpvtal,
     &     imbl,idbl,icbl,
     &     gmx,sm,
     &     rotCoor,
     &     cost, modeVctr,
     &     rotMatrix, xMass,
     &     status, iDum, jDum, iiDum, iiAtom, indxDS, iMode,
     &     COST_THRESHOLD,
     &     minimiz_str, debug_str)
#endif
c
      RETURN
      END

      SUBROUTINE cmpic2_1(amat,amdamp,p,gvec,rvec,iaconn,ibconn,
     &     ihconn,itopol,
     &     i0,i1,i2,i6,i,ic,ic2,im,i3,
     &     iat,ifb,ik0,ik1,ik4,iv6,
     &     ibup,ifit,iloc,imas,iatm,imo,iter,itype,
     &     ibisect,                  
     &     j,j1,j2,j3,jb6,jj,
     &     k,k1,kfirst,ksecnd,
     &     lda,ldf,lm,lnc,lnf,lp,lr1,lv,
     &     mcolc,nctype,named,namev,nlm,nbytes,np_v,
     &     n,na,naa,ne,ng,nx,nfm,
     &     i62,ik02,
     &     xcm,         
     &     cmat,cmat2,
     &     tmat,d,b,bc,s,s2,syscg,
     &     fmat,smat,
     &     wt,
     &     al,amas,dum,fmas,gain,
     &     perr,sum,tmas,var,verr,oldsum,
     &     vsav,
     &     kpvtm,kpvtal,
     &     imbl,idbl,icbl,
     &     gmx,sm,
     &     rotCoor,
     &     cost, modeVctr,
     &     rotMatrix, xMass,
     &     status, iDum, jDum, iiDum, iiAtom, indxDS, iMode,
     &     COST_THRESHOLD,
     &     minimiz_str, debug_str)

      IMPLICIT NONE
c
#include "PARAM.FOR"
c
#include "CHARMM.INC"
#include "COMPOS.INC"
#include "COREA.INC"
#include "CSTIFF.INC"
#include "ERRHDL.INC"
#include "HANDS2.INC"
#include "HEAPMB.INC"
#include "INFOV.INC"
#include "MEMLB.INC"
#include "MISCNO.INC"
#include "MOMENG.INC"
#include "NUMBRS.INC"
#include "OPTION.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
c
c     Original passed variables
c
      DOUBLE PRECISION amdamp(cL06,L01)
      DOUBLE PRECISION p(cl10)
      DOUBLE PRECISION gvec(cl72)
      DOUBLE PRECISION rvec(3,cL02)
      INTEGER iaconn(2,cL02)
      INTEGER ibconn(2,cL02)
      INTEGER ihconn(2,cL02)
      INTEGER itopol(2,cL02)

c     Locally passed variables
c

      DOUBLE PRECISION amat(*)
      INTEGER i0,i1,i2,i6,i,ic,ic2,im,i3     !  DO loop index
      INTEGER iat,ifb,ik0,ik1,ik4,iv6
      INTEGER ibup,ifit,iloc,imas,iatm,imo,iter,itype
      INTEGER ibisect                        !  Bisection iteration counter
      INTEGER j,j1,j2,j3,jb6,jj
      INTEGER k,k1,kfirst,ksecnd
      INTEGER lda,ldf,lm,lnc,lnf,lp,lr1,lv
      INTEGER mcolc,nctype,named,namev,nlm,nbytes,np_v
      INTEGER n,na,naa,ne,ng,nx,nfm
      INTEGER i62(2),ik02(3)
      DOUBLE PRECISION xcm(3)             !  Body center of mass (i.c.)
      DOUBLE PRECISION cmat(3,cL08),cmat2(3,cL08,2)
      DOUBLE PRECISION tmat(3,3),d(3),b(3),bc(3),s(3),s2(3,2),syscg(3)
      DOUBLE PRECISION fmat(cL08,3),smat(3,3)
      DOUBLE PRECISION wt(L03)

      DOUBLE PRECISION al,amas,dum,fmas,gain
      DOUBLE PRECISION perr,sum,tmas,var,verr,oldsum
      DOUBLE PRECISION vsav(cL72)
c
c     Additional arrays for compressing amat
      INTEGER kpvtm(cL08),kpvtal(cL10)
      INTEGER imbl(3,L01),idbl(3,cL02),icbl(4,cL76)
      DOUBLE PRECISION gmx(cL08),sm(cL08,cL08)

c-epk-edits-------------------------------------------------------------
c     variables for rigid body overlap
      DOUBLE PRECISION rotCoor(3,cL43)
      DOUBLE PRECISION cost, modeVctr(3*cL43*cL06)
      DOUBLE PRECISION rotMatrix(3,3), xMass(cL43)
      INTEGER status, iDum, jDum, iiDum, iiAtom, indxDS, iMode
      DOUBLE PRECISION COST_THRESHOLD
      CHARACTER*4 minimiz_str, debug_str

c-epk-edits-------------------------------------------------------------
#if DEBUG
C     Setting minimiz_str will re-enable minimization for testing.
      IF (minimiz_str .EQ. '') THEN
#endif
C        If hinge off (nconn=0) then skip the minimization.
         IF (nconn .EQ. 0) GOTO 200
#if DEBUG
      ENDIF
#endif
c-epk-edits-------------------------------------------------------------
      IF (ipdata(99).eq.1 .or. ipdata(99).eq.3) GO TO 200
c
      call posrms(sum,1)
c     sum = 1.0D+12

 100  continue
c
c     Initialize to zero at each new iteration of fitting
      if (imo .eq. 1) then
         n = naa + 6*nx
      else
         n = naa
      end if
      call zero(amat,n,1,n)
      call zero(gvec,ng,1,ng)
c
      do ifb = 1, nb
         i6 = 6 + IRGFLX(ifb)
         ik0 = k0(ifb) + 1
         iat = iatoms(3,ifb)
         if (iat .ne. 1) call rottr(3,itype,theta(1,ifb),tmat,dum,dum)
         i2 = iatoms(1,ifb) - 1
         lm = M20 + i2
         lp = M30 + 3*i2
         do i = 1, iat
            if (iat .eq. 1) then
               s(1) = cgnom(1,ifb) + cgadj(1,ifb)
               s(2) = cgnom(2,ifb) + cgadj(2,ifb)
               s(3) = cgnom(3,ifb) + cgadj(3,ifb)
            else
               call cmposn(i,i2,IRGFLX(ifb),ifb,0,tmat,cmat,s,
     &                     HEAP_MB(iamdampptr),HEAP_MB(ipptr))
            end if
c
c           Compute the current body-block of M and put it into 1D amat
            kfirst = imbl(3,ifb)
            call cpamat(amat(kfirst),naa,cmat,X(lm),i6,iat,wt(i2+i))
            var = wt(i2+i) / X(lm)
            do i1 = 1, 3
               d(i1) = (X(lp) - s(i1)) * var
               lp = lp + 1
            end do
            lm = lm + 1
            if (iat .ne. 1) then
CC@CC
CC@CC .........MULTAD d, cmat, gvec(ik0)
CC@CC .........1, 3, i6
CC@CC .........1, 3, 1
      CALL DGEMV ('T',3,i6,1.0d0,cmat,3,d,1,1.0d0,gvec(ik0),1)
CC@CC end of expanded call
CC@CC
            else
               gvec(ik0)   = gvec(ik0)   + d(1)
               gvec(ik0+1) = gvec(ik0+1) + d(2)
               gvec(ik0+2) = gvec(ik0+2) + d(3)
            end if
         end do
      end do
c
c     Compute the matrix and vector partitions that account for the 
c     bond-length constraints
c
      do ic = 1, nconn          ! Skip if NO constraints have been set 
         do ic2 = 1, 2
            ifb = ibconn(ic2,ic)
            i2 = iatoms(1,ifb) - 1
            i = iaconn(ic2,ic) - i2
            i62(ic2) = 6 + IRGFLX(ifb)
            ik02(ic2) = k0(ifb) + 1 
            if (iatoms(3,ifb) .eq. 1) then
               s2(1,ic2) = cgnom(1,ifb) + cgadj(1,ifb)
               s2(2,ic2) = cgnom(2,ifb) + cgadj(2,ifb)
               s2(3,ic2) = cgnom(3,ifb) + cgadj(3,ifb)
            else
               call rottr(3,itype,theta(1,ifb),tmat,dum,dum)
               call cmposn(i,i2,IRGFLX(ifb),ifb,0,tmat,cmat2
     *              (1,1,ic2),s2(1,ic2),HEAP_MB(iamdampptr),
     *              HEAP_MB(ipptr))
            end if
         end do
c
c     Compute AL, the sum square error of the bond length
c
         al = ZRO
         j1 = M30 + 3*iaconn(1,ic) - 4
         j2 = M30 + 3*iaconn(2,ic) - 4
         do i1 = 1, 3
            b(i1) = s2(i1,2) - s2(i1,1)
            bc(i1) = X(j2+i1) - X(j1+i1)
            al = al + b(i1)**2 - bc(i1)**2
         end do
c
c     Define the pointer for body-block of D corresponding to 
c     the second and first atom
      if (ibconn(1,ic) .gt. ibconn(2,ic)) then
         kfirst = idbl(3,ic) + imbl(1,ibconn(2,ic))
         ksecnd = idbl(3,ic)
      else
         kfirst = idbl(3,ic)
         ksecnd = idbl(3,ic) + imbl(1,ibconn(1,ic))
      end if   
c
c     Compute the D partition of the A matrix due to the second atom of
c     the bond
         k = koff + ic
c
         if (iatoms(3,ibconn(2,ic)) .ne. 1) then
c
CC@CC
CC@CC ...MULT3T cmat2(1,1,2), b, amat(ksecnd)
CC@CC ...i62(2), 3, 1
CC@CC ...3, 3, naa
      CALL DGEMV ('T',3,i62(2),1.0d0,cmat2(1,1,2),3,b,1,0.0d0,amat(ksecn
     .d),1)
CC@CC end of expanded call
CC@CC
         else
            amat(ksecnd)     = b(1)
            amat(ksecnd + 1) = b(2)
            amat(ksecnd + 2) = b(3)
         end if
c
c     Compute the D partition of the A matrix due to the first atom of
c     the bond
c
         do i1 = 1, 3
            b(i1) = - b(i1)
         end do
         if (iatoms(3,ibconn(1,ic)) .ne. 1) then
CC@CC
CC@CC ...MULT3T cmat2, b, amat(kfirst)
CC@CC ...i62(1), 3, 1
CC@CC ...3, 3, naa
      CALL DGEMV ('T',3,i62(1),1.0d0,cmat2,3,b,1,0.0d0,amat(kfirst),1)
CC@CC end of expanded call
CC@CC
         else
            amat(kfirst)     = b(1)
            amat(kfirst + 1) = b(2)
            amat(kfirst + 2) = b(3)
         end if
         gvec(koff+ic) = - al/2.
      end do
c
c     Solve the constrained minimization problem for position fitting 
c     taking into account the sparsity of amat
c
      call dlespa(amat,gvec,naa,ng,nx,nb,nfm,nh,nconn,nconn,nctype,
     &ihconn,itopol,named,namev,imbl,idbl,icbl,gmx,sm,
     &kpvtm,kpvtal,lnc,lnf)

      var = ZRO
      DO i = 1, ng
         var = var + gvec(i)**2
      END DO
      var = SQRT(var/DBLE(ng))

c
c     Apply the corrections to the positional states (with a reduced stepsize)
c
      i = 0
      do ifb = 1, nb
         i0 = k0(ifb)
         do i1 = 1, 3
            if (iatoms(3,ifb) .ne. 1) then
               i = i + 1
               vsav(i) = theta(i1,ifb)
               i = i + 1
               vsav(i) = cgadj(i1,ifb)
               theta(i1,ifb) = theta(i1,ifb) + gain*gvec(i0+i1)
               cgadj(i1,ifb) = cgadj(i1,ifb) + gain*gvec(i0+i1+3)
            else
               i = i + 1
               vsav(i) = cgadj(i1,ifb)
               cgadj(i1,ifb) = cgadj(i1,ifb) + gain*gvec(i0+i1)
            end if
         end do
         do j = 1, IRGFLX(ifb)
            i = i + 1
            vsav(i) = amdamp(j,ifb)
            amdamp(j,ifb) = amdamp(j,ifb) + gain*gvec(i0+j+6)
         end do
      end do
c
c     Monitor convergence by computing the sum square error of the correction
c     vector
c
      i3 = 0
 175  i3 = i3 + 1
      oldsum = sum
 150  call posrms(sum,1)
c
      if (mbplvl .ge. 1)
     $     write (MBOUT,7364) iter, gain, sum, oldsum
 7364 format(/, 'In cmpic2 after ',i8,' iterations, gain is ',f6.3,
     &     ' RMS error is ',D22.15, ' old RMS error is ',D22.15/)
c
      if (iter .ne. 1) then
         if (sum .gt. oldsum .AND. sum .GE. 5D-2 .AND. 
     &        var .GE. 0.05) then
            ibisect = 0
c
c     Re-apply the corrections to the positional states
c
 45         gain  = gain / 2D0
            ibisect = ibisect + 1
            i = 0
            do ifb = 1, nb
               i0 = k0(ifb)
               do i1 = 1, 3
                  if (iatoms(3,ifb) .ne. 1) then
                     i = i + 1
                     theta(i1,ifb) = vsav(i) + gain*gvec(i0+i1)
                     i = i + 1
                     cgadj(i1,ifb) = vsav(i) + gain*gvec(i0+i1+3)
                  else
                     i = i + 1
                     cgadj(i1,ifb) = vsav(i) + gain*gvec(i0+i1)
                  end if
               end do
               do j = 1, IRGFLX(ifb)
                  i = i + 1
                  amdamp(j,ifb) = vsav(i) + gain*gvec(i0+j+6)
               end do
            end do
            call posrms(sum,1)
            IF (mbplvl .GE. 1)
     &           WRITE (MBOUT,7370) gain, sum, oldsum
 7370       FORMAT(/,18X,'Gain bisection: New gain = ', F6.3,
     &           ' RMS error is ',D22.15, ' old RMS error is ',D22.15/)
            IF (sum .LT. oldsum) THEN
            ELSE IF (ibisect .GT. 10) THEN
               WRITE(MBOUT,7380)
 7380          FORMAT(/,' Bisection proceeded for more than 10 steps', 
     &              ' in cmpic2')
               WRITE(MBOUT,7381) iter, gain
 7381          FORMAT('Iter = ',I3,' gain = ',1PE15.3)
               GO TO 200
            ELSE
               GO TO 45
            END IF
         else
            gain = gain * 1.2d0   
         end if
c
      end if
c
      if ((sum .lt. 5D-2) .OR. (var .LT. 0.05) .OR. 
     &     (iter .eq. 200)) go to 200
c
c     Continue iteration if corrections have not converged
c
      iter = iter + 1
      go to 100
c
c ------------------------------------- Establish bond vectors
c                                         in inertial space
 200  continue
      if (iter .eq. 200) then
         CALL CLEARERR()
         WRITE(MBOUT,400) ' FAILED TO FIT INITIAL CONDITIONS *****',
     +        ' 200 position iterations performed ****'
         WRITE(ERRMSG,'(1X,A)') 'Error in subroutine.'
         CALL ERRHDL(-5,'<CMPIC2>')
      end if
 400  FORMAT(A,/,A)
c
      do ic = 1, nconn          ! Skip if NO constraints have been set 
         do ic2 = 1, 2
            ifb = ibconn(ic2,ic)
            i2  = iatoms(1,ifb) - 1
            i   = iaconn(ic2,ic) - i2
            im  = IRGFLX(ifb)
            if (iatoms(3,ifb) .eq. 1) then
               s2(1,ic2) = cgnom(1,ifb) + cgadj(1,ifb)
               s2(2,ic2) = cgnom(2,ifb) + cgadj(2,ifb)
               s2(3,ic2) = cgnom(3,ifb) + cgadj(3,ifb)
            else
               call rottr(3,itype,theta(1,ifb),tmat,dum,dum)
               call cmposn(i,i2,IRGFLX(ifb),ifb,1,tmat,dum,s2(1,ic2),
     &                     HEAP_MB(iamdampptr),HEAP_MB(ipptr))
            end if
         end do
         sum = 0.
         j1 = M30 + 3*iaconn(1,ic) - 4
         j2 = M30 + 3*iaconn(2,ic) - 4
         do i1 = 1, 3
            rvec(i1,ic) = s2(i1,2) - s2(i1,1)
            s(i1) = X(j2+i1) - X(j1+i1)
            sum = sum + rvec(i1,ic)**2 - s(i1)**2
         end do
         IF (MBPLVL .GE. 9) THEN 
           write (MBOUT,*) 'Bond ',ic,
     *     ':   Bond length error (squared) = '
     *     ,sum
         END IF
      end do
c
c ------------------------------------- Compute adjusted system C.G.
c
      call zero(syscg,3,1,3)
      tmas = 0.d0
      itype = 1
      do ifb = 1, nb
         i2 = iatoms(1,ifb) - 1
         lm = M20 + iatoms(1,ifb) - 1
         iat = iatoms(3,ifb)
         if (iat .ne. 1) then
            call rottr(3,itype,theta(1,ifb),tmat,dum,dum)
         end if
         do i = 1, iat
            amas = 1.d0/X(lm)
            lm = lm + 1
            tmas = tmas + amas
            if (iat .ne. 1) then
               call cmposn(i,i2,IRGFLX(ifb),ifb,1,tmat,dum,s,
     &                     HEAP_MB(iamdampptr),HEAP_MB(ipptr))
            else
               s(1) = cgnom(1,ifb) + cgadj(1,ifb)
               s(2) = cgnom(2,ifb) + cgadj(2,ifb)
               s(3) = cgnom(3,ifb) + cgadj(3,ifb)
            end if
            do i1 = 1, 3
               syscg(i1) = syscg(i1) + amas*s(i1)
            end do
         end do
      end do
      do i1 = 1, 3
         syscg(i1) = syscg(i1)/tmas
      end do
c
c ------------------------------------- 
c     Determine initial modal rates and rigid linear
c       and angular rates for all fragments, while
c       maintaining bond length constraints.
c
c     Assemble and solve the following set of linear equations
c
c     [  M    E**T ] { dx dot }     {   k   }
c     [            ] {        }  =  {       }
c     [  E     0   ] { lambda }     {   0   }
c
c        amat       *  unknown   =    gvec
c
c -------------------------------------
c
 
c 
c     Print out the linear and angular momentum before the least squares fit
c        
      IF (MBPLVL .GE. 9) THEN
         WRITE(MBOUT,2020) 'The linear momentum vector  = ',
     +     (totl(i),i=1,3)
         sum = ZRO
         DO i = 1, 3
            sum = sum + totl(i)**2
         END DO
         WRITE(MBOUT,2020) 'The linear mom. magnitude   = ', SQRT(sum)
         WRITE(MBOUT,2020) 'The angular momentum vector = '
     +     , (htot(i),i=1,3)
         sum = ZRO
         DO i = 1, 3
            sum = sum + htot(i)**2
         END DO
        WRITE(MBOUT,2020) 'The angular mom. magnitude  = ', SQRT(sum)
      END IF 
 2020 FORMAT(1X,A,3(1PE11.3))

      if (imo .eq. 1) then
         ifit = 1
         na = koff + nconn + 6
      else
         ifit = 0
         na = koff + nconn 
      end if
c
c     Determine all sizes of amat's blocks for packing amat into 1D array
c     (velocity fitting)
      call sizes_amat(ifit,nb,nh,nconn,2,IRGFLX,iatoms,
     &ihconn,itopol,naa,ng,nx,nfm,named,namev,imbl,idbl)
c
      call zero(amat,naa,1,naa)
      call zero(gvec,ng,1,ng)
c
      if (ipdata(99).ge.2) go to 300
c
      do ifb = 1, nb
         call zero(sm,lnf,lnf,lnf)          !  Make sm zero for new body
         i6 = 6 + IRGFLX(ifb)
         ik0 = k0(ifb) + 1
         iat = iatoms(3,ifb)
         if (iat .ne. 1) call rottr(3,itype,theta(1,ifb),tmat,dum,dum)
         i2 = iatoms(1,ifb) - 1
         lm = M20 + i2
         lv = M40 + 3*(iatoms(1,ifb)-1)
         do i = 1, iat
            if (iat .eq. 1) then
               s(1) = cgnom(1,ifb) + cgadj(1,ifb)
               s(2) = cgnom(2,ifb) + cgadj(2,ifb)
               s(3) = cgnom(3,ifb) + cgadj(3,ifb)
            else
               call cmposn(i,i2,IRGFLX(ifb),ifb,0,tmat,cmat,s,
     &                     HEAP_MB(iamdampptr),HEAP_MB(ipptr))
            end if
c
c     Form the M partition of the A matrix that accounts for the 
c     unconstrained minimization problem
c
c           Compute the current body-block of M and put it into 1D amat
            kfirst = imbl(3,ifb)
            call cpamat(amat(kfirst),naa,cmat,X(lm),i6,iat,wt(i2+i))
            do i1 = 1, 3
               s(i1) = s(i1) - syscg(i1)
            end do
            call skewv3(s,smat,1,3)
            fmas = 1./X(lm)
c
            if (imo .eq. 0) go to 147
c     Form the portion of the E**T partition of the A matrix that specifies
c     angular and linear momentum constraints
c
            i0 = ik0 - 1
            if (iat .ne. 1) then
               do k1 = 1, i6
                  do i1 = 1, 3
                     fmat(k1,i1) = cmat(i1,k1)*fmas
                  end do
               end do
CC@CC
CC@CC .........MULTAD fmat, smat, sm(1,1)
CC@CC .........i6, 3, 3
CC@CC .........ldf, 3, lnf
      CALL DGEMM ('N','N',i6,3,3,1.0d0,fmat,ldf,smat,3,1.0d0,sm(1,1),lnf
     .)
CC@CC end of expanded call
CC@CC
c
               do j = 1, 3
                  jj = 3 + j
                  do k = 1, i6
                     sm(k,jj) = sm(k,jj) + fmat(k,j)
                  end do
               end do
            else
               do j = 1, 3
                  jj = j
                  do k = 1, 3
                     sm(k,jj) = sm(k,jj) + smat(k,j)*fmas
                  end do
               end do
               do j = 1, 3
                  sm(j,3+j) = sm(j,3+j) + fmas
               end do
            end if
 147        continue
c
c     Form the k vector partition of gvec for the unconstrained velocity
c     fitting
c
            var = fmas * wt(i2+i)
            do i1 = 1, 3
               d(i1) = X(lv)*var
               lv = lv + 1
            end do
            lm = lm + 1
            if (iat .ne. 1) then
CC@CC
CC@CC .........MULTAD d, cmat, gvec(ik0)
CC@CC .........1, 3, i6
CC@CC .........1, 3, 1
      CALL DGEMV ('T',3,i6,1.0d0,cmat,3,d,1,1.0d0,gvec(ik0),1)
CC@CC end of expanded call
CC@CC
            else
               gvec(ik0)   = gvec(ik0)   + d(1)
               gvec(ik0+1) = gvec(ik0+1) + d(2)
               gvec(ik0+2) = gvec(ik0+2) + d(3)
            end if
         end do           !  atoms
c
         if (imo .eq. 0) go to 148
c        Pack body-blocks of E(V) into 1D amat
         ibup = imbl(2,ifb) - 1
c
         do iv6 = 1, 6
            np_v = namev - 1 + (iv6-1)*nx + ibup
c                       ! Pointer(-1) for 'ifb'-th b-b in 'iv6'-th
c                       ! column of E(V)' (1D amat's storage) 
            do jb6 = 1, imbl(1,ifb)
               amat(np_v+jb6) = sm(jb6,iv6)     
            end do
         end do
 148     continue
      end do          !  bodies
c
c     Form the portion of the E**T partition of the A matrix that specifies
c     velocity compatibility for the bond-length constraints
c
      do ic = 1, nconn          ! Skip if NO constraints have been set 
         do ic2 = 1, 2
            ifb = ibconn(ic2,ic)
            i2 = iatoms(1,ifb) - 1
            i = iaconn(ic2,ic) - i2
            i62(ic2) = 6 + IRGFLX(ifb)
            ik02(ic2) = k0(ifb) + 1
            if (iatoms(3,ifb) .ne. 1) then
               call rottr(3,itype,theta(1,ifb),tmat,dum,dum)
               call cmposn(i,i2,IRGFLX(ifb),ifb,2,tmat,
     +              cmat2(1,1,ic2),dum,HEAP_MB(iamdampptr),
     +              HEAP_MB(ipptr))
            end if
         end do
         do i1 = 1, 3
            b(i1) = - rvec(i1,ic)
         end do
c
c     Define the pointer for body-block of D corresponding to 
c     the second and first atom
      if (ibconn(1,ic) .gt. ibconn(2,ic)) then
         kfirst = idbl(3,ic) + imbl(1,ibconn(2,ic))
         ksecnd = idbl(3,ic)
      else
         kfirst = idbl(3,ic)
         ksecnd = idbl(3,ic) + imbl(1,ibconn(1,ic))
      end if   
c
c     Compute the bond-length part of E due to the second atom of
c     the bond
c
         if (iatoms(3,ibconn(2,ic)) .ne. 1) then
CC@CC
CC@CC ...MULT3T cmat2(1,1,2), rvec(1,ic), amat(ksecnd)
CC@CC ...i62(2), 3, 1
CC@CC ...3, 3, naa
      CALL DGEMV ('T',3,i62(2),1.0d0,cmat2(1,1,2),3,rvec(1,ic),1,0.0d0,a
     .mat(ksecnd),1)
CC@CC end of expanded call
CC@CC
         else
            amat(ksecnd)     = rvec(1,ic)
            amat(ksecnd + 1) = rvec(2,ic)
            amat(ksecnd + 2) = rvec(3,ic)
         end if
c
c     Compute the bond-length part of E due to the first atom of
c     the bond
c
         if (iatoms(3,ibconn(1,ic)) .ne. 1) then
CC@CC
CC@CC ...MULT3T cmat2, b, amat(kfirst)
CC@CC ...i62(1), 3, 1
CC@CC ...3, 3, naa
      CALL DGEMV ('T',3,i62(1),1.0d0,cmat2,3,b,1,0.0d0,amat(kfirst),1)
CC@CC end of expanded call
CC@CC
         else
            amat(kfirst)     = b(1)
            amat(kfirst + 1) = b(2)
            amat(kfirst + 2) = b(3)
         end if
      end do
c
      if (imo .eq. 0) go to 149
c     Insert the linear and angular momentum values
c
      j = koff + nconn
      j3 = j + 3
      do i = 1, 3
         gvec(j+i)  = htot(i)
         gvec(j3+i) = totl(i)
      end do
 149  continue
c
c     Solve the constrained minimization problem for velocity fitting 
c     taking into account the sparsity of amat
c
      if (imo .eq. 1) then
         nlm = nconn + 6
      else
         nlm = nconn
      end if
      call dlespa(amat,gvec,naa,ng,nx,nb,nfm,nh,nconn,nlm,nctype,
     &ihconn,itopol,named,namev,imbl,idbl,icbl,gmx,sm,
     &kpvtm,kpvtal,lnc,lnf)
c
 300  continue
c
c
c     Compute data to check velocity compatibility
c
      do ic = 1, nconn          ! Skip if NO constraints have been set 
         do ic2 = 1, 2
            ifb = ibconn(ic2,ic)
            i2 = iatoms(1,ifb) - 1
            i = iaconn(ic2,ic) - i2
            i6 = 6 + IRGFLX(ifb)
            ik0 = k0(ifb) + 1
            if (iatoms(3,ifb) .ne. 1) then
               call rottr(3,itype,theta(1,ifb),tmat,dum,dum)
               call cmposn(i,i2,IRGFLX(ifb),ifb,2,tmat,cmat,dum,
     *                     HEAP_MB(iamdampptr),HEAP_MB(ipptr))
CC@CC
CC@CC .........MULT3 cmat, gvec(ik0), s2(1,ic2)
CC@CC .........3, i6, 1
CC@CC .........3, na, 3
      CALL DGEMV ('N',3,i6,1.0d0,cmat,3,gvec(ik0),1,0.0d0,s2(1,ic2),1)
CC@CC end of expanded call
CC@CC
            else
               s2(1,ic2) = gvec(ik0)
               s2(2,ic2) = gvec(ik0+1)
               s2(3,ic2) = gvec(ik0+2)
            end if
         end do
c
c     Check the velocity compatibility requirement
c
         sum = 0d0
         do i1 = 1, 3
            s(i1) = s2(i1,2) - s2(i1,1)
            sum = sum + s(i1)*rvec(i1,ic)
         end do
         IF (MBPLVL .GE. 9) THEN 
           write (MBOUT,*) 'Bond ',ic,':   R dot V = ',sum
         END IF
      end do

c
c     Compute the position and velocity errors
c
      call posrms(perr,1)
      call velrms(verr,syscg,HEAP_MB(igvecptr),LocalHeap(
     *            icmatptr_velrms))
      IF (MBPLVL .GE. 9) THEN 
        write (MBOUT,*) 'RMS position error: ',perr
        write (MBOUT,*) 'RMS velocity error: ',verr
      END IF
c
      return
      end


C-----------------------------------------------------------------------
      SUBROUTINE targetC(
     &              nAtm,       !i:  number of atoms 
     &              mass,       !i:  mass (nAtm)
     &              rotCoor,    !i:  nominal coord's (3*nAtm)
     &              refCoor,    !i:  reference coord's (3*nAtm)
     &              error,      !o:  diff between rot and ref (3*nAtm)
     &              cost)       !o:  rms average of error
C-----------------------------------------------------------------------
C
C     Compute the difference between the nominal coordinates and the
C     reference coordinates (error) and the rms average of those 
C     differences (cost)
C
      IMPLICIT NONE

C     Arguments:
      INTEGER nAtm
      DOUBLE PRECISION mass(nAtm), rotCoor(3,nAtm)
      DOUBLE PRECISION refCoor(3,nAtm), error(3,nAtm),cost

C     Local variables: 
      INTEGER j

      cost = 0.D+0

      DO j = 1, nAtm
         error(1,j) = refCoor(1,j) - rotCoor(1,j)
         error(2,j) = refCoor(2,j) - rotCoor(2,j)
         error(3,j) = refCoor(3,j) - rotCoor(3,j)
         cost = cost + mass(j) * (error(1,j)**2
     &                          + error(2,j)**2
     &                          + error(3,j)**2)
      ENDDO
      cost = SQRT(cost/DBLE(3*nAtm))

      RETURN
      END




C-----------------------------------------------------------------------
      SUBROUTINE bodyFit( 
     &                mbout,        !i:  unit number of output file
     &                nAtm,         !i:  number of atoms 
     &                nMode,        !i:  number of modes 
     &                mass,         !i:  mass (nAtm)
     &                modeAmp,      !o:  modal amplitude (nMode)
     &                modeVctr,     !i:  modal eigenvectors (3*nAtm*nMode)
     &                rotCoor,      !io: nominal coord's (3*nAtm)
     &                refCoor,      !i:  reference coord's (3*nAtm)
     &                costThreshold,!i:  threshold for iterations
     &                eulAngle,     !o:  Euler angle (3)
     &                rotMatrix,    !o:  rotation matrix (3*3)
     &                cost,         !o:  rms average of error
     &                status,       !io: completion status
     &                tmpAmp,
     &                error)
C-----------------------------------------------------------------------
C
C Routine to perform nominal and reference coordinates overlap.  If body
C is rigid then nominal coordinates are rotated onto reference.  If body
C is flexible then the remaining difference will also be decomposed into
C modes.
C 
C
      IMPLICIT NONE
C
#include "PARAM.FOR"

#include "HEAPMB.INC"
#include "STATUS.INC"
C
C     Arguments:
      INTEGER mbout, nAtm, nMode
      DOUBLE PRECISION mass(nAtm), modeAmp(nMode)
      DOUBLE PRECISION modeVctr(3*nAtm,nMode), rotCoor(3,nAtm)
      DOUBLE PRECISION refCoor(3,nAtm), costThreshold
      DOUBLE PRECISION eulAngle(3), rotMatrix(3,3), cost
      INTEGER status 

C     Local variables: 
      DOUBLE PRECISION tmpRmtrx(3,3), tmpAmp(cL43), comDiff(3)
      DOUBLE PRECISION error(3,cL43)
      INTEGER iLoop
#if DEBUG
      DOUBLE PRECISION thet(3), sum, vecDot
      INTEGER j
      INTEGER iMode, jMode, iiAtom
      CHARACTER*4 debug_str, iterate_str

C     Functions:
      DOUBLE PRECISION weightedDot
#endif
C
#if DEBUG
C     Set debug string.
      CALL getenv('DEBUG_BODYFIT',debug_str)
C     Set iteration string.
      CALL getenv('ITER_BODYFIT',iterate_str)
#endif
C
C     initialize variables for iteration
      iLoop = 0
      CALL ZERO(tmpRmtrx,3,3,3)
      CALL ZERO(tmpAmp,nMode,1,nMode)
      tmpRmtrx(1,1) = 1.0D+0
      tmpRmtrx(2,2) = 1.0D+0
      tmpRmtrx(3,3) = 1.0D+0

#if DEBUG
      IF (debug_str .NE. '') THEN
         CALL targetC(nAtm, mass, rotCoor, refCoor, error, cost)
         write(mbout,'(a,d10.3)') 
     &       'BODYFIT> cost before fitting ', cost
C        Verify that the mode vectors are orthonormal, warn if not.
         DO iMode = 1,nMode
            vecDot = weightedDot(nAtm,modeVctr(1,iMode),
     &                           mass,modeVctr(1,iMode))
            IF ( (1.0D+0 - vecDot)**2 .GT. 1.0D-8 ) 
     &        WRITE(mbout,'(a,I4,a)') 'Mode',iMode,' is not normalized.'
            DO jMode = iMode+1,nMode
               vecDot = weightedDot(nAtm,modeVctr(1,iMode),
     &                              mass,modeVctr(1,jMode))
               IF ( vecDot**2 .GT. 1.0D-8 ) 
     &           WRITE(mbout,'(a,I4,a,I4,a)') 
     &             'Modes',iMode,' and',jMode,' are not orthogonal.'
            ENDDO
         ENDDO
      ENDIF
#endif

500   CONTINUE     ! iterate if body is flexible
      iLoop = iLoop + 1
      CALL kabsch(mbout,nAtm,mass,rotCoor,refCoor,
     &            comDiff,rotMatrix,status)
C     compute error for modal decomposition.
      CALL targetC(nAtm, mass, rotCoor, refCoor, error, cost)

#if DEBUG
      IF (debug_str .NE. '') THEN
         write(mbout,'(a,d10.3)') 
     &       'BODYFIT> cost after rotational overlap (Kabsch) ', cost
      ENDIF
#endif

      IF (nMode .GT. 0) THEN
         CALL modal_decomp(nAtm,nMode,mass,modeAmp,modeVctr,rotCoor, 
     &                     refCoor,rotMatrix, error, status,
     &                     LocalHeap(ievalptr))
C        compute final cost
         CALL targetC(nAtm, mass, rotCoor, refCoor, error, cost)

#if DEBUG
         IF (debug_str .NE. '') THEN
            write(mbout,'(a,d10.3)')
     &         'BODYFIT> cost after modal decomposition ', cost
            write(mbout,'(a)') 
     &            'BODYFIT> error after modal decomposition'
            DO iiAtom = 1, nAtm
               write(mbout,'(3d10.3)') (error(j,iiAtom),j=1,3)
            END DO
         ENDIF
         IF (iterate_str .NE. '') THEN
C           Iterate if cost is too high but quit after 10 iterations
            IF (iLoop .LT. 10 .AND.     
     &          cost .GT. costThreshold) THEN
C              Store sum of modal amplitudes
               DO iMode = 1,nMode
                  tmpAmp(iMode) = tmpAmp(iMode) + modeAmp(iMode)
               ENDDO
C              Store product of rotation matrices.
               CALL multb(rotMatrix,tmpRmtrx,3,3,3,3,3,
     &                    LocalHeap(iwptr_multb))
               GOTO 500
            ELSE IF (iLoop .GT. 1) THEN 
C              Update modeAmp and rotMatrix
               CALL multb(tmpRmtrx,rotMatrix,3,3,3,3,3,
     &                    LocalHeap(iwptr_multb))
               DO iMode = 1,nMode
                  modeAmp(iMode) = tmpAmp(iMode) + modeAmp(iMode)
               ENDDO
            ENDIF
         ENDIF
#endif
      ENDIF
C     Put accumulated rotations into rotMatrix.
      CALL multb(rotMatrix,tmpRmtrx,3,3,3,3,3,
     &           LocalHeap(iwptr_multb))

C     compute Euler Angles for Euler sequence 1.
      CALL eulerAngle(rotMatrix, 1, eulAngle)

      IF (iLoop .GE. 10) THEN
         status = FAILURE
      ELSE 
         status = SUCCESS
      ENDIF

      RETURN
      END




C-----------------------------------------------------------------------
      SUBROUTINE modal_decomp( 
     &                nAtm,        !i:  number of atoms 
     &                nMode,       !i:  number of modes 
     &                mass,        !i:  mass (nAtm)
     &                modeAmp,     !i:  modal amplitude (nMode)
     &                modeVctr,    !i:  modal eigenvectors (3*nAtm*nMode)
     &                rotCoor,     !io: coor set to rotate  (3*nAtm)
     &                refCoor,     !i:  coor reference set  (3*nAtm)
     &                rotMatrix,   !o:  rotation matrix (3*3)
     &                error,       !o:  rot-ref difference (3*nAtm)
     &                status,      !io: completion status
     &                eval)
C-----------------------------------------------------------------------
C
C Routine to decompose errors into modes
C 
      IMPLICIT NONE
C
#include "PARAM.FOR"
C
C     Arguments:
      INTEGER nAtm, nMode
      DOUBLE PRECISION mass(nAtm), modeAmp(nMode)
      DOUBLE PRECISION modeVctr(3*nAtm,nMode), rotCoor(3,nAtm)
      DOUBLE PRECISION refCoor(3,nAtm)
      DOUBLE PRECISION rotMatrix(3,3), error(3,nAtm)
      INTEGER status

C     Local variables:
      DOUBLE PRECISION eval(3,cL43)
      INTEGER iMode, iiAtom

C     Functions:
      DOUBLE PRECISION weightedDot

C     Rotate error into body frame for decomposition into modes.
C     Modes are in body frame.
      DO iiAtom = 1, nAtm
CC@CC
CC@CC ...MULT3T rotMatrix, error(1,iiAtom), eval(1,iiAtom)
CC@CC ...3, 3, 1
CC@CC ...3, 3, 3
      eval(1,iiAtom) = rotMatrix(1,1)*error(1,iiAtom) + rotMatrix(2,1)*e
     .rror(2,iiAtom) + rotMatrix(3,1)*error(3,iiAtom)
      eval(2,iiAtom) = rotMatrix(1,2)*error(1,iiAtom) + rotMatrix(2,2)*e
     .rror(2,iiAtom) + rotMatrix(3,2)*error(3,iiAtom)
      eval(3,iiAtom) = rotMatrix(1,3)*error(1,iiAtom) + rotMatrix(2,3)*e
     .rror(2,iiAtom) + rotMatrix(3,3)*error(3,iiAtom)
CC@CC end of expanded call
CC@CC
      ENDDO

C     Decompose the error into modes
      DO iMode = 1,nMode
         modeAmp(iMode) = weightedDot(nAtm,modeVctr(1,iMode),mass,eval)
      ENDDO

C     Sum the modes, e.g. sum the amplitudes * the eigenvectors
      CALL weightedSum(3*nAtm,nMode,modeVctr,modeAmp,eval)

C     Rotate eval into inertial frame and store in error
C     then add error to rotCoor, rotCoor is in inertial frame.
      DO iiAtom = 1, nAtm
CC@CC
CC@CC MULT3 rotMatrix, eval(1,iiAtom), error(1,iiAtom)
CC@CC 3, 3, 1
CC@CC 3, 3, 3
      error(1,iiAtom) = rotMatrix(1,1)*eval(1,iiAtom) + rotMatrix(1,2
     .)*eval(2,iiAtom) + rotMatrix(1,3)*eval(3,iiAtom)
      error(2,iiAtom) = rotMatrix(2,1)*eval(1,iiAtom) + rotMatrix(2,2
     .)*eval(2,iiAtom) + rotMatrix(2,3)*eval(3,iiAtom)
      error(3,iiAtom) = rotMatrix(3,1)*eval(1,iiAtom) + rotMatrix(3,2
     .)*eval(2,iiAtom) + rotMatrix(3,3)*eval(3,iiAtom)
CC@CC end of expanded call
CC@CC
      END DO
      DO iiAtom = 1, nAtm
         rotCoor(1,iiAtom) = rotCoor(1,iiAtom) + error(1,iiAtom)
         rotCoor(2,iiAtom) = rotCoor(2,iiAtom) + error(2,iiAtom)
         rotCoor(3,iiAtom) = rotCoor(3,iiAtom) + error(3,iiAtom)
      END DO

      RETURN
      END




C-----------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION weightedDot(
     &                  nComps,   !i:  number of components
     &                  vctr1,    !i:  first vector (3*nComps)
     &                  weight,   !i:  weights (nComps)
     &                  vctr2)    !i:  second vector (3*nComps)
C-----------------------------------------------------------------------
C
C
C     Weighted dot product of two vectors
C
      IMPLICIT NONE
C
C     Returned variable:
c     DOUBLE PRECISION weightedDot

C     Passed variables:
      INTEGER nComps
      DOUBLE PRECISION vctr1(3,nComps), weight(nComps), vctr2(3,nComps)
c     DOUBLE PRECISION vctr1(3*nComps), weight(nComps), vctr2(3*nComps)

C     Local variables:
      INTEGER i

      weightedDot = 0.D+0
      DO i = 1,nComps
         weightedDot = weightedDot + (vctr1(1,i)*weight(i)*vctr2(1,i))
     &                             + (vctr1(2,i)*weight(i)*vctr2(2,i))
     &                             + (vctr1(3,i)*weight(i)*vctr2(3,i))
      ENDDO

      RETURN
      END




C-----------------------------------------------------------------------
      SUBROUTINE weightedSum(
     &                  nComps,   !i:  number of components
     &                  nVctrs,   !i:  number of vectors
     &                  vctr1,    !i:  input vectors (nComps*nVctrs)
     &                  weight,   !i:  weights (nVctrs)
     &                  vctr2)    !o:  output vector (nComps)
C-----------------------------------------------------------------------
C
C     Weighted sum of vectors
C
      IMPLICIT NONE
C
C     Passed variables:
      INTEGER nComps, nVctrs
      DOUBLE PRECISION vctr1(nComps,nVctrs), weight(nVctrs)
      DOUBLE PRECISION vctr2(nComps)

C     Local variables:
      INTEGER i, j

      DO i = 1,nComps
         vctr2(i) = 0.D+0
         DO j = 1,nVctrs
            vctr2(i) = vctr2(i) + weight(j)*vctr1(i,j)
         ENDDO
      ENDDO

      RETURN
      END

