C $Header: /export/cvs/c34a1/source/moldyn/crea.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
      SUBROUTINE CREA(NREC3,NJ,NE,UVEC,ACOF,B,KB,KWS)
CSE
C
CPS        PURPOSE:
C
C                   MAKES USE OF LUMPED PARAMETER DATA TO COMPUTE THE
C                   ALPHA COEFFICIENTS IN EQ II-88 WHICH ARE ASSOCIATED
C                   WITH THE COMPUTATION OF THE CHANGE IN STATIC MASS
C                   MOMENT DUE TO FLEXIBLE BODY DEFORMATION, SEE ALSO
C                   APPENDIX-A VOL 1 EQS. A-12 TO A-20
C
CPE
C                                                          DEBUG #  21
      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: crea.f,v $$Revision: 1.1.1.1 $'/
C
C         USE THE LUMPED PARAMETER DATA ON NTAPE3, AND EQ II-33,35
C         ALONG WITH A-12 TO A-20 TO COMPUTE THE ALPHA COEFFICIENTS OF
C         EQ II-88.    USED TO DEFINE THE LINEAR DEPENDENCE OF BODY'S
C         STATIC MASS MOMENT ON DEFORMATION
C
#include "PARAM.FOR"
#include "NUMBRS.INC"
#include "TAPENO.INC"
#include "CHARMM.INC"
C
C     Passed Variables
C
      INTEGER KB,NJ,NE,NREC3,KWS
      DOUBLE PRECISION acof(9,*),B(KB,*),UVEC(*)
C
C     Local Variables
C
      INTEGER j
C
      CALL ZERO(acof,9,NE,9)
C***  FETCH M*HX
      CALL FETCH(NTAPE3, 1,NREC3,B,NJ,NE,KB)
CC@CC
CC@CC SATB -ONE, UVEC, B, ACOF(6,1)
CC@CC NJ, 1, NE
CC@CC KWS, KB, 9
      CALL DGEMM ('T','N',1,NE,NJ,-ONE,UVEC,KWS,B,KB,1.0d0,ACOF(6,1),9)
CC@CC end of expanded call
CC@CC
C***  FETCH M*HY
      CALL FETCH(NTAPE3, 4,NREC3,B,NJ,NE,KB)
CC@CC
CC@CC SATB ONE, UVEC, B, ACOF(3,1)
CC@CC NJ, 1, NE
CC@CC KWS, KB, 9
      CALL DGEMM ('T','N',1,NE,NJ,ONE,UVEC,KWS,B,KB,1.0d0,ACOF(3,1),9)
CC@CC end of expanded call
CC@CC
C***  FETCH M*HZ
      CALL FETCH(NTAPE3, 7,NREC3,B,NJ,NE,KB)
CC@CC
CC@CC SATB -ONE, UVEC, B, ACOF(2,1)
CC@CC NJ, 1, NE
CC@CC KWS, KB, 9
      CALL DGEMM ('T','N',1,NE,NJ,-ONE,UVEC,KWS,B,KB,1.0d0,ACOF(2,1),9)
CC@CC end of expanded call
CC@CC
      DO 49 J=1,NE
      ACOF(4,J) = -ACOF(2,J)
      ACOF(7,J) = -ACOF(3,J)
   49 ACOF(8,J) = -ACOF(6,J)
C
      if (mbplvl .ge. 2) CALL MWRITE(acof,9,NE,'ACOF',9)
C
      RETURN
      END
