C $Header: /export/cvs/c34a1/source/moldyn/cread0.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
      SUBROUTINE CREAD0(NREC3,NJ,NE,UVEC,A,B,C,WS,AMU,KA,KB,KC,KWS,KAMU)
CSE
C
CPS        PURPOSE:
C
C                   MAKES USE OF LUMPED PARAMETER DATA TO COMPUTE THE
C                   D AND A COEFFICIENTS WHICH ARE INDEPENDENT OF
C                   DEFORMATION AND DEFINE THE INERTIAL COUPLING BETWEEN
C                   6 ROTATION AND TRANSLATION COORDINATES AND THE
C                   IRGFLX(N) MODAL DISPLACEMENT COORDINATES,
C                   SEE EQ II-87
C
CPE
C                                                          DEBUG #  19
C
C         USE THE LUMPED PARAMETER DATA ON NTAPE3,  ALONG WITH EQUATIONS
C         II-33,36 TO COMPUTE THE 3 BY IRGFLX(N) MATRIX OF D-COEFFICIENT
C         AND THE 3 BY IRGFLX(N) MATRIX OF A-COEFFICIENTS IN EQ II-87
C         THESE ARE INERTIAL COUPLING COEFFICIENTS WHICH ARE INDEPENDENT
C         OF DEFORMATION
C
      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: cread0.f,v $$Revision: 1.1.1.1 $'/
C
#include "PARAM.FOR"
#include "NUMBRS.INC"
#include "TAPENO.INC"
#include "CHARMM.INC"
C
      INTEGER KA,KB,KC,KWS,KAMU,NJ
      INTEGER NREC3,NE
      DOUBLE PRECISION A(KA,*),B(KB,*),C(KC,*)
      DOUBLE PRECISION WS(KWS,*),AMU(KAMU,*),UVEC(*)
C
C***  FETCH M*HX,M*HY,M*HZ
      CALL FETCH(NTAPE3, 1,NREC3,A,NJ,NE,KA)
      CALL FETCH(NTAPE3, 4,NREC3,B,NJ,NE,KB)
      CALL FETCH(NTAPE3, 7,NREC3,C,NJ,NE,KC)
CC@CC
CC@CC SATB ONE, UVEC    , A, AMU(4,7)
CC@CC NJ, 1, NE
CC@CC KWS, KA, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,ONE,UVEC    ,KWS,A,KA,1.0d0,AMU(4,7),K
     .AMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, UVEC    , B, AMU(5,7)
CC@CC NJ, 1, NE
CC@CC KWS, KB, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,ONE,UVEC    ,KWS,B,KB,1.0d0,AMU(5,7),K
     .AMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, UVEC    , C, AMU(6,7)
CC@CC NJ, 1, NE
CC@CC KWS, KC, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,ONE,UVEC    ,KWS,C,KC,1.0d0,AMU(6,7),K
     .AMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, WS(1,13), A, AMU(2,7)
CC@CC NJ, 1, NE
CC@CC KWS, KA, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,ONE,WS(1,13),KWS,A,KA,1.0d0,AMU(2,7),K
     .AMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB -ONE, WS(1,12), A, AMU(3,7)
CC@CC NJ, 1, NE
CC@CC KWS, KA, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,-ONE,WS(1,12),KWS,A,KA,1.0d0,AMU(3,7),
     .KAMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB -ONE, WS(1,13), B, AMU(1,7)
CC@CC NJ, 1, NE
CC@CC KWS, KB, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,-ONE,WS(1,13),KWS,B,KB,1.0d0,AMU(1,7),
     .KAMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, WS(1,11), B, AMU(3,7)
CC@CC NJ, 1, NE
CC@CC KWS, KB, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,ONE,WS(1,11),KWS,B,KB,1.0d0,AMU(3,7),K
     .AMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, WS(1,12), C, AMU(1,7)
CC@CC NJ, 1, NE
CC@CC KWS, KC, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,ONE,WS(1,12),KWS,C,KC,1.0d0,AMU(1,7),K
     .AMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB -ONE, WS(1,11), C, AMU(2,7)
CC@CC NJ, 1, NE
CC@CC KWS, KC, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,-ONE,WS(1,11),KWS,C,KC,1.0d0,AMU(2,7),
     .KAMU)
CC@CC end of expanded call
CC@CC
C***  FETCH SY*SIGX,SZ*SIGX
      CALL FETCH(NTAPE3,13,NREC3,A,NJ,NE,KA)
      CALL FETCH(NTAPE3,14,NREC3,B,NJ,NE,KB)
CC@CC
CC@CC SATB ONE, UVEC    , A, AMU(6,7)
CC@CC NJ, 1, NE
CC@CC KWS, KA, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,ONE,UVEC    ,KWS,A,KA,1.0d0,AMU(6,7),K
     .AMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB -ONE, UVEC    , B, AMU(5,7)
CC@CC NJ, 1, NE
CC@CC KWS, KB, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,-ONE,UVEC    ,KWS,B,KB,1.0d0,AMU(5,7),
     .KAMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, WS(1,12), A, AMU(1,7)
CC@CC NJ, 1, NE
CC@CC KWS, KA, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,ONE,WS(1,12),KWS,A,KA,1.0d0,AMU(1,7),K
     .AMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, WS(1,13), B, AMU(1,7)
CC@CC NJ, 1, NE
CC@CC KWS, KB, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,ONE,WS(1,13),KWS,B,KB,1.0d0,AMU(1,7),K
     .AMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB -ONE, WS(1,11), A, AMU(2,7)
CC@CC NJ, 1, NE
CC@CC KWS, KA, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,-ONE,WS(1,11),KWS,A,KA,1.0d0,AMU(2,7),
     .KAMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB -ONE, WS(1,11), B, AMU(3,7)
CC@CC NJ, 1, NE
CC@CC KWS, KB, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,-ONE,WS(1,11),KWS,B,KB,1.0d0,AMU(3,7),
     .KAMU)
CC@CC end of expanded call
CC@CC
C***  FETCH SX*SIGY,SZ*SIGY
      CALL FETCH(NTAPE3,18,NREC3,A,NJ,NE,KA)
      CALL FETCH(NTAPE3,19,NREC3,B,NJ,NE,KB)
CC@CC
CC@CC SATB -ONE, UVEC    , A, AMU(6,7)
CC@CC NJ, 1, NE
CC@CC KWS, KA, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,-ONE,UVEC    ,KWS,A,KA,1.0d0,AMU(6,7),
     .KAMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, UVEC    , B, AMU(4,7)
CC@CC NJ, 1, NE
CC@CC KWS, KB, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,ONE,UVEC    ,KWS,B,KB,1.0d0,AMU(4,7),K
     .AMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB -ONE, WS(1,12), A, AMU(1,7)
CC@CC NJ, 1, NE
CC@CC KWS, KA, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,-ONE,WS(1,12),KWS,A,KA,1.0d0,AMU(1,7),
     .KAMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, WS(1,13), B, AMU(2,7)
CC@CC NJ, 1, NE
CC@CC KWS, KB, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,ONE,WS(1,13),KWS,B,KB,1.0d0,AMU(2,7),K
     .AMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, WS(1,11), A, AMU(2,7)
CC@CC NJ, 1, NE
CC@CC KWS, KA, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,ONE,WS(1,11),KWS,A,KA,1.0d0,AMU(2,7),K
     .AMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB -ONE, WS(1,12), B, AMU(3,7)
CC@CC NJ, 1, NE
CC@CC KWS, KB, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,-ONE,WS(1,12),KWS,B,KB,1.0d0,AMU(3,7),
     .KAMU)
CC@CC end of expanded call
CC@CC
C***  FETCH SX*SIGZ,SY*SIGZ
      CALL FETCH(NTAPE3,23,NREC3,A,NJ,NE,KA)
      CALL FETCH(NTAPE3,24,NREC3,B,NJ,NE,KB)
CC@CC
CC@CC SATB ONE, UVEC    , A, AMU(5,7)
CC@CC NJ, 1, NE
CC@CC KWS, KA, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,ONE,UVEC    ,KWS,A,KA,1.0d0,AMU(5,7),K
     .AMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB -ONE, UVEC    , B, AMU(4,7)
CC@CC NJ, 1, NE
CC@CC KWS, KB, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,-ONE,UVEC    ,KWS,B,KB,1.0d0,AMU(4,7),
     .KAMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB -ONE, WS(1,13), A, AMU(1,7)
CC@CC NJ, 1, NE
CC@CC KWS, KA, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,-ONE,WS(1,13),KWS,A,KA,1.0d0,AMU(1,7),
     .KAMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB -ONE, WS(1,13), B, AMU(2,7)
CC@CC NJ, 1, NE
CC@CC KWS, KB, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,-ONE,WS(1,13),KWS,B,KB,1.0d0,AMU(2,7),
     .KAMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, WS(1,11), A, AMU(3,7)
CC@CC NJ, 1, NE
CC@CC KWS, KA, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,ONE,WS(1,11),KWS,A,KA,1.0d0,AMU(3,7),K
     .AMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, WS(1,12), B, AMU(3,7)
CC@CC NJ, 1, NE
CC@CC KWS, KB, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,ONE,WS(1,12),KWS,B,KB,1.0d0,AMU(3,7),K
     .AMU)
CC@CC end of expanded call
CC@CC
C***  FETCH SY*HX,SZ*HX
      CALL FETCH(NTAPE3, 2,NREC3,A,NJ,NE,KA)
      CALL FETCH(NTAPE3, 3,NREC3,B,NJ,NE,KB)
CC@CC
CC@CC SATB ONE, UVEC    , B, AMU(2,7)
CC@CC NJ, 1, NE
CC@CC KWS, KB, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,ONE,UVEC    ,KWS,B,KB,1.0d0,AMU(2,7),K
     .AMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB -ONE, UVEC    , A, AMU(3,7)
CC@CC NJ, 1, NE
CC@CC KWS, KA, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,-ONE,UVEC    ,KWS,A,KA,1.0d0,AMU(3,7),
     .KAMU)
CC@CC end of expanded call
CC@CC
C***  FETCH SX*HY,SZ*HY
      CALL FETCH(NTAPE3, 5,NREC3,A,NJ,NE,KA)
      CALL FETCH(NTAPE3, 6,NREC3,B,NJ,NE,KB)
CC@CC
CC@CC SATB -ONE, UVEC    , B, AMU(1,7)
CC@CC NJ, 1, NE
CC@CC KWS, KB, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,-ONE,UVEC    ,KWS,B,KB,1.0d0,AMU(1,7),
     .KAMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, UVEC    , A, AMU(3,7)
CC@CC NJ, 1, NE
CC@CC KWS, KA, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,ONE,UVEC    ,KWS,A,KA,1.0d0,AMU(3,7),K
     .AMU)
CC@CC end of expanded call
CC@CC
C***  FETCH SX*HZ,SY*HZ
      CALL FETCH(NTAPE3, 8,NREC3,A,NJ,NE,KA)
      CALL FETCH(NTAPE3, 9,NREC3,B,NJ,NE,KB)
CC@CC
CC@CC SATB ONE, UVEC    , B, AMU(1,7)
CC@CC NJ, 1, NE
CC@CC KWS, KB, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,ONE,UVEC    ,KWS,B,KB,1.0d0,AMU(1,7),K
     .AMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB -ONE, UVEC    , A, AMU(2,7)
CC@CC NJ, 1, NE
CC@CC KWS, KA, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,-ONE,UVEC    ,KWS,A,KA,1.0d0,AMU(2,7),
     .KAMU)
CC@CC end of expanded call
CC@CC
C***  FETCH JXX*SIGX,JXY*SIGX,JXZ*SIGX
      CALL FETCH(NTAPE3,10,NREC3,A,NJ,NE,KA)
      CALL FETCH(NTAPE3,11,NREC3,B,NJ,NE,KB)
      CALL FETCH(NTAPE3,12,NREC3,C,NJ,NE,KC)
CC@CC
CC@CC SATB ONE, UVEC    , A, AMU(1,7)
CC@CC NJ, 1, NE
CC@CC KWS, KA, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,ONE,UVEC    ,KWS,A,KA,1.0d0,AMU(1,7),K
     .AMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB -ONE, UVEC    , B, AMU(2,7)
CC@CC NJ, 1, NE
CC@CC KWS, KB, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,-ONE,UVEC    ,KWS,B,KB,1.0d0,AMU(2,7),
     .KAMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB -ONE, UVEC    , C, AMU(3,7)
CC@CC NJ, 1, NE
CC@CC KWS, KC, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,-ONE,UVEC    ,KWS,C,KC,1.0d0,AMU(3,7),
     .KAMU)
CC@CC end of expanded call
CC@CC
C***  FETCH JXY*SIGY,JYY*SIGY,JYZ*SIGY
      CALL FETCH(NTAPE3,15,NREC3,A,NJ,NE,KA)
      CALL FETCH(NTAPE3,16,NREC3,B,NJ,NE,KB)
      CALL FETCH(NTAPE3,17,NREC3,C,NJ,NE,KC)
CC@CC
CC@CC SATB -ONE, UVEC    , A, AMU(1,7)
CC@CC NJ, 1, NE
CC@CC KWS, KA, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,-ONE,UVEC    ,KWS,A,KA,1.0d0,AMU(1,7),
     .KAMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, UVEC    , B, AMU(2,7)
CC@CC NJ, 1, NE
CC@CC KWS, KB, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,ONE,UVEC    ,KWS,B,KB,1.0d0,AMU(2,7),K
     .AMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB -ONE, UVEC    , C, AMU(3,7)
CC@CC NJ, 1, NE
CC@CC KWS, KC, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,-ONE,UVEC    ,KWS,C,KC,1.0d0,AMU(3,7),
     .KAMU)
CC@CC end of expanded call
CC@CC
C***  FETCH JXZ*SIGZ,JYZ*SIGZ,JZZ*SIGZ
      CALL FETCH(NTAPE3,20,NREC3,A,NJ,NE,KA)
      CALL FETCH(NTAPE3,21,NREC3,B,NJ,NE,KB)
      CALL FETCH(NTAPE3,22,NREC3,C,NJ,NE,KC)
CC@CC
CC@CC SATB -ONE, UVEC    , A, AMU(1,7)
CC@CC NJ, 1, NE
CC@CC KWS, KA, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,-ONE,UVEC    ,KWS,A,KA,1.0d0,AMU(1,7),
     .KAMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB -ONE, UVEC    , B, AMU(2,7)
CC@CC NJ, 1, NE
CC@CC KWS, KB, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,-ONE,UVEC    ,KWS,B,KB,1.0d0,AMU(2,7),
     .KAMU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, UVEC    , C, AMU(3,7)
CC@CC NJ, 1, NE
CC@CC KWS, KC, KAMU
      CALL DGEMM ('T','N',1,NE,NJ,ONE,UVEC    ,KWS,C,KC,1.0d0,AMU(3,7),K
     .AMU)
CC@CC end of expanded call
CC@CC
C
      if (mbplvl .ge. 2) CALL MWRITE(AMU(1,7),3,NE,'D0COEF',KAMU)
      if (mbplvl .ge. 2) CALL MWRITE(AMU(4,7),3,NE,'A0COEF',KAMU)
C
      RETURN
      END
