C $Header: /export/cvs/c34a1/source/moldyn/creb.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
      SUBROUTINE CREB(NREC3,NREC2,NJ,NE,A,BCOF,WS,KA,KWS)
CSE
C
CPS        PURPOSE:
C
C                   MAKES USE OF LUMPED PARAMETER DATA TO COMPUTE THE
C                   B COEFFICIENTS IN EQ II-88 WHICH ARE ASSOCIATED
C                   WITH THE COMPUTATION OF THE CHANGE IN THE BODY'S
C                   INERTIA TENSOR DUE TO TERMS LINEAR IN FLEXIBLE BODY
C                   DEFORMATION, SEE APPENDIX A VOL 1 EQS A-21 TO A-26
C
CPE
C                                                          DEBUG #  22
      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: creb.f,v $$Revision: 1.1.1.1 $'/
C
C         USE THE LUMPED PARAMETER DATA ON NTAPE3 AND EQS II-31,32,37
C         ALONG WITH A-21 TO A-26 TO COMPUTE THE B COEFFICIENTS OF
C         EQ II-88. USED TO DEFINE THE LINEAR DEPENDENCE OF BODY'S
C         INERTIA TENSOR ON DEFORMATION
C
#include "PARAM.FOR"
#include "NUMBRS.INC"
#include "TAPENO.INC"
#include "CHARMM.INC"
C
c     Passed Variables
c
      INTEGER KA,KWS,NE,NJ,NREC2,NREC3
      DOUBLE PRECISION A(KA,*),BCOF(6,*),WS(KWS,*)
c
c     Local Variables
c
      INTEGER I
C
      CALL ZERO(BCOF,6,NE,6)
C***  FETCH M*RHOX,M*RHOY,M*RHOZ
      CALL FETCH(NTAPE3,25,NREC3,A(1,1),NJ,1,KA)
      CALL FETCH(NTAPE3,26,NREC3,A(1,2),NJ,1,KA)
      CALL FETCH(NTAPE3,27,NREC3,A(1,3),NJ,1,KA)
      DO 52 I=1,NJ
      WS(I, 8) = WS(I, 8) + A(I,1)
      WS(I, 9) = WS(I, 9) + A(I,2)
   52 WS(I,10) = WS(I,10) + A(I,3)
C***  FETCH HX
      CALL FETCH(NTAPE2, 5,NREC2,A,NJ,NE,KA)
CC@CC
CC@CC SATB ONE, WS(1, 8), A, BCOF(2,1)
CC@CC NJ, 1, NE
CC@CC KWS, KA, 6
      CALL DGEMM ('T','N',1,NE,NJ,ONE,WS(1, 8),KWS,A,KA,1.0d0,BCOF(2,1),
     .6)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, WS(1, 8), A, BCOF(3,1)
CC@CC NJ, 1, NE
CC@CC KWS, KA, 6
      CALL DGEMM ('T','N',1,NE,NJ,ONE,WS(1, 8),KWS,A,KA,1.0d0,BCOF(3,1),
     .6)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, WS(1, 9), A, BCOF(4,1)
CC@CC NJ, 1, NE
CC@CC KWS, KA, 6
      CALL DGEMM ('T','N',1,NE,NJ,ONE,WS(1, 9),KWS,A,KA,1.0d0,BCOF(4,1),
     .6)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, WS(1,10), A, BCOF(5,1)
CC@CC NJ, 1, NE
CC@CC KWS, KA, 6
      CALL DGEMM ('T','N',1,NE,NJ,ONE,WS(1,10),KWS,A,KA,1.0d0,BCOF(5,1),
     .6)
CC@CC end of expanded call
CC@CC
C***  FETCH HY
      CALL FETCH(NTAPE2, 6,NREC2,A,NJ,NE,KA)
CC@CC
CC@CC SATB ONE, WS(1, 9), A, BCOF(1,1)
CC@CC NJ, 1, NE
CC@CC KWS, KA, 6
      CALL DGEMM ('T','N',1,NE,NJ,ONE,WS(1, 9),KWS,A,KA,1.0d0,BCOF(1,1),
     .6)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, WS(1, 9), A, BCOF(3,1)
CC@CC NJ, 1, NE
CC@CC KWS, KA, 6
      CALL DGEMM ('T','N',1,NE,NJ,ONE,WS(1, 9),KWS,A,KA,1.0d0,BCOF(3,1),
     .6)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, WS(1, 8), A, BCOF(4,1)
CC@CC NJ, 1, NE
CC@CC KWS, KA, 6
      CALL DGEMM ('T','N',1,NE,NJ,ONE,WS(1, 8),KWS,A,KA,1.0d0,BCOF(4,1),
     .6)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, WS(1,10), A, BCOF(6,1)
CC@CC NJ, 1, NE
CC@CC KWS, KA, 6
      CALL DGEMM ('T','N',1,NE,NJ,ONE,WS(1,10),KWS,A,KA,1.0d0,BCOF(6,1),
     .6)
CC@CC end of expanded call
CC@CC
C***  FETCH HZ
      CALL FETCH(NTAPE2, 7,NREC2,A,NJ,NE,KA)
CC@CC
CC@CC SATB ONE, WS(1,10), A, BCOF(1,1)
CC@CC NJ, 1, NE
CC@CC KWS, KA, 6
      CALL DGEMM ('T','N',1,NE,NJ,ONE,WS(1,10),KWS,A,KA,1.0d0,BCOF(1,1),
     .6)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, WS(1,10), A, BCOF(2,1)
CC@CC NJ, 1, NE
CC@CC KWS, KA, 6
      CALL DGEMM ('T','N',1,NE,NJ,ONE,WS(1,10),KWS,A,KA,1.0d0,BCOF(2,1),
     .6)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, WS(1, 8), A, BCOF(5,1)
CC@CC NJ, 1, NE
CC@CC KWS, KA, 6
      CALL DGEMM ('T','N',1,NE,NJ,ONE,WS(1, 8),KWS,A,KA,1.0d0,BCOF(5,1),
     .6)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, WS(1, 9), A, BCOF(6,1)
CC@CC NJ, 1, NE
CC@CC KWS, KA, 6
      CALL DGEMM ('T','N',1,NE,NJ,ONE,WS(1, 9),KWS,A,KA,1.0d0,BCOF(6,1),
     .6)
CC@CC end of expanded call
CC@CC
C
      if (mbplvl .ge. 2) CALL MWRITE(BCOF,6,NE,'BCOF',6)
C
      RETURN
      END
