C $Header: /export/cvs/c34a1/source/moldyn/crec.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
      SUBROUTINE CREC(NREC3,NREC2,NJ,NE,A,B,C,C11,C22,C33,C12,C13,C23,
     &                CXY,CXZ,CYZ,KA,KB,KC,ic)
CSE
C
CPS         PURPOSE:
C
C                   MAKES USE OF LUMPED PARAMETER DATA TO COMPUTE THE
C                   C COEFFICIENTS IN EQ II-88 WHICH ARE ASSOCIATED
C                   WITH THE COMPUTATION OF THE CHANGE IN THE COUPLING
C                   COEFFICIENTS BETWEEN ROTATION AND DISPLACEMENT
C                   COORDINATES DUE TO TERMS LINEAR IN FLEXIBLE BODY
C                   DEFORMATION, SEE APPENDIX A VOL 1 EQS A-27,28,29
C                   ALSO COMPUTES THE C COEFFICIENTS IN EQ II-89 WHICH
C                   ARE ASSOCIATED WITH THE COMPUTATION OF THE CHANGE
C                   IN THE BODY'S INERTIA TENSOR DUE TO TERMS QUADRATIC
C                   IN FLEXIBLE BODY DEFORMATION, SEE APPENDIX A VOL 1
C                   EQS A-30 TO A-35
C
CPE
C                                                          DEBUG #  23
      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: crec.f,v $$Revision: 1.1.1.1 $'/
C
C         USE THE LUMPED PARAMETER DATA ON NTAPE3 AND EQS II-32,36
C         ALONG WITH A-27,28,29 TO COMPUTE THE C COEFFICIENTS OF
C         EQ II-88. USED TO DEFINE THE LINEAR DEPENDENCE OF BODY'S
C         COUPLING COEFFICIENTS ON DEFORMATION.
C         ALSO WITH EQS II-31,32,37 ALONG WITH A-30 TO A-35 COMPUTE THE
C         C COEFFICIENTS OF EQ II-89. USED TO DEFINE THE QUADRATIC
C         DEPENDENCE OF BODY'S INERTIA TENSOR ON DEFORMATION
C
#include "PARAM.FOR"
#include "NUMBRS.INC"
#include "TAPENO.INC"
#include "CHARMM.INC"
C
C     Passed Variables
C
      INTEGER KA, KB,KC
      INTEGER NE,NJ,NREC2,NREC3,ic
      DOUBLE PRECISION A(KA,*),B(KB,*),C(KC,*)
      DOUBLE PRECISION C11(ic,ic),C22(ic,ic),C33(ic,ic)
      DOUBLE PRECISION C12(ic,ic),C13(ic,ic),C23(ic,ic)
      DOUBLE PRECISION CXY(ic,ic),CXZ(ic,ic),CYZ(ic,ic)
C
C
C***  FORM CCOF1 = CXY
      CALL ZERO(CXY,NE,NE,NE)
C***  FETCH M*HY,SX*SIGZ,SZ*SIGX
      CALL FETCH(NTAPE3, 4,NREC3,A,NJ,NE,KA)
      CALL FETCH(NTAPE3,23,NREC3,B,NJ,NE,KB)
      CALL FETCH(NTAPE3,14,NREC3,C,NJ,NE,KC)
      CALL ADD3( ONE,A, ONE,B,-ONE,C,NJ,NE,KA)
C***  FETCH HX
      CALL FETCH(NTAPE2, 5,NREC2,B,NJ,NE,KB)
CC@CC
CC@CC SATB ONE, B, A, CXY
CC@CC NJ, NE, NE
CC@CC KB, KA, NE
      CALL DGEMM ('T','N',NE,NE,NJ,ONE,B,KB,A,KA,1.0d0,CXY,NE)
CC@CC end of expanded call
CC@CC
C***  FETCH M*HX,SZ*SIGY,SY*SIGZ
      CALL FETCH(NTAPE3, 1,NREC3,A,NJ,NE,KA)
      CALL FETCH(NTAPE3,19,NREC3,B,NJ,NE,KB)
      CALL FETCH(NTAPE3,24,NREC3,C,NJ,NE,KC)
      CALL ADD3( ONE,A, ONE,B,-ONE,C,NJ,NE,KA)
C***  FETCH HY
      CALL FETCH(NTAPE2, 6,NREC2,B,NJ,NE,KB)
CC@CC
CC@CC SATB -ONE, B, A, CXY
CC@CC NJ, NE, NE
CC@CC KB, KA, NE
      CALL DGEMM ('T','N',NE,NE,NJ,-ONE,B,KB,A,KA,1.0d0,CXY,NE)
CC@CC end of expanded call
CC@CC
C
      if (mbplvl .ge. 2) CALL MWRITE(CXY,NE,NE,'CXY',NE)
C
C***  FORM CCOF2 = CXZ
      CALL ZERO(CXZ,NE,NE,NE)
C***  FETCH HZ
      CALL FETCH(NTAPE2, 7,NREC2,B,NJ,NE,KB)
CC@CC
CC@CC SATB ONE, B, A, CXZ
CC@CC NJ, NE, NE
CC@CC KB, KA, NE
      CALL DGEMM ('T','N',NE,NE,NJ,ONE,B,KB,A,KA,1.0d0,CXZ,NE)
CC@CC end of expanded call
CC@CC
C***  FETCH M*HZ,SY*SIGX,SX*SIGY
      CALL FETCH(NTAPE3, 7,NREC3,A,NJ,NE,KA)
      CALL FETCH(NTAPE3,13,NREC3,B,NJ,NE,KB)
      CALL FETCH(NTAPE3,18,NREC3,C,NJ,NE,KC)
      CALL ADD3( ONE,A, ONE,B,-ONE,C,NJ,NE,KA)
C***  FETCH HX
      CALL FETCH(NTAPE2, 5,NREC2,B,NJ,NE,KB)
CC@CC
CC@CC SATB -ONE, B, A, CXZ
CC@CC NJ, NE, NE
CC@CC KB, KA, NE
      CALL DGEMM ('T','N',NE,NE,NJ,-ONE,B,KB,A,KA,1.0d0,CXZ,NE)
CC@CC end of expanded call
CC@CC
C
      if (mbplvl .ge. 2) CALL MWRITE(CXZ,NE,NE,'CXZ',NE)
C
C***  FORM CCOF3 = CYZ
      CALL ZERO(CYZ,NE,NE,NE)
C***  FETCH HY
      CALL FETCH(NTAPE2, 6,NREC2,B,NJ,NE,KB)
CC@CC
CC@CC SATB ONE, B, A, CYZ
CC@CC NJ, NE, NE
CC@CC KB, KA, NE
      CALL DGEMM ('T','N',NE,NE,NJ,ONE,B,KB,A,KA,1.0d0,CYZ,NE)
CC@CC end of expanded call
CC@CC
C***  FETCH M*HY,SX*SIGZ,SZ*SIGX
      CALL FETCH(NTAPE3, 4,NREC3,A,NJ,NE,KA)
      CALL FETCH(NTAPE3,23,NREC3,B,NJ,NE,KB)
      CALL FETCH(NTAPE3,14,NREC3,C,NJ,NE,KC)
      CALL ADD3( ONE,A, ONE,B,-ONE,C,NJ,NE,KA)
C***  FETCH HZ
      CALL FETCH(NTAPE2, 7,NREC2,B,NJ,NE,KB)
CC@CC
CC@CC SATB -ONE, B, A, CYZ
CC@CC NJ, NE, NE
CC@CC KB, KA, NE
      CALL DGEMM ('T','N',NE,NE,NJ,-ONE,B,KB,A,KA,1.0d0,CYZ,NE)
CC@CC end of expanded call
CC@CC
C
      if (mbplvl .ge. 2) CALL MWRITE(CYZ,NE,NE,'CYZ',NE)
C
C***  FORM CCOF4 = C11
      CALL ZERO(C11,NE,NE,NE)
C***  FETCH M*HY AND HY
      CALL FETCH(NTAPE3, 4,NREC3,A,NJ,NE,KA)
      CALL FETCH(NTAPE2, 6,NREC2,B,NJ,NE,KB)
CC@CC
CC@CC SATB ONE, B, A, C11
CC@CC NJ, NE, NE
CC@CC KB, KA, NE
      CALL DGEMM ('T','N',NE,NE,NJ,ONE,B,KB,A,KA,1.0d0,C11,NE)
CC@CC end of expanded call
CC@CC
C***  FETCH M*HZ AND HZ
      CALL FETCH(NTAPE3, 7,NREC3,A,NJ,NE,KA)
      CALL FETCH(NTAPE2, 7,NREC2,B,NJ,NE,KB)
CC@CC
CC@CC SATB ONE, B, A, C11
CC@CC NJ, NE, NE
CC@CC KB, KA, NE
      CALL DGEMM ('T','N',NE,NE,NJ,ONE,B,KB,A,KA,1.0d0,C11,NE)
CC@CC end of expanded call
CC@CC
C
      if (mbplvl .ge. 2) CALL MWRITE(C11,NE,NE,'C11',NE)
C
C***  FORM CCOF5 = C22
      CALL ZERO(C22,NE,NE,NE)
CC@CC
CC@CC SATB ONE, B, A, C22
CC@CC NJ, NE, NE
CC@CC KB, KA, NE
      CALL DGEMM ('T','N',NE,NE,NJ,ONE,B,KB,A,KA,1.0d0,C22,NE)
CC@CC end of expanded call
CC@CC
C***  FETCH M*HX AND HX
      CALL FETCH(NTAPE3, 1,NREC3,A,NJ,NE,KA)
      CALL FETCH(NTAPE2, 5,NREC2,B,NJ,NE,KB)
CC@CC
CC@CC SATB ONE, B, A, C22
CC@CC NJ, NE, NE
CC@CC KB, KA, NE
      CALL DGEMM ('T','N',NE,NE,NJ,ONE,B,KB,A,KA,1.0d0,C22,NE)
CC@CC end of expanded call
CC@CC
C
      if (mbplvl .ge. 2) CALL MWRITE(C22,NE,NE,'C22',NE)
C
C***  FORM CCOF6 = C33
      CALL ZERO(C33,NE,NE,NE)
CC@CC
CC@CC SATB ONE, B, A, C33
CC@CC NJ, NE, NE
CC@CC KB, KA, NE
      CALL DGEMM ('T','N',NE,NE,NJ,ONE,B,KB,A,KA,1.0d0,C33,NE)
CC@CC end of expanded call
CC@CC
C***  FETCH M*HY AND HY
      CALL FETCH(NTAPE3, 4,NREC3,A,NJ,NE,KA)
      CALL FETCH(NTAPE2, 6,NREC2,B,NJ,NE,KB)
CC@CC
CC@CC SATB ONE, B, A, C33
CC@CC NJ, NE, NE
CC@CC KB, KA, NE
      CALL DGEMM ('T','N',NE,NE,NJ,ONE,B,KB,A,KA,1.0d0,C33,NE)
CC@CC end of expanded call
CC@CC
C
      if (mbplvl .ge. 2) CALL MWRITE(C33,NE,NE,'C33',NE)
C
C***  FORM CCOF7 = C12
      CALL ZERO(C12,NE,NE,NE)
C***  FETCH M*HX
      CALL FETCH(NTAPE3, 1,NREC3,A,NJ,NE,KA)
CC@CC
CC@CC SATB ONE, B, A, C12
CC@CC NJ, NE, NE
CC@CC KB, KA, NE
      CALL DGEMM ('T','N',NE,NE,NJ,ONE,B,KB,A,KA,1.0d0,C12,NE)
CC@CC end of expanded call
CC@CC
C
      if (mbplvl .ge. 2) CALL MWRITE(C12,NE,NE,'C12',NE)
C
C***  FORM CCOF8 = C13
      CALL ZERO(C13,NE,NE,NE)
C***  FETCH HZ
      CALL FETCH(NTAPE2, 7,NREC2,B,NJ,NE,KB)
CC@CC
CC@CC SATB ONE, B, A, C13
CC@CC NJ, NE, NE
CC@CC KB, KA, NE
      CALL DGEMM ('T','N',NE,NE,NJ,ONE,B,KB,A,KA,1.0d0,C13,NE)
CC@CC end of expanded call
CC@CC
C
      if (mbplvl .ge. 2) CALL MWRITE(C13,NE,NE,'C13',NE)
C
C***  FORM CCOF9 = C23
      CALL ZERO(C23,NE,NE,NE)
C***  FETCH M*HY
      CALL FETCH(NTAPE3, 4,NREC3,A,NJ,NE,KA)
CC@CC
CC@CC SATB ONE, B, A, C23
CC@CC NJ, NE, NE
CC@CC KB, KA, NE
      CALL DGEMM ('T','N',NE,NE,NJ,ONE,B,KB,A,KA,1.0d0,C23,NE)
CC@CC end of expanded call
CC@CC
C
      if (mbplvl .ge. 2) CALL MWRITE(C23,NE,NE,'C23',NE)
C
      RETURN
      END
