C $Header: /export/cvs/c34a1/source/moldyn/cree.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
      SUBROUTINE CREE(NREC3,NREC2,NJ,NE,A,B,C,AMU,KA,KB,KC,KAMU)
CSE
C
CPS        PURPOSE:
C
C                   MAKES USE OF LUMPED PARAMETER DATA TO COMPUTE THE
C                   E COEFFICIENTS WHICH ARE INDEPENDENT OF DEFORMATION
C                   THESE DEFINE THE MODAL MASS MATRIX WHICH IS DIAGONAL
C                   IF THE MODES ARE ORTHOGONAL SEE EQ II-87 MODES MAY
C                   BE NON-ORTHOGONAL
C
CPE
C                                                          DEBUG #  20
      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: cree.f,v $$Revision: 1.1.1.1 $'/
C
C         USE THE LUMPED PARAMETER DATA ON NTAPE3; AND EQ II-34 TO
C         COMPUTE THE IRGFLX(N) BY IRGFLX(N) MODAL MASS MATRIX. THIS
C         IS THE E MATRIX IN EQ II-87
C
#include "PARAM.FOR"
#include "NUMBRS.INC"
#include "TAPENO.INC"
#include "CHARMM.INC"
C
C     Local Variables
C
      INTEGER KA,KB,KC,KAMU
      INTEGER NE,NJ,NREC2,NREC3
      DOUBLE PRECISION A(KA,*),B(KB,*),C(KC,*),AMU(KAMU,*)
C
C***  FETCH M*HX,SZ*SIGY,SY*SIGZ
      CALL FETCH(NTAPE3, 1,NREC3,A,NJ,NE,KA)
      CALL FETCH(NTAPE3,19,NREC3,B,NJ,NE,KB)
      CALL FETCH(NTAPE3,24,NREC3,C,NJ,NE,KC)
      CALL ADD3( ONE,A, ONE,B,-ONE,C,NJ,NE,KA)
C***  FETCH HX
      CALL FETCH(NTAPE2, 5,NREC2,B,NJ,NE,KB)
CC@CC
CC@CC SATB ONE, B, A, AMU(7,7)
CC@CC NJ, NE, NE
CC@CC KB, KA, KAMU
      CALL DGEMM ('T','N',NE,NE,NJ,ONE,B,KB,A,KA,1.0d0,AMU(7,7),KAMU)
CC@CC end of expanded call
CC@CC
C***  FETCH M*HY,SX*SIGZ,SZ*SIGX
      CALL FETCH(NTAPE3, 4,NREC3,A,NJ,NE,KA)
      CALL FETCH(NTAPE3,23,NREC3,B,NJ,NE,KB)
      CALL FETCH(NTAPE3,14,NREC3,C,NJ,NE,KC)
      CALL ADD3( ONE,A, ONE,B,-ONE,C,NJ,NE,KA)
C***  FETCH HY
      CALL FETCH(NTAPE2, 6,NREC2,B,NJ,NE,KB)
CC@CC
CC@CC SATB ONE, B, A, AMU(7,7)
CC@CC NJ, NE, NE
CC@CC KB, KA, KAMU
      CALL DGEMM ('T','N',NE,NE,NJ,ONE,B,KB,A,KA,1.0d0,AMU(7,7),KAMU)
CC@CC end of expanded call
CC@CC
C***  FETCH M*HZ,SY*SIGX,SX*SIGY
      CALL FETCH(NTAPE3, 7,NREC3,A,NJ,NE,KA)
      CALL FETCH(NTAPE3,13,NREC3,B,NJ,NE,KB)
      CALL FETCH(NTAPE3,18,NREC3,C,NJ,NE,KC)
      CALL ADD3( ONE,A, ONE,B,-ONE,C,NJ,NE,KA)
C***  FETCH HZ
      CALL FETCH(NTAPE2, 7,NREC2,B,NJ,NE,KB)
CC@CC
CC@CC SATB ONE, B, A, AMU(7,7)
CC@CC NJ, NE, NE
CC@CC KB, KA, KAMU
      CALL DGEMM ('T','N',NE,NE,NJ,ONE,B,KB,A,KA,1.0d0,AMU(7,7),KAMU)
CC@CC end of expanded call
CC@CC
C***  FETCH JXX*SIGX,JXY*SIGY,JXZ*SIGZ
      CALL FETCH(NTAPE3,10,NREC3,A,NJ,NE,KA)
      CALL FETCH(NTAPE3,15,NREC3,B,NJ,NE,KB)
      CALL FETCH(NTAPE3,20,NREC3,C,NJ,NE,KC)
      CALL ADD3( ONE,A,-ONE,B,-ONE,C,NJ,NE,KA)
C***  FETCH SY*HZ,SZ*HY
      CALL FETCH(NTAPE3, 9,NREC3,B,NJ,NE,KB)
      CALL FETCH(NTAPE3, 6,NREC3,C,NJ,NE,KC)
      CALL ADD3( ONE,A, ONE,B,-ONE,C,NJ,NE,KA)
C***  FETCH SIGX
      CALL FETCH(NTAPE2, 8,NREC2,B,NJ,NE,KB)
CC@CC
CC@CC SATB ONE, B, A, AMU(7,7)
CC@CC NJ, NE, NE
CC@CC KB, KA, KAMU
      CALL DGEMM ('T','N',NE,NE,NJ,ONE,B,KB,A,KA,1.0d0,AMU(7,7),KAMU)
CC@CC end of expanded call
CC@CC
C***  FETCH JXY*SIGX,JYY*SIGY,JYZ*SIGZ
      CALL FETCH(NTAPE3,11,NREC3,A,NJ,NE,KA)
      CALL FETCH(NTAPE3,16,NREC3,B,NJ,NE,KB)
      CALL FETCH(NTAPE3,21,NREC3,C,NJ,NE,KC)
      CALL ADD3(-ONE,A, ONE,B,-ONE,C,NJ,NE,KA)
C***  FETCH SZ*HX,SX*HZ
      CALL FETCH(NTAPE3, 3,NREC3,B,NJ,NE,KB)
      CALL FETCH(NTAPE3, 8,NREC3,C,NJ,NE,KC)
      CALL ADD3( ONE,A, ONE,B,-ONE,C,NJ,NE,KA)
C***  FETCH SIGY
      CALL FETCH(NTAPE2, 9,NREC2,B,NJ,NE,KB)
CC@CC
CC@CC SATB ONE, B, A, AMU(7,7)
CC@CC NJ, NE, NE
CC@CC KB, KA, KAMU
      CALL DGEMM ('T','N',NE,NE,NJ,ONE,B,KB,A,KA,1.0d0,AMU(7,7),KAMU)
CC@CC end of expanded call
CC@CC
C***  FETCH JXZ*SIGX,JYZ*SIGY,JZZ*SIGZ
      CALL FETCH(NTAPE3,12,NREC3,A,NJ,NE,KA)
      CALL FETCH(NTAPE3,17,NREC3,B,NJ,NE,KB)
      CALL FETCH(NTAPE3,22,NREC3,C,NJ,NE,KC)
      CALL ADD3(-ONE,A,-ONE,B, ONE,C,NJ,NE,KA)
C***  FETCH SX*HY,SY*HX
      CALL FETCH(NTAPE3, 5,NREC3,B,NJ,NE,KB)
      CALL FETCH(NTAPE3, 2,NREC3,C,NJ,NE,KC)
      CALL ADD3( ONE,A,ONE,B,-ONE,C,NJ,NE,KA)
C***  FETCH SIGZ
      CALL FETCH(NTAPE2,10,NREC2,B,NJ,NE,KB)
CC@CC
CC@CC SATB ONE, B, A, AMU(7,7)
CC@CC NJ, NE, NE
CC@CC KB, KA, KAMU
      CALL DGEMM ('T','N',NE,NE,NJ,ONE,B,KB,A,KA,1.0d0,AMU(7,7),KAMU)
CC@CC end of expanded call
CC@CC
      if (mbplvl .ge. 2) CALL MWRITE(AMU(7,7),NE,NE,'ECOEF',KAMU)
C
      RETURN
      END
