C $Header: /export/cvs/c34a1/source/moldyn/cremu0.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
      SUBROUTINE CREMU0(NREC3,NJ,UVEC,A,WS,AMU,KA,KWS,KAMU)
CSE
C
CPS        PURPOSE:
C
C                   MAKES USE OF LUMPED PARAMETER DATA TO COMPUTE THE
C                   FLEXIBLE BODY'S UNDEFORMED INERTIA TENSOR, STATIC
C                   MASS MOMENT AND TOTAL MASS, SEE EQ II-87
C
CPE
C                                                          DEBUG #  18
      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: cremu0.f,v $$Revision: 1.1.1.1 $'/
C
C         USE THE LUMPED PARAMETER DATA ON NTAPE3,  ALONG WITH EQUATIONS
C         II-30,31,35 AND 37 TO COMPUTE THE INERTIA TENSOR, STATIC MASS
C         MOMENT AND TOTAL MASS FOR THE UNDEFORMED FLEXIBLE BODY.
C         THESE TERMS ARE STORED AS A 6 BY 6 MATRIX AND DEFINE THE
C         UPPER LEFT 2 BY 2 PARTITION OF EQUATION II-87
C
C
#include "PARAM.FOR"
#ifdef CHARMM
#include "CHARMM.INC"
#endif
#include "NUMBRS.INC"
#include "TAPENO.INC"
c
C     Local Variables
c
      INTEGER NREC3,NJ,KA,KWS,KAMU
      DOUBLE PRECISION A(KA,*),WS(KWS,*),AMU(KAMU,*),UVEC(*)
C
C***  FETCH M*RHOX,M*RHOY,M*RHOZ
      CALL FETCH(NTAPE3,25,NREC3,A(1,1),NJ,1,KA)
      CALL FETCH(NTAPE3,26,NREC3,A(1,2),NJ,1,KA)
      CALL FETCH(NTAPE3,27,NREC3,A(1,3),NJ,1,KA)
C***  FORM JXX0
CC@CC
CC@CC SATB ONE, WS(1,13), A(1, 3), AMU(1,1)
CC@CC NJ, 1, 1
CC@CC KWS, KA, KAMU
      CALL DGEMV ('T',NJ,1,ONE,WS(1,13),KWS,A(1, 3),1,1.0d0,AMU(1,1),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, WS(1,12), A(1, 2), AMU(1,1)
CC@CC NJ, 1, 1
CC@CC KWS, KA, KAMU
      CALL DGEMV ('T',NJ,1,ONE,WS(1,12),KWS,A(1, 2),1,1.0d0,AMU(1,1),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB TWO, WS(1,13), WS(1,10), AMU(1,1)
CC@CC NJ, 1, 1
CC@CC KWS, KWS, KAMU
      CALL DGEMV ('T',NJ,1,TWO,WS(1,13),KWS,WS(1,10),1,1.0d0,AMU(1,1),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB TWO, WS(1,12), WS(1, 9), AMU(1,1)
CC@CC NJ, 1, 1
CC@CC KWS, KWS, KAMU
      CALL DGEMV ('T',NJ,1,TWO,WS(1,12),KWS,WS(1, 9),1,1.0d0,AMU(1,1),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, UVEC    , WS(1, 2), AMU(1,1)
CC@CC NJ, 1, 1
CC@CC KWS, KWS, KAMU
      CALL DGEMV ('T',NJ,1,ONE,UVEC    ,KWS,WS(1, 2),1,1.0d0,AMU(1,1),1)
CC@CC end of expanded call
CC@CC
C***  FORM JXY0
CC@CC
CC@CC SATB -ONE, WS(1,12), A(1, 1), AMU(1,2)
CC@CC NJ, 1, 1
CC@CC KWS, KA, KAMU
      CALL DGEMV ('T',NJ,1,-ONE,WS(1,12),KWS,A(1, 1),1,1.0d0,AMU(1,2),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB -ONE, WS(1,12), WS(1, 8), AMU(1,2)
CC@CC NJ, 1, 1
CC@CC KWS, KWS, KAMU
      CALL DGEMV ('T',NJ,1,-ONE,WS(1,12),KWS,WS(1, 8),1,1.0d0,AMU(1,2),1
     .)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB -ONE, WS(1,11), WS(1, 9), AMU(1,2)
CC@CC NJ, 1, 1
CC@CC KWS, KWS, KAMU
      CALL DGEMV ('T',NJ,1,-ONE,WS(1,11),KWS,WS(1, 9),1,1.0d0,AMU(1,2),1
     .)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB -ONE, UVEC    , WS(1, 5), AMU(1,2)
CC@CC NJ, 1, 1
CC@CC KWS, KWS, KAMU
      CALL DGEMV ('T',NJ,1,-ONE,UVEC    ,KWS,WS(1, 5),1,1.0d0,AMU(1,2),1
     .)
CC@CC end of expanded call
CC@CC
C***  FORM JXZ0
CC@CC
CC@CC SATB -ONE, WS(1,13), A(1, 1), AMU(1,3)
CC@CC NJ, 1, 1
CC@CC KWS, KA, KAMU
      CALL DGEMV ('T',NJ,1,-ONE,WS(1,13),KWS,A(1, 1),1,1.0d0,AMU(1,3),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB -ONE, WS(1,13), WS(1, 8), AMU(1,3)
CC@CC NJ, 1, 1
CC@CC KWS, KWS, KAMU
      CALL DGEMV ('T',NJ,1,-ONE,WS(1,13),KWS,WS(1, 8),1,1.0d0,AMU(1,3),1
     .)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB -ONE, WS(1,11), WS(1,10), AMU(1,3)
CC@CC NJ, 1, 1
CC@CC KWS, KWS, KAMU
      CALL DGEMV ('T',NJ,1,-ONE,WS(1,11),KWS,WS(1,10),1,1.0d0,AMU(1,3),1
     .)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB -ONE, UVEC    , WS(1, 6), AMU(1,3)
CC@CC NJ, 1, 1
CC@CC KWS, KWS, KAMU
      CALL DGEMV ('T',NJ,1,-ONE,UVEC    ,KWS,WS(1, 6),1,1.0d0,AMU(1,3),1
     .)
CC@CC end of expanded call
CC@CC
C***  FORM JYY0
CC@CC
CC@CC SATB ONE, WS(1,13), A(1, 3), AMU(2,2)
CC@CC NJ, 1, 1
CC@CC KWS, KA, KAMU
      CALL DGEMV ('T',NJ,1,ONE,WS(1,13),KWS,A(1, 3),1,1.0d0,AMU(2,2),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, WS(1,11), A(1, 1), AMU(2,2)
CC@CC NJ, 1, 1
CC@CC KWS, KA, KAMU
      CALL DGEMV ('T',NJ,1,ONE,WS(1,11),KWS,A(1, 1),1,1.0d0,AMU(2,2),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB TWO, WS(1,13), WS(1,10), AMU(2,2)
CC@CC NJ, 1, 1
CC@CC KWS, KWS, KAMU
      CALL DGEMV ('T',NJ,1,TWO,WS(1,13),KWS,WS(1,10),1,1.0d0,AMU(2,2),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB TWO, WS(1,11), WS(1, 8), AMU(2,2)
CC@CC NJ, 1, 1
CC@CC KWS, KWS, KAMU
      CALL DGEMV ('T',NJ,1,TWO,WS(1,11),KWS,WS(1, 8),1,1.0d0,AMU(2,2),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, UVEC    , WS(1, 3), AMU(2,2)
CC@CC NJ, 1, 1
CC@CC KWS, KWS, KAMU
      CALL DGEMV ('T',NJ,1,ONE,UVEC    ,KWS,WS(1, 3),1,1.0d0,AMU(2,2),1)
CC@CC end of expanded call
CC@CC
C***  FORM JYZ0
CC@CC
CC@CC SATB -ONE, WS(1,13), A(1, 2), AMU(2,3)
CC@CC NJ, 1, 1
CC@CC KWS, KA, KAMU
      CALL DGEMV ('T',NJ,1,-ONE,WS(1,13),KWS,A(1, 2),1,1.0d0,AMU(2,3),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB -ONE, WS(1,13), WS(1, 9), AMU(2,3)
CC@CC NJ, 1, 1
CC@CC KWS, KWS, KAMU
      CALL DGEMV ('T',NJ,1,-ONE,WS(1,13),KWS,WS(1, 9),1,1.0d0,AMU(2,3),1
     .)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB -ONE, WS(1,12), WS(1,10), AMU(2,3)
CC@CC NJ, 1, 1
CC@CC KWS, KWS, KAMU
      CALL DGEMV ('T',NJ,1,-ONE,WS(1,12),KWS,WS(1,10),1,1.0d0,AMU(2,3),1
     .)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB -ONE, UVEC    , WS(1, 7), AMU(2,3)
CC@CC NJ, 1, 1
CC@CC KWS, KWS, KAMU
      CALL DGEMV ('T',NJ,1,-ONE,UVEC    ,KWS,WS(1, 7),1,1.0d0,AMU(2,3),1
     .)
CC@CC end of expanded call
CC@CC
C***  FORM JZZ0
CC@CC
CC@CC SATB ONE, WS(1,12), A(1, 2), AMU(3,3)
CC@CC NJ, 1, 1
CC@CC KWS, KA, KAMU
      CALL DGEMV ('T',NJ,1,ONE,WS(1,12),KWS,A(1, 2),1,1.0d0,AMU(3,3),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, WS(1,11), A(1, 1), AMU(3,3)
CC@CC NJ, 1, 1
CC@CC KWS, KA, KAMU
      CALL DGEMV ('T',NJ,1,ONE,WS(1,11),KWS,A(1, 1),1,1.0d0,AMU(3,3),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB TWO, WS(1,12), WS(1, 9), AMU(3,3)
CC@CC NJ, 1, 1
CC@CC KWS, KWS, KAMU
      CALL DGEMV ('T',NJ,1,TWO,WS(1,12),KWS,WS(1, 9),1,1.0d0,AMU(3,3),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB TWO, WS(1,11), WS(1, 8), AMU(3,3)
CC@CC NJ, 1, 1
CC@CC KWS, KWS, KAMU
      CALL DGEMV ('T',NJ,1,TWO,WS(1,11),KWS,WS(1, 8),1,1.0d0,AMU(3,3),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, UVEC    , WS(1, 4), AMU(3,3)
CC@CC NJ, 1, 1
CC@CC KWS, KWS, KAMU
      CALL DGEMV ('T',NJ,1,ONE,UVEC    ,KWS,WS(1, 4),1,1.0d0,AMU(3,3),1)
CC@CC end of expanded call
CC@CC
C***  FORM SX0
CC@CC
CC@CC SATB ONE, UVEC    , WS(1, 8), AMU(3,5)
CC@CC NJ, 1, 1
CC@CC KWS, KWS, KAMU
      CALL DGEMV ('T',NJ,1,ONE,UVEC    ,KWS,WS(1, 8),1,1.0d0,AMU(3,5),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, WS(1,11), WS(1, 1), AMU(3,5)
CC@CC NJ, 1, 1
CC@CC KWS, KWS, KAMU
      CALL DGEMV ('T',NJ,1,ONE,WS(1,11),KWS,WS(1, 1),1,1.0d0,AMU(3,5),1)
CC@CC end of expanded call
CC@CC
C***  FORM SY0
CC@CC
CC@CC SATB ONE, UVEC    , WS(1, 9), AMU(1,6)
CC@CC NJ, 1, 1
CC@CC KWS, KWS, KAMU
      CALL DGEMV ('T',NJ,1,ONE,UVEC    ,KWS,WS(1, 9),1,1.0d0,AMU(1,6),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, WS(1,12), WS(1, 1), AMU(1,6)
CC@CC NJ, 1, 1
CC@CC KWS, KWS, KAMU
      CALL DGEMV ('T',NJ,1,ONE,WS(1,12),KWS,WS(1, 1),1,1.0d0,AMU(1,6),1)
CC@CC end of expanded call
CC@CC
C***  FORM SZ0
CC@CC
CC@CC SATB ONE, UVEC    , WS(1,10), AMU(2,4)
CC@CC NJ, 1, 1
CC@CC KWS, KWS, KAMU
      CALL DGEMV ('T',NJ,1,ONE,UVEC    ,KWS,WS(1,10),1,1.0d0,AMU(2,4),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC SATB ONE, WS(1,13), WS(1, 1), AMU(2,4)
CC@CC NJ, 1, 1
CC@CC KWS, KWS, KAMU
      CALL DGEMV ('T',NJ,1,ONE,WS(1,13),KWS,WS(1, 1),1,1.0d0,AMU(2,4),1)
CC@CC end of expanded call
CC@CC
      AMU(2,6) = -AMU(3,5)
      AMU(3,4) = -AMU(1,6)
      AMU(1,5) = -AMU(2,4)
C***  FORM MASS
CC@CC
CC@CC SATB ONE, UVEC    , WS(1, 1), AMU(4,4)
CC@CC NJ, 1, 1
CC@CC KWS, KWS, KAMU
      CALL DGEMV ('T',NJ,1,ONE,UVEC    ,KWS,WS(1, 1),1,1.0d0,AMU(4,4),1)
CC@CC end of expanded call
CC@CC
      AMU(5,5) = AMU(4,4)
      AMU(6,6) = AMU(4,4)
C
#ifdef CHARMM
      IF (mbplvl .GE. 2) THEN
#endif
         CALL MWRITE(AMU(1,1),3,3,'INER0',KAMU)
         CALL MWRITE(AMU(1,4),3,3,'STAT0',KAMU)
         CALL MWRITE(AMU(4,4),3,3,'MASS0',KAMU)
#ifdef CHARMM
      END IF
#endif
C
      RETURN
      END
