C $Header: /export/cvs/c34a1/source/moldyn/cret3.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
      SUBROUTINE CRET3(NREC2,NJ,NE,A,B,WS,KA,KB,KWS)
CSE
C
CPS        PURPOSE:
C
C                   TO FETCH RAW FLEXIBLE BODY DATA FROM NTAPE2 AND TO
C                   CREATE THE FUNCTIONS WHICH MUST BE INTEGRATED OVER
C                   THE BODY'S VOLUMN TO DEFINE RESULTANT MODE DEPENDENT
C                   INERTIA PARAMETERS
C
CPE
C                                                          DEBUG #  17
      IMPLICIT NONE
C 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: cret3.f,v $$Revision: 1.1.1.1 $'/
CAS         ***  OUTPUT DATA ARGUMENT LIST  ***
C
C         LET
C
C              N = JOINT NUMBER  N=1,...,NJ
C           M(N) = JOINT MASS
C
C        JXX(N) -JXY(N) -JXZ(N)
C       -JXY(N)  JYY(N) -JYZ(N) = JOINT INERTIA TENSOR
C       -JXZ(N) -JYZ(N)  JZZ(N)
C
C          0      SZ(N)  -SY(N)
C        -SZ(N)    0      SX(N) = JOINT MASS MOMENT TENSOR
C         SY(N)  -SX(N)    0
C
C          P1(N) = JOINT MODAL X DISPLACEMENT COMPONENTS
C          P2(N) = JOINT MODAL Y DISPLACEMENT COMPONENTS
C          P3(N) = JOINT MODAL Z DISPLACEMENT COMPONENTS
C          P4(N) = JOINT MODAL X ROTATION COMPONENTS
C          P5(N) = JOINT MODAL Y ROTATION COMPONENTS
C          P6(N) = JOINT MODAL Z ROTATION COMPONENTS
C           X(N) = JOINT X LOCATION
C           Y(N) = JOINT Y LOCATION
C           Z(N) = JOINT Z LOCATION
C
C         THEN
C                        ON NTAPE3 RECORD  1  MATRIX   M * P1
C                        ON NTAPE3 RECORD  2  MATRIX  SY * P1
C                        ON NTAPE3 RECORD  3  MATRIX  SZ * P1
C                        ON NTAPE3 RECORD  4  MATRIX   M * P2
C                        ON NTAPE3 RECORD  5  MATRIX  SX * P2
C                        ON NTAPE3 RECORD  6  MATRIX  SZ * P2
C                        ON NTAPE3 RECORD  7  MATRIX   M * P3
C                        ON NTAPE3 RECORD  8  MATRIX  SX * P3
C                        ON NTAPE3 RECORD  9  MATRIX  SY * P3
C                        ON NTAPE3 RECORD 10  MATRIX JXX * P4
C                        ON NTAPE3 RECORD 11  MATRIX JXY * P4
C                        ON NTAPE3 RECORD 12  MATRIX JXZ * P4
C                        ON NTAPE3 RECORD 13  MATRIX  SY * P4
C                        ON NTAPE3 RECORD 14  MATRIX  SZ * P4
C                        ON NTAPE3 RECORD 15  MATRIX JXY * P5
C                        ON NTAPE3 RECORD 16  MATRIX JYY * P5
C                        ON NTAPE3 RECORD 17  MATRIX JYZ * P5
C                        ON NTAPE3 RECORD 18  MATRIX  SX * P5
C                        ON NTAPE3 RECORD 19  MATRIX  SZ * P5
C                        ON NTAPE3 RECORD 20  MATRIX JXZ * P6
C                        ON NTAPE3 RECORD 21  MATRIX JYZ * P6
C                        ON NTAPE3 RECORD 22  MATRIX JZZ * P6
C                        ON NTAPE3 RECORD 23  MATRIX  SX * P6
C                        ON NTAPE3 RECORD 24  MATRIX  SY * P6
C                        ON NTAPE3 RECORD 25  MATRIX   M * X
C                        ON NTAPE3 RECORD 26  MATRIX   M * Y
C                        ON NTAPE3 RECORD 27  MATRIX   M * Z
C
CAE
C
#include "PARAM.FOR"
C
#include "NUMBRS.INC"
#include "TAPENO.INC"
C
C     Local Variabes
C
      INTEGER KA,KB,KWS,NREC2
      INTEGER NE,NJ
      DOUBLE PRECISION A(KA,*),B(KB,*),WS(KWS,*)
c
#include "LDEBUG.INC"
      LOGICAL LEQU
      EQUIVALENCE (LEQU,DEBUG(17))
      IF(LEQU) WRITE (MBOUT,1000)
 1000 FORMAT (' SUBROUTINE CRET3')
C
C***  FETCH M
      CALL FETCH(NTAPE2, 1,NREC2,WS(1, 1),NJ,1,KWS)
C***  FETCH JXX,....,JYZ
      CALL FETCH(NTAPE2, 2,NREC2,WS(1, 2),NJ,6,KWS)
C***  FETCH SX,SY,SZ
      CALL FETCH(NTAPE2, 3,NREC2,WS(1, 8),NJ,3,KWS)
C***  FETCH GEOMETRY
      CALL FETCH(NTAPE2, 4,NREC2,WS(1,11),NJ,3,KWS)
C***  FETCH HX
      CALL FETCH(NTAPE2, 5,NREC2,A,NJ,NE,KA)
      CALL STORE(NTAPE3,WS(1, 1),A,B,NJ,NE,KWS,KA,KB)
      IF(LEQU) CALL MWRITE(B,NJ,NE,'  M*P1',KB)
      CALL STORE(NTAPE3,WS(1, 9),A,B,NJ,NE,KWS,KA,KB)
      IF(LEQU) CALL MWRITE(B,NJ,NE,' SY*P1',KB)
      CALL STORE(NTAPE3,WS(1,10),A,B,NJ,NE,KWS,KA,KB)
      IF(LEQU) CALL MWRITE(B,NJ,NE,' SZ*P1',KB)
C***  FETCH HY
      CALL FETCH(NTAPE2, 6,NREC2,A,NJ,NE,KA)
      CALL STORE(NTAPE3,WS(1, 1),A,B,NJ,NE,KWS,KA,KB)
      IF(LEQU) CALL MWRITE(B,NJ,NE,'  M*P2',KB)
      CALL STORE(NTAPE3,WS(1, 8),A,B,NJ,NE,KWS,KA,KB)
      IF(LEQU) CALL MWRITE(B,NJ,NE,' SX*P2',KB)
      CALL STORE(NTAPE3,WS(1,10),A,B,NJ,NE,KWS,KA,KB)
      IF(LEQU) CALL MWRITE(B,NJ,NE,' SZ*P2',KB)
C***  FETCH HZ
      CALL FETCH(NTAPE2, 7,NREC2,A,NJ,NE,KA)
      CALL STORE(NTAPE3,WS(1, 1),A,B,NJ,NE,KWS,KA,KB)
      IF(LEQU) CALL MWRITE(B,NJ,NE,'  M*P3',KB)
      CALL STORE(NTAPE3,WS(1, 8),A,B,NJ,NE,KWS,KA,KB)
      IF(LEQU) CALL MWRITE(B,NJ,NE,' SX*P3',KB)
      CALL STORE(NTAPE3,WS(1, 9),A,B,NJ,NE,KWS,KA,KB)
      IF(LEQU) CALL MWRITE(B,NJ,NE,' SY*P3',KB)
C***  FETCH SIGX
      CALL FETCH(NTAPE2, 8,NREC2,A,NJ,NE,KA)
      CALL STORE(NTAPE3,WS(1, 2),A,B,NJ,NE,KWS,KA,KB)
      IF(LEQU) CALL MWRITE(B,NJ,NE,'JXX*P4',KB)
      CALL STORE(NTAPE3,WS(1, 5),A,B,NJ,NE,KWS,KA,KB)
      IF(LEQU) CALL MWRITE(B,NJ,NE,'JXY*P4',KB)
      CALL STORE(NTAPE3,WS(1, 6),A,B,NJ,NE,KWS,KA,KB)
      IF(LEQU) CALL MWRITE(B,NJ,NE,'JXZ*P4',KB)
      CALL STORE(NTAPE3,WS(1, 9),A,B,NJ,NE,KWS,KA,KB)
      IF(LEQU) CALL MWRITE(B,NJ,NE,' SY*P4',KB)
      CALL STORE(NTAPE3,WS(1,10),A,B,NJ,NE,KWS,KA,KB)
      IF(LEQU) CALL MWRITE(B,NJ,NE,' SZ*P4',KB)
C***  FETCH SIGY
      CALL FETCH(NTAPE2, 9,NREC2,A,NJ,NE,KA)
      CALL STORE(NTAPE3,WS(1, 5),A,B,NJ,NE,KWS,KA,KB)
      IF(LEQU) CALL MWRITE(B,NJ,NE,'JXY*P5',KB)
      CALL STORE(NTAPE3,WS(1, 3),A,B,NJ,NE,KWS,KA,KB)
      IF(LEQU) CALL MWRITE(B,NJ,NE,'JYY*P5',KB)
      CALL STORE(NTAPE3,WS(1, 7),A,B,NJ,NE,KWS,KA,KB)
      IF(LEQU) CALL MWRITE(B,NJ,NE,'JYZ*P5',KB)
      CALL STORE(NTAPE3,WS(1, 8),A,B,NJ,NE,KWS,KA,KB)
      IF(LEQU) CALL MWRITE(B,NJ,NE,' SX*P5',KB)
      CALL STORE(NTAPE3,WS(1,10),A,B,NJ,NE,KWS,KA,KB)
      IF(LEQU) CALL MWRITE(B,NJ,NE,' SZ*P5',KB)
C***  FETCH SIGZ
      CALL FETCH(NTAPE2,10,NREC2,A,NJ,NE,KA)
      CALL STORE(NTAPE3,WS(1, 6),A,B,NJ,NE,KWS,KA,KB)
      IF(LEQU) CALL MWRITE(B,NJ,NE,'JXZ*P6',KB)
      CALL STORE(NTAPE3,WS(1, 7),A,B,NJ,NE,KWS,KA,KB)
      IF(LEQU) CALL MWRITE(B,NJ,NE,'JYZ*P6',KB)
      CALL STORE(NTAPE3,WS(1, 4),A,B,NJ,NE,KWS,KA,KB)
      IF(LEQU) CALL MWRITE(B,NJ,NE,'JZZ*P6',KB)
      CALL STORE(NTAPE3,WS(1, 8),A,B,NJ,NE,KWS,KA,KB)
      IF(LEQU) CALL MWRITE(B,NJ,NE,' SX*P6',KB)
      CALL STORE(NTAPE3,WS(1, 9),A,B,NJ,NE,KWS,KA,KB)
      IF(LEQU) CALL MWRITE(B,NJ,NE,' SY*P6',KB)
      CALL STORE(NTAPE3,WS(1, 1),WS(1,11),B,NJ,1,KWS,KWS,KB)
      IF(LEQU) CALL MWRITE(B,NJ,1,'   M*X',KB)
      CALL STORE(NTAPE3,WS(1, 1),WS(1,12),B,NJ,1,KWS,KWS,KB)
      IF(LEQU) CALL MWRITE(B,NJ,1,'   M*Y',KB)
      CALL STORE(NTAPE3,WS(1, 1),WS(1,13),B,NJ,1,KWS,KWS,KB)
      IF(LEQU) CALL MWRITE(B,NJ,1,'   M*Z',KB)
C
      RETURN
      END
