c $Header: /export/cvs/c34a1/source/moldyn/ctinit1_CHARMM.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
c
C COPYRIGHT (C) 1991-1994 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
      SUBROUTINE ctinit1_CHARMM(IHPATH,ITOPOL,IHDATA,IHCUTJ,IOP,LOOP)
C                                                          DEBUG # 112
CSE
      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: ctinit1_CHARMM.f,v $$Revision: 1.1.1.1 $'/
CPS
C     PURPOSE:
C              INITIALIZE CUT JOINT SPECIFICATION ARRAYS AND COUNTERS
C              CHECK FOR INPUT DATA INCONSISTENCIES WITH RESPECT TO
C              CUT JOINT SELECTION AND REPORT WITH APPROPRIATE MESSAGE
C              AND ERROR STOP
C
CPE
CAS   ARGUMENT LIST:
C
C              DATA IS CURRENTLY READ IN VIA NAMELIST.  IT WILL EVENTUALLY
C              BE COMPUTED WITHOUT USER INPUT ASSIST.
C
C              THE FOLLOWING ARRAYS AND VARIABLS ARE STORED IN /CPATHS/.
C
C         NCUT = TOTAL NUMBER OF CUT JOINTS REQUIRED TO CREATE A TOPOLOGICAL
C                TREE FROM THE TOPOLOGICAL LOOP CONFIGURATION DEFINED.  NCUT
C                MUST EQUAL NH-NB
C        ICOMP = NCUT+1 - NUMBER OF CUT JOINTS + 1
C    IHCUTJ(J) = HINGE NUMBER OF THE J-TH CUT JOINT, J=1,...,NCUT
C  IHPATH(I,J) = TRUE IF HINGE J IS ON ANY ONE OF THE PATHS LEADING FROM
C                   BODY 1 TO CUT JOINT IHCUTJ(I)
C                FALSE IF IT IS NOT, I=1,...,NCUT.
C                ROW I=NCUT+1 - DEFINES IF HINGE J IS IN A TOPOLOGICAL LOOP,
C                   TRUE  - HINGE J IS ON A PATH LEADING TO A CUT JOINT.
C                   FALSE - HINGE J IS NOT ON A PATH LEADING TO A CUT JOINT.
C     ITOPW  = CONTAINS THE SEQUENCED TOPOLOGY DATA, INDICATING FOR EACH BODY
C              WHICH HINGE IS THE INBOARD HINGE, AND WHETHER THE ASSOCIATED
C              HINGE FRAME IS A P-FRAME OR A Q-FRAME.  HINGE DATA SEQUENCED
C              TO BEGIN FROM BODY 1 AND TO PROGRESS OUTWARD UNTIL THE END
C              BODY OF EACH BRANCH IS REACHED.  SEQUENCING IS NOT UNIQUE;
C              HOWEVER, THE PATH FROM THE HINGE/BODY PAIR DEFINED IN COLUMN I
C              OF ITOPW TO BODY 1 MUST BE DEFINED IN COLUMNS 1,..,I-1 OF
C              ITOPW.  ITOPW IS STORED IN /ORDERN/.  IT IS NEEDED FOR FORWARD
C              AND BACKWARD SWEEPING IN RECURSIVE ALGORITHM.  THE ITOPOL
C              ARRAY IS USED TO FIND THE INBOARD BODY NUMBER.
C                  ITOPW(1,I) = INBOARD HINGE NUMBER FOR BODY ITOPW(2,I)
C                               NEGATIVE IF P-FRAME ON OUTBOARD BODY
C                               POSITIVE IF Q-FRAME ON OUTBOARD BODY
C                  ITOPW(2,I) = OUTBOARD BODY NUMBER FOR HINGE ITOPW(1,I)
C       NCTCON = TOTAL NUMBER OF KINEMATIC AND RHENOMIC CONSTRAINTS THAT MUST
C                   BE SATISFIED AT ALL CUT JOINTS.  NCTCON COMPUTED FROM
C                   IHDATA ARRAY BY COUNTING ARRAY ELEMENTS .EQ.1 .OR. .EQ.2
C
C
CAE
#include "PARAM.FOR"
#include "CHARMM.INC"
#include "CPATHS.INC"
#include "ERRHDL.INC"
#include "OPTION.INC"
#include "ORDERN.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
C
c     Passed
      LOGICAL ihpath(cL63+1,cL02)
      INTEGER itopol(2,cL02)
      INTEGER ihdata(7,cL02)
      INTEGER IHCUTJ(cL63)
C     External variables
C 
C     Local Variables
C
      INTEGER IS,IS1,JOPA,JOP,N,NOP
      INTEGER ICUTH,IHG,IABS,IDOF,IHINGE
      INTEGER I,J,K
      INTEGER IOP(2,cL02),NBODF(L01),IOB(2),LOOP(cL02)
C
#include "LDEBUG.INC"
      LOGICAL LEQU
      EQUIVALENCE (LEQU,DEBUG(112))
C
      IF(LEQU) WRITE (MBOUT,1000)
 1000 FORMAT (' SUBROUTINE CTINIT, INITIALIZE CUT JOINT ARRAYS ')
C
      IF(IPDATA(22).EQ.0) THEN
C      DEFAULT - COMPUTE ALL TOPOLOGICAL LOOP COMPUTATIONAL CONTROL ARRAYS
C      THE SYSTEM HAS TOPOLOGICAL LOOPS, COMPUTE ITOPW, SEQUENCED TOPOLOGY
C      DATA NEEDED TO OBTAIN POSITION AND ORIENTATION OF REFERENCE FRAMES
C      FROM RELATIVE COORDINATE STATE VARIABLES
C
         DO I=1,2
            DO J=1,NH
               ITOPW(I,J) = ITOPOL(I,J)
            END DO
         END DO
C   ZERO OUT ROWS OF ITOPW ASSOCIATED WITH CUT JOINTS
         DO I=1,NCUT
           J=IHCUTJ(I)
           ITOPW(1,J)=0
           ITOPW(2,J)=0
         END DO
C  START SEQUENCING LOOP
         IS = 1
         DO N=1,NB
           NBODF(N) = 0
         END DO
         ITOPW(1,1) = 0
         NOP = 1
         IOP(1,1) = 1
         IOP(2,1) = 1
C  SEQUENCING LOOP RETURN POINT
  125    CONTINUE
         DO 110 I=1,2
         DO 110 J=1,NH
            IF (ITOPW(I,J) .NE. IS) GO TO 110
            NOP = NOP + 1
            IOP(1,J) = NOP
            IOP(2,J) = ITOPW(1,J)
            IF (I .NE. 2) THEN
               IOP(1,J) = -NOP
               IOP(2,J) = ITOPW(2,J)
            END IF
            IS1 = IOP(2,J)
            NBODF(IS1) = 1
            ITOPW(1,J) = 0
            ITOPW(2,J) = 0
  110    CONTINUE
         NBODF(IS) = 0
         IF (NOP .EQ. NH-NCUT) GO TO 120
         DO 116 N=1,NB
            IF (NBODF(N) .EQ. 0) GO TO 116
            IS = N
            GO TO 125
  116    CONTINUE
         GO TO 999
  120    DO J=1,NH
            JOPA = IOP(1,J)
            IF(JOPA.NE.0) THEN
               JOP = IABS(JOPA)
               ITOPW(1,JOP) = J*JOPA/JOP
               ITOPW(2,JOP) = IOP(2,J)
            END IF
         END DO
C
C  FINISHED WITH ITOPW ARRAY, BEGIN IHPATH ARRAY
C
         DO K=1,NCUT
            DO I=1,NH
               IHPATH(NCUT+1,I) = .FALSE.
            END DO
            DO I=1,NH
               LOOP(I)=0
               IHPATH(K,I) = .FALSE.
            END DO
            ICUTH = IHCUTJ(K)
            LOOP(ICUTH) = 1
            IOB(1) = ITOPOL(1,ICUTH)
            IOB(2) = ITOPOL(2,ICUTH)
            DO I=1,2
100            CONTINUE
               DO J=1,NH-NCUT
                  IF(ITOPW(2,J).EQ.IOB(I)) THEN
                     IHG = IABS(ITOPW(1,J))
                     IF(LOOP(IHG).EQ.0) THEN
                         LOOP(IHG)=1
                     ELSE
                        LOOP(IHG)=0
                     END IF
                     IHPATH(K,IHG)=.TRUE.
                     IF(ITOPOL(1,IHG).EQ.IOB(I)) THEN
                        IOB(I)=ITOPOL(2,IHG)
                     ELSE
                        IOB(I)=ITOPOL(1,IHG)
                     END IF
                     GO TO 150
                  END IF
               END DO
150            CONTINUE
               IF(IOB(I).NE.0) GO TO 100
            END DO
            DO I=1,NH
               IF(LOOP(I).EQ.1) THEN
                  IHPATH(NCUT+1,I)=.TRUE.
               END IF
            END DO
         END DO
      END IF
C
C     END OF COMPUTATION FOR CLOSED LOOP INTEGER CONTROL ARRAYS
C
C     THE COMPOSITE ROW IS AFTER THE LAST CUT JOINT.
      ICOMP = NCUT + 1
C
C     FILL THE COMPOSITE ROW: AN ENTRY IS TRUE IFF THE HINGE LIES ON ANY
C     CUT JOINT PATH.
      DO 300 I = 1, NH
         IHPATH(ICOMP,I) = .FALSE.
         DO J = 1, NCUT
            IF (IHPATH(J,I)) THEN
               IHPATH(ICOMP,I) = .TRUE.
               GO TO 300
            END IF
         END DO
300   CONTINUE
C
C     COUNT THE CONSTRAINTS ON THE CUT JOINTS
      NCTCON = 0
      DO I = 1, NCUT
         IHINGE = IHCUTJ(I)
         if (itopol(1,ihinge) .GT. nbdy) then ! both objects are particles
            ihdata(1,ihinge) = 0
         else                                ! at least one object not particle
            ihdata(1,ihinge) = 1
         end if
         DO IDOF = 5, 7
            IF (IHDATA(IDOF,IHINGE) .GT. 0) NCTCON = NCTCON + 1
         END DO
      END DO
C
      if (mbplvl .ge. 2) then
         WRITE (MBOUT,*) ' NUMBER OF CUT JOINTS, NCUT              = ',
     $        NCUT
         WRITE (MBOUT,*) ' NUMBER OF CUT JOINT CONSTRAINTS, NCTCON = ',
     $        NCTCON
         WRITE (MBOUT,*) 
     &       '  CTINIT: CUT JOINT COMPUTATIONAL CONTROL ARRAYS'
         WRITE (MBOUT,*) ' IHCUTJ VECTOR '
         CALL WRITIS (IHCUTJ,1,NCUT,1)
         WRITE (MBOUT,*) ' ITOPW ARRAY '
         CALL WRITIS (ITOPW,2,NH,2)
         WRITE (MBOUT,*) ' CTINIT COMPUTED IHPATH ARRAY '
         CALL WRITELGCL(ihpath,ICOMP,NH,cL63+1)
      endif
C
      RETURN
 999  CALL CLEARERR()
      WRITE (ERRMSG,200) 
     +  ' TOPOLOGY ERROR FOUND IN ITOPOL ARRAY' 
      WRITE (MBOUT,1001)
 1001 FORMAT (' ITOPW ARRAY IS')
      CALL WRITIS(ITOPW,2,cL02,2)
      WRITE (MBOUT,1030)
 1030 FORMAT (' NBODF ARRAY IS')
      CALL WRITIS(NBODF,1,L01,1)
      CALL ERRHDL(-5,'<CTINIT1_CHARMM>') 
 200  FORMAT(1X,A)
C
      END
