C $Header: /export/cvs/c34a1/source/moldyn/eulerAngle.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C ========================================================================
C
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS.  USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C



C-----------------------------------------------------------------------
       SUBROUTINE eulerAngle (RotMatrix,  ! i: rotation matrix
     &                        EulSeq,     ! i: Euler sequence
     &                        EulAngle)   ! o: Euler angle
C-----------------------------------------------------------------------

C      compute an Euler angle vector given a Rotation Matrix
C      and an Euler Sequence.

       INTEGER EulSeq
       DOUBLE PRECISION RotMatrix(3,3)
       DOUBLE PRECISION EulAngle(3)
c
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: eulerAngle.f,v $$Revision: 1.1.1.1 $'/


C      Sequence = 1-2-3
       IF (EulSeq .EQ. 1) THEN
          EulAngle(1) = ATAN2(-RotMatrix(2,3), RotMatrix(3,3))
          EulAngle(2) = ASIN(RotMatrix(1,3))
          EulAngle(3) = ATAN2(-RotMatrix(1,2), RotMatrix(1,1))

C      Sequence = 1-3-2
       ELSEIF (EulSeq .EQ. 2) THEN
          EulAngle(1) = ATAN2(RotMatrix(2,3), RotMatrix(2,2))
          EulAngle(2) = ASIN(-RotMatrix(2,1))
          EulAngle(3) = ATAN2(RotMatrix(3,1), RotMatrix(1,1))

C      Sequence = 2-3-1
       ELSEIF (EulSeq .EQ. 3) THEN
          EulAngle(1) = ATAN2(-RotMatrix(1,3), RotMatrix(1,1))
          EulAngle(2) = ASIN(RotMatrix(1,2))
          EulAngle(3) = ATAN2(-RotMatrix(3,2), RotMatrix(2,2))

C      Sequence = 2-1-3
       ELSEIF (EulSeq .EQ. 4) THEN
          EulAngle(1) = ATAN2(RotMatrix(3,1), RotMatrix(3,3))
          EulAngle(2) = ASIN(-RotMatrix(3,2))
          EulAngle(3) = ATAN2(RotMatrix(1,2), RotMatrix(2,2))

C      Sequence = 3-1-2
       ELSEIF (EulSeq .EQ. 5) THEN
          EulAngle(1) = ATAN2(-RotMatrix(2,1), RotMatrix(2,2))
          EulAngle(2) = ASIN(RotMatrix(2,3))
          EulAngle(3) = ATAN2(-RotMatrix(1,3), RotMatrix(3,3))

C      Sequence = 3-2-1
       ELSEIF (EulSeq .EQ. 6) THEN
          EulAngle(1) = ATAN2(RotMatrix(1,2), RotMatrix(1,1))
          EulAngle(2) = ASIN(-RotMatrix(1,3))
          EulAngle(3) = ATAN2(RotMatrix(2,3), RotMatrix(3,3))

C      Sequence = 1-2-1
       ELSEIF (EulSeq .EQ. 7) THEN
          EulAngle(1) = ATAN2(RotMatrix(1,2), -RotMatrix(1,3))
          EulAngle(2) = ACOS(RotMatrix(1,1))
          EulAngle(3) = ATAN2(RotMatrix(2,1), RotMatrix(3,1))

C      Sequence = 1-3-1
       ELSEIF (EulSeq .EQ. 8) THEN
          EulAngle(1) = ATAN2(RotMatrix(1,3), RotMatrix(1,2))
          EulAngle(2) = ACOS(RotMatrix(1,1))
          EulAngle(3) = ATAN2(RotMatrix(3,1), -RotMatrix(2,1))

C      Sequence = 2-1-2
       ELSEIF (EulSeq .EQ. 9) THEN
          EulAngle(1) = ATAN2(RotMatrix(2,1), RotMatrix(2,3))
          EulAngle(2) = ACOS(RotMatrix(2,2))
          EulAngle(3) = ATAN2(RotMatrix(1,2), -RotMatrix(3,2))

C      Sequence = 2-3-2
       ELSEIF (EulSeq .EQ. 10) THEN
          EulAngle(1) = ATAN2(RotMatrix(2,3), -RotMatrix(2,1))
          EulAngle(2) = ACOS(RotMatrix(2,2))
          EulAngle(3) = ATAN2(RotMatrix(3,2), RotMatrix(1,2))

C      Sequence = 3-1-3
       ELSEIF (EulSeq .EQ. 11) THEN
          EulAngle(1) = ATAN2(RotMatrix(3,1), -RotMatrix(3,2))
          EulAngle(2) = ACOS(RotMatrix(3,3))
          EulAngle(3) = ATAN2(RotMatrix(1,3), RotMatrix(2,3))

C      Sequence = 3-2-3
       ELSEIF (EulSeq .EQ. 12) THEN
          EulAngle(1) = ATAN2(RotMatrix(3,2), RotMatrix(3,1))
          EulAngle(2) = ACOS(RotMatrix(3,3))
          EulAngle(3) = ATAN2(RotMatrix(2,3), -RotMatrix(1,3))

       ENDIF

       RETURN
       END

