C $Header: /export/cvs/c34a1/source/moldyn/lforce.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C ========================================================================
C
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER 
C STATE AND FEDERAL LAWS.  USE, DISCLOSURE, REPRODUCTION OR DUPLICATION 
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS 
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT 
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.


      SUBROUTINE LFORCE(gh)
c
c     Subroutine to transform atomistic forces into generalized body forces
c
      IMPLICIT NONE
C
C     Argument List
C
      DOUBLE PRECISION gh(*)
C
#include "PARAM.FOR"
C
#include "BHBSRD.INC"
#include "COREA.INC"
#include "GCOMP.INC"
#include "HANDS2.INC"
#include "HEAPMB.INC"
#include "MEMLB.INC"
#include "NUMBRS.INC"
#include "SPECIF.INC"
C
C     local variables:
C
      INTEGER ipoint                     
      INTEGER ibod                       
      integer iloc,iat,i,j,n,ni
      integer lon,lo3,lo6,ne,nbod
      DOUBLE PRECISION tq      !  Temp. variable
      DOUBLE PRECISION vec3(3) !  Temp. vector
      DOUBLE PRECISION v(6)    !  Temp. variable for storing forces and torques
C
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: lforce.f,v $$Revision: 1.1.1.1 $'/
c
C     Transform forces to body frame
C
      ipoint = M35
      DO j = 1, nspt
         ibod = iftsmw(j)
         IF (ibod .LE. nbdy) THEN  ! Its a body
CC@CC
CC@CC ......MULT3T r0l(1,1,ibod), x(ipoint), vec3
CC@CC ......3, 3, 1
CC@CC ......3, 3, 3
      vec3(1) = r0l(1,1,ibod)*x(ipoint+0) + r0l(2,1,ibod)*x(ipoint+1) + 
     .r0l(3,1,ibod)*x(ipoint+2)
      vec3(2) = r0l(1,2,ibod)*x(ipoint+0) + r0l(2,2,ibod)*x(ipoint+1) + 
     .r0l(3,2,ibod)*x(ipoint+2)
      vec3(3) = r0l(1,3,ibod)*x(ipoint+0) + r0l(2,3,ibod)*x(ipoint+1) + 
     .r0l(3,3,ibod)*x(ipoint+2)
CC@CC end of expanded call
CC@CC
            x(ipoint)   = vec3(1)
            x(ipoint+1) = vec3(2)
            x(ipoint+2) = vec3(3)
         END IF
         ipoint = ipoint + 3
      END DO
c
      iloc = M35
      DO 65 iat = 1, nspt
         nbod = iftsmw(iat)
         lon = locu(nbod) - 1
         lo3 = lon + 3
         lo6 = lon + 6
         ne  = irgflx(nbod)
         IF (nbod .GT. nbdy) THEN  ! Its a particle
            DO i = 1, 3
               gh(lon+i) = gh(lon+i) + x(iloc)
               iloc = iloc + 1
            END DO
         ELSE                      ! Its a body
            CALL vcross(DS(1,2*iat),x(iloc),v)
            DO i = 1, 3
               gh(lon+i) = gh(lon+i) + v(i)
            END DO
            n = ihtsptr(iat) - 3  ! pointer to hats on heap
            DO 66 I = 1, 3
               ni = n + i
               TQ = X(iloc)
               iloc = iloc + 1
               IF (TQ .EQ. ZRO) GO TO 66
               gh(lo3+i) = gh(lo3+i) + tq
               do j = 1, ne           
                  gh(lo6+j) = gh(lo6+j) + tq*HATS(ni+3*j)
               end do
 66         CONTINUE
         end if
 65   CONTINUE

      RETURN
      END
