C $Header: /export/cvs/c34a1/source/moldyn/lmadji.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
      SUBROUTINE lmadji(xvel,ami,alm,tmas,n,job,imas)
c
c     Compute group mass, linear momentum, and zero out linear
c     momentum
c
      IMPLICIT NONE
c
c     Argument list
c
      INTEGER n                     !  Number of atoms in group
      INTEGER job                   !  1:  Compute alm only
                                    !  2:  Zero out lin. momentum only
                                    !  other:  Comp. alm & zro momentum
      INTEGER imas                  !  Calculate tmas if equal to 0
      DOUBLE PRECISION tmas         !  Total group mass
      DOUBLE PRECISION xvel(3,n)    !  Input atomic velocities
      DOUBLE PRECISION ami(n)       !  Atomic mass inverse
      DOUBLE PRECISION alm(3)       !  Linear momentum of group
c
c     Local Variables
c
      INTEGER i, i1                 !  DO loop indices
      DOUBLE PRECISION sum          !  Temp. variable
      DOUBLE PRECISION voff         !  Velocity offset
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: lmadji.f,v $$Revision: 1.1.1.1 $'/
c
c
c
      IF (job .NE. 2) THEN
c
c     Compute group mass
c
         IF (imas .EQ. 0) THEN
            tmas = 0.
            DO i = 1, n
               tmas = tmas + 1./ami(i)
            END DO
         END IF
c
c     Compute linear momentum
c
         DO i1 = 1, 3
            sum = 0.
            DO i = 1, n
               sum = sum + xvel(i1,i)/ami(i)
            END DO
            alm(i1) = sum
         END DO
      END IF
c
c     Reset velocities to zero out the linear momentum
c
      IF (job .NE. 1) THEN
         DO i1 = 1, 3
            voff = alm(i1)/tmas
            DO i = 1, n
               xvel(i1,i) = xvel(i1,i) - voff
            END DO
         END DO
      END IF
c
      RETURN
      END
