c
C $Header: /export/cvs/c34a1/source/moldyn/mbtopol.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1994 MOLDYN, INC.  ALL RIGHTS RESERVED
C ========================================================================
C
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER 
C STATE AND FEDERAL LAWS.  USE, DISCLOSURE, REPRODUCTION OR DUPLICATION 
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS 
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT 
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C
c
      SUBROUTINE mbtopol(list_tmp,ptr,mbmap,matom,nmbsub,nbody,
     &     qhinge,jaconn,mconn)

      IMPLICIT NONE

#include "PARAM.FOR"

#include "HEAPMB.INC"
#include "BHBSRD.INC"
#include "CHARMM.INC"
#include "CPATHS.INC"
#include "CSTIFF.INC"
#include "ERRHDL.INC"
#include "MAXMUM.INC"
#include "NUMBRS.INC"
#include "ORDERN.INC"
#include "PARTCL.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"

      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: mbtopol.f,v $$Revision: 1.1.1.1 $'/
c
c     Argument list
c
      INTEGER ptr(*),list_tmp(*),jaconn(2,*)
      INTEGER matom, nmbsub, nbody, mconn
      LOGICAL qhinge(3)
      CHARACTER*4 mbmap(*)
c
c     local 
      integer i, lastindx
      integer cnh
      integer n   ! number of calls to mbtopol_1
                  ! if n is 5 die
c
c     stats = 1  Enough memory allocate do not call mbtopol_1 again
c     stats = 0  Not enough memory allocate.  allocate more
c   		 memory and call mbtopol_1 again        
      integer stats 
c
c     Pointers to temporary heap
      integer isctptr,iacnnptr,ibcnnptr,ihcnnptr,ihpvtptr
      integer icnnhptr,itplptr,ihdtptr,ihctjptr 
c
c     Temporary heaps used to for the variables
c     used in mbtopol.f chkbon.f branch_out.f.
c     These two heap are used to determine what
c     NH is.  They are deallocated after NH is
c     determined and the values copied over to
c     the actual heap.
#ifdef POINTER_KEYWORD
      pointer (ltphpptr,ltemphp)
      logical ltemphp(*)
      pointer (itphpptr,itemphp)
      integer itemphp(*)
#else
      logical ltemphp(MAX_ltemphp)
      integer itemphp(MAX_itemphp)
#endif
c
      n = 0
      stats = 1
      cnh = mconn + nmbsub

C     Estimate the size of itopol et al.  If too small return
C     here and double size.
 100  if ( n .eq. 0 ) then
         cL02 = cnh
      else
         cL02 = cL02 * 2
      end if
c
      n = n + 1
c
      maxloop = cl02 - nmbsub
      cL09 = 6 * cL02
      cL12 = 2 * cL02 - 1
      cL15 = 6 * (cL02 - 1)
      cL16 = 7 * (cL02 - 1)
      cL63 = MaxLoop
      cL64 = 6 * cL63
      cL76 = cL02 + 6
c 
      isctptr = 1
#ifdef POINTER_KEYWORD
      call mbalcptr(ltphpptr,lgcalsz*cL02)      
#else
C     Check if enough memory is statically allocated
      IF ( cL02 .GT. MAX_ltemphp ) THEN
        WRITE(MBOUT,*)
     *      'NOT ENOUGH MEMORY ALLOCATED FOR ltemphp
     *  in source/moldyn/PARAM.FOR'
         CALL CLEARERR()
         WRITE(ERRMSG,201)
     *       'Increase MAX_ltemphp to > ', cL02,
     *      ' in PARAM.FOR'
         CALL ERRHDL(-5,'<MBTOPOL>')
      ENDIF
#endif
c
      iacnnptr = 1
      ibcnnptr = iacnnptr + 2 * cl02
      ihcnnptr = ibcnnptr + 2 * cL02
      icnnhptr = ihcnnptr + 2 * cl02
      ihpvtptr = icnnhptr + cl02
      itplptr = ihpvtptr + cl02
      ihdtptr = itplptr + 2 * cl02
      ihctjptr = ihdtptr + 7 * cl02 
c   
      if ( MaxLoop .le. 0 ) then
          cL63 = 1
      end if
#ifdef POINTER_KEYWORD
      call mbAlcPtr(itphpptr,intgrsz*(ihctjptr+cl63))
c
      if ( ltphpptr .LE. 0 .OR. itphpptr .LE. 0 ) then
           CALL CLEARERR()
           WRITE(ERRMSG,200)
     *     'NOT ENOUGH MEMORY ALLOCATED FOR TEMPORARY
     *      IN mbtopol.f'
           CALL ERRHDL(-5,'<MBTOPOL>')
      end if
 200  FORMAT(1X,A)
#else
      lastindx = ihctjptr + cl63
C     Check if enough memory is statically allocated
      IF ( lastindx .GT. MAX_itemphp ) THEN
        WRITE(MBOUT,*)
     *       'NOT ENOUGH MEMORY ALLOCATED FOR itemphp
     *  in source/moldyn/PARAM.FOR'
         CALL CLEARERR()
         WRITE(ERRMSG,201)
     *        'Increase MAX_itemphp to > ', lastindx,
     *        ' in PARAM.FOR'
         CALL ERRHDL(-5,'<MBTOPOL>')
      ENDIF
 201  FORMAT(1X,A,I9,A)
#endif
c
      do i = 1, ihctjptr+cl63
           itemphp(i) = 0
      end do
      do i = 1, cL02
           ltemphp(i) = .FALSE.
      end do     
c
      CALL mbtopol_1(list_tmp,ptr,mbmap,matom,nmbsub,nbody,
     *     qhinge,jaconn,mconn,ltemphp(isctptr),
     *     itemphp(iacnnptr),itemphp(ihcnnptr),
     *     itemphp(ihpvtptr),itemphp(itplptr),
     *     itemphp(ihdtptr),itemphp(ihctjptr),
     *     itemphp(ibcnnptr),itemphp(icnnhptr),stats)
c
c     if stats is 0 deallocate the two heaps and
c     call mbtopol_1 again until NH is determined
c
      if ( stats .eq. 0 ) then
#ifdef POINTER_KEYWORD
           call mbfreptr(itphpptr)
           call mbfreptr(ltphpptr)
#endif
           go to 100
      end if
c     
c     Allocate memory for LOOP HEAPS
      MAXLOOP = NH - NB 
      CALL init_LoopHeap
c
c     Copy values from temporary heap to global heap.
c     Variables iaconn, ihconn, ibconn, iconnh, itopol
c     ihdata, ihcutj, iscut
c
      do i = 1, 2*cL02
           intLoopheap(iiaconnptr+i-1) = itemphp(iacnnptr+i-1)
           intLoopHeap(iihconnptr+i-1) = itemphp(ihcnnptr+i-1)
           intloopheap(iitopolptr+i-1) = itemphp(itplptr+i-1)
           intloopheap(iibconnptr+i-1) = itemphp(ibcnnptr+i-1)
      end do
      do i = 1, cl02
           intloopheap(iiconnhptr+i-1) = itemphp(icnnhptr+i-1)
           intLoopHeap(iihpvtptr+i-1) = itemphp(ihpvtptr+i-1)
           logicLoopHeap(iiscutptr+i-1) = ltemphp(isctptr+i-1)
      end do
      do i = 1, 7*cL02
           intloopheap(iihdataptr+i-1) = itemphp(ihdtptr+i-1)
      end do
      do i = 1, cL63
           intloopheap(iihcutjptr+i-1) = itemphp(ihctjptr+i-1) 
      end do

#ifdef POINTER_KEYWORD
c     deallocate the two temporary heaps
      call mbfreptr(itphpptr)
      call mbfreptr(ltphpptr)
#endif
c
      RETURN
      END

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE mbtopol_1(list_tmp,ptr,mbmap,matom,nmbsub,nbody,
     &     qhinge,jaconn,mconn,iscut,iaconn,ihconn,ihpvt,itopol,
     &     ihdata,ihcutj,ibconn,iconnh,stats)
C
      IMPLICIT NONE
#include "PARAM.FOR"
C
c     Argument list
c
c      integer status
      INTEGER stats
      INTEGER iaconn(2,cL02)
      INTEGER ibconn(2,cL02)
      INTEGER iconnh(cL02)
      INTEGER ihconn(2,cL02)
      INTEGER ihpvt(cL02)
      INTEGER itopol(2,cL02)
      INTEGER ihdata(7,cL02)
      INTEGER ihcutj(cL63)
      INTEGER ptr(*),list_tmp(*),jaconn(2,*)
      INTEGER matom, nmbsub, nbody, mconn
      LOGICAL qhinge(3)
      LOGICAL iscut(cL02)
      CHARACTER*4 mbmap(*)
C
c     CHARMM/MBO(N)D COMMON blocks
c
c
C     MBO(N)D COMMON blocks
C     
#include "CHARMM.INC"
#include "CPATHS.INC"
#include "CSTIFF.INC"
#include "ERRHDL.INC"
#include "HEAPMB.INC"
#include "MAXMUM.INC"
#include "NUMBRS.INC"
#include "ORDERN.INC"
#include "PARTCL.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
c
c     Other COMMON blocks
c
      INTEGER        natom,nres,nbonh,nbona,ntheth,ntheta,nphih,
     @ nphia,nnb,ntypes,nrcp,nconp,mbona,mtheta,mphia,natc,
     @ isegmt, natbel,ishake,nmxrs
      COMMON/INFOV/  NATOM,NRES,NBONH,NBONA,NTHETH,NTHETA,NPHIH,
     @ NPHIA,NNB,NTYPES,NRCP,NCONP,MBONA,MTHETA,MPHIA,NATC,
     @ ISEGMT, NATBEL,ISHAKE,NMXRS
c
c     Local Variables
c
      INTEGER i, j, n        !  DO loop indices
      INTEGER k, j1          !  Counter
      INTEGER nerror         !  Error flag
      INTEGER nbodf(L01)     !  Body counter for cut joints
C
C     Initialize unit numbers
C
      NTAPE1 = 1
      NTAPE2 = 2
      NTAPE3 = 3
      MBOUT  = 6
      DBGOUT = 26
C
C        DEFINE MAX SIZES OF GDISCOS ARRAYS. THESE MAY ONLY BE CHANGED
C         VIA THE INCLUDE FILE 'PARAM.FOR'
C
      NBMAX  = L01
      NHMAX  = cL02
      NSPMAX = L03
c  moved to mbdyna.f
c      NMDBOD = L06
c     Memory allocation
c      NMDBOD = cL06
c      KY     = cL07
c      KU     = cL10
C
C     Define some useful numbers
C
      ZRO  = 0.D 0
      ONE  = 1.D 0
      TWO  = 2.D 0
      TRES = 3.D 0
c
c     Calculate the machine dependent precision of floating
c     point arithmetic.
c
      eps_mach = one
    1 eps_mach = eps_mach/two
      if (one + eps_mach .gt. one) go to 1
C
      CALL START
C
                                                            NERROR = 50
c     Check the dimensions of the problem before copying over
c
      natom = matom
      nb    = nmbsub
      nbdy  = nbody
      IF (nb .GT. L01) THEN
         CALL CLEARERR()
         WRITE(ERRMSG,100) 'TOO MANY TOTAL BODIES, NB =', nb
         CALL ERRHDL(-5,'<MBTOPOL>')
      END IF
 100  FORMAT(1X,A,I9)
c
      IF (nbdy .GT. MAXBOD) THEN
         CALL CLEARERR()
         WRITE(ERRMSG,100)
     $        'TOO MANY MULTI-ATOM BODIES, NBDY =', nbdy
         CALL ERRHDL(-5,'<MBTOPOL>')
      END IF
c
      nconn = mconn
      IF (nconn .GT. cL02) THEN
         CALL CLEARERR()
         WRITE(ERRMSG,300) 'Too many inter-body bonds'
         CALL ERRHDL(-5,'<MBTOPOL>')
      END IF
 300  FORMAT(1X,A)
c
C******************* COPY OVER THE MOLECULAR SUBSTRUCTURING DATA
c
      DO j = 1, nb
         iatoms(1,j) = ptr(j)
         iatoms(2,j) = ptr(j+1) - 1
         iatoms(3,j) = ptr(j+1) - ptr(j)
c         if (iatoms(3,j) .GT. MPERBD) then
c            CALL CLEARERR()
c            WRITE(ERRMSG,100) 'Too many atoms in body number ', j
c            CALL ERRHDL(-5,'<MBTOPOL>')
c         end if
      END DO
      do i = 1, nb-1
         if (iatoms(2,i)+1.ne.iatoms(1,i+1)) then
            CALL CLEARERR()
            WRITE(ERRMSG,300)  
     +        'Component atoms must be consecutive.'
            CALL ERRHDL(-5,'<MBTOPOL>')
         end if
      end do
      CALL writim(iatoms,3,nb,'IATOMS',3)
c
c     Check the number of atoms in the system
c
      NSPT = iatoms(2,nb)
      IF (NSPT .GT. L03) THEN
         CALL CLEARERR()
         WRITE(ERRMSG,100) 'Number of atoms exceeds', L03
         CALL ERRHDL(-5,'<MBTOPOL>')
      END IF
                                                            NERROR = 51
C******************* COPY OVER BOND ATOM LIST
c
      do j = 1, nconn
         do i = 1, 2
            iaconn(i,j) = jaconn(i,j)
         end do
      end do
      CALL writim(iaconn,2,nconn,'IACONN',2)
c
C******************* Set up atom/body list
c
      k = 0
      do i = 1, nb
         do j = 1, iatoms(3,i)
            k = k + 1
            if (k .gt. NSPMAX) then
               CALL CLEARERR()
               WRITE(ERRMSG,300)
     +           'Too many sensor points in subroutine.'
               CALL ERRHDL(-5,'<MBTOPOL>')
            end if
            IFTSMW(k) = i
         end do
      end do
C
C     Clear arrays (this may not be the first call to mbtopol)

      do i = 1, NHMAX
         ihpvt(i) = 0
         do j = 1, 7
            ihdata(j,i) = 0
         end do
      end do
         
c
c******************* Set up system topology and body connections
c
c     Call chkbon to use the bond connections to initialize the itopol
c     topology array, and finish off the non-covalently bonded bodies
c

      CALL chkbon(iaconn,ibconn,
     *            ihconn,iconnh,
     *            ihpvt,itopol,stats)

      if ( stats .eq. 0 ) goto 1001   ! not enough memory allocated
c
C     Preliminary topology check, complete check done by rotdh ....
                                                            NERROR =  7
      IF (ITOPOL(1,1).NE.1 .OR. ITOPOL(2,1).NE.0) GO TO 999
                                                            NERROR =  8
      DO 605 J=2,NH
      IF (ITOPOL(1,J) .EQ. ITOPOL(2,J)) GO TO 999
  605 CONTINUE
                                                            NERROR =  9
      IF (nh .GT. 1) THEN
      DO 610 N=1,NB
      DO 615 I=1,2
      DO 615 J=2,NH
      IF (ITOPOL(I,J) .EQ. N) GO TO 610
  615 CONTINUE
      GOTO 999
  610 CONTINUE
      END IF
c
      do j = 2, nh
         if (itopol(1,j).GT.nbdy .and. itopol(2,j).LE.nbdy) then
c           q-frame is a body and p-frame is a particle
            i = itopol(1,j)
            itopol(1,j) = itopol(2,j)
            itopol(2,j) = i
         end if
      end do
c
c******************* Copy and save pointers, lists, etc
c
      DO i = 1, natom
         list(i) = list_tmp(i)
      END DO
      DO i = 1, nb
         pointr(i) = ptr(i)
      END DO
      pointr(nb+1) = ptr(nb+1)
      DO i = 1, nbdy
         bodyname(i) = mbmap(i)
      END DO
      DO i = nbdy+1, nb
         bodyname(i) = 'ATOM'
      END DO
      DO i = 1, 3
         constraint_type(i) = qhinge(i)
      END DO
c
C******************* SET UP HINGE CONSTRAINT TABLE
c
      do i = 1, NH
         IHDATA(1,i) = 1
      end do
c
c        For particle simulations, the above rotation types may be changed
c        from within CMPIC3.
c
      do j = 1, nconn
         i = ihconn(1,j)
         if (i .ne. 0) then
            IHDATA(5,i) = 1
            IHDATA(6,i) = 0
            IHDATA(7,i) = 0
         end if
      end do
                                                            NERROR =  19
C******************* TOPOLOGICAL LOOPS, PROCESS CUT JOINT LIST
      NCUT=NH-NB
      IF (ncut .GT. cL63) THEN
         CALL CLEARERR()
         WRITE(ERRMSG,'(1X,A,I9,A)')
     +   'Too many cut joints, ncut =', ncut,
     +   'Rerun without bond length constraints.'
         CALL ERRHDL(-5,'<MBTOPOL>')
      END IF

      DO I = 1, NH
         ISCUT(I) = .FALSE.
      END DO
C
      IF (NCUT .GT. 0) THEN
c
c     Find the cut joint locations
c
         j1 = 0            
         DO i = 1, nb
            nbodf(i) = 0
         END DO
         DO i = 1, nh
            j = itopw(2,i) 
            IF (nbodf(j) .EQ. 1) THEN   
c
c     Remove joint from itopw
c
               j1 = j1 + 1          
               ihcutj(j1) = IABS(itopw(1,i))
               iscut(ihcutj(j1)) = .TRUE.
               itopw(1,i) = 0
               itopw(2,i) = 0
            ELSE
               nbodf(j) = 1
            END IF
         END DO
         IF (j1 .NE. ncut) THEN
            CALL CLEARERR()
            WRITE(ERRMSG,300)
     +       'Error in finding cut-joints'
            CALL ERRHDL(-5,'<MBTOPOL>')
         END IF
c
c     Pack down the itopw array
c
         k = nh
         i = 1
 200     CONTINUE
         IF (itopw(1,i) .EQ. 0) THEN  
            k = k - 1
            DO j = i, k
               itopw(1,j) = itopw(1,j+1)
               itopw(2,j) = itopw(2,j+1)
            END DO
         ELSE
            i = i + 1
         END IF
         IF (i .LE. k) GO TO 200  
c
         IF (k .NE. nb) THEN
            CALL CLEARERR()
            WRITE(ERRMSG,300)
     &           'Error in packing cut-joints in itopw'
            CALL ERRHDL(-5,'<MBTOPOL>')
         END IF
      ENDIF
c
 
 1001 RETURN
c
 999  CALL CLEARERR()
      WRITE (ERRMSG,2110) 'Preliminary topology check failed'
 2110 FORMAT (1X,A,I3)
      CALL ERRHDL(-5,'<MBTOPOL>')
c
      END
