C $Header: /export/cvs/c34a1/source/moldyn/msmodr.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C ========================================================================
C
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER 
C STATE AND FEDERAL LAWS.  USE, DISCLOSURE, REPRODUCTION OR DUPLICATION 
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS 
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT 
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C
      SUBROUTINE MSMODR(NBOD,ainer,isz,iaconn,ibconn,iconnh,
     &                  ihpvt,itopol,dh)
C
C     SUBROUTINE TO INPUT MOLECULAR DATA FROM FILE AND PROCESS TO
C     OBTAIN INERTIAL INTEGRALS
C
      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: msmodr.f,v $$Revision: 1.1.1.1 $'/
C
#include "PARAM.FOR"
C
#include "CHARMM.INC"
#include "COREA.INC"
#include "CSTIFF.INC"
#include "ERRHDL.INC"
#include "MEMLB.INC"
#include "NHNS.INC"
#include "NUMBRS.INC"
#include "OPTION.INC"
#include "PARTCL.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
C
C     Passed Variables
C
      INTEGER nbod,isz
      INTEGER iaconn(2,cL02)
      INTEGER ibconn(2,cL02)
      INTEGER iconnh(cL02)
      INTEGER ihpvt(cL02)
      INTEGER itopol(2,cL02)
      DOUBLE PRECISION ainer(isz,isz)
      DOUBLE PRECISION dh(3,cL16)
C
C     Local Variables
C
      INTEGER I0,NJ,K1,LD,LR
      INTEGER IATM,IFLG,ICONN,IBOD,JOINT
      INTEGER NHB,NOH,NOS,NSB
      INTEGER I,J,K,L
      DOUBLE PRECISION V(6), stmom(3), com(3)
      DOUBLE PRECISION TMAS,AMTOT,AMAS
C
 1001 FORMAT(16I5)
 1002 FORMAT(8D10.3)
 3001 FORMAT (//15X,'SUMMARY OF INPUT DATA FOR BODY',I3,
     *   ' WHICH IS RIGID.'//3X,'THE 6X6 INERTIA MATRIX IS ---')
 3011 FORMAT (//15X,'SUMMARY OF INPUT DATA FOR BODY',I3,
     *   ' WHICH IS PARTICLE.'//3X,'THE PARTICLE MASS IS ',F10.3)
 3002 FORMAT (//5X,'FOR BODY',I3,' THE P-Q HINGE NO. AND THE EULER ',
     * 'ROTATION TYPE APPEAR IN THE FOLLOWING INTEGER ARRAY WHICH '/
     * 5X,'IS FOLLOWED BY AN ARRAY CONTAINING EULER ANGLES (1,2,3),',
     * ' AND POSITION VECTOR COMPONENTS (4,5,6) THAT POSITION THE '/
     * 5X,'HINGE TRIAD WRT THE BODY TRIAD')
 3003 FORMAT (//5X,'FOR BODY',I3,' THE SENSOR POINT NO. AND THE EULER',
     * ' ROTATION TYPE APPEAR IN THE FOLLOWING INTEGER ARRAY WHICH '/
     * 5X,'IS FOLLOWED BY AN ARRAY CONTAINING EULER ANGLES(1,2,3)',
     * 'AND POSITION VECTOR COMPONENTS (4,5,6) THAT POSITION THE'/
     * 5X,'SENSOR TRIAD WRT THE BODY TRIAD')

      JOINT = BADADDR
C
C*************************************************
C
C***  NJ = NUMBER OF MASS POINTS ON BODY I
      NJ = iatoms(3,NBOD)
      i0 = iatoms(1,NBOD)
      if (mbplvl .ge. 9) WRITE (MBOUT,3050) NBOD
 3050 FORMAT(///,5X,'LUMPED MASS DATA USED TO DEFINE RIGIDIZED ',
     *'BODY NUMBER ',I3,/)
c
c Compute CM offset
c
      call zero(stmom,1,3,1)
      k = M20 + i0 - 2
      k1 = 2*i0 - 2
      tmas = zro
      do i = 1, NJ
         k = k + 1
         k1 = k1 + 2
         tmas = tmas + one / X(k)
         do j = 1, 3
            stmom(j) = stmom(j) + ds(j,k1) / X(k)
         end do
      end do
      do i = 1, 3
         stmom(i) = stmom(i) / tmas
         cgnom(i,NBOD) = stmom(i)
      end do
c
c     MASSES
c
c     ainer is now returned as the mass, am
c     it is (6x6) if a body and (1x1) if a particle
c
      CALL ZERO(AINER,isz,isz,isz)
      call zero(stmom,1,3,1)
      call zero(v,1,6,1)
      J = M20 + i0 - 2
      amtot = 0d0
      do i = 1, 3
         com(i) = cgnom(i,nbod)
      end do
      DO I = 1, NJ
         iatm = 2 * (i0 + i - 1)
         J = J + 1
         amas = ONE / X(J)
         amtot = amtot + amas
         stmom(1) = stmom(1) - amas*(ds(1,iatm)-com(1))
         stmom(2) = stmom(2) - amas*(ds(2,iatm)-com(2))
         stmom(3) = stmom(3) - amas*(ds(3,iatm)-com(3))
         v(1) = v(1) + amas*((ds(2,iatm)-com(2))**2
     *                      +(ds(3,iatm)-com(3))**2)
         v(2) = v(2) + amas*((ds(1,iatm)-com(1))**2
     *                      +(ds(3,iatm)-com(3))**2)
         v(3) = v(3) + amas*((ds(1,iatm)-com(1))**2
     *                      +(ds(2,iatm)-com(2))**2)
         v(4) = v(4) + amas*(ds(1,iatm)-com(1))
     *                     *(ds(2,iatm)-com(2))
         v(5) = v(5) + amas*(ds(1,iatm)-com(1))
     *                     *(ds(3,iatm)-com(3))
         v(6) = v(6) + amas*(ds(2,iatm)-com(2))
     *                     *(ds(3,iatm)-com(3))
      END DO
      if (NJ .NE. 1) then    ! not a particle
         CALL SKEWV3(stmom,ainer(1,4),1,6)
         do i = 1, 3
            ainer(i,i) = v(i)       
         end do
         DO I = 4, 6
            AINER(I,I) = amtot
         END DO
         ainer(1,2) = - v(4) 
         ainer(1,3) = - v(5) 
         ainer(2,3) = - v(6) 
         do i = 1, 6
            do j = i, 6              
               ainer(j,i) = ainer(i,j) 
            end do
         end do
      end if

      if (nbod .GT. nbdy) then 
         ainer(1,1) = amtot
      end if
C
      if (mbplvl .ge. 2) then
C     PRINT BODY INERTIA MATRIX FOR BODY N
         if (nbod .GT. nbdy) then
            WRITE (MBOUT,3011) NBOD, amtot
         else
            CALL  PAGEHD
            WRITE (MBOUT,3001) NBOD
            CALL WRITES (AINER,6,6,6)
         end if
      end if
C
C***  HINGE LOOP  ******************************************
C
      NHB = NHPOI(NBOD)
      L   = 0
c
      do noh = 2, nh
         iflg = 0
         if (itopol(1,noh) .eq. nbod .or. 
     +       itopol(2,noh) .eq. nbod) then
            iflg = 1
c
c              Find the atom number where hinge frame is to be attached
c
            if (ihpvt(noh) .ne. 0) then
c
c     Hinge is bonded.  Search inter-fragment bond list for hinge atom.
c
               iconn = iconnh(noh)
               if (ibconn(1,iconn) .eq. nbod) then
                  joint = iaconn(1,iconn)
               else if (ibconn(2,iconn) .eq. nbod) then
                  joint = iaconn(2,iconn)
               else
                  WRITE (MBOUT,*) ' Error in msmodr: ibconn'
                  CALL ERRHDL(-5,'<MSMODR>')
               end if
            else
c
c     Hinge is not bonded.
c
               if (itopol(1,noh) .eq. nbod) then
                  ibod = itopol(2,noh)
               else
                  ibod = itopol(1,noh)
               end if
               if (ibod .lt. nbod) then
                  joint = iatoms(1,nbod)
               else
                  joint = iatoms(2,nbod)
               end if
            end if
         end if          !  End of ITOPOL test
c     
         if (iflg.ne.0) then
            L = L + 1
            if (itopol(1,noh) .eq. nbod) then
               LD = 7*(NOH-2) + 3
            else
               LD = 7*(noh-2) + 4
            end if
c
c              Finally, compute the vector from body reference to hinge
c
            if (nj .eq. 1) then
               dh(1,ld) = 0d0
               dh(2,ld) = 0d0
               dh(3,ld) = 0d0
            else
               i = 2*joint
               dh(1,ld) = ds(1,i) - com(1)
               dh(2,ld) = ds(2,i) - com(2)
               dh(3,ld) = ds(3,i) - com(3)
            end if
         end if
c
      end do
c
      if (L .ne. NHB) then
         CALL CLEARERR()
         WRITE(ERRMSG,200) 'Topology error in subroutine.'
         CALL ERRHDL(-5,'<MSMODR>')
      end if
 200  FORMAT(1X,A)
c
C***  SENSOR LOOP  *****************************************
C
      NSB = NSPOI(NBOD)
      IF (NSB .NE. NJ) THEN
         CALL CLEARERR()
         WRITE(ERRMSG,200)
     +     'SENSOR NUMBER INCORRECT IN subroutine.'
         CALL ERRHDL(-5,'<MSMODR>')
      END IF
c
      DO L = 1, NSB
         NOS   = i0 + L - 1
         IF (IFTSMW(NOS) .NE. NBOD) GO TO 996
         LR    = 2 * NOS
         if (nj .eq. 1) then
            ds(1,lr) = 0d0
            ds(2,lr) = 0d0
            ds(3,lr) = 0d0
         else
            DS(1,LR) = ds(1,LR) - com(1)
            DS(2,LR) = ds(2,LR) - com(2)
            DS(3,LR) = ds(3,LR) - com(3)
         end if
      end do
c
      RETURN
C
 996  CALL CLEARERR()
      WRITE (ERRMSG,2003)
 2003 FORMAT(1X,1H1,31HTOPOLOGY ERROR, PROGRAM STOPPED)
      CALL ERRHDL(-5,'<MSMODR>')
C
      END
