C $Header: /export/cvs/c34a1/source/moldyn/multb.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
      SUBROUTINE MULTB (A,BZ,NRA,NRB,NCB,KA,KBZ,W)
CSE
C                                                          DEBUG #  97
CPS        PURPOSE:
C
C                   UTILITY ROUTINE TO MULTIPY RECTANGULAR MATRICES
C                            A * BZ = Z
C                   INPUT A AND BZ, OUTPUT Z PUT IN ARRAY BZ
C
CPE
      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: multb.f,v $$Revision: 1.1.1.1 $'/
C
#include "PARAM.FOR"
C
#include "ERRHDL.INC"
#include "TAPENO.INC"
C
      INTEGER KA,KBZ,NRA,NRB,NCB
      INTEGER I,J,K
      DOUBLE PRECISION A(KA,*), BZ(KBZ,*), W(cL07)
      DOUBLE PRECISION S
C
C  LAST REVISION BY H P FRISCH. MARCH 1991
C        Increase workspace size to max length of system state vector
C        Add array size error checks
C
CAS             -----SUBROUTINE ARGUMENT DESCRIPTIONS-----
C
C  A      = INPUT  MATRIX. SIZE (NRA,NRB).
C  BZ     = INPUT  MATRIX.  SIZE (NRB,NCB).
C         = OUTPUT RESULT MATRIX.  SIZE (NRA,NCB).
C  NRA    = INPUT  NUMBER OF ROWS OF MATRICES A,Z.
C  NRB    = INPUT  NUMBER OF ROWS OF MATRIX B, COLS OF MATRIX A.
C  NCB    = INPUT  NUMBER OF COLS OF MATRICES B,Z.
C  KA     = INPUT  ROW DIMENSION OF A IN CALLING PROGRAM.
C  KBZ    = INPUT  ROW DIMENSION OF BZ IN CALLING PROGRAM.
C
CAE
C
      IF (NRB .GT. cL07) GO TO 999
      IF (NRA .GT. KA)  GO TO 999
      IF (NRB .GT. KBZ) GO TO 999
C
      DO 40 J=1,NCB
      DO 20 K=1,NRB
   20 W(K) = BZ(K,J)
      DO 40 I=1,NRA
      S = 0.D0
      DO 30 K=1,NRB
   30 S = S + A(I,K)*W(K)
   40 BZ(I,J) = S
C
      RETURN
C
 999  CALL CLEARERR()
      WRITE(ERRMSG,200)
     +  ' ARRAY SIZE ERROR IN subroutine, PROGRAM STOPPED.'
      CALL ERRHDL(-5,'<MULTB>')
 200  FORMAT(1X,A)
      END
