C $Header: /export/cvs/c34a1/source/moldyn/multsym.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C ======================================================================
C
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER 
C STATE AND FEDERAL LAWS.  USE, DISCLOSURE, REPRODUCTION OR DUPLICATION 
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS 
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT 
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C
C                 SUBROUTINE - MULTSYM.F
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      subroutine multsym (a,x,beta,v,n)
c
c     This subroutine calculates the product v = a*x+beta*v,
c     where
c     a = Symmetric matrix stored in compact row storage form,
c     x = A vector,
c     beta = A scalar (for accumulation),
c     v = The result vector,
c     n = The number of "rows" in a, and
c
c     Declare variables
c
      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: multsym.f,v $$Revision: 1.1.1.1 $'/
      integer n
      DOUBLE PRECISION a(*),x(n),v(n)
      DOUBLE PRECISION sumi,sumj,beta
      INTEGER i,j,k
c
c     Form scalar multiple of result vector
c
      if (beta.ne.1.0d0) then
	if (beta.eq.0.0) then
	  do 600 i=1,n
	    v(i) = 0.0d0
  600     continue
        else
	  do 601 i=1,n
	    v(i) = v(i)*beta
  601     continue
	end if
      end if
c
c     Loop to Calculate the "diagonal" products
c
      k=1
      do 500 i=1,n
        sumi = a(k)*x(i)
	v(i) = v(i) + sumi
        k = k + 1
c
c       Loop to Calculate the "off-diagonal" products
c
	do 501 j=i+1,n
	  sumi = a(k)*x(j)
	  sumj = a(k)*x(i)
	  v(i) = v(i) + sumi
	  v(j) = v(j) + sumj
	  k = k+1
  501   continue
  500 continue
      return
      end
