C $Header: /export/cvs/c34a1/source/moldyn/prnten.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1994 MOLDYN, INC.  ALL RIGHTS RESERVED
C ========================================================================
C
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER 
C STATE AND FEDERAL LAWS.  USE, DISCLOSURE, REPRODUCTION OR DUPLICATION 
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS 
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT 
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
c
      SUBROUTINE prnten(P)
c
c     Print the energies and momenta
c
      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: prnten.f,v $$Revision: 1.1.1.1 $'/
c
#include "PARAM.FOR"
c
#include "CHARMM.INC"
#include "MOMENG.INC"
#include "MULTIPOLE.INC"
#include "SPECIF.INC"
c
c     Passed Variables
c
      DOUBLE PRECISION P(cL10)
c
c     Local Variables
c
      INTEGER n, i        
      INTEGER ll          
      REAL    sum         
c
c     Write the body modal energies
c
      if (.not. internal_atom) then
         WRITE(noutvc,65) 'MBDYN>', 'No.', 'Bodyname', 'Modal Energy'
         DO n = 1, nbdy
            WRITE(noutvc,66) 'MBDYN>', n, bodyname(n), REAL(engpm(n))
         END DO
      end if
c
c     Write the interbody electrostatic energies
c
      if (idovfma) then
      WRITE(noutvc,65) 'MBDYN>', 'No.', 'Bodyname', 
     *     'Electrostatic Energy'
      DO n = 1, nb
         WRITE(noutvc,66) 'MBDYN>', n, bodyname(n), 
     *        REAL(engpe(n)-engpm(n))
      END DO
      end if
c
c     Write the kinetic energies
c
      WRITE(noutvc,65) 'MBDYN>', 'No.', 'Bodyname', 'Kinetic Energy'
      DO n = 1, nb
         WRITE(noutvc,66) 'MBDYN>', n, bodyname(n), REAL(engke(n))
      END DO
      WRITE(noutvc,67) 'MBDYN>', 'Total KE =', totke
 65   format(a6,a5,a10,a20)
 66   format(a6,i4,a9,'    ',e20.12)
 67   format(a6,a17,e20.12)
c
c
c     Write the linear momenta
c
      WRITE(noutvc,75) 'MBDYN>', 'No.', 'Bodyname', 
     *  'Body Lin. Momentum','Magnitude'
      DO n = 1, nbdy
         ll = locu(n) + 2
         sum = 0.
         DO i = 1, 3
            sum = sum + REAL(p(ll+i)**2)
         END DO
         sum = SQRT(sum)
         WRITE(noutvc,76) 'MBDYN>', n, bodyname(n), 
     *        (REAL(p(ll+i)),i=1,3), sum
      END DO
c
c     Write the angular momenta
c
      WRITE(noutvc,75) 'MBDYN>', 'No.', 'Bodyname', 
     *   'Body Ang. Momentum', 'Magnitude'
      DO n = 1, nbdy
         ll = locu(n) - 1
         sum = 0.
         DO i = 1, 3
            sum = sum + REAL(p(ll+i)**2)
         END DO
         sum = SQRT(sum)
         WRITE(noutvc,76) 'MBDYN>', n, bodyname(n), 
     *        (REAL(p(ll+i)),i=1,3), sum
      END DO
c
 75   format(a6,a5,a10,'    ',a20,a15)
 76   format(a6,i4,a9,4f10.4)
      RETURN
      END







