C $Header: /export/cvs/c34a1/source/moldyn/psitx.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
      SUBROUTINE PSITX (psi,rinv,isel,ndof,nfree,nm,rvec,prodt)
C                                                            DEBUG # 79
CSE
C
      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: psitx.f,v $$Revision: 1.1.1.1 $'/
CPS   PURPOSE:
C
C        SPECIAL PURPOSE MATRIX MULTIPLY FOR SUBROUTINE FRWRD2.
C        ONLY THE UPPER RIGHT PARTITION OF THE TRANSFORMATION MATRICES
C        PSI(I) ARE STORED IN THE PSI ARRAY STORED IN /F1BKF2/. THE
C        INFORMATION NEEDED TO FILL OUT THE ARRAY EXISTS IN ARRAYS
C        RINV AND ISEL.
C
C     This subroutine pre-multiplies a vector by PSI**T,
C     where
C
C                +-  -1         |    -1     -+
C                |  R    PHI    |  -R    F   |
C                |   Ii     Ii  |    Ii   Ii |
C                |  ____________|____________|
C                |              |            |
C        PSI  =  |       0      |    I       |
C           i    |              |     nm     |
C                +-                         -+
C
C
C
C     Argument List
C
      INTEGER nfree                     !  Number of free DOFs
      INTEGER ndof                      !  Number of DOFs at the hinge (3 or 6)
      INTEGER nm                        !  Number of modes
      INTEGER isel(nfree)               !  Selection array for free DOFs
      DOUBLE PRECISION psi(6,nm)        !  Rinv F partition of PSI
      DOUBLE PRECISION rinv(6,6)        !  1,1 partition of PSI
      DOUBLE PRECISION rvec(6+nm)       !  Input vector to be pre-multiplied
      DOUBLE PRECISION prodt(nfree+nm)  !  Output vector
c
c     Local Variables
c
      INTEGER isrow                     !  Selected DOF number
      INTEGER ielem, irow               !  DO loop indices
      DOUBLE PRECISION sum              !  Summation variable
C
C     First do the free hinge DOFs
C
      DO irow = 1, nfree
         isrow = isel(irow)      !  Select the columns of rinv
         sum = 0.0D0
         DO ielem = 1, ndof
            sum = sum + rinv(ielem,isrow) * rvec(ielem)
         END DO
         prodt(irow) = sum
      END DO
C
C     Now do the nm columns of psi  (If nm>0, then ndof=6)
C
      DO irow = 1, nm
         sum = rvec(6+irow)       !  The identity partition of psi
         DO ielem = 1, 6
            sum = sum + psi(ielem,irow) * rvec(ielem)
         END DO
         prodt(nfree+irow) = sum
      END DO
C
      RETURN
      END
