C $Header: /export/cvs/c34a1/source/moldyn/rcmatprd.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
      SUBROUTINE rcmatprd(ramat,cbmat,ccmat,scale,nra,nca,ncb,ka,kb,kc)
c
c     Subroutine to perform complex matrix product
c
c     scale * A(nra x nca) B(nca x ncb) ==> C(nra x ncb)
c
c     Used to compute transformations from LE coefficients to body forces.
c
c     Called from compute_le_coeff
c
c
      IMPLICIT NONE
c
c     Inputs:
      INTEGER  nra, nca, ncb        !  Dimensions of problem
      INTEGER  ka, kb, kc           !  Declared dimensions of arrays
      DOUBLE PRECISION scale        !  Scale factor
      DOUBLE PRECISION ramat(ka,*)  !  Real matrix A
      COMPLEX*16       cbmat(kb,*)  !  Complex matrix B
c
c     Output:
      COMPLEX*16       ccmat(kc,*)  !  Complex matrix C
c
c     Local variables:
      INTEGER    i, j, k            !  DO loop indices
      COMPLEX*16 csum               !  Temporary storage
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: rcmatprd.f,v $$Revision: 1.1.1.1 $'/
c
c
      DO j = 1, ncb
         DO i = 1, nra
            csum = (0D0,0D0)
            DO k = 1, nca
               csum = csum + scale*ramat(i,k)*cbmat(k,j)
            END DO
            ccmat(i,j) = csum
         END DO
      END DO
c
      RETURN
      END
