C $Header: /export/cvs/c34a1/source/moldyn/rcvcross.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
      SUBROUTINE rcvcross(rvec1,cvec2,cvec3)
c
c     Subroutine to perform complex vector cross product and accumulation
c
c     cvec3 := cvec3 + rvec1 X cvec2
c
c     Called from compute_le_coeff
c
c
      IMPLICIT NONE
c
c     Inputs:
      DOUBLE PRECISION rvec1(*)     !  Real vector 1
      COMPLEX*16       cvec2(*)     !  Complex vector 2
c
c     Output:
      COMPLEX*16       cvec3(*)     !  Complex vector 3
c
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: rcvcross.f,v $$Revision: 1.1.1.1 $'/
c
c
      cvec3(1) = cvec3(1) + rvec1(2)*cvec2(3) - rvec1(3)*cvec2(2)
      cvec3(2) = cvec3(2) + rvec1(3)*cvec2(1) - rvec1(1)*cvec2(3)
      cvec3(3) = cvec3(3) + rvec1(1)*cvec2(2) - rvec1(2)*cvec2(1)
c
      RETURN
      END
