C $Header: /export/cvs/c34a1/source/moldyn/rkdumb.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C ========================================================================
C
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER 
C STATE AND FEDERAL LAWS.  USE, DISCLOSURE, REPRODUCTION OR DUPLICATION 
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS 
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT 
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
c
      SUBROUTINE rkdumb(v,dv,nvar,x1,x2,nstep,derivs,nbflag,prtflg)
C
      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: rkdumb.f,v $$Revision: 1.1.1.1 $'/
c
#include "PARAM.FOR"
c
#include "CPATHS.INC"
#include "ERRHDL.INC"
#include "IVCONS.INC"
#include "JILFLG.INC"
#include "MISCNO.INC"
#include "MISCN2.INC"
#include "TAPENO.INC"
#include "HEAPMB.INC"
#include "VECTOR.INC"
#include "MOMENG.INC"
#include "SELECT.INC"
#include "SPECIF.INC"
c
#ifdef CHARMM
#include "CHARMM.INC"
#endif
c
#ifdef AMBER
#include "MDCON.INC"
#endif
C
C     Variable list
C
      LOGICAL          nbflag, prtflg !  Nonbond pairlist & print flags
      INTEGER          NVAR           !  Number of state variables
      INTEGER          NSTEP          !  Number of steps to take
      DOUBLE PRECISION X1, X2         !  Start and end times
      DOUBLE PRECISION V(NVAR)        !  State vector before and after
                                      !  integration
      DOUBLE PRECISION DV(NVAR)
      EXTERNAL DERIVS                 !  Subroutine for derivative calc.
c
c     Local variables
c
      INTEGER i               !  Do loop index
      DOUBLE PRECISION X      !  Current time
      DOUBLE PRECISION H      !  Time step
      DOUBLE PRECISION dum
      INTEGER idum,iextor
C
 2000 FORMAT(1X,A)
C
      X = X1
      H = (X2-X1) / NSTEP
C
      iextor = 1   ! Call to external torque
C      
      DO i = 1, NSTEP-1
         CALL RK4(V,DV,NVAR,X,H,V,DERIVS,IEXTOR,LocalHeap(iytptr_rk4),
     *         LocalHeap(idytptr_rk4),LocalHeap(idymptr_rk4))
         IF (X+H.EQ.X) THEN
            CALL CLEARERR()
            WRITE(ERRMSG,2000)
     +        'Stepsize is not significant in subroutine.'
            CALL ERRHDL(-5,'<RKDUMB>')
         END IF
         X = X + H
         jil = 4
#ifdef CHARMM
C     If using Langevin dynamics call GASRND to populate RF, a 1xNU 
C     vector, with random values (forces)
      IF (LANGEVIN) CALL GASRND(mbdynaHeap(ilangevinptr),
     &                          mbdynaHeap(irfptr),
     &                          HEAP_MB(ipptr))
         iparam(16) = iparam(16) + 1
#endif
         CALL derivs(x,v,dv,dum,idum,iextor,HEAP_MB(iyptr),
     &            HEAP_MB(iydtptr),HEAP_MB(ipptr),
     &            LocalHeap(iggvptr_ydot),
     &            logicLoopHeap(iiscutptr),
     &            intLoopHeap(iivptr),intLoopHeap(iibetdtptr),
     &            LoopHeap(ibetahdptr),intloopheap(iitopolptr),
     &            intLoopheap(iihdataptr),LocalHeap(iirhptr_ydot))
      END DO
C
C     Final step
C
      CALL RK4(V,DV,NVAR,X,H,V,DERIVS,IEXTOR,LocalHeap(iytptr_rk4),
     *         LocalHeap(idytptr_rk4),LocalHeap(idymptr_rk4))
      IF (X+H.EQ.X) THEN
         CALL CLEARERR()
         WRITE(ERRMSG,2000)
     +     'Stepsize not significant in subroutine.'
         CALL ERRHDL(-5,'<RKDUMB>')
      END IF
      X = X + H
      jil = 4
#ifdef AMBER
      if (nbflag) ntnb  = 1
#endif
      if (prtflg) iprnt = noprnt
      if (long1)  long2 =.TRUE.
#ifdef CHARMM
C     If using Langevin dynamics call GASRND to populate RF, a 1xNU 
C     vector, with random values (forces)
      IF (LANGEVIN) CALL GASRND(mbdynaHeap(ilangevinptr),
     &                          mbdynaHeap(irfptr),
     &                          HEAP_MB(ipptr))
      iparam(16) = iparam(16) + 1
      if (vlflag) ivprt = 1
#endif
c
      CALL derivs(x,v,dv,dum,idum,iextor,HEAP_MB(iyptr),
     &            HEAP_MB(iydtptr),HEAP_MB(ipptr),
     &            LocalHeap(iggvptr_ydot),
     &            logicLoopHeap(iiscutptr),
     &            intLoopHeap(iivptr),intLoopHeap(iibetdtptr),
     &            LoopHeap(ibetahdptr),intloopheap(iitopolptr),
     &            intLoopheap(iihdataptr),LocalHeap(iirhptr_ydot))
c
#ifdef AMBER
      ntnb  = 0
#endif
      iprnt = 0
      long2 = .FALSE.
#ifdef CHARMM
      ivprt = 0
#endif
C
      RETURN
      END
