c $Header: /export/cvs/c34a1/source/moldyn/rotdh1_CHARMM.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1994 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
      subroutine rotdh1_CHARMM(ihpvt,itopol,ihdata,iop)
c
c     Initialize ITOPW and call bkinit
c
      IMPLICIT NONE
c 
#include "PARAM.FOR"
c
#include "CPATHS.INC"
#include "ERRHDL.INC"
#include "HEAPMB.INC"
#include "SPECIF.INC"
#include "ORDERN.INC"
#include "PARTCL.INC"
#include "INTGRL.INC"
#include "MULTIPOLE.INC"
#include "TAPENO.INC"
#include "SELECT.INC"
c
c     Passed Variables
c
      INTEGER ihpvt(cL02)
      INTEGER itopol(2,cL02)
      INTEGER ihdata(7,cL02)
c
c     Local Variables
c
      INTEGER i,is,is1,j,jop,jopa,n,nm1,nop
      INTEGER ihinge,icbody,inbody
      INTEGER NBODF(L01), IOP(2,cL02)
c
#include "LDEBUG.INC"
      LOGICAL LEQU
      EQUIVALENCE (LEQU,DEBUG(44))
C
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: rotdh1_CHARMM.f,v $$Revision: 1.1.1.1 $'/
C
      IF(LEQU) WRITE (MBOUT,1000)
 1000 FORMAT (' SUBROUTINE ROTDH1 ')
c
C         CHECK IF SYSTEM IS A TREE OR IF IT HAS TOPOLOGICAL LOOPS
c
      IF (NH .GT. NB) THEN
C              THE SYSTEM HAS TOPOLOGICAL LOOPS, CALL CTINIT
C              TO OBTAIN CUT JOINT ARRAYS:
C              ITOPW, IHCUTJ, IHPATH
         CALL CTINIT1_CHARMM(logicLoopHeap(iihpathptr),
     &                       intLoopHeap(iitopolptr),
     &                       intLoopHeap(iihdataptr),
     &                       intLoopHeap(iihcutjptr),
     &                       intLocalHeap(iiopptr_ctinit1_CHARMM),
     &                       intLocalHeap(iloopptr_ctinit1_CHARMM))
      ELSE
C              THE SYSTEM IS A TOPOLOGICAL TREE, PERFORM ORIGINAL
C              DISCOS COMPUTATION FOR ITOPW
         NCTCON = 0
         DO I = 1, 2
            DO J = 1, NH
               ITOPW(I,J) = ITOPOL(I,J)
            end do
         end do
C
         IS = 1
         DO N = 1, NB
            NBODF(N) = 0
         end do
         ITOPW(1,1) = 0
         NOP = 1
         IOP(1,1) = 1
         IOP(2,1) = 1
 125     DO I = 1, 2
            DO J = 1, NH
               IF (ITOPW(I,J) .EQ. IS) THEN
                  NOP = NOP + 1
                  IOP(1,J) = NOP
                  IOP(2,J) = ITOPW(1,J)
                  IF (I .NE. 2) THEN
                     IOP(1,J) = -NOP
                     IOP(2,J) = ITOPW(2,J)
                  END IF
                  IS1 = IOP(2,J)
                  NBODF(IS1) = 1
                  ITOPW(1,J) = 0
                  ITOPW(2,J) = 0
               END IF
            end do
         end do
C     
         NBODF(IS) = 0
         IF (NOP .NE. NH) THEN
            DO N = 1, NB
               IF (NBODF(N) .ne. 0) then
                  IS = N
                  GO TO 125
               end if
            end do
            GO TO 999
         END IF
c     
         DO J = 1, NH
            JOPA = IOP(1,J)
            JOP = IABS(JOPA)
            ITOPW(1,JOP) = J*JOPA/JOP
            ITOPW(2,JOP) = IOP(2,J)
         END DO
C     
      END IF             ! End of IF test for tree or loop topology.
C
C                            LENU = STATE VECTOR LENGTH ARRAY
C                            LOCU = STATE VECTOR LOCATION ARRAY
C
      NEQ = 0
      DO N = 1, NB
         NEQ = NEQ + IRGFLX(N)
         if (n .GT. nbdy) then
            lenu(n) = 3
         else
            LENU(N) = 6 + IRGFLX(N)
         end if
      end do
c
c     NEQ is not done yet!!  The calculation is finished in BKINIT.
c
      LOCU(1) = 1
      DO N = 2, NB
         LOCU(N) = LOCU(N - 1) + LENU(N - 1)
      end do
c
      NU = LOCU(NB) + LENU(NB) - 1
      DO N = 1, NB
         NM1 = N - 1
         LENU(N+NB) = IRGFLX(N)
         LOCU(N+NB) = LOCU(NM1+NB) + LENU(NM1+NB)
      end do
      LOCU(2*NB+1) = LOCU(2*NB) + LENU(2*NB)
c
c     Assign values for pointer masptr for the different types of arrays
c     stored in compact storage vector aintgl.
c
      masptr(6,1) = 1
      do n = 2, nb
        masptr(6,n) = masptr(6,n-1) + irgflx(n-1)*(irgflx(n-1)+1)/2
      end do
c
c     Assign values for pointer ainptr for the beginning of each array
c
      ainptr(1) = 1
      ainptr(2) = 0  ! Array AD is not used and therefore not stored
      ainptr(3) = masptr(6,nb) + irgflx(nb)*(irgflx(nb)+1)/2
c
c     The following lines would have been used if modal damping, AD, is enabled
c     ainptr(2) = masptr(6,nb) + irgflx(nb)*(irgflx(nb)+1)/2
c     ainptr(3) = 2*ainptr(2) - 1
c
c     Check for out-of-bounds assignment for aintgl
c  
c      if (ainptr(3)-1 .gt. lintgl .and. .not.(internal_atom) ) then
c        CALL CLEARERR()
c	WRITE (MBOUT,200) 
c     +     'The parameter lintgl, the length of the compact',
c     +     'storage vector aintgl, is too small for this',
c     +     'problem.  Please increase the value in PARAM.FOR,',
c     +     'compile and run again.'
c        WRITE(ERRMSG,2001) 'Error in subroutine.'
c        CALL ERRHDL(-5,'<ROTDH1>')
c      end if
c 200  FORMAT(A,/,A,/,A,/,A)
c
      NBETA = 0
      NLAM  = nctcon
      do n = 1, nb            ! nb = number of non-cut joint hinges
         ihinge = itopw(1,n)
         icbody = itopw(2,n)
         if (ihinge .lt. 0) then
            ihinge = -ihinge
            inbody = itopol(1,ihinge)
         else
            inbody = itopol(2,ihinge)
         end if
         if (icbody .LE. nbdy) then
            nbeta = nbeta + 3
         else
            ihdata(1,ihinge) = 0  ! No need to track rotation of particle
         end if
         if (ihpvt(ihinge) .ne. 0) then
            nbeta = nbeta + 2
            nlam  = nlam + 1
         else
            nbeta = nbeta + 3
         end if
      end do
c
      LENU(2*NB+1) = NBETA
      LENU(2*NB+2) = NDELTA
      LOCU(2*NB+2) = LOCU(2*NB+1) + NBETA
      LOCU(2*NB+3) = LOCU(2*NB+2) + NDELTA
c
C         COMPUTE ARRAYS NEEDED FOR THE ORDER N BACKWARD PASS
C
      CALL BKINIT(logicLoopHeap(iiscutptr),intLoopHeap(iiselptr),
     *            intLoopHeap(iisdofptr),intLoopHeap(iibetdtptr),
     *            intLoopHeap(iihdataptr))
c
      IF (LEQU) THEN
         WRITE (MBOUT,1001)
 1001    FORMAT (' ITOPW ARRAY IS ')
         CALL WRITIS(ITOPW,2,NH,2)
      END IF
      return
c
 999  CALL CLEARERR()
      WRITE (ERRMSG,2001) 
     +   'Topology error found in itopol data in rotdh0.'
 2001 FORMAT (1X,A)
      WRITE (MBOUT,1001)
      CALL WRITIS(ITOPW,2,cL02,2)
      WRITE (MBOUT,1010)
 1010 FORMAT (' NBODF ARRAY IS ')
      CALL WRITIS(NBODF,1,L01,1)
      CALL ERRHDL(-5,'<ROTDH1>')
c
      end
