C $Header: /export/cvs/c34a1/source/moldyn/rotran.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
      SUBROUTINE ROTRAN(L,IHPVT,BETAH,RH)
C
C     SUBROUTINE TO COMPUTE TRANSFORMATION MATRIX FOR PARTICLE HINGES
C
      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: rotran.f,v $$Revision: 1.1.1.1 $'/
C
#include "PARAM.FOR"
C
#include "ERRHDL.INC"
#include "NUMBRS.INC"
#include "PARTCL.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
C
c     Passed

      integer ihpvt(cl02)
      double precision betah(6,cL02)
      double precision rh(3,3,cL15)
c
C     Local Variables
C
      INTEGER LR2,LR4,L
      INTEGER I1,I2,I3
      DOUBLE PRECISION BLEN,STHET,CTHET,CGAMA,SGAMA
C
      DATA I1,I2,I3/3*BADADDR/

      LR2   = 6*(L-2) + 2
      LR4   = LR2 + 2
      BLEN  = BETAH(4,L)
      STHET = SIN(BETAH(5,L))
      CTHET = COS(BETAH(5,L))
      CGAMA = COS(BETAH(6,L))
      SGAMA = SIN(BETAH(6,L))
      IF (IHPVT(L) .EQ. 1) THEN
         I1 = 1
         I2 = 2
         I3 = 3
      ELSE IF (IHPVT(L) .EQ. 2) THEN
         I1 = 2
         I2 = 3
         I3 = 1
      ELSE
         CALL CLEARERR()
         WRITE(ERRMSG,200) 'Error in subroutine.'
         CALL ERRHDL(-5,'<ROTRAN>')
      END IF
 200  FORMAT(1X,A)
C
C     TRANSFORMATION FROM SPHERICAL TO CARTESIAN COORDINATES
C
      RH(I1,1,LR2) =  CGAMA * CTHET
      RH(I2,1,LR2) =  CGAMA * STHET
      RH(I3,1,LR2) =  SGAMA
      RH(I1,2,LR2) = -BLEN * CGAMA * STHET
      RH(I2,2,LR2) =  BLEN * CGAMA * CTHET
      RH(I3,2,LR2) =  ZRO
      RH(I1,3,LR2) = -BLEN * SGAMA * CTHET
      RH(I2,3,LR2) = -BLEN * SGAMA * STHET
      RH(I3,3,LR2) =  BLEN * CGAMA
C
C     TRANSFORMATION FROM CARTESIAN COORDINATES TO SPHERICAL COORDINATES
C
      RH(1,I1,LR4) =  CGAMA * CTHET
      RH(1,I2,LR4) =  CGAMA * STHET
      RH(1,I3,LR4) =  SGAMA
      RH(2,I1,LR4) = -STHET / (BLEN * CGAMA)
      RH(2,I2,LR4) =  CTHET / (BLEN * CGAMA)
      RH(2,I3,LR4) =  ZRO
      RH(3,I1,LR4) = -SGAMA * CTHET / BLEN
      RH(3,I2,LR4) = -SGAMA * STHET / BLEN
      RH(3,I3,LR4) =  CGAMA / BLEN
C
      RETURN
      END
