C $Header: /export/cvs/c34a1/source/moldyn/rottr.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
      SUBROUTINE ROTTR (I23,ITYPE,ANG,ROT,RP2,RP3)
CSE
C                                                          DEBUG #  32
CPS        PURPOSE:
C
C                   TO COMPUTE ANY ONE OF THE TWELVE TYPES OF EULER
C                   ANGLE TRANSFORMATION MATRICES AND/OR THE PI INVERSE
C                   VELOCITY TRANSFORMATIONS, FOR THEORY SEE APPENDIX B,
C                   VOL 1.  FOR ORDER N COMPUTATION CALCULATION OF [PI]
C                   IS NOW INCLUDED.
C
C      ALSO IF I23 .EQ. 1, COMPUTE RP2 AND RP3 WHICH MULTIPLY
C            D/DT(THETA(2)) AND D/DT(THETA(3)) TO FORM D/DT(PI INVERSE).
C      I23 = (1 IF ROT = PI INVERSE),  = (3 IF ROT = ROT. TRANS.)
C      I23 = (-1 IF ROT = PI)
C      ITYPE = 1,2,..12 (TYPE OF EULER ANGLE PERMUTATION, SEE IP BELOW)
C      ANG = INPUT EULER ANGLES
C      ROT = EITHER PI INVERSE OR ROT. TRANS.
C
CPE
      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: rottr.f,v $$Revision: 1.1.1.1 $'/
C
C
#include "ERRHDL.INC"
#include "NUMBRS.INC"
#include "TAPENO.INC"
C        SEE VOL 1 APPENDIX B FOR THEORETICAL DEVELOPMENT
C
C        CODED BY CARL BODLEY,  NOV. 20, 1973.
C   ADDITIONS MADE BY CARL BODLEY,  APR. 5, 1974
C   ADDITIONS MADE BY HON M CHUN, MARCH 16, 1989 FOR CALCULATION OF [PI]
C
C     Local Variables
C
      INTEGER I,J,K,I1
      INTEGER L1,L,I23,ITYPE,LR
      INTEGER IP(36),IV(3)
      DOUBLE PRECISION ANG(*),ROT(3,3), RP2(3,3), RP3(3,3)
      DOUBLE PRECISION A(3,3,4)
      DOUBLE PRECISION ALP,AL2,AL,BE,BEP,C,C2,S,S2
      DATA IP / 1,2,3,    1,2,1,    1,3,1,    1,3,2,
     *          2,3,1,    2,3,2,    2,1,2,    2,1,3,
     *          3,1,2,    3,1,3,    3,2,3,    3,2,1   /
C
      L1 = 3*(ITYPE - 1)
C
      DO 15 L=1,3
      IV(L) = 1
      DO 10 I=1,3
      DO  5 J=1,3
    5 A(I,J,L) = ZRO
   10 A(I,I,L) = ONE
   15 CONTINUE
C
      LR = 4 - ABS(I23)
      DO 20 L=LR,3
      K = IP(L1 + L)
      S = DSIN(ANG(L))
      C = DCOS(ANG(L))
      GO TO (1,2,3), K
    1 A(2,2,L) =  C
      A(3,3,L) =  C
      A(2,3,L) = -S
      A(3,2,L) =  S
      GO TO 20
    2 A(1,1,L) =  C
      A(3,3,L) =  C
      A(1,3,L) =  S
      A(3,1,L) = -S
      GO TO 20
    3 A(1,1,L) =  C
      A(2,2,L) =  C
      A(1,2,L) = -S
      A(2,1,L) =  S
   20 CONTINUE
      IF (I23 .EQ. 1) GO TO 50
      IF (I23 .EQ. -1) GO TO 100
C
C        DROP HERE IF ROTATION TRANSFORMATION MATRIX NEEDED
C        OBTAIN VIA MATRIX PRODUCTS OF ELEMENTARY ROTATION MATRICIES
CC@CC
CC@CC MULT3 A(1,1,1), A(1,1,2), A(1,1,4)
CC@CC 3, 3, 3
CC@CC 3, 3, 3
      A(1,1,4) = A(1,1,1)*A(1,1,2) + A(1,2,1)*A(2,1,2) + A(1,3,1)*A(3,1,
     .2)
      A(2,1,4) = A(2,1,1)*A(1,1,2) + A(2,2,1)*A(2,1,2) + A(2,3,1)*A(3,1,
     .2)
      A(3,1,4) = A(3,1,1)*A(1,1,2) + A(3,2,1)*A(2,1,2) + A(3,3,1)*A(3,1,
     .2)
      A(1,2,4) = A(1,1,1)*A(1,2,2) + A(1,2,1)*A(2,2,2) + A(1,3,1)*A(3,2,
     .2)
      A(2,2,4) = A(2,1,1)*A(1,2,2) + A(2,2,1)*A(2,2,2) + A(2,3,1)*A(3,2,
     .2)
      A(3,2,4) = A(3,1,1)*A(1,2,2) + A(3,2,1)*A(2,2,2) + A(3,3,1)*A(3,2,
     .2)
      A(1,3,4) = A(1,1,1)*A(1,3,2) + A(1,2,1)*A(2,3,2) + A(1,3,1)*A(3,3,
     .2)
      A(2,3,4) = A(2,1,1)*A(1,3,2) + A(2,2,1)*A(2,3,2) + A(2,3,1)*A(3,3,
     .2)
      A(3,3,4) = A(3,1,1)*A(1,3,2) + A(3,2,1)*A(2,3,2) + A(3,3,1)*A(3,3,
     .2)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC MULT3 A(1,1,4), A(1,1,3), ROT
CC@CC 3, 3, 3
CC@CC 3, 3, 3
      ROT(1,1) = A(1,1,4)*A(1,1,3) + A(1,2,4)*A(2,1,3) + A(1,3,4)*A(3,1,
     .3)
      ROT(2,1) = A(2,1,4)*A(1,1,3) + A(2,2,4)*A(2,1,3) + A(2,3,4)*A(3,1,
     .3)
      ROT(3,1) = A(3,1,4)*A(1,1,3) + A(3,2,4)*A(2,1,3) + A(3,3,4)*A(3,1,
     .3)
      ROT(1,2) = A(1,1,4)*A(1,2,3) + A(1,2,4)*A(2,2,3) + A(1,3,4)*A(3,2,
     .3)
      ROT(2,2) = A(2,1,4)*A(1,2,3) + A(2,2,4)*A(2,2,3) + A(2,3,4)*A(3,2,
     .3)
      ROT(3,2) = A(3,1,4)*A(1,2,3) + A(3,2,4)*A(2,2,3) + A(3,3,4)*A(3,2,
     .3)
      ROT(1,3) = A(1,1,4)*A(1,3,3) + A(1,2,4)*A(2,3,3) + A(1,3,4)*A(3,3,
     .3)
      ROT(2,3) = A(2,1,4)*A(1,3,3) + A(2,2,4)*A(2,3,3) + A(2,3,4)*A(3,3,
     .3)
      ROT(3,3) = A(3,1,4)*A(1,3,3) + A(3,2,4)*A(2,3,3) + A(3,3,4)*A(3,3,
     .3)
CC@CC end of expanded call
CC@CC
      RETURN
C
C        COME HERE TO GET PI INVERSE VELOCITY TRANSFORMATIONS
   50 DO 25 I=2,3
      I1 = IP(L1 + I)
   25 IV(I1) = I
      S2 = DSIN(ANG(2))
      C2 = DCOS(ANG(2))
      I1 = DBLE(ITYPE)/4.2
      K = ITYPE - 4*I1
      GO TO (61,62,63,64), K
   61 IF (ONE+C2*C2 .EQ. ONE) GO TO 999
      AL = C2
      AL2 = AL*AL
      BE = S2
      ALP = S2/AL2
      BEP = -ONE/AL2
      GO TO 65
   62 IF (ONE+S2*S2 .EQ. ONE) GO TO 999
      AL = S2
      AL2 = AL*AL
      BE = C2
      ALP = -C2/AL2
      BEP = ONE/AL2
      GO TO 65
   63 IF (ONE+S2*S2 .EQ. ONE) GO TO 999
      AL = -S2
      AL2 = AL*AL
      BE = C2
      ALP = C2/AL2
      BEP = -ONE/AL2
      GO TO 65
   64 IF (ONE+C2*C2 .EQ. ONE) GO TO 999
      AL = C2
      AL2 = AL*AL
      BE = -S2
      ALP = S2/AL2
      BEP = ONE/AL2
C
   65 K = IP(L1+3)
      GO TO (71,72,73), K
   71 A(2,2,1) =  A(2,3,3)
      A(3,3,1) =  A(2,3,3)
      A(3,2,1) =  A(2,2,3)
      A(2,3,1) = -A(2,2,3)
      A(1,1,1) = ZRO
      GO TO 75
   72 A(1,1,1) =  A(3,1,3)
      A(3,3,1) =  A(3,1,3)
      A(1,3,1) =  A(1,1,3)
      A(3,1,1) = -A(1,1,3)
      A(2,2,1) = ZRO
      GO TO 75
   73 A(1,1,1) =  A(1,2,3)
      A(2,2,1) =  A(1,2,3)
      A(2,1,1) =  A(1,1,3)
      A(1,2,1) = -A(1,1,3)
      A(3,3,1) = ZRO
   75 DO 80 I=1,3
      I1 = IV(I)
      DO 80 J=1,3
      A(I1,J,2) = A(I,J,1)
   80 A(I1,J,4) = A(I,J,3)
C
      DO 90 J=1,3
      ROT(1,J) = A(1,J,4)/AL
      RP3(1,J) = A(1,J,2)/AL
      ROT(2,J) = A(2,J,4)
      RP3(2,J) = A(2,J,2)
      ROT(3,J) = A(3,J,4) - BE*ROT(1,J)
      RP3(3,J) = A(3,J,2) - BE*RP3(1,J)
      RP2(1,J) = ALP*A(1,J,4)
      RP2(2,J) = ZRO
   90 RP2(3,J) = BEP*A(1,J,4)
C
      RETURN
C
C        COME HERE TO GET PI VELOCITY TRANSFORMATIONS
  100 DO I = 2, 3
        I1 = IP(L1 + I)
        IV(I1) = I
      END DO
      S2 = DSIN(ANG(2))
      C2 = DCOS(ANG(2))
      I1 = DBLE(ITYPE)/4.2
      K = ITYPE - 4*I1
      GO TO (161,162,163,164), K
  161 AL = C2
      BE = S2
      GO TO 165
  162 AL = S2
      BE = C2
      GO TO 165
  163 AL = -S2
      BE = C2
      GO TO 165
  164 AL = C2
      BE = -S2
C
  165 DO I = 1, 3
        I1 = IV(I)
        DO J = 1, 3
          A(J,I1,4) = A(I,J,3)
        END DO
      END DO
C
      DO I = 1, 3
        ROT(I,1) = A(I,1,4)*AL + A(I,3,4)*BE
        ROT(I,2) = A(I,2,4)
        ROT(I,3) = A(I,3,4)
      END DO
C
      RETURN
 999  CALL CLEARERR()
      WRITE (ERRMSG,1000) ITYPE,ANG(2)
 1000 FORMAT (1X,'1GIMBAL LOCK-- ITYPE = ',I5,'ANGLE = ',D15.8)
      CALL ERRHDL(-5,'<ROTTR>')
      END
