C $Header: /export/cvs/c34a1/source/moldyn/rtcst2.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C ========================================================================
C
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER 
C STATE AND FEDERAL LAWS.  USE, DISCLOSURE, REPRODUCTION OR DUPLICATION 
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS 
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT 
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C
C
      DOUBLE PRECISION FUNCTION rtcst2(thet,xloc,dsloc,ami,n,ibod)
c
      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: rtcst2.f,v $$Revision: 1.1.1.1 $'/
c
#include "PARAM.FOR"
c
#include "CSTIFF.INC"
c
      INTEGER n                       !  Number of atoms in body ibod
      INTEGER ibod                    !  Body number
      DOUBLE PRECISION thet(3)        !  Rotation to apply to dsloc
      DOUBLE PRECISION xloc(3,n)      !  Initial coords. in inertial frame
      DOUBLE PRECISION dsloc(3,2*n)   !  Nominal coords. in body frame
      DOUBLE PRECISION ami(n)         !  Mass inverse
c
c     Local Variables
c
      INTEGER i, i1                   !  DO loop index
      INTEGER itype                   !  Euler Sequence
      DOUBLE PRECISION sum            !  Summation and dummy variable
      DOUBLE PRECISION tmat(3,3)      !  Transformation matrix
      DOUBLE PRECISION vec1(3)        !  Transformed vector
c
c     Get transformation matrix
c
      itype = 1
      call rottr(3,itype,thet,tmat,sum,sum)
c
      rtcst2 = 0D0
      DO i = 1, n
c
c     Perform transformation on each atom
c
         i1 = 2*i
CC@CC
CC@CC ...MULT3 tmat, dsloc(1,i1), vec1
CC@CC ...3, 3, 1
CC@CC ...3, 3, 3
      vec1(1) = tmat(1,1)*dsloc(1,i1) + tmat(1,2)*dsloc(2,i1) + tmat(1,3
     .)*dsloc(3,i1)
      vec1(2) = tmat(2,1)*dsloc(1,i1) + tmat(2,2)*dsloc(2,i1) + tmat(2,3
     .)*dsloc(3,i1)
      vec1(3) = tmat(3,1)*dsloc(1,i1) + tmat(3,2)*dsloc(2,i1) + tmat(3,3
     .)*dsloc(3,i1)
CC@CC end of expanded call
CC@CC
c
c     Sum up to get the weighted sum square error
c
         sum = 0.
         DO i1 = 1, 3
            sum = sum + (xloc(i1,i) - vec1(i1) - cgnom(i1,ibod)
     .           - cgadj(i1,ibod))**2
         END DO
         rtcst2 = rtcst2 + sum/ami(i)
      END DO
C
      RETURN
      END
