C $Header: /export/cvs/c34a1/source/moldyn/svbksb.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
      SUBROUTINE SVBKSB(U,W,V,M,N,MP,NP,B,X,TMP)
CSE
C                                                          DEBUG # 157
CPS        PURPOSE:
C                    USED TO COMPUTE THE SOLUTIONS TO THE LEAST SQUARES
C          PROBLEM OF DETERMINING THE VECTOR "X" SUCH THAT
C
C                           NORM ( A*X - B )
C
C          IS MINIMIZED, WHERE THE SINGULAR VALUE DECOMPOSITION OF THE
C          RECTANGULAR MxN MATRIX "A" IS PROVIDED AS
C
C                              T
C                         A = U * diag(W) * V
C
C          "U" & "V" ARE THE LEFT & RIGHT ORTHOGONAL SINGULAR VECTORS, AND
C          "diag(W)" IS THE DIAGONAL MATRIX OF NON-ZERO SINGULAR VALUES.
C
C          THE COMPUTED SOULTION IS
C                                      -1   T
C                      X  =  V * diag(W) * U * B
C
CPE
CAS                    ARGUMENT LIST
C
C       W   -  VECTOR OF NON-ZERO SINGULAR VALUES (Nx1)
C       U   -  MATRIX OF LEFT SINGULAR VECTORS (MxN)
C       V   -  MATRIX OF RIGHT SINGULAR VECTORS (NxN)
C              SUCH THAT:
C                             T
C                        A = U * diag(W) * V
C
C       TMP -  INPUT WORK VECTOR
C       MP  -  LEADING DIMENSION OF ARRAY "U"
C       NP  -  LEADING DIMENSION OF ARRAY "V" AND LENGTH
C              OF VECTORS "W", "B", "X", AND "TMP"
C       B   -  INPUT VECTOR (Mx1)
C       X   -  OUTPUT, SOLUTION VECTOR (Nx1) TO THE LEAST SQUARES
C              PROBLEM OF FINDING THE SOLUTION "X" WHICH MINIMIZES
C
C                       NORM [ A * X  -  B ]
CAE
C
      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: svbksb.f,v $$Revision: 1.1.1.1 $'/
      INTEGER I,J,JJ,M,MP,N,NP
      DOUBLE PRECISION U(MP,NP),W(NP),V(NP,NP),B(MP),X(NP),TMP(NP)
      DOUBLE PRECISION S
C
      DO 12 J=1,N
        S=0.D0
        IF(W(J).NE.0d0 )THEN
          DO 11 I=1,M
            S=S+U(I,J)*B(I)
11        CONTINUE
          S=S/W(J)
        ENDIF
        TMP(J)=S
12    CONTINUE
      DO 14 J=1,N
        S=0.D0
        DO 13 JJ=1,N
          S=S+V(J,JJ)*TMP(JJ)
13      CONTINUE
        X(J)=S
14    CONTINUE
      RETURN
      END
