C $Header: /export/cvs/c34a1/source/moldyn/torque.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C ========================================================================
C
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER 
C STATE AND FEDERAL LAWS.  USE, DISCLOSURE, REPRODUCTION OR DUPLICATION 
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS 
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT 
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C
      SUBROUTINE TORQUE (G,itflag,iextor,gpos,p)
CSE
C                                                          DEBUG #  57
CPS        PURPOSE:
C
C                   COMPUTE ALL GYROSCOPIC FORCES AND TORQUES ACTING
C                   ON THE SYSTEM, CALL USER ROUTINES WHICH DEFINE
C                   NON-GYROSCOPIC EFFECTS (SPRING, DASHPOTS, MOTORS)
C                   WHEEL CONTROL TORQUES, GRAVITY GRADIENT, ALSO
C                   CALL TO EQADD DEFINES THE SENSOR AND TORQUE SIGNAL
C                   EQUATIONS FOR STABILITY ANALYSIS.
C
CPE
      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: torque.f,v $$Revision: 1.1.1.1 $'/
C
#include "PARAM.FOR"
C
#include "BHBSRD.INC"
#ifdef CHARMM
#include "CHARMM.INC"
#endif
#include "COREA.INC"
#include "CSTIFF.INC"
#include "GCOMP.INC"
#include "GGSAVE.INC"
#include "HANDS2.INC"
#include "ILINER.INC"
#include "INTGRL.INC"
#include "LDEBUG.INC"
#include "MAXMUM.INC"
#include "HEAPMB.INC"
#include "MEMLB.INC"
#include "MISCNO.INC"
#include "MOMENG.INC"
#include "MULTIPOLE.INC"
#include "NUMBRS.INC"
#include "OPTION.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
#include "TIMESS.INC"
#include "TIMING.INC"
#include "VECTOR.INC"
c
c     Passed Variables
c
      INTEGER itflag, iextor
      DOUBLE PRECISION G(*)
      DOUBLE PRECISION GPOS(cL10)
      DOUBLE PRECISION P(cL10)
     
C
c
c     Local variables:
c
      LOGICAL LEQU
      INTEGER   i, n     !  DO loop index
      INTEGER   le          !  Length of modal amplitude vector
      INTEGER   icxy,icxz,icyz,iacf,ibcf   !  Cof pointers

      DOUBLE PRECISION tim1, tim2    !  Temp variables used for timing
c
      EQUIVALENCE (LEQU,DEBUG(57))
c
c
      IF(LEQU) WRITE (MBOUT,1000)
c
c     Note:  The code for electrostatic interactions (when ready)
c            should be adjusted for MTSL
c
      if ( (verlet .AND. iextor .EQ. 1) .OR.
     +     (.NOT. verlet              ) )THEN
c
C
C     SUBROUTINE VFMA  ADDS TO VECTOR OF GENERALIZED FORCES (G = GGV)
C                      THE CONTRIBUTIONS DUE TO ELECTROSTATIC INTERACTIONS
C                      BETWEEN BODIES USING THE VFMA ROUTINES.
c
         CALL msecond(tim1)
C
C     For CHARMM, the call to extor takes place in subroutine ydot
C
#ifndef CHARMM
         DO i = M35, M35+3*nspt-1
            x(i) = 0D0
         END DO
C
         nfrc_call = nfrc_call + 1
         CALL EXTOR 
#endif
         CALL msecond(tim2)
         timer(inon_vfma) = timer(inon_vfma) + tim2 - tim1
#ifdef HBMA
         IF (idovfma) THEN
            CALL msecond(tim1)
            IF (long2) THEN
               CALL vfma(gpos)
            ELSE
               CALL vfma_short(gpos)
            END IF
            CALL msecond(tim2)
            timer(ivfma) = timer(ivfma) + tim2 - tim1
         ELSE
#endif
            DO n = 1, nb
               engpe(n) = 0.0D0
            END DO
#ifdef HBMA
         END IF
#endif
C
C     SUBROUTINE KHINGE ESTABLISHES THE CONTRIBUTION FROM FORCES AND TORQUES
C                       ACTING BETWEEN CONTIGUOUS BODIES AT HINGE POINTS.
C                       USER SUPPLIED --
C
cblink      CALL KHINGE (G)
C
         IF (lequ) THEN
            WRITE (MBOUT,1001)
            CALL writes(g,1,nu,1)
         END IF
c
      END IF    !  (verlet & iextor=1) | NOT verlet
c
      DO i = 1, locu(nb+1)-1
         g(i) = gpos(i)
      END DO
c
c end of if block for type of integrator
c
C
C####    INSERT AT THIS POINT NEW TO-BE-DEVELOPED SUBROUTINES TO SUPPORT
C        THE USER INTERFACE TO NEW CAPABILITY, FOR EXAMPLE:
C                    HARMONIC DRIVES AT JOINTS
C                    ROLLING/SLIDING CONTACT AT JOINTS
C
C      THE FOLLOWING CODE IS USED TO TRANSFORM PHYSICALLY REALIZABLE
C      FORCES AND TORQUES DEFINED BY THE USER INTO THE THE GENERALIZED
C      LOADS REQUIRED BY THE DISCOS SOULTION ALGORITHMS
C
C        CYCLE THROUGH ALL BODIES COMPUTING GYROSCOPIC FORCES AND
C        TORQUES ACTING ON THEM
C
      DO 50 N=1,NBDY
         LE   = LENU(N+NB)
         iacf = iacfptr(n)      ! acof pointer
         ibcf = ibcfptr(n)      ! bcof pointer
         icxy = icxyptr(n)      ! cofxy pointer
         icxz = icxzptr(n)      ! cofxz pointer
         icyz = icyzptr(n)      ! cofyz pointer
C
C        EVALUATE EQUATION II-58 ADD IT TO THE LOAD VECTOR G
C
C     Pass heap_mb locations of cofs to torque_1
C
#ifdef ANALYZE_FORCE
         CALL TORQUE_1(HEAP_MB(iacf),HEAP_MB(ibcf),HEAP_MB(icxy),
     &        HEAP_MB(icxz),HEAP_MB(icyz),le,n,G,HEAP_MB(iggsptr),
     &        HEAP_MB(iyptr),HEAP_MB(iydtptr),HEAP_MB(ig_chmptr),
     &        HEAP_MB(ig_gyroptr),HEAP_MB(ig_deformptr),
     &        HEAP_MB(ipptr),LocalHeap(irwptr_torque),
     &        LocalHeap(icwptr_torque),LocalHeap(iv1ptr_torque))
#else
         CALL TORQUE_1(HEAP_MB(iacf),HEAP_MB(ibcf),HEAP_MB(icxy),
     &        HEAP_MB(icxz),HEAP_MB(icyz),le,n,G,HEAP_MB(iggsptr),
     &        HEAP_MB(iyptr),HEAP_MB(iydtptr),HEAP_MB(ipptr),
     &        LocalHeap(irwptr_torque),LocalHeap(icwptr_torque),
     &        LocalHeap(iv1ptr_torque))
#endif
c
 50   CONTINUE      
C
#ifdef CHARMM
C     CALL TORQ_LANGEVIN TO ADD STOCHASTIC TERMS TO G
C     (le= # of dof's, n= body id #, G= load vector,
C      HEAP_MB stores the AMU (mass-inertia-coeff) matrix)
C
       IF (LANGEVIN) CALL TORQ_LANGEVIN (G,mbdynaHeap(igamlngptr),
     &                                   mbdynaHeap(irfptr),
     &                                   HEAP_MB(ipptr))
C
#endif
C
C     SUBROUTINE EQADD ESTABLISHES ADDITIONAL CONTROL BLOCK EQUATIONS
C     TO SET UP SIMILARITY TRANSFORMATION. USED ONLY FOR LINEARIZATION
C     AND STABILITY PACKAGE.  USER SUPPLIED --
C
cblink      CALL EQADD
c
C
      IF(.NOT.LEQU) RETURN
      WRITE (MBOUT,1002)
      CALL WRITES(G,1,NU,1)
 1000 FORMAT (' SUBROUTINE TORQUE ')
 1001 FORMAT (' G VECTOR ALL FORCES AND TORQUES EXTERNAL TO BODIES ')
 1002 FORMAT (' LOAD VECTOR G WITH GYROSCOPIC EFFECTS ADDED ON' )
C   
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C     Beginning of torque_1
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
#ifdef ANALYZE_FORCE
      SUBROUTINE TORQUE_1(ACOF,BCOF,COFXY,COFXZ,COFYZ,le,n,G,GGS,
     &	                  Y,YDT,G_chm,G_gyro,G_deform,P,RW,CW,V1)
#else
      SUBROUTINE TORQUE_1(ACOF,BCOF,COFXY,COFXZ,COFYZ,le,n,G,GGS,
     &	                  Y,YDT,P,RW,CW,V1)
#endif
C
      IMPLICIT NONE
C
#include "PARAM.FOR"
C
#include "BHBSRD.INC"
#include "COREA.INC"
#include "CSTIFF.INC"
#include "ERRHDL.INC"
#include "GCOMP.INC"
#include "GGSAVE.INC"
#include "HANDS2.INC"
#include "HEAPMB.INC"
#include "ILINER.INC"
#include "INTGRL.INC"
#include "LDEBUG.INC"
#include "MAXMUM.INC"
#include "MEMLB.INC"
#include "MISCNO.INC"
#include "MOMENG.INC"
#include "MULTIPOLE.INC"
#include "NUMBRS.INC"
#include "OPTION.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
#include "TIMESS.INC"
#include "TIMING.INC"
#include "VECTOR.INC"
C
C     Passed Variables
C
      INTEGER  n           !  Body number
      INTEGER  le          !  Length of modal amplitude vector
      DOUBLE PRECISION G(*)
      DOUBLE PRECISION ACOF(9,le),BCOF(6,le)
      DOUBLE PRECISION COFXY(le,le),COFXZ(le,le),COFYZ(le,le)
      DOUBLE PRECISION GGS(cL06,9,MAXBOD)
      DOUBLE PRECISION Y(cL07),YDT(cL07)
      DOUBLE PRECISION P(cL10)
#ifdef ANALYZE_FORCE
      DOUBLE PRECISION G_chm(cL10),G_gyro(6*MAXBOD)
      DOUBLE PRECISION G_deform(6*MAXBOD)
#endif

c
c     Local variables:
c
      INTEGER   i, j     !  DO loop index
      INTEGER   lou         !  Pointer for rigid velocities
      INTEGER   lou1, lou2, lou3, lou4, lou5  !  lou(n) = lou + (n)
      INTEGER   lo          !  Pointer for modal amplitudes
      INTEGER   iloc        !  Local pointer in aintgl vector
      DOUBLE PRECISION  wsk(3,3)     !  Skew symmetric matrix
      DOUBLE PRECISION  v(6)         !  Temp vector
      DOUBLE PRECISION  cw(cL06,3)    !  Set of 3 column work vectors
      DOUBLE PRECISION  rw(3,cL06)    !  Set of 3 row work vectors
      DOUBLE PRECISION  v1(cL06)
c
c
      LO   = LOCU(N+NB)
      LOU  = LOCU(N)
      LOU1 = LOU + 1
      LOU2 = LOU + 2
      LOU3 = LOU + 3
      LOU4 = LOU + 4
      LOU5 = LOU + 5
c
      CALL SKEWV3 (Y(LOU),WSK,1,3)
#ifdef ANALYZE_FORCE
      j = 6 * (n-1) + 1
CC@CC
CC@CC MULT3 wsk, P(lou), G_gyro(j)
CC@CC 3, 3, 1
CC@CC 3, 1, 1
      G_gyro(j+0) = wsk(1,1)*P(lou+0) + wsk(1,2)*P(lou+1) + wsk(1,3)*P(l
     .ou+2)
      G_gyro(j+1) = wsk(2,1)*P(lou+0) + wsk(2,2)*P(lou+1) + wsk(2,3)*P(l
     .ou+2)
      G_gyro(j+2) = wsk(3,1)*P(lou+0) + wsk(3,2)*P(lou+1) + wsk(3,3)*P(l
     .ou+2)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC MULT3 wsk, P(lou3), G_gyro(j+3)
CC@CC 3, 3, 1
CC@CC 3, 1, 1
      G_gyro(j+3+0) = wsk(1,1)*P(lou3+0) + wsk(1,2)*P(lou3+1) + wsk(1,3)
     .*P(lou3+2)
      G_gyro(j+3+1) = wsk(2,1)*P(lou3+0) + wsk(2,2)*P(lou3+1) + wsk(2,3)
     .*P(lou3+2)
      G_gyro(j+3+2) = wsk(3,1)*P(lou3+0) + wsk(3,2)*P(lou3+1) + wsk(3,3)
     .*P(lou3+2)
CC@CC end of expanded call
CC@CC
      DO i = 0, 2
         G(lou+i)  = G(lou+i)  + G_gyro(j+i)
         G(lou3+i) = G(lou3+i) + G_gyro(j+3+i)
      END DO
#else
CC@CC
CC@CC MULTAD wsk, P(lou), G(lou)
CC@CC 3, 3, 1
CC@CC 3, 1, 1
      G(lou+0) = G(lou+0) + wsk(1,1)*P(lou+0) + wsk(1,2)*P(lou+1) + wsk(
     .1,3)*P(lou+2)
      G(lou+1) = G(lou+1) + wsk(2,1)*P(lou+0) + wsk(2,2)*P(lou+1) + wsk(
     .2,3)*P(lou+2)
      G(lou+2) = G(lou+2) + wsk(3,1)*P(lou+0) + wsk(3,2)*P(lou+1) + wsk(
     .3,3)*P(lou+2)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC MULTAD wsk, P(lou3), G(lou3)
CC@CC 3, 3, 1
CC@CC 3, 1, 1
      G(lou3+0) = G(lou3+0) + wsk(1,1)*P(lou3+0) + wsk(1,2)*P(lou3+1) + 
     .wsk(1,3)*P(lou3+2)
      G(lou3+1) = G(lou3+1) + wsk(2,1)*P(lou3+0) + wsk(2,2)*P(lou3+1) + 
     .wsk(2,3)*P(lou3+2)
      G(lou3+2) = G(lou3+2) + wsk(3,1)*P(lou3+0) + wsk(3,2)*P(lou3+1) + 
     .wsk(3,3)*P(lou3+2)
CC@CC end of expanded call
CC@CC
#endif
c
      CALL SKEWV3 (Y(LOU3),WSK,1,3)
CC@CC
CC@CC MULTAD WSK, P(LOU3), G(LOU)
CC@CC 3, 3, 1
CC@CC 3, 1, 1
      G(LOU+0) = G(LOU+0) + WSK(1,1)*P(LOU3+0) + WSK(1,2)*P(LOU3+1) + WS
     .K(1,3)*P(LOU3+2)
      G(LOU+1) = G(LOU+1) + WSK(2,1)*P(LOU3+0) + WSK(2,2)*P(LOU3+1) + WS
     .K(2,3)*P(LOU3+2)
      G(LOU+2) = G(LOU+2) + WSK(3,1)*P(LOU3+0) + WSK(3,2)*P(LOU3+1) + WS
     .K(3,3)*P(LOU3+2)
CC@CC end of expanded call
CC@CC
C
      IF (LE .GT. cL06) THEN
         CALL CLEARERR()
         WRITE(ERRMSG,200) 'LE excedes cL06.'
         CALL ERRHDL(-5,'<TORQUE_1>')
      END IF
 200  FORMAT(1X,A)
C
      IF (LE .EQ. 0) RETURN
c
c     Add in modal stiffness and damping contributions if required
c
#ifdef CHARMM
      IF (.NOT. internal_atom) THEN
#endif
c
c     Add effects of modal stiffness
c
         iloc = ainptr(1)+masptr(6,n)-1
         CALL multsym (aintgl(iloc),y(lo),0.0d0,v1,irgflx(n))
c
c     Add effects of modal damping (not currently enabled)
c
c         iloc = ainptr(2)+masptr(6,n)-1
c         call multsym (aintgl(iloc),ydt(lo),1.0d0,v1,irgflx(n))
c
         DO J=1,LE
            I = LOU5 + J
            G(I) = G(I) - V1(J)
         END DO
c
#ifdef CHARMM
      END IF
#endif
C
C        GGS COMPUTED IN MGEN USED HERE IN THE EVALUATION OF
C        EQUATION II-91,92,93 AS WELL AS IN THE GRAVITY GRADIENT STUFF
C
      DO 15 J=1,LE
      CW(J,1) = -2D0*Y(LOU )*(BCOF(1,J) + GGS(J,1,N))
     *   + Y(LOU1)*(BCOF(4,J) + GGS(J,4,N) + GGS(J,7,N))
     *   + Y(LOU2)*(BCOF(5,J) + GGS(J,5,N) + GGS(J,8,N))
     *   - Y(LOU3)*ACOF(1,J) - Y(LOU4)*ACOF(2,J) - Y(LOU5)*ACOF(3,J)
      CW(J,2) = -2D0*Y(LOU1)*(BCOF(2,J) + GGS(J,2,N))
     *   + Y(LOU2)*(BCOF(6,J) + GGS(J,6,N) + GGS(J,9,N))
     *   + Y(LOU )*(BCOF(4,J) + GGS(J,4,N) + GGS(J,7,N))
     *   - Y(LOU3)*ACOF(4,J) - Y(LOU4)*ACOF(5,J) - Y(LOU5)*ACOF(6,J)
      CW(J,3) = -2D0*Y(LOU2)*(BCOF(3,J) + GGS(J,3,N))
     *   + Y(LOU )*(BCOF(5,J) + GGS(J,5,N) + GGS(J,8,N))
     *   + Y(LOU1)*(BCOF(6,J) + GGS(J,6,N) + GGS(J,9,N))
     *   - Y(LOU3)*ACOF(7,J) - Y(LOU4)*ACOF(8,J) - Y(LOU5)*ACOF(9,J)
   15 CONTINUE
CC@CC
CC@CC MULTAD YDT(LO), CW, G(LOU)
CC@CC 1, LE, 3
CC@CC 1, cL06, 1
      CALL DGEMV ('T',LE,3,1.0d0,CW,cL06,YDT(LO),1,1.0d0,G(LOU),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC MULT3 COFXY, YDT(LO), CW(1,1)
CC@CC LE, LE, 1
CC@CC LE, 1, cL06
      CALL DGEMV ('N',LE,LE,1.0d0,COFXY,LE,YDT(LO),1,0.0d0,CW(1,1),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC MULT3 COFXZ, YDT(LO), CW(1,2)
CC@CC LE, LE, 1
CC@CC LE, 1, cL06
      CALL DGEMV ('N',LE,LE,1.0d0,COFXZ,LE,YDT(LO),1,0.0d0,CW(1,2),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC MULT3 COFYZ, YDT(LO), CW(1,3)
CC@CC LE, LE, 1
CC@CC LE, 1, cL06
      CALL DGEMV ('N',LE,LE,1.0d0,COFYZ,LE,YDT(LO),1,0.0d0,CW(1,3),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC MULT3 YDT(LO), CW, V
CC@CC 1, LE, 3
CC@CC 1, cL06, 1
      CALL DGEMV ('T',LE,3,1.0d0,CW,cL06,YDT(LO),1,0.0d0,V,1)
CC@CC end of expanded call
CC@CC
      G(LOU ) = G(LOU ) - V(3)
      G(LOU1) = G(LOU1) - V(2)
      G(LOU2) = G(LOU2) - V(1)
C
C        COMPUTE EQUATION II-94,95,96
      DO 18 J=1,LE
      CW(J,1) = -Y(LOU )*ACOF(1,J) - Y(LOU1)
     *    *ACOF(4,J) - Y(LOU2)*ACOF(7,J)
      CW(J,2) = -Y(LOU )*ACOF(2,J) - Y(LOU1)
     *    *ACOF(5,J) - Y(LOU2)*ACOF(8,J)
      CW(J,3) = -Y(LOU )*ACOF(3,J) - Y(LOU1)
     *    *ACOF(6,J) - Y(LOU2)*ACOF(9,J)
   18 CONTINUE
CC@CC
CC@CC MULTAD YDT(LO), CW, G(LOU3)
CC@CC 1, LE, 3
CC@CC 1, cL06, 1
      CALL DGEMV ('T',LE,3,1.0d0,CW,cL06,YDT(LO),1,1.0d0,G(LOU3),1)
CC@CC end of expanded call
CC@CC
C
C
C        COMPUTE EQUATION II-97
      DO 20 J=1,LE
      I = LOU5 + J
      G(I) = G(I) + (Y(LOU )**2)*(BCOF(1,J) + GGS(J,1,N))
     *            + (Y(LOU1)**2)*(BCOF(2,J) + GGS(J,2,N))
     *            + (Y(LOU2)**2)*(BCOF(3,J) + GGS(J,3,N))
     *   - Y(LOU )*Y(LOU1)*(BCOF(4,J) + GGS(J,4,N) + GGS(J,7,N)) 
     *   - Y(LOU )*Y(LOU2)*(BCOF(5,J) + GGS(J,5,N) + GGS(J,8,N)) 
     *   - Y(LOU1)*Y(LOU2)*(BCOF(6,J) + GGS(J,6,N) + GGS(J,9,N))
     *   + Y(LOU )*(Y(LOU3)*ACOF(1,J) + Y(LOU4)*ACOF(2,J) 
     *   + Y(LOU5)*ACOF(3,J)) + Y(LOU1)*(Y(LOU3)*ACOF(4,J) 
     *   + Y(LOU4)*ACOF(5,J) + Y(LOU5)*ACOF(6,J))
     *   + Y(LOU2)*(Y(LOU3)*ACOF(7,J) + Y(LOU4)*ACOF(8,J) 
     *   + Y(LOU5)*ACOF(9,J))
   20 CONTINUE
C
CC@CC
CC@CC MULT3 COFXY, YDT(LO), CW(1,1)
CC@CC LE, LE, 1
CC@CC LE, 1, cL06
      CALL DGEMV ('N',LE,LE,1.0d0,COFXY,LE,YDT(LO),1,0.0d0,CW(1,1),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC MULT3 COFXZ, YDT(LO), CW(1,2)
CC@CC LE, LE, 1
CC@CC LE, 1, cL06
      CALL DGEMV ('N',LE,LE,1.0d0,COFXZ,LE,YDT(LO),1,0.0d0,CW(1,2),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC MULT3 COFYZ, YDT(LO), CW(1,3)
CC@CC LE, LE, 1
CC@CC LE, 1, cL06
      CALL DGEMV ('N',LE,LE,1.0d0,COFYZ,LE,YDT(LO),1,0.0d0,CW(1,3),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC MULT3 YDT(LO), COFXY, RW(1,1)
CC@CC 1, LE, LE
CC@CC 1, LE, 3
      CALL DGEMV ('T',LE,LE,1.0d0,COFXY,LE,YDT(LO),1,0.0d0,RW(1,1),3)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC MULT3 YDT(LO), COFXZ, RW(2,1)
CC@CC 1, LE, LE
CC@CC 1, LE, 3
      CALL DGEMV ('T',LE,LE,1.0d0,COFXZ,LE,YDT(LO),1,0.0d0,RW(2,1),3)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC MULT3 YDT(LO), COFYZ, RW(3,1)
CC@CC 1, LE, LE
CC@CC 1, LE, 3
      CALL DGEMV ('T',LE,LE,1.0d0,COFYZ,LE,YDT(LO),1,0.0d0,RW(3,1),3)
CC@CC end of expanded call
CC@CC
      DO 30 J=1,LE
      I = LOU5 + J
      G(I) = G(I) + Y(LOU )*(CW(J,3) - RW(3,J))
     *            + Y(LOU1)*(CW(J,2) - RW(2,J))
     *            + Y(LOU2)*(CW(J,1) - RW(1,J))
   30 CONTINUE
C
#ifdef ANALYZE_FORCE
      j = 6 * (N-1)
      l = LOU - 1
      DO 35 I = 1, 6
         G_deform(j+i) = G(l+i) - G_chm(l+i) - G_gyro(j+i)
 35   CONTINUE
#endif    
C
      return
      end    ! End of torque_1


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C     Beginning of torq_langevin 
C     Adds stochastic terms (Langevin dynamics) to the 
C     equations of motion of the bodies.
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE TORQ_LANGEVIN(Glange,gamLng,RF,P)


#include "PARAM.FOR"

#include "CHARMM.INC"
#include "MOMENG.INC"
#include "SPECIF.INC"

      INTEGER  I
      INTEGER  iBod     !  Body number
      INTEGER  le       !  Length of iBod's U vector 
      INTEGER  lo       !  Location of  U coord's in Y (and Glange)
      DOUBLE PRECISION  Glange(cL10) ! load vector for Langevin dynamics
      DOUBLE PRECISION  gamLng(cL10) 
      DOUBLE PRECISION  RF(cL10) 
      DOUBLE PRECISION  P(cL10) 


      DO iBod = 1,NB
         lo = LOCU(iBod)
         le = LENU(iBod)
         DO I = lo, (lo+le-1)
            Glange(I) = Glange(I) - (gamLng(I)*P(I)) + RF(I)
         ENDDO
      ENDDO
      
      END

