C $Header: /export/cvs/c34a1/source/moldyn/vcdint.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C ========================================================================
C
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER 
C STATE AND FEDERAL LAWS.  USE, DISCLOSURE, REPRODUCTION OR DUPLICATION 
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS 
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT 
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.

      SUBROUTINE vcdint(z1,z2,nvar,t1,t2,nstep,DERIVS,nbflag,prtflg)
C
C     PURPOSE: Integrator driver for Verlet central difference
C
C     INPUTS:  z1 contains the positions x(t1+dt) stored in z1(1:nvar) and 
C                 the positions x(t1) stored in z1(nvar+1:2*nvar)
C
C              z2 contains the positions x(t1-dt) stored in z2(1:nvar) and
C                 the velocities v(t1) stored in z2(nvar+1:2*nvar)
C
C     OUTPUTS:  z1 contains the positions x(t2+dt) stored in z1(1:nvar) and 
C                 the positions x(t2) stored in z1(nvar+1:2*nvar)
C
C              z2 contains the positions x(t1-dt) stored in z2(1:nvar) and
C                 the velocities v(t2) stored in z2(nvar+1:2*nvar)
C
C
      IMPLICIT NONE
C
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: vcdint.f,v $$Revision: 1.1.1.1 $'/
c
#include "PARAM.FOR"
c
#include "MDCON.INC"
#include "MISCN2.INC"
#include "MISCNO.INC"
#include "TIMESS.INC"
#include "HEAPMB.INC"
#include "MOMENG.INC"
C
#include "CHARMM.INC"
C
C     Argument List
C
      LOGICAL          nbflag, prtflg !  Nonbond pairlist & print flags
      INTEGER          nvar           !  Number of state variables
      INTEGER          nstep          !  Number of steps to take
      DOUBLE PRECISION t1, t2         !  Start and end times
      DOUBLE PRECISION z1(2*nvar)     !  See comments above
      DOUBLE PRECISION z2(2*nvar)     !  See comments above
      EXTERNAL DERIVS                 !  Subroutine for derivative calc.
c
c     Local variables
c
      INTEGER i                 !  Do loop index
      Double PRECISION h        !  Time step
c
      t = t1
      h = (t2-t1) / DBLE(nstep)
      DO i = 1, nstep-1
        t = t + h
        CALL verlcd(z1,z1(nvar+1),z2,z2(nvar+1),nvar,t,h,DERIVS,
     &              HEAP_MB(ipptr),LocalHeap(iaccptr_verlcd))
      END DO
c
c     Final Step
c
#ifdef CHARMM
      if (vlflag) ivprt = 1
#endif
      if (nbflag) ntnb  = 1
      if (prtflg) iprnt = noprnt
      if (long1)  long2 = .TRUE.
      t = t + h
      CALL verlcd(z1,z1(nvar+1),z2,z2(nvar+1),nvar,t,h,DERIVS,
     &            HEAP_MB(ipptr),LocalHeap(iaccptr_verlcd))
      ntnb  = 0
      iprnt = 0
      long2 = .FALSE.
#ifdef CHARMM
      ivprt = 0
#endif
c
      RETURN
      END
