C $Header: /export/cvs/c34a1/source/moldyn/vvint.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C ========================================================================
C
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER 
C STATE AND FEDERAL LAWS.  USE, DISCLOSURE, REPRODUCTION OR DUPLICATION 
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS 
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT 
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C
      SUBROUTINE vvint(x,dx,d2x,nvar,t1,t2,nstep,DERIVS,nbflag,prtflg)
C
      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: vvint.f,v $$Revision: 1.1.1.1 $'/
c
#include "PARAM.FOR"
#include "MDCON.INC"
#include "MISCN2.INC"
#include "MISCNO.INC"
#include "MOMENG.INC"
#include "MULTIPOLE.INC"
#include "TIMESS.INC"
#include "HEAPMB.INC"
C
#ifdef CHARMM
#include "CHARMM.INC"
#endif
C
C     Argument List
C
      LOGICAL          nbflag, prtflg !  Nonbond pairlist & print flags
      INTEGER          nvar           !  Number of state variables
      INTEGER          nstep          !  Number of steps to take
      DOUBLE PRECISION t1, t2         !  Start and end times
      DOUBLE PRECISION x(nvar)        !  Coordinates before & after integration
      DOUBLE PRECISION dx(nvar)       !  Velocities
      DOUBLE PRECISION d2x(nvar)      !  Accelerations
      EXTERNAL DERIVS                 !  Subroutine for derivative calc.
c
c     Local variables
c
      INTEGER i                 !  Do loop index
      Double PRECISION h        !  Time step
c
      t = t1
      h = (t2-t1) / DBLE(nstep)
      DO i = 1, nstep-1
        t = t + h
        CALL VEL_VERL(x,dx,d2x,nvar,t,h,DERIVS,d2x(nvar+1),
     &                 HEAP_MB(ipptr))
      END DO
c
c     Final step
c
#ifdef CHARMM
      if (vlflag) ivprt = 1
#endif
      IF (nbflag) ntnb  = 1
      IF (prtflg) iprnt = noprnt
      IF (long1)  long2 = .TRUE.
      t = t + h
      CALL VEL_VERL(x,dx,d2x,nvar,t,h,DERIVS,d2x(nvar+1),
     *              HEAP_MB(ipptr))
      ntnb  = 0
      iprnt = 0
      long2 = .FALSE.
#ifdef CHARMM
      ivprt = 0
#endif
c
      RETURN
      END
