C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE BROYDEN(NITER,ALPHA,JTOP,VECIN,VECOUT)
       IMPLICIT REAL*8 (A-H,O-Z)
       INCLUDE 'maxima.inc'
C
C************************************************************
C*  THE VECTORS UI(MAXSIZ) AND VTI(MAXSIZ) ARE JOHNSON'S    *
C*  U(OF I ) AND DF(TRANSPOSE), RESPECTIVELY. THESE ARE     *
C*  CONTINUALLY UPDATED. ALL ITERATIONS ARE STORED ON TAPE  *
C*  32 . THIS IS DONE TO PREVENT THE PROHIBITIVE STORAGE    *
C*  COSTS ASSOCIATED WITH HOLDING ONTO THE ENTIRE JACOBIAN. *
C*  VECTOR TL IS THE VT OF EARLIER ITERATIONS. VECTOR F IS: *
C*  VECTOR(OUTPUT) - VECTOR(IN). VECTOR DF IS:  F(M+1)-F(M) *
C*  FINALLY,VECTOR DUMVI(MAXSIZ) IS THE PREDICTED VECTOR.   *
C*  ON RETURN, VECIN CONTAINS THE NEW TRIAL VECTOR.         *
C************************************************************
C*  FOR THE CRAY2-CIVIC ENVIRONMENT , FILES 32 AND 31       *
C*  SHOULD BE INTRODUCED IN THE LINK STATEMENT.             *
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      PARAMETER (ZERO=0.0D0,ONE=1.0D0,IMATSZ=200)
C
C ADDED PARAMETER MAXITER. POREZAG, MAY 1995
C
      PARAMETER(MAXITER=25)
C
c replaced writing to disk by storing values in
c arrays UNIT31, UNIT32  hajnal@scientist.com 2000-10-4
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C      CHARACTER*7 NAMES
C
C SCRATCH COMMON BLOCK FOR LOCAL VARIABLES
C
      DIMENSION VECIN(*),VECOUT(*)
      DIMENSION F(MAXSIZ),UI(MAXSIZ),VTI(MAXSIZ),T1(MAXSIZ),
     &          VECTOR(MAXSIZ,2),DUMVI(MAXSIZ),DF(MAXSIZ)
C      DIMENSION NAMES(3)
      DIMENSION A(IMATSZ,IMATSZ),B(IMATSZ,IMATSZ),CM(IMATSZ)
      DIMENSION D(IMATSZ,IMATSZ),W(IMATSZ)
      DIMENSION UNIT31(MAXSIZ,2),UNIT32(MAXSIZ,2,MAXITER)
C      DATA NAMES/'BROYD01','BROYD02','BROYD03'/
      REAL*8 UAMIX
      INTEGER ILASTIT
      SAVE
C
C     PRINT *,'IN MIXING, WHERE ARE YOU?'
C
C NEW LINES JULY 1996
C
      IF (JTOP .GT. MAXSIZ) THEN
       PRINT *,'BROYDEN: JTOP > MAXSIZ'
       STOP
      END IF
C
C NEW LINES POREZAG, MAY 1995
C
      ITER=NITER
      IF(NITER.GT.MAXITER)ITER=MOD(ITER,MAXITER)+1
      IF(ITER.EQ.0)RETURN
C
C END NEW LINES
C
C      OPEN(66,FILE=NAMES(1),STATUS='UNKNOWN',FORM='FORMATTED')
C      REWIND(66)
C      OPEN(31,FILE=NAMES(2),STATUS='UNKNOWN',FORM='UNFORMATTED')
C      OPEN(32,FILE=NAMES(3),STATUS='UNKNOWN',FORM='UNFORMATTED')
C      REWIND(31)
C      REWIND(32)

C      IF(ITER.EQ.1)THEN
C       ENDFILE 31
C       ENDFILE 32
C      END IF
C
C
C++++++ SET UP THE VECTOR OF THE CURRENT ITERATION FOR MIXING ++++++
C
C  FOR THIS METHOD WE HAVE ONLY SAVED INPUT/OUTPUT CHG. DENSITIES,
      DO 38  K=1,JTOP
      VECTOR(K,1)= VECIN(K)
   38 VECTOR(K,2)= VECOUT(K)
C++++++ END OF PROGRAM SPECIFIC LOADING OF VECTOR FROM MAIN ++++++++
C
C  IVSIZ IS THE LENGTH OF THE VECTOR
      IVSIZ=JTOP
C     IF(ITER.LT.3)WRITE( 6,1001)IVSIZ
      IF(IVSIZ.GT.MAXSIZ)THEN
       PRINT *,'MIXING: EXCEEDED MAXIMAL VECTOR LENGTH'
       STOP
      END IF
C
C
C*******************  BEGIN BROYDEN'S METHOD  **********************
C
C  WEIGHTING FACTOR FOR THE ZEROTH ITERATION
      W0=0.01D0
C
C      F:  THE DIFFERENCE OF PREVIOUS OUTPUT AND INPUT VECTORS
C  DUMVI:  A DUMMY VECTOR, HERE IT IS THE PREVIOUS INPUT VECTOR
C      REWIND(31)
C      READ(31,END=119,ERR=119)AMIX,LASTIT
      IF (ITER .EQ. 1) THEN
        GOTO 119
      ELSE
        AMIX=UAMIX
        LASTIT=ILASTIT
      END IF
C      READ(31)(F(K),K=1,IVSIZ)
      DO k=1,IVSIZ
        F(k)=UNIT31(K,1)
      END DO
C      READ(31)(DUMVI(K),K=1,IVSIZ)
      DO k=1,IVSIZ
        DUMVI(k)=UNIT31(K,2)
      END DO
C      IF(ITER.EQ.1 .AND. LASTIT.GT.1)THEN
C      READ(31)LTMP,((A(I,J),I=1,LTMP),J=1,LTMP)
C      READ(31)(W(I),I=1,LTMP)
C      ENDIF
C
C  ALPHA(OR AMIX)IS SIMPLE MIXING PARAMETERS
C      WRITE(66,1002)AMIX,ITER+1
C
      DO 104 K=1,IVSIZ
      DUMVI(K)=VECTOR(K,1)-DUMVI(K)
  104 DF(K)=VECTOR(K,2)-VECTOR(K,1)-F(K)
      DO 114 K=1,IVSIZ
  114 F(K)=VECTOR(K,2)-VECTOR(K,1)
C
C  FOR I-TH ITER.,DFNORM IS ( F(I) MINUS F(I-1) ), USED FOR NORMALIZATION
C
      DFNORM=ZERO
      FNORM=ZERO
      DO 113 K=1,IVSIZ
      DFNORM=DFNORM + DF(K)*DF(K)
  113 FNORM=FNORM + F(K)*F(K)
      DFNORM=SQRT(DFNORM)
      FNORM=SQRT(FNORM)
C      WRITE(66,'(''  DFNORM '',E12.6,'' FNORM '',E12.6)')DFNORM,FNORM
C
      FAC2=ONE/DFNORM
      FAC1=AMIX*FAC2
C
      DO 105 K=1,IVSIZ
      UI(K) = FAC1*DF(K) + FAC2*DUMVI(K)
 105  VTI(K)= FAC2*DF(K)
C
C*********** CALCULATION OF COEFFICIENT MATRICES *************
C***********    AND THE SUM FOR CORRECTIONS      *************
C
C RECALL: A(I,J) IS A SYMMETRIC MATRIX
C       : B(I,J) IS THE INVERSE OF [ W0**2 I + A ]
C
         LASTIT=LASTIT+1
         LASTM1=LASTIT-1
         LASTM2=LASTIT-2
C
C DUMVI IS THE U(OF I) AND T1 IS THE VT(OF I)
C FROM THE PREVIOUS ITERATIONS
C      REWIND(32)
C      WRITE(66,1003)LASTIT,LASTM1
      IF(LASTIT.GT.2)THEN
      DO 500 J=1,LASTM2
C      READ(32)(DUMVI(K),K=1,IVSIZ)
      DO k=1,IVSIZ
       DUMVI(k)=UNIT32(k,1,J)
      END DO
C      READ(32)(T1(K),K=1,IVSIZ)
      DO k=1,IVSIZ
       T1(k)=UNIT32(k,2,J)
      END DO
C
      AIJ=ZERO
      CMJ=ZERO
      DO 501 K=1,IVSIZ
      CMJ=CMJ + T1(K)*F(K)
  501 AIJ=AIJ + T1(K)*VTI(K)
      A(LASTM1,J)=AIJ
      A(J,LASTM1)=AIJ
            CM(J)=CMJ
  500 CONTINUE
      ENDIF
C
      AIJ=ZERO
      CMJ=ZERO
      DO 106 K=1,IVSIZ
      CMJ= CMJ + VTI(K)*F(K)
  106 AIJ= AIJ + VTI(K)*VTI(K)
      A(LASTM1,LASTM1)=AIJ
            CM(LASTM1)=CMJ
C
C      WRITE(32)(UI(K),K=1,IVSIZ)
      DO k=1,IVSIZ
       UNIT32(k,1,LASTM1)=UI(k)
      END DO
C      WRITE(32)(VTI(K),K=1,IVSIZ)
      DO k=1,IVSIZ
       UNIT32(k,2,LASTM1)=VTI(k)
      END DO
C      REWIND(32)
C
C THE WEIGHTING FACTORS FOR EACH ITERATION HAVE BEEN CHOSEN
C EQUAL TO ONE OVER THE R.M.S. ERROR. THIS NEED NOT BE THE CASE.
       IF(FNORM .GT. 1.0D-7)THEN
       WTMP=0.010D0/FNORM
       ELSE
       WTMP=1.0D5
       END IF
       IF(WTMP.LT. 1.00D0)WTMP=1.00D0
       W(LASTM1)=WTMP
C       WRITE(66,'(''  WEIGHTING SET =  '',E12.6)')WTMP
C
C
C WITH THE CURRENT ITERATIONS F AND VECTOR CALCULATED,
C WRITE THEM TO UNIT 31 FOR USE LATER.
C      REWIND(31)
C      WRITE(31)AMIX,LASTIT
      UAMIX=AMIX
      ILASTIT=LASTIT
C      WRITE(31)(F(K),K=1,IVSIZ)
      DO k=1,IVSIZ
        UNIT31(K,1)=F(k)
      END DO
C      WRITE(31)(VECTOR(K,1),K=1,IVSIZ)
      DO k=1,IVSIZ
        UNIT31(K,2)=VECTOR(K,1)
      END DO
C      WRITE(31)LASTM1,((A(I,J),I=1,LASTM1),J=1,LASTM1)
C      WRITE(31)(W(I),I=1,LASTM1)
C
C SET UP AND CALCULATE BETA MATRIX
      DO 506 LM=1,LASTM1
      DO 507 LN=1,LASTM1
         D(LN,LM)= A(LN,LM)*W(LN)*W(LM)
 507     B(LN,LM)= ZERO
         B(LM,LM)= ONE
 506     D(LM,LM)= W0**2 + A(LM,LM)*W(LM)*W(LM)
C
      CALL INVERSE(D,B,LASTM1)
C
C  CALCULATE THE VECTOR FOR THE NEW ITERATION
      DO 505 K=1,IVSIZ
  505 DUMVI(K)= VECTOR(K,1) + AMIX*F(K)
C
      DO 504 I=1,LASTM1
C      READ(32)(UI(K),K=1,IVSIZ)
      DO k=1,IVSIZ
       UI(k)=UNIT32(k,1,I)
      END DO
C      READ(32)(VTI(K),K=1,IVSIZ)
      DO k=1,IVSIZ
       VTI(k)=UNIT32(k,2,I)
      END DO
      GMI=ZERO
      DO 503 IP=1,LASTM1
  503 GMI=GMI + CM(IP)*B(IP,I)*W(IP)
      DO 504 K=1,IVSIZ
  504 DUMVI(K)=DUMVI(K)-GMI*UI(K)*W(I)
C  END OF THE CALCULATION OF DUMVI, THE NEW VECTOR
C
C      REWIND(31)
C      REWIND(32)
C
      GOTO 120
C IF THIS IS THE FIRST ITERATION, THEN LOAD
C    F=VECTOR(OUT)-VECTOR(IN) AND VECTOR(IN)
  119 CONTINUE
C     PRINT*,'SIMPLE MIXING THIS ITERATION'
C      REWIND(31)
      LASTIT=1
      AMIX=ALPHA
C      WRITE(31)AMIX,LASTIT
      UAMIX=AMIX
      ILASTIT=LASTIT
      DO 101 K=1,IVSIZ
  101 F(K)=VECTOR(K,2)-VECTOR(K,1)
C      WRITE(31)(F(K),K=1,IVSIZ)
      DO k=1,IVSIZ
        UNIT31(K,1)=F(k)
      END DO
C      WRITE(31)(VECTOR(K,1),K=1,IVSIZ)
      DO k=1,IVSIZ
        UNIT31(K,2)=VECTOR(K,1)
      END DO
C
C SINCE WE ARE ON THE FIRST ITERATION, SIMPLE MIX THE VECTOR.
      DO 102 K=1,IVSIZ
  102 DUMVI(K)= VECTOR(K,1) + AMIX*F(K)
C     WRITE( 6,1000)
  120 CONTINUE
C
C      CLOSE(31,STATUS='KEEP')
C      CLOSE(32,STATUS='KEEP')
C
C*************  THE END OF THE BROYDEN METHOD **************
C
C+++++++ PROGRAM SPECIFIC CODE OF RELOADING ARRAYS +++++++++
C
C NEED TO UNLOAD THE NEW VECTOR INTO THE APPROPRIATE ARRAYS.
      DO 606 K=1,JTOP
      VECIN(K)=DUMVI(K)
 606  CONTINUE
C
C+++++++++ END OF PROGRAM SPECIFIC RELOADING OF ARRAYS +++++++++
C
C      WRITE(66,1004)ITER+1
C      CLOSE(66)
      RETURN
C
 1000 FORMAT(' ---->  STRAIGHT MIXING ON THIS ITERATION')
 1001 FORMAT(' IN MIXING:   IVSIZ =',I7,/)
 1002 FORMAT(' IN MIXING: SIMPLE MIX PARAMETER',1(F10.6,',')
     >      ,'  FOR ITER=',I5)
 1003 FORMAT(' CURRENT ITER= ',I5,' INCLUDES VALUES FROM ITER=',I5)
 1004 FORMAT(10X,'DENSITY FOR ITERATION',I4,' PREPARED')
      END
C
C     CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE INVERSE(A,B,M)
      IMPLICIT REAL*8 (A-H,O-Z)
C     =============================================================
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      PARAMETER (IMATSZ=200)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      DIMENSION A(IMATSZ,IMATSZ),B(IMATSZ,IMATSZ)
      DIMENSION TD(IMATSZ),AD(IMATSZ),BD(IMATSZ)
      SAVE
C
C SUBROUTINE TO PREFORM GAUSSIAN ELIMINATION
C            NO ZEROS ALONG THE DIAGONAL
C
      N=M
      IF(N.GT.IMATSZ)THEN
       PRINT *,'INVERT: MATRIX A TOO LARGE'
       STOP
      END IF
C
      DO 14 I=1,N
      ATMP=A(I,I)
      IF(ABS(ATMP) .LT. 1.0D-08)THEN
C        WRITE(66,'('' INVERT: MATRIX HAS ZERO DIAGONAL'',
C     &            '' ELEMENT IN THE '',I4,'' ROW'')')I
        STOP
      ENDIF
  14  CONTINUE
C
      IF(N.EQ.1) GO TO 605
C
      DO 23 I=1,N
C
      DO 35 J=1,N
 35      TD(J)=A(J,I)/A(I,I)
C
C     TD(I)=(0.0E+00,0.0E+00)
      TD(I)=0.0D0
C
      DO 71 K=1,N
         BD(K)=B(I,K)
 71      AD(K)=A(I,K)
C
      DO 601 K=1,N
      DO 601 J=1,N
         B(J,K)=B(J,K)-(TD(J)*BD(K))
 601     A(J,K)=A(J,K)-(TD(J)*AD(K))
C
 23   CONTINUE
C
      DO 603 I=1,N
      DO 603 J=1,N
 603     B(J,I)=B(J,I)/A(J,J)
C
      RETURN
C
 605  B(1,1)=1.0D0/A(1,1)
      RETURN
      END
C

