       subroutine externalshift(nn,x,izp,shiftE,qsccewc,qsccews)
       implicit REAL*8 (A-H,O-Z)
       include 'maxima.inc'
       integer n,nE,izp(NNDIM)
       real*8 x(3,NNDIM)
       integer MXCHMPT
       parameter(MXCHMPT=25120)
       real*8 xE(3,MXCHMPT),ZE(MXCHMPT)
       real*8 shiftE(NNDIM),dif(3),r,r2
       real*8 qsccewc(*),qsccews(*)
       character*2 EXT
       common /mcharge/ qzeroscc(MAXTYP), uhubb(MAXTYP)
       common /extchr/ xE, ZE, nE, EXT
C     --------------------------------------------------------------
       integer MAXPTR
       parameter(MAXPTR=5000)
       REAL*8 CPTR,ZPTR
       INTEGER NPTR
       INTEGER IMM2LST 
       COMMON/EXTCH2/CPTR(3,MAXPTR),ZPTR(MAXPTR),NPTR,IMM2LST(MAXPTR)
C      REAL*8 DXTBM2,DYTBM2,DZTBM2
C      COMMON/CHRMTB/DXTBM2(MAXPTR),DYTBM2(MAXPTR),DZTBM2(MAXPTR)
C     ----------------------------------------------------------------
C      SCC Nonbond
       real*8  sccfnb
       logical qsccnb,qsccs,qsccsh
       common /scccut/qsccnb,sccfnb,qsccs,qsccsh
C      --------------------------------------------------------------
c      QC_UW04: Add ewald potential if periodic
       logical period
       common /box/ boxsiz(3,3), xinvbox(3,3), xnullvec(3), period, 
     $              nlat(3)     
       REAL*8 recbasis(3,3), vol
C      If choose to optimize para
       logical LSCOEWD 
       real*8 kappascc
       integer kmxscc,ksqmxscc
       common /sccewd/ kappascc,kmxscc,ksqmxscc,LSCOEWD
C      --------------------------------------------------------------
       real*8 sccftmp
       sccftmp=sccfnb/0.529177249d0

       if (EXT.eq.'CH') then
        if (period) then
c         get reciprocal lattice vectors and cell volume
          CALL REZVOL(boxsiz,recbasis,vol)

c         choose good convergence parameter alpha(another option is to
C         use the alpha provided by CHARMM)
          alpha = getalpha(boxsiz)

        if (LSCOEWD) then
C       ============== Ewald potential from all MM atoms =============  
C       ...... Optimize everything, iterate ......
        do j=1,nn 
        shiftE(j) = 0.0
        do k=1,nE
          r2=0.0
          do i=1,3 
            dif(i) = x(i,j) - xE(i,k)
            r2=r2 + dif(i)**2
          enddo 
c         set tolerance for convergence
          tol = 1.0d-8
C         in principle can use phi!!!          
          call phi(dif,boxsiz,recbasis,alpha,vol,tol,phivalue)
          shiftE(j) = shiftE(j) + phivalue*ZE(k)
        enddo !k
        enddo !j

        else
C       --------------------------------------------------------------
        if (.not.qsccnb) then
C       ...... Use input parameters for ewald, but enforce real space
C       ...... convergence 
          do j=1,nn 
          shiftE(j) = 0.0
CQ06      do k=1,nE
CQ06        r2=0.0
CQ06        do i=1,3 
CQ06          dif(i) = x(i,j) - xE(i,k)
CQ06          r2=r2 + dif(i)**2
CQ06        enddo 

c         set tolerance for convergence
            tol = 1.0d-8
CQ06        call phiscc(dif,boxsiz,recbasis,alpha,vol,tol,phivalue)
            call phiscc(x(1,j),boxsiz,recbasis,alpha,vol,tol,
     $                  xE,nE,ZE,qsccewc,qsccews,phivalue)
CQ06        shiftE(j) = shiftE(j) + phivalue*ZE(k)
            shiftE(j) = phivalue
CQ06      enddo !k
          enddo !j
C       --------------------------------------------------------------
        else
C         ...... do reciprocal space for ALL pt charges ......
C         ...... UW04_06: First pre-assemble terms related to 
C         ...... MM point charges ......
           

          do j=1,nn 
          shiftE(j) = 0.0
CQ06      do k=1,nE
CQ06        r2=0.0
CQ06        do i=1,3 
CQ06          dif(i) = x(i,j) - xE(i,k)
CQ06        enddo 
CQ06        call phiscc2a(dif,recbasis,alpha,vol,phivalue)
CQ06        shiftE(j) = shiftE(j) + phivalue*ZE(k)
CQ06      enddo !k

            call phiscc2a(x(1,j),recbasis,alpha,vol,nE,zE,
     $                    qsccewc,qsccews,phivalue)
            shiftE(j) = phivalue
          enddo !j
C         ..... then do the real space sum over only those within
C         ..... minimum image < sccfnb ......
C         DEBUG DEBUG
C         goto 700
          do j=1,nn 
          do k=1,NPTR
            r2=0.0
            do i=1,3 
              dif(i) = x(i,j) - CPTR(i,k)
              r2=r2 + dif(i)**2
            enddo 
            gamma =  sqrt(r2)
            if (gamma.le.sccftmp) 
     $      shiftE(j) = shiftE(j) + terfc(alpha*gamma)*ZPTR(k)/gamma
          enddo !k
          enddo !j
  700   CONTINUE 
        endif ! for nonbond cut in eWald

        endif ! for eWALD
C       ============== Normal case (No PBC) ================= 
        else
        do j=1,nn 
        shiftE(j) = 0.0
        do k=1,nE
          r2=0.0
          do i=1,3 
            dif(i) = x(i,j) - xE(i,k)
            r2=r2 + dif(i)**2
          enddo 
          gamma =  1.0/sqrt(r2)
C         shiftE(j) = shiftE(j) + gamma*ZE(k)
         shiftE(j) = shiftE(j) + gamma*ZE(k)*sccg(r2)
        enddo !k
        enddo !j

        endif ! for period
       endif ! for CHARMM

c end CH!, now field EF
       if (EXT.eq.'EF') then
       do i=1,nn
        shiftE(i) = 0.0
        do j=1,3
         shiftE(i) = shiftE(i) + ZE(j)*(x(j,i)-xE(1,j))
        enddo 
c 2* shiftE, da der gleiche Vekrtor wie fuer CH genommen.
c der wird bei Addition of shift halbiert, was
c im Falle des Feldes nicht noetig ist
         shiftE(i) =2*shiftE(i) 
       enddo
       endif 
      end
