C $Header: /export/cvs/c34a1/source/moldyn/BHBSRD.INC,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C     
C     ibhptr is sized max # of frames (2*NH - 1).  
C            It stores the pointer to the beginning
C            of each stored section in BH.  Elements are 0 if nothing is
C            stored
C     ibhtype is sized NH.  It is a code for what 
C            is stored in BH for later ease in manipulation.
c            (codes described below)
C
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
C     *    =  calculated in bhgenr and stored in BH
c
c  Constant parts:
c       -1
c     pi   =  pin(1,1,ihinge)   
c       -1
c     C2   =  rh(1,1,lr4)
c
c     R0L  =  R0L(1,1,nobq)
c
c     Rpq  =  rh(1,1,lr5)
c
c     hp   =  hats
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c   For the first hinge:
c   IF it is a particle, IBHTYPE(1) = 1 (treated as a q-frame)
c
c   IF it is a body,     IBHTYPE(1) = 0
c            -------------
c            |   -1|     |
c     bh(1)= | pi  |  0  |
c            -------------
c            |     |     |
c            |  0  | r0l |
c            -------------
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c   For both P and Q frames on particles:
c
c IBHTYPE(IHINGE) = 1
c     IF (NOT FBL)    bh(q) =  I (3x3)      bh(p) = -I (3x3)
C
C IBHTYPE(IHINGE) = 2
c     IF (FBL) THEN
c          --------                  --------
c          |   -1 |  (3x3)           |   -1 |   (3x3)
c   bh(q)= |  C2  |           bh(p)= | -C2  |   
c          --------                  --------   
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c   For P-frame a particle and Q-frame a body:
C
c IBHTYPE(IHINGE) = 3
c     IF (NOT FBL) THEN
c        IF Q-frame body is inboard BH(q) is 3x(6+NM).  
c             ---------------------------------              -------
c             |     |     |                   |              |     |
c      bh(q)= |  *  | R0L |        *          |       bh(p)= | -I  |         
c             ---------------------------------              -------
c
c IBHTYPE(IHINGE) = 4
c        IF Q-frame body is outboard BH(q) is 6x(6+NM).  
c             ---------------------------------              -------
c             |   -1|    |                    |              |     |
c      bh(q)= | pi  | 0  |  0                 |              |  0  |
c             ---------------------------------              -------
c             |     |    |                    |       bh(p)= |     |
c             |  *  | R0L|          *         |              | -I  |
c             ---------------------------------              -------
C
C IBHTYPE(IHINGE) = 5
c     IF (FBL) THEN
c        IF Q-frame body is inboard BH(q) is 3x(6+NM).  
c             ---------------------------------              -------       
c             |     |     |                   |              |  -1 |
c      bh(q)= |  *  |  *  |        *          |      bh(p)=  | C2  | 
c             ---------------------------------              -------       
C
c IBHTYPE(IHINGE) = 6
c        IF Q-frame body is outboard BH(q) is 6x(6+NM).  
c             ---------------------------------              -------
c             |   -1|   |                     |              |     |
c      bh(q)= | pi  | 0 |   0                 |              |  0  |
c             ---------------------------------              -------
c             |     |   |                     |       bh(p)= |  -1 |
c             |  *  | * |           *         |              | C2  |
c             ---------------------------------              -------
c
c            
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c    For both Q-frame and P-frame bodies:
C
C IBHTYPE(IHINGE) = 7
c       IF (NOT FBL) THEN
c             ---------------------------        ----------------------------
c             |   -1|    |              |        |   |    |                 |
c      bh(q)= | pi  | 0  |  0           |  bh(p)=| * | 0  |   0             |  
c             ---------------------------        ----------------------------
c             |     |    |              |        |   |    |                 |
c             |  *  | R* |  *           |        | * | -I |  -hp            |
c             ---------------------------        ----------------------------
c             R* = Rpq if NM = 0
c                = R0L if NM > 0
C
C IBHTYPE(IHINGE) = 8
c       IF (FBL) THEN
c             ---------------------------        ----------------------------
c             |   -1|   |               |        |   |    |                 |
c      bh(q)= | pi  | 0 |   0           |  bh(p)=| * | 0  |    0            |
c             ---------------------------        ----------------------------
c             |     |   |               |        |   |  -1|                 |
c             |  *  | * |   *           |        | * | C2 |    *            |
c             ---------------------------        ----------------------------
c
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C 
C
	DOUBLE PRECISION  
C      BH(3*L02*(mxprtl+2*(maxbod+mxloop))),
     &     R0L(3, 3, L01), D0L(3, L01)
c	INTEGER ibh_ptr(L12+1), ibhtype(L02)
        INTEGER iibhtypeptr, iibh_ptrptr
              COMMON /BHBSRD/
     &  R0L, D0L,iibhtypeptr,iibh_ptrptr
 
      CHARACTER*128  BHBSRD_RCSID
      DATA           BHBSRD_RCSID
     &/'$RCSfile: BHBSRD.INC,v $$Revision: 1.1.1.1 $'/




