C $Header: /export/cvs/c34a1/source/moldyn/bdotqp.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
C

      SUBROUTINE BDOTQP (L,BDTQ,BDTP,BHQ,BHP,HATSQ,HATSP)
c
c     Subroutine added to pass Y, HEAP_MB(iyptr), and YDT, 
c     HEAP_MB(iydtptr).  Original routine changed to 
c     BDOTQP_1 

      IMPLICIT NONE

#include "PARAM.FOR"
c
#include "BHBSRD.INC"
#include "ERRHDL.INC"
#include "HANDS2.INC"
#include "MAXMUM.INC"
#include "NUMBRS.INC"
#include "PARTCL.INC"
#include "PINRP.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
#include "VECTOR.INC"
#include "HEAPMB.INC"
c
C     Passed Variables
C
      INTEGER L
      DOUBLE PRECISION BDTQ(6,*),BDTP(6,*)
      DOUBLE PRECISION BHQ(3,*), BHP(3,*)
      DOUBLE PRECISION HATSQ(3,*),HATSP(3,*)
c
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: bdotqp.f,v $$Revision: 1.1.1.1 $'/

      CALL BDOTQP_1(L,BDTQ,BDTP,BHQ,BHP,HATSQ,HATSP,
     & 	  	     HEAP_MB(iyptr),HEAP_MB(iydtptr),
     &               intLoopHeap(iihpvtptr),LoopHeap(ipinptr),
     &               LoopHeap(irp2ptr),LoopHeap(irp3ptr),
     &               LoopHeap(ibetahptr),LoopHeap(ibetahdptr),
     &               intLoopHeap(iitopolptr),intLoopHeap(iihdataptr),
     &               Loopheap(irhptr),Loopheap(idhptr))

      RETURN
c
      END

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      SUBROUTINE BDOTQP_1(L,BDTQ,BDTP,BHQ,BHP,HATSQ,HATSP,Y,YDT,
     &           IHPVT,PIN,RP2,RP3,BETAH,BETAHD,ITOPOL,IHDATA,RH,
     &           DH)
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
CSE
C                                                          DEBUG #  51
CPS       PURPOSE:
C
C                  TO OBTAIN THE TIME DERIVATIVES OF THE KINEMATIC
C                  COEFFICIENTS. TO COMPUTE THE LOWER CASE B DOT MATRIX
C                  IN EQUATION II-6. SEE ALSO IN VOL 1, APPENDIX C AND
C                  PAGES 36-38 FOR SUPPORTING THEORY.
C
C                  CORRECTION ADDED TO ACCOUNT FOR MOTION OF Q-FRAME
C                  ORIGIN RELATIVE TO P-FRAME.
C
C                  EXIT WITH ASSOCIATED MATRICES FOR BODY L.
C
CPE
      IMPLICIT NONE
 
C
#include "PARAM.FOR"
C
C
C        GET LOWER CASE B DOT MATRIX CALLED FOR IN EQ. II-6
C        REFER TO APPENDIX C VOL I FOR THEORY ALSO PAGES 36-38
C        EXIT WITH THE B DOT MATRIX TO BE USED IN EQ. II-6 ASSOCIATED
C        WITH BODY L
C
C
#include "BHBSRD.INC"
#include "ERRHDL.INC"
#include "HANDS2.INC"
#include "MAXMUM.INC"
#include "NUMBRS.INC"
#include "PARTCL.INC"
#include "PINRP.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
#include "VECTOR.INC"
#include "HEAPMB.INC"
C     
c
C     External Variables
C
C     Passed Variables
C
      INTEGER L
      INTEGER IHPVT(cL02)
      INTEGER ITOPOL(2,cL02)
      INTEGER IHDATA(7,cL02)
      DOUBLE PRECISION BDTQ(6,*),BDTP(6,*)
      DOUBLE PRECISION BHQ(3,*), BHP(3,*)
      DOUBLE PRECISION HATSQ(3,*),HATSP(3,*)
      DOUBLE PRECISION Y(cL07), YDT(cL07)
      DOUBLE PRECISION PIN(3,3,cL02)
      DOUBLE PRECISION RP2(3,3,cl02)
      DOUBLE PRECISION RP3(3,3,cl02)
      DOUBLE PRECISION BETAH(6,cL02)
      DOUBLE PRECISION BETAHD(6,cL02)
      DOUBLE PRECISION RH(3,3,cL15)
      DOUBLE PRECISION DH(3,cL16)

C
C     Local Variables
C
      INTEGER NOBQ,NOBP,NDOF,NP6,NQ6,NCL
      INTEGER I1,I2,I3,IQ,IP
      INTEGER K1,K2,K3
      INTEGER LR2,LR4,LP
      INTEGER LOQ,LOP,LEQ,LEP,LQ,LD3
      INTEGER LRPQ,LDNQ,LDMP,LRMP
      INTEGER I,J
      DOUBLE PRECISION B2DT,B3DT,BLEN,BLDOT,GDOT,TDOT
      DOUBLE PRECISION CTHET,CGAMA,STHET,SGAMA
      DOUBLE PRECISION SUM
      DOUBLE PRECISION PINDT(3,3),HXDQN(3),HXDPM(3),RQP(3,3)
      DOUBLE PRECISION DRQP(3,3)
      DOUBLE PRECISION SNQ(3,3),SMP(3,3),WQN(3),WPM(3)
      DOUBLE PRECISION WSK(3,3),C2NVDT(3,3), C2DOT(3,3)
      DOUBLE PRECISION VQP(3),W1(3,3),W2(3,3)
C
#include "LDEBUG.INC"
      LOGICAL LEQU
      EQUIVALENCE (LEQU,DEBUG(51))
c
      IF(LEQU) WRITE (MBOUT,1000)
 1000 FORMAT (' SUBROUTINE BDOTQP ')
C
      NOBQ = ITOPOL(1,L)
      NOBP = ITOPOL(2,L)
c
      i1 = BADADDR
      i2 = BADADDR
      i3 = BADADDR
      if (ihdata(1,L) .eq. 0) then       ! No hinge rotational DOFs
         i1 = 1
         i2 = 2
         i3 = 3
         ndof = 3
      else                               ! Hinge rotational DOFs exist
         if (nobp .GT. nbdy) then        ! Body P is a particle
            i1 = 4
            i2 = 5
            i3 = 6
         end if
         ndof = 6
      end if
c
c     Zero out the BDTQ output matrix
c
      do j = 1, lenu(nobq)
         do i = 1, ndof
            bdtq(i,j) = 0d0
         end do
      end do
c
      if (ihdata(1,L) .ne. 0) then
c
CC  GET D/DT(PI(INVERSE))
C                       o -1
C           PINDT  =  [PI]
c
         B2DT = BETAHD(2,L)
         B3DT = BETAHD(3,L)
         DO 5 I=1,3
         DO 5 J=1,3
            PINDT(I,J) = B2DT*RP2(I,J,L) + B3DT*RP3(I,J,L)
 5       continue
c
c     Form the rotational part of BDTQ
c
         bdtq(1,1) = pindt(1,1)
         bdtq(2,1) = pindt(2,1)
         bdtq(3,1) = pindt(3,1)
         bdtq(1,2) = pindt(1,2)
         bdtq(2,2) = pindt(2,2)
         bdtq(3,2) = pindt(3,2)
         bdtq(1,3) = pindt(1,3)
         bdtq(2,3) = pindt(2,3)
         bdtq(3,3) = pindt(3,3)
      end if
c
      IF (L .EQ. 1) GO TO 100
c
c     Zero out the BDTP output matrix
c
      do j = 1, lenu(nobp)
         do i = 1, ndof
            bdtp(i,j) = 0d0
         end do
      end do
C
C     Compute C2 inverse for pivoting hinges
C
      IF (IHPVT(L) .NE. 0) THEN
         IF (IHPVT(L) .EQ. 1) THEN
            k1 = 1
            k2 = 2
            k3 = 3
         ELSE IF (IHPVT(L) .EQ. 2) THEN
            k1 = 2
            k2 = 3
            k3 = 1
         ELSE
            k1 = BADADDR
            k2 = BADADDR
            k3 = BADADDR
            WRITE(ERRMSG,'(a)') 'k1,k2,k3 not initialized'
            CALL ERRHDL(-5,'<BDOTQP>')
         END IF
         BLEN  = BETAH(4,L)
         BLDOT = BETAHD(4,L)
C
         TDOT  = BETAHD(5,L)
         CTHET = COS(BETAH(5,L))
         STHET = SIN(BETAH(5,L))
C
         GDOT  = BETAHD(6,L)
         CGAMA = COS(BETAH(6,L))
         SGAMA = SIN(BETAH(6,L))
C     
         IF (nobp .GT. nbdy) THEN     ! Body P is a particle
            C2NVDT(1,K1) = - GDOT*SGAMA*CTHET - TDOT*CGAMA*STHET
            C2NVDT(1,K2) = - GDOT*SGAMA*STHET + TDOT*CGAMA*CTHET
            C2NVDT(1,K3) =   GDOT*CGAMA
C
            SUM = (BLDOT*CGAMA-BLEN*GDOT*SGAMA) / (BLEN*CGAMA)**2
            C2NVDT(2,K1) = - TDOT*CTHET/(BLEN*CGAMA) + STHET*SUM
            C2NVDT(2,K2) = - TDOT*STHET/(BLEN*CGAMA) - CTHET*SUM
            C2NVDT(2,K3) =   ZRO
C
            SUM = BLDOT / BLEN**2
            C2NVDT(3,K1) = (-GDOT*CGAMA*CTHET+TDOT*SGAMA*STHET)/BLEN
     .           + SUM*SGAMA*CTHET
            C2NVDT(3,K2) = (-GDOT*CGAMA*STHET-TDOT*SGAMA*CTHET)/BLEN
     .           + SUM*SGAMA*STHET
            C2NVDT(3,K3) = - GDOT*SGAMA/BLEN - SUM*CGAMA
C
         ELSE                          ! Body P is a body
C
            C2DOT(K1,1) = - GDOT*SGAMA*CTHET - TDOT*CGAMA*STHET
            C2DOT(K2,1) = - GDOT*SGAMA*STHET + TDOT*CGAMA*CTHET
            C2DOT(K3,1) =   GDOT*CGAMA
C
            C2DOT(K1,2) = - BLDOT*CGAMA*STHET + 
     .           BLEN*(GDOT*SGAMA*STHET-TDOT*CGAMA*CTHET)
            C2DOT(K2,2) =   BLDOT*CGAMA*CTHET -
     .           BLEN*(GDOT*SGAMA*CTHET+TDOT*CGAMA*STHET)
            C2DOT(K3,2) = 0D0
C
            C2DOT(K1,3) = - BLDOT*SGAMA*CTHET -
     .           BLEN*(GDOT*CGAMA*CTHET-TDOT*SGAMA*STHET)
            C2DOT(K2,3) = - BLDOT*SGAMA*STHET -
     .           BLEN*(GDOT*CGAMA*STHET+TDOT*SGAMA*CTHET)
            C2DOT(K3,3) =   BLDOT*CGAMA - BLEN*GDOT*SGAMA
         END IF
      END IF
C
C                           o  
C           HXDQN  =  [Hq]{XIn}
C                           o  
C           HXDPM  =  [Hp]{XIm}
C
      LOQ = LOCU(NOBQ) + 6
      LOP = LOCU(NOBP) + 6
      LEQ = IRGFLX(NOBQ)
      LEP = IRGFLX(NOBP)
      lq   = 2*L - 2

c
      if (nobq .GT. nbdy) then    !both objects are particles
         if (ihpvt(l) .eq. 0) return
C
         BDTQ(1,1) = C2NVDT(1,1)
         BDTQ(2,1) = C2NVDT(2,1)
         BDTQ(3,1) = C2NVDT(3,1)
         BDTQ(1,2) = C2NVDT(1,2)
         BDTQ(2,2) = C2NVDT(2,2)
         BDTQ(3,2) = C2NVDT(3,2)
         BDTQ(1,3) = C2NVDT(1,3)
         BDTQ(2,3) = C2NVDT(2,3)
         BDTQ(3,3) = C2NVDT(3,3)
C
         BDTP(1,1) = - C2NVDT(1,1)
         BDTP(2,1) = - C2NVDT(2,1)
         BDTP(3,1) = - C2NVDT(3,1)
         BDTP(1,2) = - C2NVDT(1,2)
         BDTP(2,2) = - C2NVDT(2,2)
         BDTP(3,2) = - C2NVDT(3,2)
         BDTP(1,3) = - C2NVDT(1,3)
         BDTP(2,3) = - C2NVDT(2,3)
         BDTP(3,3) = - C2NVDT(3,3)
         return
      end if
c
c     This section of code is executed when one object is a particle and the
c     other object is a rigid/flexible body.
c
      if (nobp .GT. nbdy) then          ! Body P is a particle
         if (ihpvt(L) .eq. 0) then      ! Free bond-length kinematics
            iq = locu(nobq)
            call skewv3(y(iq),w2,1,3)
CC@CC
CC@CC ......MULT3N r0l(1,1,nobq), w2, bdtq(i1,4)
CC@CC ......3, 3, 3
CC@CC ......3, 3, 6
            if (i1.eq.BADADDR) then
               WRITE(ERRMSG,'(a)') 'i1,i2,i3 not initialized'
               CALL ERRHDL(-5,'<BDOTQP>')
            endif
      bdtq(i1+0,4) = -r0l(1,1,nobq)*w2(1,1) - r0l(1,2,nobq)*w2(2,1) - r0
     .l(1,3,nobq)*w2(3,1)
      bdtq(i1+1,4) = -r0l(2,1,nobq)*w2(1,1) - r0l(2,2,nobq)*w2(2,1) - r0
     .l(2,3,nobq)*w2(3,1)
      bdtq(i1+2,4) = -r0l(3,1,nobq)*w2(1,1) - r0l(3,2,nobq)*w2(2,1) - r0
     .l(3,3,nobq)*w2(3,1)
      bdtq(i1+0,5) = -r0l(1,1,nobq)*w2(1,2) - r0l(1,2,nobq)*w2(2,2) - r0
     .l(1,3,nobq)*w2(3,2)
      bdtq(i1+1,5) = -r0l(2,1,nobq)*w2(1,2) - r0l(2,2,nobq)*w2(2,2) - r0
     .l(2,3,nobq)*w2(3,2)
      bdtq(i1+2,5) = -r0l(3,1,nobq)*w2(1,2) - r0l(3,2,nobq)*w2(2,2) - r0
     .l(3,3,nobq)*w2(3,2)
      bdtq(i1+0,6) = -r0l(1,1,nobq)*w2(1,3) - r0l(1,2,nobq)*w2(2,3) - r0
     .l(1,3,nobq)*w2(3,3)
      bdtq(i1+1,6) = -r0l(2,1,nobq)*w2(1,3) - r0l(2,2,nobq)*w2(2,3) - r0
     .l(2,3,nobq)*w2(3,3)
      bdtq(i1+2,6) = -r0l(3,1,nobq)*w2(1,3) - r0l(3,2,nobq)*w2(2,3) - r0
     .l(3,3,nobq)*w2(3,3)
CC@CC end of expanded call
CC@CC
            LD3 = 7*(L-2) + 3
            call skewv3(dh(1,ld3),w1,1,3)
CC@CC
CC@CC ......MULT3 bdtq(i1,4), w1, bdtq(i1,1)
CC@CC ......3, 3, 3
CC@CC ......6, 3, 6
      bdtq(i1+0,1) = bdtq(i1+0,4)*w1(1,1) + bdtq(i1+0,5)*w1(2,1) + bdtq(
     .i1+0,6)*w1(3,1)
      bdtq(i1+1,1) = bdtq(i1+1,4)*w1(1,1) + bdtq(i1+1,5)*w1(2,1) + bdtq(
     .i1+1,6)*w1(3,1)
      bdtq(i1+2,1) = bdtq(i1+2,4)*w1(1,1) + bdtq(i1+2,5)*w1(2,1) + bdtq(
     .i1+2,6)*w1(3,1)
      bdtq(i1+0,2) = bdtq(i1+0,4)*w1(1,2) + bdtq(i1+0,5)*w1(2,2) + bdtq(
     .i1+0,6)*w1(3,2)
      bdtq(i1+1,2) = bdtq(i1+1,4)*w1(1,2) + bdtq(i1+1,5)*w1(2,2) + bdtq(
     .i1+1,6)*w1(3,2)
      bdtq(i1+2,2) = bdtq(i1+2,4)*w1(1,2) + bdtq(i1+2,5)*w1(2,2) + bdtq(
     .i1+2,6)*w1(3,2)
      bdtq(i1+0,3) = bdtq(i1+0,4)*w1(1,3) + bdtq(i1+0,5)*w1(2,3) + bdtq(
     .i1+0,6)*w1(3,3)
      bdtq(i1+1,3) = bdtq(i1+1,4)*w1(1,3) + bdtq(i1+1,5)*w1(2,3) + bdtq(
     .i1+1,6)*w1(3,3)
      bdtq(i1+2,3) = bdtq(i1+2,4)*w1(1,3) + bdtq(i1+2,5)*w1(2,3) + bdtq(
     .i1+2,6)*w1(3,3)
CC@CC end of expanded call
CC@CC
            if (leq .gt. 0) then
CC@CC
CC@CC .........MULT3 hatsq, y(loq), hxdqn
CC@CC .........3, leq, 1
CC@CC .........3, leq, 3
      CALL DGEMV ('N',3,leq,1.0d0,hatsq,3,y(loq),1,0.0d0,hxdqn,1)
CC@CC end of expanded call
CC@CC
               call skewv3(hxdqn,wsk,1,3)
CC@CC
CC@CC .........MULTAD r0l(1,1,nobq), wsk, bdtq(i1,1)
CC@CC .........3, 3, 3
CC@CC .........3, 3, 6
      bdtq(i1+0,1) = bdtq(i1+0,1) + r0l(1,1,nobq)*wsk(1,1) + r0l(1,2,nob
     .q)*wsk(2,1) + r0l(1,3,nobq)*wsk(3,1)
      bdtq(i1+1,1) = bdtq(i1+1,1) + r0l(2,1,nobq)*wsk(1,1) + r0l(2,2,nob
     .q)*wsk(2,1) + r0l(2,3,nobq)*wsk(3,1)
      bdtq(i1+2,1) = bdtq(i1+2,1) + r0l(3,1,nobq)*wsk(1,1) + r0l(3,2,nob
     .q)*wsk(2,1) + r0l(3,3,nobq)*wsk(3,1)
      bdtq(i1+0,2) = bdtq(i1+0,2) + r0l(1,1,nobq)*wsk(1,2) + r0l(1,2,nob
     .q)*wsk(2,2) + r0l(1,3,nobq)*wsk(3,2)
      bdtq(i1+1,2) = bdtq(i1+1,2) + r0l(2,1,nobq)*wsk(1,2) + r0l(2,2,nob
     .q)*wsk(2,2) + r0l(2,3,nobq)*wsk(3,2)
      bdtq(i1+2,2) = bdtq(i1+2,2) + r0l(3,1,nobq)*wsk(1,2) + r0l(3,2,nob
     .q)*wsk(2,2) + r0l(3,3,nobq)*wsk(3,2)
      bdtq(i1+0,3) = bdtq(i1+0,3) + r0l(1,1,nobq)*wsk(1,3) + r0l(1,2,nob
     .q)*wsk(2,3) + r0l(1,3,nobq)*wsk(3,3)
      bdtq(i1+1,3) = bdtq(i1+1,3) + r0l(2,1,nobq)*wsk(1,3) + r0l(2,2,nob
     .q)*wsk(2,3) + r0l(2,3,nobq)*wsk(3,3)
      bdtq(i1+2,3) = bdtq(i1+2,3) + r0l(3,1,nobq)*wsk(1,3) + r0l(3,2,nob
     .q)*wsk(2,3) + r0l(3,3,nobq)*wsk(3,3)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC .........MULT3 bdtq(i1,4), hatsq, bdtq(i1,7)
CC@CC .........3, 3, leq
CC@CC .........6, 3, 6
      CALL DGEMM ('N','N',3,leq,3,1.0d0,bdtq(i1,4),6,hatsq,3,0.0d0,bdtq(
     .i1,7),6)
CC@CC end of expanded call
CC@CC
            end if
         else     ! Fixed bond-length kinematics
c
cccccccccccccccc
c
c     Form the translation-translation partition of bdtq
c
c     Compute C2 inverse times the derivative of R0L
c
            iq = locu(nobq)
            call skewv3(y(iq),w2,1,3)
C  original: CALL MULT3N (bh(i1,4,lq),w2,bdtq(i1,4),3,3,3,6,3,6)
CC@CC
CC@CC MULT3N bhq(1,4), w2, bdtq(i1,4)
CC@CC 3, 3, 3
CC@CC 3, 3, 6
      bdtq(i1+0,4) = -bhq(1,4)*w2(1,1) - bhq(1,5)*w2(2,1) - bhq(1,6)*w2(
     .3,1)
      bdtq(i1+1,4) = -bhq(2,4)*w2(1,1) - bhq(2,5)*w2(2,1) - bhq(2,6)*w2(
     .3,1)
      bdtq(i1+2,4) = -bhq(3,4)*w2(1,1) - bhq(3,5)*w2(2,1) - bhq(3,6)*w2(
     .3,1)
      bdtq(i1+0,5) = -bhq(1,4)*w2(1,2) - bhq(1,5)*w2(2,2) - bhq(1,6)*w2(
     .3,2)
      bdtq(i1+1,5) = -bhq(2,4)*w2(1,2) - bhq(2,5)*w2(2,2) - bhq(2,6)*w2(
     .3,2)
      bdtq(i1+2,5) = -bhq(3,4)*w2(1,2) - bhq(3,5)*w2(2,2) - bhq(3,6)*w2(
     .3,2)
      bdtq(i1+0,6) = -bhq(1,4)*w2(1,3) - bhq(1,5)*w2(2,3) - bhq(1,6)*w2(
     .3,3)
      bdtq(i1+1,6) = -bhq(2,4)*w2(1,3) - bhq(2,5)*w2(2,3) - bhq(2,6)*w2(
     .3,3)
      bdtq(i1+2,6) = -bhq(3,4)*w2(1,3) - bhq(3,5)*w2(2,3) - bhq(3,6)*w2(
     .3,3)
CC@CC end of expanded call
CC@CC
c
c     Multiply the derivative of C2 inverse by R0L and add to above
c
CC@CC
CC@CC ......MULTAD c2nvdt, r0l(1,1,nobq), bdtq(i1,4)
CC@CC ......3, 3, 3
CC@CC ......3, 3, 6
      bdtq(i1+0,4) = bdtq(i1+0,4) + c2nvdt(1,1)*r0l(1,1,nobq) + c2nvdt(1
     .,2)*r0l(2,1,nobq) + c2nvdt(1,3)*r0l(3,1,nobq)
      bdtq(i1+1,4) = bdtq(i1+1,4) + c2nvdt(2,1)*r0l(1,1,nobq) + c2nvdt(2
     .,2)*r0l(2,1,nobq) + c2nvdt(2,3)*r0l(3,1,nobq)
      bdtq(i1+2,4) = bdtq(i1+2,4) + c2nvdt(3,1)*r0l(1,1,nobq) + c2nvdt(3
     .,2)*r0l(2,1,nobq) + c2nvdt(3,3)*r0l(3,1,nobq)
      bdtq(i1+0,5) = bdtq(i1+0,5) + c2nvdt(1,1)*r0l(1,2,nobq) + c2nvdt(1
     .,2)*r0l(2,2,nobq) + c2nvdt(1,3)*r0l(3,2,nobq)
      bdtq(i1+1,5) = bdtq(i1+1,5) + c2nvdt(2,1)*r0l(1,2,nobq) + c2nvdt(2
     .,2)*r0l(2,2,nobq) + c2nvdt(2,3)*r0l(3,2,nobq)
      bdtq(i1+2,5) = bdtq(i1+2,5) + c2nvdt(3,1)*r0l(1,2,nobq) + c2nvdt(3
     .,2)*r0l(2,2,nobq) + c2nvdt(3,3)*r0l(3,2,nobq)
      bdtq(i1+0,6) = bdtq(i1+0,6) + c2nvdt(1,1)*r0l(1,3,nobq) + c2nvdt(1
     .,2)*r0l(2,3,nobq) + c2nvdt(1,3)*r0l(3,3,nobq)
      bdtq(i1+1,6) = bdtq(i1+1,6) + c2nvdt(2,1)*r0l(1,3,nobq) + c2nvdt(2
     .,2)*r0l(2,3,nobq) + c2nvdt(2,3)*r0l(3,3,nobq)
      bdtq(i1+2,6) = bdtq(i1+2,6) + c2nvdt(3,1)*r0l(1,3,nobq) + c2nvdt(3
     .,2)*r0l(2,3,nobq) + c2nvdt(3,3)*r0l(3,3,nobq)
CC@CC end of expanded call
CC@CC
c
cccccccccccccccc
c
c     Form the translational part of bdtp
c
            bdtp(i1,1) = - c2nvdt(1,1)
            bdtp(i2,1) = - c2nvdt(2,1)
            bdtp(i3,1) = - c2nvdt(3,1)
            bdtp(i1,2) = - c2nvdt(1,2)
            bdtp(i2,2) = - c2nvdt(2,2)
            bdtp(i3,2) = - c2nvdt(3,2)
            bdtp(i1,3) = - c2nvdt(1,3)
            bdtp(i2,3) = - c2nvdt(2,3)
            bdtp(i3,3) = - c2nvdt(3,3)
c
cccccccccccccccc
c
c     Form the translation-rotation partition of bdtq.
c     First, pre-multiply
c             n
c         [  S  ]  by the [2,2] partition of bdtq.
c             nq
c
            LD3 = 7*(L-2) + 3
            CALL SKEWV3 (DH(1,LD3),W1,3,3)
CC@CC
CC@CC ......MULT3 bdtq(i1,4), w1, bdtq(i1,1)
CC@CC ......3, 3, 3
CC@CC ......6, 3, 6
      bdtq(i1+0,1) = bdtq(i1+0,4)*w1(1,1) + bdtq(i1+0,5)*w1(2,1) + bdtq(
     .i1+0,6)*w1(3,1)
      bdtq(i1+1,1) = bdtq(i1+1,4)*w1(1,1) + bdtq(i1+1,5)*w1(2,1) + bdtq(
     .i1+1,6)*w1(3,1)
      bdtq(i1+2,1) = bdtq(i1+2,4)*w1(1,1) + bdtq(i1+2,5)*w1(2,1) + bdtq(
     .i1+2,6)*w1(3,1)
      bdtq(i1+0,2) = bdtq(i1+0,4)*w1(1,2) + bdtq(i1+0,5)*w1(2,2) + bdtq(
     .i1+0,6)*w1(3,2)
      bdtq(i1+1,2) = bdtq(i1+1,4)*w1(1,2) + bdtq(i1+1,5)*w1(2,2) + bdtq(
     .i1+1,6)*w1(3,2)
      bdtq(i1+2,2) = bdtq(i1+2,4)*w1(1,2) + bdtq(i1+2,5)*w1(2,2) + bdtq(
     .i1+2,6)*w1(3,2)
      bdtq(i1+0,3) = bdtq(i1+0,4)*w1(1,3) + bdtq(i1+0,5)*w1(2,3) + bdtq(
     .i1+0,6)*w1(3,3)
      bdtq(i1+1,3) = bdtq(i1+1,4)*w1(1,3) + bdtq(i1+1,5)*w1(2,3) + bdtq(
     .i1+1,6)*w1(3,3)
      bdtq(i1+2,3) = bdtq(i1+2,4)*w1(1,3) + bdtq(i1+2,5)*w1(2,3) + bdtq(
     .i1+2,6)*w1(3,3)
CC@CC end of expanded call
CC@CC
c
c     Then add the product of the [2,2] partition of bh(lq) and the derivative
c     of
c                   n
c              [  S   ]
c                   nq
c
            if (leq .gt. 0) then
CC@CC
CC@CC .........MULT3 hatsq, y(loq), hxdqn
CC@CC .........3, leq, 1
CC@CC .........3, leq, 3
      CALL DGEMV ('N',3,leq,1.0d0,hatsq,3,y(loq),1,0.0d0,hxdqn,1)
CC@CC end of expanded call
CC@CC
               call skewv3(hxdqn,wsk,1,3)
C  original: CALL MULTAD (bh(i1,4,lq), wsk, bdtq(i1,1), 3, 3, 3, 3, 3, 6)
CC@CC
CC@CC MULTAD bhq(1,4), wsk, bdtq(i1,1)
CC@CC 3, 3, 3
CC@CC 3, 3, 6
      bdtq(i1+0,1) = bdtq(i1+0,1) + bhq(1,4)*wsk(1,1) + bhq(1,5)*wsk(2,1
     .) + bhq(1,6)*wsk(3,1)
      bdtq(i1+1,1) = bdtq(i1+1,1) + bhq(2,4)*wsk(1,1) + bhq(2,5)*wsk(2,1
     .) + bhq(2,6)*wsk(3,1)
      bdtq(i1+2,1) = bdtq(i1+2,1) + bhq(3,4)*wsk(1,1) + bhq(3,5)*wsk(2,1
     .) + bhq(3,6)*wsk(3,1)
      bdtq(i1+0,2) = bdtq(i1+0,2) + bhq(1,4)*wsk(1,2) + bhq(1,5)*wsk(2,2
     .) + bhq(1,6)*wsk(3,2)
      bdtq(i1+1,2) = bdtq(i1+1,2) + bhq(2,4)*wsk(1,2) + bhq(2,5)*wsk(2,2
     .) + bhq(2,6)*wsk(3,2)
      bdtq(i1+2,2) = bdtq(i1+2,2) + bhq(3,4)*wsk(1,2) + bhq(3,5)*wsk(2,2
     .) + bhq(3,6)*wsk(3,2)
      bdtq(i1+0,3) = bdtq(i1+0,3) + bhq(1,4)*wsk(1,3) + bhq(1,5)*wsk(2,3
     .) + bhq(1,6)*wsk(3,3)
      bdtq(i1+1,3) = bdtq(i1+1,3) + bhq(2,4)*wsk(1,3) + bhq(2,5)*wsk(2,3
     .) + bhq(2,6)*wsk(3,3)
      bdtq(i1+2,3) = bdtq(i1+2,3) + bhq(3,4)*wsk(1,3) + bhq(3,5)*wsk(2,3
     .) + bhq(3,6)*wsk(3,3)
CC@CC end of expanded call
CC@CC
c
c     Now compute the modal part of bdtq
c
CC@CC
CC@CC .........MULT3 bdtq(i1,4), hatsq, bdtq(i1,7)
CC@CC .........3, 3, leq
CC@CC .........6, 3, 6
      CALL DGEMM ('N','N',3,leq,3,1.0d0,bdtq(i1,4),6,hatsq,3,0.0d0,bdtq(
     .i1,7),6)
CC@CC end of expanded call
CC@CC
            end if
         end if
      else          ! Both objects are rigid/flex bodies
C
C        THE Q-FRAME IS IN BODY NOBQ IT HAS LEQ FLEXIBLE BODY MODES
C        THE P-FRAME IS IN BODY NOBP IT HAS LEP FLEXIBLE BODY MODES
c
      IF (LEQ .ne. 0) then
CC@CC
CC@CC ...MULT3 HATSQ, Y(LOQ), HXDQN
CC@CC ...3, LEQ, 1
CC@CC ...3, LEQ, 3
      CALL DGEMV ('N',3,LEQ,1.0d0,HATSQ,3,Y(LOQ),1,0.0d0,HXDQN,1)
CC@CC end of expanded call
CC@CC
      end if
c
      IF (LEP .ne. 0) then
CC@CC
CC@CC ...MULT3 HATSP, Y(LOP), HXDPM
CC@CC ...3, LEP, 1
CC@CC ...3, LEP, 3
      CALL DGEMV ('N',3,LEP,1.0d0,HATSP,3,Y(LOP),1,0.0d0,HXDPM,1)
CC@CC end of expanded call
CC@CC
      end if
C
C          RQP = [qRp]     RQM = [qRm]     RPN = [pRn]
C
C          SNQ = [Snq]     SMP = [Smp]
C
      LRMP = 6*(L-2) + 4
      LRPQ = LRMP + 1
      LDNQ = 7*(L-2) + 3
      LDMP = LDNQ + 1
      DO 15 I=1,3
      DO 15 J=1,3
      RQP(I,J) = RH(J,I,LRPQ)
 15   continue
      CALL SKEWV3 (DH(1,LDNQ),SNQ,3,3)
      CALL SKEWV3 (DH(1,LDMP),SMP,3,3)
C
C                     n              m
C          WQN = -{Wq}      WPM = {Wp}
C
      IQ = LOCU(NOBQ) - 1
      IP = LOCU(NOBP) - 1
c
ccccccccccccccccc
c
c     EQN. (C-10)
c
      DO 25 I=1,3
      WQN(I) = -Y(IQ+I)
   25 WPM(I) =  Y(IP+I)
C
C                          m            n
C          WPQP = [pRm]{Wp}  + [pRn]{Wq}
C
C          WSK  = SK*{WPQP}
C
C                   o                 o
C          DRPQ = [pRq]      DRQP = [qRp]
C
CC@CC
CC@CC MULTAD RH(1,1,lrpq), WQN, WPM
CC@CC 3, 3, 1
CC@CC 3, 3, 3
      WPM(1) = WPM(1) + RH(1,1,lrpq)*WQN(1) + RH(1,2,lrpq)*WQN(2) + RH(1
     .,3,lrpq)*WQN(3)
      WPM(2) = WPM(2) + RH(2,1,lrpq)*WQN(1) + RH(2,2,lrpq)*WQN(2) + RH(2
     .,3,lrpq)*WQN(3)
      WPM(3) = WPM(3) + RH(3,1,lrpq)*WQN(1) + RH(3,2,lrpq)*WQN(2) + RH(3
     .,3,lrpq)*WQN(3)
CC@CC end of expanded call
CC@CC
      CALL SKEWV3 (WPM,WSK,1,3)
C
CCCCCCCCCCCCCCCCCCCCCCCCC
c
c     EQN (C-9)
C                         o
C           BDTQ[2,2] = [pRq]
c
CC@CC
CC@CC MULT3 WSK, RH(1,1,LRPQ), BDTQ(4,4)
CC@CC 3, 3, 3
CC@CC 3, 3, 6
      BDTQ(4,4) = WSK(1,1)*RH(1,1,LRPQ) + WSK(1,2)*RH(2,1,LRPQ) + WSK(1,
     .3)*RH(3,1,LRPQ)
      BDTQ(5,4) = WSK(2,1)*RH(1,1,LRPQ) + WSK(2,2)*RH(2,1,LRPQ) + WSK(2,
     .3)*RH(3,1,LRPQ)
      BDTQ(6,4) = WSK(3,1)*RH(1,1,LRPQ) + WSK(3,2)*RH(2,1,LRPQ) + WSK(3,
     .3)*RH(3,1,LRPQ)
      BDTQ(4,5) = WSK(1,1)*RH(1,2,LRPQ) + WSK(1,2)*RH(2,2,LRPQ) + WSK(1,
     .3)*RH(3,2,LRPQ)
      BDTQ(5,5) = WSK(2,1)*RH(1,2,LRPQ) + WSK(2,2)*RH(2,2,LRPQ) + WSK(2,
     .3)*RH(3,2,LRPQ)
      BDTQ(6,5) = WSK(3,1)*RH(1,2,LRPQ) + WSK(3,2)*RH(2,2,LRPQ) + WSK(3,
     .3)*RH(3,2,LRPQ)
      BDTQ(4,6) = WSK(1,1)*RH(1,3,LRPQ) + WSK(1,2)*RH(2,3,LRPQ) + WSK(1,
     .3)*RH(3,3,LRPQ)
      BDTQ(5,6) = WSK(2,1)*RH(1,3,LRPQ) + WSK(2,2)*RH(2,3,LRPQ) + WSK(2,
     .3)*RH(3,3,LRPQ)
      BDTQ(6,6) = WSK(3,1)*RH(1,3,LRPQ) + WSK(3,2)*RH(2,3,LRPQ) + WSK(3,
     .3)*RH(3,3,LRPQ)
CC@CC end of expanded call
CC@CC
C
      drqp(1,1) = bdtq(4,4)
      drqp(2,1) = bdtq(4,5)
      drqp(3,1) = bdtq(4,6)
      drqp(1,2) = bdtq(5,4)
      drqp(2,2) = bdtq(5,5)
      drqp(3,2) = bdtq(5,6)
      drqp(1,3) = bdtq(6,4)
      drqp(2,3) = bdtq(6,5)
      drqp(3,3) = bdtq(6,6)
C
C       Develop flexible body contributions to BDTQ
C
C                         o                 o
C           BDTQ[2,1] = [pRn][Snq] + [pRn][Snq]
C
C                         o       
C           BDTQ[2,3] = [pRq][Hq]
C
C           BDTQ[1,3] = [0]
C
CC@CC
CC@CC MULT3 BDTQ(4,4), SNQ, BDTQ(4,1)
CC@CC 3, 3, 3
CC@CC 6, 3, 6
      BDTQ(4,1) = BDTQ(4,4)*SNQ(1,1) + BDTQ(4,5)*SNQ(2,1) + BDTQ(4,6)*SN
     .Q(3,1)
      BDTQ(5,1) = BDTQ(5,4)*SNQ(1,1) + BDTQ(5,5)*SNQ(2,1) + BDTQ(5,6)*SN
     .Q(3,1)
      BDTQ(6,1) = BDTQ(6,4)*SNQ(1,1) + BDTQ(6,5)*SNQ(2,1) + BDTQ(6,6)*SN
     .Q(3,1)
      BDTQ(4,2) = BDTQ(4,4)*SNQ(1,2) + BDTQ(4,5)*SNQ(2,2) + BDTQ(4,6)*SN
     .Q(3,2)
      BDTQ(5,2) = BDTQ(5,4)*SNQ(1,2) + BDTQ(5,5)*SNQ(2,2) + BDTQ(5,6)*SN
     .Q(3,2)
      BDTQ(6,2) = BDTQ(6,4)*SNQ(1,2) + BDTQ(6,5)*SNQ(2,2) + BDTQ(6,6)*SN
     .Q(3,2)
      BDTQ(4,3) = BDTQ(4,4)*SNQ(1,3) + BDTQ(4,5)*SNQ(2,3) + BDTQ(4,6)*SN
     .Q(3,3)
      BDTQ(5,3) = BDTQ(5,4)*SNQ(1,3) + BDTQ(5,5)*SNQ(2,3) + BDTQ(5,6)*SN
     .Q(3,3)
      BDTQ(6,3) = BDTQ(6,4)*SNQ(1,3) + BDTQ(6,5)*SNQ(2,3) + BDTQ(6,6)*SN
     .Q(3,3)
CC@CC end of expanded call
CC@CC
      IF (LEQ .EQ. 0) GO TO 40
      CALL SKEWV3 (HXDQN,WSK,1,3)
CC@CC
CC@CC MULTAD RH(1,1,lrpq), WSK, BDTQ(4,1)
CC@CC 3, 3, 3
CC@CC 3, 3, 6
      BDTQ(4,1) = BDTQ(4,1) + RH(1,1,lrpq)*WSK(1,1) + RH(1,2,lrpq)*WSK(2
     .,1) + RH(1,3,lrpq)*WSK(3,1)
      BDTQ(5,1) = BDTQ(5,1) + RH(2,1,lrpq)*WSK(1,1) + RH(2,2,lrpq)*WSK(2
     .,1) + RH(2,3,lrpq)*WSK(3,1)
      BDTQ(6,1) = BDTQ(6,1) + RH(3,1,lrpq)*WSK(1,1) + RH(3,2,lrpq)*WSK(2
     .,1) + RH(3,3,lrpq)*WSK(3,1)
      BDTQ(4,2) = BDTQ(4,2) + RH(1,1,lrpq)*WSK(1,2) + RH(1,2,lrpq)*WSK(2
     .,2) + RH(1,3,lrpq)*WSK(3,2)
      BDTQ(5,2) = BDTQ(5,2) + RH(2,1,lrpq)*WSK(1,2) + RH(2,2,lrpq)*WSK(2
     .,2) + RH(2,3,lrpq)*WSK(3,2)
      BDTQ(6,2) = BDTQ(6,2) + RH(3,1,lrpq)*WSK(1,2) + RH(3,2,lrpq)*WSK(2
     .,2) + RH(3,3,lrpq)*WSK(3,2)
      BDTQ(4,3) = BDTQ(4,3) + RH(1,1,lrpq)*WSK(1,3) + RH(1,2,lrpq)*WSK(2
     .,3) + RH(1,3,lrpq)*WSK(3,3)
      BDTQ(5,3) = BDTQ(5,3) + RH(2,1,lrpq)*WSK(1,3) + RH(2,2,lrpq)*WSK(2
     .,3) + RH(2,3,lrpq)*WSK(3,3)
      BDTQ(6,3) = BDTQ(6,3) + RH(3,1,lrpq)*WSK(1,3) + RH(3,2,lrpq)*WSK(2
     .,3) + RH(3,3,lrpq)*WSK(3,3)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC MULT3 BDTQ(4,4), HATSQ, BDTQ(4,7)
CC@CC 3, 3, LEQ
CC@CC 6, 3, 6
      CALL DGEMM ('N','N',3,LEQ,3,1.0d0,BDTQ(4,4),6,HATSQ,3,0.0d0,BDTQ(4
     .,7),6)
CC@CC end of expanded call
CC@CC
   40 CONTINUE
C
C       Develop flexible body contributions to BDTP
C
C           BDTP[2,2] = [0]
C
C                         o -1            -1  o
C           BDTP[1,1] = [PI]  [qRm] + [PI]  [qRm]
C
CC@CC
CC@CC MULT3 PINDT, RQP, BDTP(1,1)
CC@CC 3, 3, 3
CC@CC 3, 3, 6
      BDTP(1,1) = PINDT(1,1)*RQP(1,1) + PINDT(1,2)*RQP(2,1) + PINDT(1,3)
     .*RQP(3,1)
      BDTP(2,1) = PINDT(2,1)*RQP(1,1) + PINDT(2,2)*RQP(2,1) + PINDT(2,3)
     .*RQP(3,1)
      BDTP(3,1) = PINDT(3,1)*RQP(1,1) + PINDT(3,2)*RQP(2,1) + PINDT(3,3)
     .*RQP(3,1)
      BDTP(1,2) = PINDT(1,1)*RQP(1,2) + PINDT(1,2)*RQP(2,2) + PINDT(1,3)
     .*RQP(3,2)
      BDTP(2,2) = PINDT(2,1)*RQP(1,2) + PINDT(2,2)*RQP(2,2) + PINDT(2,3)
     .*RQP(3,2)
      BDTP(3,2) = PINDT(3,1)*RQP(1,2) + PINDT(3,2)*RQP(2,2) + PINDT(3,3)
     .*RQP(3,2)
      BDTP(1,3) = PINDT(1,1)*RQP(1,3) + PINDT(1,2)*RQP(2,3) + PINDT(1,3)
     .*RQP(3,3)
      BDTP(2,3) = PINDT(2,1)*RQP(1,3) + PINDT(2,2)*RQP(2,3) + PINDT(2,3)
     .*RQP(3,3)
      BDTP(3,3) = PINDT(3,1)*RQP(1,3) + PINDT(3,2)*RQP(2,3) + PINDT(3,3)
     .*RQP(3,3)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC MULTAD PIN(1,1,L), DRQP, BDTP
CC@CC 3, 3, 3
CC@CC 3, 3, 6
      BDTP(1,1) = BDTP(1,1) + PIN(1,1,L)*DRQP(1,1) + PIN(1,2,L)*DRQP(2,1
     .) + PIN(1,3,L)*DRQP(3,1)
      BDTP(2,1) = BDTP(2,1) + PIN(2,1,L)*DRQP(1,1) + PIN(2,2,L)*DRQP(2,1
     .) + PIN(2,3,L)*DRQP(3,1)
      BDTP(3,1) = BDTP(3,1) + PIN(3,1,L)*DRQP(1,1) + PIN(3,2,L)*DRQP(2,1
     .) + PIN(3,3,L)*DRQP(3,1)
      BDTP(1,2) = BDTP(1,2) + PIN(1,1,L)*DRQP(1,2) + PIN(1,2,L)*DRQP(2,2
     .) + PIN(1,3,L)*DRQP(3,2)
      BDTP(2,2) = BDTP(2,2) + PIN(2,1,L)*DRQP(1,2) + PIN(2,2,L)*DRQP(2,2
     .) + PIN(2,3,L)*DRQP(3,2)
      BDTP(3,2) = BDTP(3,2) + PIN(3,1,L)*DRQP(1,2) + PIN(3,2,L)*DRQP(2,2
     .) + PIN(3,3,L)*DRQP(3,2)
      BDTP(1,3) = BDTP(1,3) + PIN(1,1,L)*DRQP(1,3) + PIN(1,2,L)*DRQP(2,3
     .) + PIN(1,3,L)*DRQP(3,3)
      BDTP(2,3) = BDTP(2,3) + PIN(2,1,L)*DRQP(1,3) + PIN(2,2,L)*DRQP(2,3
     .) + PIN(2,3,L)*DRQP(3,3)
      BDTP(3,3) = BDTP(3,3) + PIN(3,1,L)*DRQP(1,3) + PIN(3,2,L)*DRQP(2,3
     .) + PIN(3,3,L)*DRQP(3,3)
CC@CC end of expanded call
CC@CC
      DO 55 I=1,3
      DO 55 J=1,3
      BDTP(I,J) = -BDTP(I,J)
 55   continue
C
C      Add contribution to BDTP[2,1]
C
C                         o       o
C           BDTP[2,1] = [Smp] + [Spq]
C
      IF (ihpvt(L) .NE. 0) THEN
         LR2 = 6*(L-2) + 2
CC@CC
CC@CC ...MULT3N rh(1,1,lr2), betahd(4,L), vqp
CC@CC ...3, 3, 1
CC@CC ...3, 6, 3
      vqp(1) = -rh(1,1,lr2)*betahd(4,L) - rh(1,2,lr2)*betahd(5,L) - rh(1
     .,3,lr2)*betahd(6,L)
      vqp(2) = -rh(2,1,lr2)*betahd(4,L) - rh(2,2,lr2)*betahd(5,L) - rh(2
     .,3,lr2)*betahd(6,L)
      vqp(3) = -rh(3,1,lr2)*betahd(4,L) - rh(3,2,lr2)*betahd(5,L) - rh(3
     .,3,lr2)*betahd(6,L)
CC@CC end of expanded call
CC@CC
      ELSE
         DO I = 1, 3
            vqp(i) = -betahd(i+3,L)
         END DO
      END IF

      IF (LEP .NE. 0) THEN
         DO I = 1, 3
            VQP(I) = VQP(I) - hxdpm(I)
         END DO
      END IF

      CALL SKEWV3 (VQP,BDTP(4,1),1,6)
C
c     Add contribution from pivoting hinges
c
      if (ihpvt(L) .ne. 0) then
         lr4 = 6*(L-2) + 4
         lp  = lq + 1
         np6 = lep + 6
         nq6 = leq + 6
c
c     Compute contribution to BDTP
c
         call multb(rh(1,1,lr4),bdtp(4,1),3,3,np6,3,6,
     .              LocalHeap(iwptr_multb))
CC@CC
CC@CC ...MULT3N rh(1,1,lr4), c2dot, w1
CC@CC ...3, 3, 3
CC@CC ...3, 3, 3
      w1(1,1) = -rh(1,1,lr4)*c2dot(1,1) - rh(1,2,lr4)*c2dot(2,1) - rh(1,
     .3,lr4)*c2dot(3,1)
      w1(2,1) = -rh(2,1,lr4)*c2dot(1,1) - rh(2,2,lr4)*c2dot(2,1) - rh(2,
     .3,lr4)*c2dot(3,1)
      w1(3,1) = -rh(3,1,lr4)*c2dot(1,1) - rh(3,2,lr4)*c2dot(2,1) - rh(3,
     .3,lr4)*c2dot(3,1)
      w1(1,2) = -rh(1,1,lr4)*c2dot(1,2) - rh(1,2,lr4)*c2dot(2,2) - rh(1,
     .3,lr4)*c2dot(3,2)
      w1(2,2) = -rh(2,1,lr4)*c2dot(1,2) - rh(2,2,lr4)*c2dot(2,2) - rh(2,
     .3,lr4)*c2dot(3,2)
      w1(3,2) = -rh(3,1,lr4)*c2dot(1,2) - rh(3,2,lr4)*c2dot(2,2) - rh(3,
     .3,lr4)*c2dot(3,2)
      w1(1,3) = -rh(1,1,lr4)*c2dot(1,3) - rh(1,2,lr4)*c2dot(2,3) - rh(1,
     .3,lr4)*c2dot(3,3)
      w1(2,3) = -rh(2,1,lr4)*c2dot(1,3) - rh(2,2,lr4)*c2dot(2,3) - rh(2,
     .3,lr4)*c2dot(3,3)
      w1(3,3) = -rh(3,1,lr4)*c2dot(1,3) - rh(3,2,lr4)*c2dot(2,3) - rh(3,
     .3,lr4)*c2dot(3,3)
CC@CC end of expanded call
CC@CC
CC    Original: CALL MULTAD(w1,bh(4,1,lp),bdtp(4,1),3,3,np6,3,6,6)
CC              (Use 3x3 (4,1) section here)
CC@CC
CC@CC MULTAD w1, bhp(1,4), bdtp(4,1)
CC@CC 3, 3, 3
CC@CC 3, 3, 6
      bdtp(4,1) = bdtp(4,1) + w1(1,1)*bhp(1,4) + w1(1,2)*bhp(2,4) + w1(1
     .,3)*bhp(3,4)
      bdtp(5,1) = bdtp(5,1) + w1(2,1)*bhp(1,4) + w1(2,2)*bhp(2,4) + w1(2
     .,3)*bhp(3,4)
      bdtp(6,1) = bdtp(6,1) + w1(3,1)*bhp(1,4) + w1(3,2)*bhp(2,4) + w1(3
     .,3)*bhp(3,4)
      bdtp(4,2) = bdtp(4,2) + w1(1,1)*bhp(1,5) + w1(1,2)*bhp(2,5) + w1(1
     .,3)*bhp(3,5)
      bdtp(5,2) = bdtp(5,2) + w1(2,1)*bhp(1,5) + w1(2,2)*bhp(2,5) + w1(2
     .,3)*bhp(3,5)
      bdtp(6,2) = bdtp(6,2) + w1(3,1)*bhp(1,5) + w1(3,2)*bhp(2,5) + w1(3
     .,3)*bhp(3,5)
      bdtp(4,3) = bdtp(4,3) + w1(1,1)*bhp(1,6) + w1(1,2)*bhp(2,6) + w1(1
     .,3)*bhp(3,6)
      bdtp(5,3) = bdtp(5,3) + w1(2,1)*bhp(1,6) + w1(2,2)*bhp(2,6) + w1(2
     .,3)*bhp(3,6)
      bdtp(6,3) = bdtp(6,3) + w1(3,1)*bhp(1,6) + w1(3,2)*bhp(2,6) + w1(3
     .,3)*bhp(3,6)
CC@CC end of expanded call
CC@CC
CC             (Use 3x3 (4,4) section here, bhp(4,4) = -rh)
CC    Modified rewrite by hand due to missing capability in rewrite code:
CC        CALL MULTMN (w1,rh(1,1,lr4),bdtp(4,4),3,3,3,3,3,6)
CC
      bdtp(4,4) = bdtp(4,4) - w1(1,1)*rh(1,1,lr4) - w1(1,2)*rh(2,1,lr4) 
     .- w1(1,3)*rh(3,1,lr4)
      bdtp(5,4) = bdtp(5,4) - w1(2,1)*rh(1,1,lr4) - w1(2,2)*rh(2,1,lr4) 
     .- w1(2,3)*rh(3,1,lr4)
      bdtp(6,4) = bdtp(6,4) - w1(3,1)*rh(1,1,lr4) - w1(3,2)*rh(2,1,lr4) 
     .- w1(3,3)*rh(3,1,lr4)
      bdtp(4,5) = bdtp(4,5) - w1(1,1)*rh(1,2,lr4) - w1(1,2)*rh(2,2,lr4) 
     .- w1(1,3)*rh(3,2,lr4)
      bdtp(5,5) = bdtp(5,5) - w1(2,1)*rh(1,2,lr4) - w1(2,2)*rh(2,2,lr4) 
     .- w1(2,3)*rh(3,2,lr4)
      bdtp(6,5) = bdtp(6,5) - w1(3,1)*rh(1,2,lr4) - w1(3,2)*rh(2,2,lr4) 
     .- w1(3,3)*rh(3,2,lr4)
      bdtp(4,6) = bdtp(4,6) - w1(1,1)*rh(1,3,lr4) - w1(1,2)*rh(2,3,lr4) 
     .- w1(1,3)*rh(3,3,lr4)
      bdtp(5,6) = bdtp(5,6) - w1(2,1)*rh(1,3,lr4) - w1(2,2)*rh(2,3,lr4) 
     .- w1(2,3)*rh(3,3,lr4)
      bdtp(6,6) = bdtp(6,6) - w1(3,1)*rh(1,3,lr4) - w1(3,2)*rh(2,3,lr4) 
     .- w1(3,3)*rh(3,3,lr4)
C
CC            (Use 3xnmp (4,7) section here)
CC@CC
CC@CC ...MULTAD w1, bhp(1,7), bdtp(4,7)
CC@CC ...3, 3, lep
CC@CC ...3, 3, 6
      CALL DGEMM ('N','N',3,lep,3,1.0d0,w1,3,bhp(1,7),3,1.0d0,bdtp(4,7),
     .6)
CC@CC end of expanded call
CC@CC
CC    END OF MULTAD w/ bh(4,1,lp) call
c
c
c     Compute contribution to BDTQ
c
         call multb(rh(1,1,lr4),bdtq(4,1),3,3,nq6,3,6,
     .              LocalHeap(iwptr_multb))
C
CC    Original: CALL MULTAD(bh(4,1,lq),bdtq(4,1),3,3,nq6,3,6,6)
CC@CC
CC@CC ...MULTAD w1, bhq(1,1), bdtq(4,1)
CC@CC ...3, 3, nq6
CC@CC ...3, 3, 6
      CALL DGEMM ('N','N',3,nq6,3,1.0d0,w1,3,bhq(1,1),3,1.0d0,bdtq(4,1),
     .6)
CC@CC end of expanded call
CC@CC
      end if

      IF(.NOT.LEQU) RETURN
      WRITE (MBOUT,1001) L
 1001 FORMAT (' BDTP ARRAY HINGE',I3)
      NCL = 6 + LEP
      CALL WRITES(BDTP,6,NCL,6)
      WRITE (MBOUT,1002) L
 1002 FORMAT (' BDTQ ARRAY HINGE',I3)
      NCL = 6 + LEQ
      CALL WRITES(BDTQ,6,NCL,6)
c      
      end if       ! End of Test for nobq or nobp being particles

      RETURN
C
 100  continue
c
c     Check to be sure First hinge is totally free.
c
      if (ihpvt(1) .ne. 0) then
         CALL CLEARERR()
         WRITE(ERRMSG,200) 
     +     'Error, First hinge assumed free for particle simulation.'
         CALL ERRHDL(-5,'<BDOTQP>')
      end if
 200  FORMAT(1X,A)
      IF (nbdy .EQ. 0) RETURN
c
      DO 70 I=1,3
   70 WQN(I) = -Y(I)
      CALL SKEWV3 (WQN,WSK,1,3)
CC@CC
CC@CC MULT3 R0L(1,1,1), WSK, BDTQ(4,4)
CC@CC 3, 3, 3
CC@CC 3, 3, 6
      BDTQ(4,4) = R0L(1,1,1)*WSK(1,1) + R0L(1,2,1)*WSK(2,1) + R0L(1,3,1)
     .*WSK(3,1)
      BDTQ(5,4) = R0L(2,1,1)*WSK(1,1) + R0L(2,2,1)*WSK(2,1) + R0L(2,3,1)
     .*WSK(3,1)
      BDTQ(6,4) = R0L(3,1,1)*WSK(1,1) + R0L(3,2,1)*WSK(2,1) + R0L(3,3,1)
     .*WSK(3,1)
      BDTQ(4,5) = R0L(1,1,1)*WSK(1,2) + R0L(1,2,1)*WSK(2,2) + R0L(1,3,1)
     .*WSK(3,2)
      BDTQ(5,5) = R0L(2,1,1)*WSK(1,2) + R0L(2,2,1)*WSK(2,2) + R0L(2,3,1)
     .*WSK(3,2)
      BDTQ(6,5) = R0L(3,1,1)*WSK(1,2) + R0L(3,2,1)*WSK(2,2) + R0L(3,3,1)
     .*WSK(3,2)
      BDTQ(4,6) = R0L(1,1,1)*WSK(1,3) + R0L(1,2,1)*WSK(2,3) + R0L(1,3,1)
     .*WSK(3,3)
      BDTQ(5,6) = R0L(2,1,1)*WSK(1,3) + R0L(2,2,1)*WSK(2,3) + R0L(2,3,1)
     .*WSK(3,3)
      BDTQ(6,6) = R0L(3,1,1)*WSK(1,3) + R0L(3,2,1)*WSK(2,3) + R0L(3,3,1)
     .*WSK(3,3)
CC@CC end of expanded call
CC@CC
c
      DO J = 7, 6+IRGFLX(1)
         DO I = 1, 6
            BDTQ(I,J) = 0D0
         END DO
      END DO
C
      IF(.NOT.LEQU) RETURN
      WRITE (MBOUT,1002) L
      NCL = 6
      CALL WRITES(BDTQ,6,NCL,6)
      RETURN
      END


