C $Header: /export/cvs/c34a1/source/moldyn/bkinit.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
      SUBROUTINE BKINIT(iscut,isel,isdof,ibetdt,ihdata)
C                                                          DEBUG #  42
CSE
      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: bkinit.f,v $$Revision: 1.1.1.1 $'/
CPS   PURPOSE:
C
C     COMPUTE ARRAYS NEEDED FOR BOTH THE FORWARD AND BACKWARD
C     PASSES ASSOCIATED WITH THE ORDER N ALGORITHM
C
CPE
CAS
C         SELECTION MATRICES COMPUTED HEREIN AND STORED IN /SELECT/
C
C         ISEL(J)  = HINGE DEGREE OF FREEDOM CODE (1,2,3,4,5,6) ASSOCIATED
C                    WITH THE J-TH HINGE DEGREE OF FREEDOM, J=1,2,...,6*NH.
C                    THIS INTEGER ARRAY IS USED TO IMPLEMENT MULTIPLICATIONS
C                    BY THE SELECTION MATRIX PHI AND PHI(TRANSPOSE)
C      ISDOF(1,I)  = STARTING LOCATION IN THE ISEL ARRAY FOR THE FIRST
C                    UNRESTRAINED HINGE DEGREE OF FREEDOM (1,2,3,4,5,6)
C                    ASSOCIATED WITH HINGE POINT I
C      ISDOF(2,I)  = STARTING LOCATION IN THE ISEL ARRAY FOR THE FIRST
C                    RESTRAINED HINGE DEGREE OF FREEDOM (1,2,3,4,5,6)
C                    ASSOCIATED WITH HINGE POINT I
C      ISDOF(3,I)  = NUMBER OF UNCONSTRAINED HINGE DEGREES OF FREEDOM AT
C                    HINGE POINT I
C      ISDOF(4,I)  = NUMBER OF FIXED KINEMATIC AND RHEONOMIC CONSTRAINTS
C                    AT HINGE POINT I
C       IBETDT(I)  = LOCATION IN THE STATE VECTOR OF THE FIRST BETA^F(DOT)
C                    ASSOCIATED WITH HINGE I
C
C        INPUT DATA FROM USER VIA DYNS10
C
CAE
C
#include "PARAM.FOR"
c
#include "CPATHS.INC"
#include "LDEBUG.INC"
#include "OPTION.INC"
#include "SELECT.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
C
c     passed
c
      LOGICAL ISCUT(cL02)
      INTEGER ISEL(6*cL02)
      INTEGER ISDOF(9,cL02)
      INTEGER IBETDT(cL02)
      INTEGER IHDATA(7,cL02)
C     Local Variables
C
      INTEGER LOC, IHINGE
      INTEGER NFREE, NCONS, IDOF1, IDOF
      INTEGER N0, i
      INTEGER ITEMP(6)
      LOGICAL LEQU
C
C     Equivlances
C
      EQUIVALENCE (LEQU,DEBUG(42))
C
C
      IF(LEQU) WRITE (MBOUT,1000)
 1000 FORMAT (' SUBROUTINE BKINIT ')
C
      LOC = 1
      DO 100 IHINGE = 1, NH
         ISDOF(1,IHINGE) = LOC
         NFREE = 0
         NCONS = 0
         if (ihdata(1,ihinge) .eq. 0) then
            idof1 = 4
         else
            idof1 = 1
         end if
C
         n0 = idof1 - 1
         DO 101 IDOF = idof1, 6
            IF (IHDATA(IDOF+1,IHINGE) .EQ. 0) THEN
               ISEL(LOC) = IDOF - n0
               LOC       = LOC + 1
               NFREE     = NFREE + 1
            ELSE
               NCONS        = NCONS + 1
               ITEMP(NCONS) = IDOF - n0
            END IF
 101     CONTINUE
c
         ISDOF(2,IHINGE) = LOC
         ISDOF(3,IHINGE) = NFREE
         ISDOF(4,IHINGE) = NCONS
C
         DO 102 IDOF = 1, NCONS
            ISEL(LOC) = ITEMP(IDOF)
            LOC       = LOC + 1
102      CONTINUE
100   CONTINUE
c
      IF(LEQU) THEN
        WRITE (MBOUT,1010)
1010    FORMAT (/,' THE ISEL ARRAY IS ')
        CALL WRITIS(ISEL,1,LOC-1,1)
        WRITE (MBOUT,1020)
1020    FORMAT (/,' THE ISDOF ARRAY IS')
        CALL WRITIS(ISDOF,4,NH,4)
      ENDIF
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C
C     COMPUTE THE POINTER INTO Y FOR EACH BETA DOT -F
c
      IBETDT(1) = LOCU(2*NB + 3)
      nfree = isdof(3,1)
      DO 300 I = 2, NH
c
c     Do not include cut-joint beta-dots in the y vector
c
         if (iscut(i-1)) then
            IBETDT(I) = IBETDT(I-1)
         else
            IBETDT(I) = IBETDT(I-1) + ISDOF(3,I-1)
         end if
         if (.not.iscut(i)) nfree = nfree + isdof(3,i)
300   CONTINUE
c
      LENU(2*NB+3) = NFREE
      NEQ = NEQ + NBETA + NDELTA + NU + NFREE
c
      IF(LEQU) THEN
        WRITE (MBOUT,1030)
1030    FORMAT (/,' THE IBETDT ARRAY IS')
        CALL WRITIS(IBETDT,1,NH,1)
      ENDIF
C
      RETURN
      END
