C $Header: /export/cvs/c34a1/source/moldyn/cjmpls.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      SUBROUTINE CJMPLS (psi,y,ydt,kmbpvt,p,btilde,dbetxi,temp1,rinv,
     &                   ihthptr,ihpvt,isel,isdof,ibetdt,itopol,
     &                   ibh_ptr,ihcutj,rlamda)
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      IMPLICIT NONE

C                                                          DEBUG #  87
CPS
C     PURPOSE:
C
C     This subroutine is used to make a forward pass that applies the impulse/
C     momentum correction for closed loop topologies.  During this pass,
C     relative hinge and modal velocities are corrected.  The operations are
C     similar to those performed by subroutine CLFOR3, except that there are
C     no G tilde zeta terms.  The recursion begins at the base body and
C     terminates with the end bodies.
C
CPE
#include "PARAM.FOR"
C
C     COMMON BLOCKS FROM DISCOS
C
#include "AMUBW.INC"
#include "BHBSRD.INC"
#include "CLOOP.INC"
#include "CONSTR.INC"
#include "CPATHS.INC"
#include "F1BKF2.INC"
#include "HANDS2.INC"      
#include "IVCONS.INC"
#include "JILFLG.INC"
#include "LAMBDA.INC"
#include "HEAPMB.INC"
#include "MISCNO.INC"
#include "MISCN2.INC"
#include "MOMENG.INC"
#include "ORDERN.INC"
#include "PARTCL.INC"
#include "SELECT.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
#include "VECTOR.INC"
C
C 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: cjmpls.f,v $$Revision: 1.1.1.1 $'/
c
C     Passed Variables
      DOUBLE PRECISION psi(6,cL06,MAXBOD)
      DOUBLE PRECISION y(cL07),ydt(cL07)
      integer kmbpvt(cL08,L01)
      DOUBLE PRECISION p(cL10)
      DOUBLE PRECISION btilde(cL11,6,L01,cL63)
      DOUBLE PRECISION rinv(6,6,cL02)
      DOUBLE PRECISION rlamda(cl64)
      INTEGER ihthptr(2*cL02)
      INTEGER ihpvt(cL02)
      INTEGER isel(6*cL02)
      INTEGER isdof(9,cL02)
      INTEGER ibetdt(cL02)
      INTEGER itopol(2,cL02)
      INTEGER ibh_ptr(cL12+1)
      INTEGER ihcutj(cL63)

C     LOCAL VARIABLES
C
      INTEGER I, J, IROW, ICUT, IHINGE, ibtdt
      INTEGER IBODY, ICBODY, INBODY
      INTEGER ITHISB, INBORD
      INTEGER LEN, NM, NFREE, NCONS, NDOF
      INTEGER LOCF
      INTEGER icamu,icrm,ibh_ic         ! pointers to heap_mb
      LOGICAL qin, useHATS
C
C     LOCAL ARRAYS
C
      DOUBLE PRECISION DBETXI(cL11)
      DOUBLE PRECISION TEMP1(cL11)
      DOUBLE PRECISION dUMPSI
C
#include "LDEBUG.INC"
      LOGICAL LEQU
      EQUIVALENCE (LEQU,DEBUG(87))
C
      IF(LEQU) THEN
         WRITE (MBOUT,1000)
         WRITE (MBOUT,*) ' P ENTERING CJMPLS'
         CALL WRITES(P,1,LOCU(NB+1)-1,1)
      END IF
 1000 FORMAT (' SUBROUTINE CJMPLS ')
C
C     FIRST DO THE REFERENCE BODY, BODY 1
C
      LOCF   = ISDOF(1,1)
      NFREE  = ISDOF(3,1)
      NDOF   = NFREE + ISDOF(4,1)
      NM     = IRGFLX(1)
      LEN    = LENU(1)
C
      IF (NM + NFREE .GT. 0) THEN
C
C        COMPUTE THE CUT JOINT TERMS
C
         DO I = 1, LEN
            TEMP1(I) = 0D0
         END DO
         IROW = 1
         DO 888 ICUT = 1, NCUT
            IHINGE = IHCUTJ(ICUT)
            NCONS  = ISDOF(4,IHINGE)
            IF (NCONS .GT. 0) THEN
CC@CC
CC@CC .........MULTAD BTILDE(1,1,1,ICUT), RLAMDA(IROW), TEMP1
CC@CC .........LEN, NCONS, 1
CC@CC .........L11, 6, L11
      CALL DGEMV ('N',LEN,NCONS,1.0d0,BTILDE(1,1,1,ICUT),cL11,RLAMDA(
     .IROW),1,1.0d0,TEMP1,1)
CC@CC end of expanded call
CC@CC
               IROW = IROW + NCONS
            END IF
 888     CONTINUE
C
         IF (nbdy .gt. 0) THEN
            CALL PSITX (PSI,RINV,ISEL(LOCF),ndof,
     +               NFREE,NM,TEMP1,DBETXI)
         ELSE
            CALL PSITX (DUMPSI,RINV,ISEL(LOCF),ndof,
     +               NFREE,NM,TEMP1,DBETXI)
         END IF
         CALL DSISL (HEAP_MB(irm_ptr(1)),LEN,NFREE+NM,KMBPVT,DBETXI)
C
         IF (LEQU .AND. NFREE+NM .GT. 0) THEN
            WRITE (MBOUT,1023) 1
            CALL WRITES(DBETXI,1,NFREE+NM,1)
         END IF
 1023    FORMAT(' DBETXI FOR HINGE',I3)
C
C     NOW COMPUTE THE GAMMA DOT CORRECTION.
         DO 150 J = 1, NDOF
            TEMP1(J) = 0D0
 150     CONTINUE
         DO 200 J = 1, NFREE
            TEMP1(ISEL(LOCF+J-1)) = DBETXI(J)
 200     CONTINUE
C
CC@CC
CC@CC ...MULT3 RINV(1,1,1), TEMP1, YDT
CC@CC ...NDOF, NDOF, 1
CC@CC ...6, 6, 6
      CALL DGEMV ('N',NDOF,NDOF,1.0d0,RINV(1,1,1),6,TEMP1,1,0.0d0,YDT,1)
CC@CC end of expanded call
CC@CC
C
C        NOW APPLY THE BETA DOT AND XI DOT CORRECTIONS
C        FIRST THE BETA DOTS
C
         IBTDT = IBETDT(1)
         DO 300 I = 1, NFREE
            Y(IBTDT) = Y(IBTDT) + DBETXI(I)
            IBTDT    = IBTDT + 1
 300     CONTINUE
C
C        CORRECT THE GAMMA DOTS
C
         DO I = 1, NDOF
            Y(I) = Y(I) + YDT(I)
         END DO
C
C        AND NOW THE XIS
C
         DO 400 I = 1, NM
            Y(6+I) = Y(6+I) + DBETXI(NFREE+I)
            YDT(6+I) = DBETXI(NFREE+I)
 400     CONTINUE
      ELSE
         DO I = 1, NDOF
            YDT(I) = 0D0
         END DO
      END IF
C
      IF (LEQU) THEN
         WRITE (MBOUT,1070) 1
         CALL WRITES(YDT,1,NDOF+NM,1)
      END IF
 1070    FORMAT (' DGAMXI FOR BODY',I3)

C
C     PARTIALLY CORRECT THE ORDINARY MOMENTA
C
CC@CC
CC@CC MULTAD HEAP_MB(iamuptr(1)), YDT, P
CC@CC LEN, LEN, 1
CC@CC LEN, L11, L08
      CALL DGEMV ('N',LEN,LEN,1.0d0,HEAP_MB(iamuptr(1)),LEN,YDT,1,1.0d0,
     .P,1)
CC@CC end of expanded call
CC@CC
C
      IF (LEQU) THEN
         WRITE (MBOUT,1010) 1,NDOF+NM,1
         CALL WRITES(Y,1,NDOF+NM,1)
         IF (NFREE .GT. 0) THEN
            WRITE (MBOUT,1020) IBETDT(1),IBETDT(1)-1+NFREE,1
            CALL WRITES(Y(IBETDT(1)),1,NFREE,1)
         END IF
      ENDIF
 1010 FORMAT (' Y(',I3,'...',I3,'), NEW U FOR BODY ',I3)
 1020 FORMAT (' Y(',I3,'...',I3,'), NEW BETA DOT FOR HINGE ',I3)
C
C     NOW FOR THE REST OF THE BODIES
C
      DO 600 IBODY = 2, NB
C
         IHINGE = ITOPW(1,IBODY)
         ICBODY = ITOPW(2,IBODY)
C
         IF (IHINGE .LT. 0) THEN
C           PFRAME IS ON THIS (OUTBOARD) BODY
C
            IHINGE = -IHINGE
            INBODY = ITOPOL(1,IHINGE)
            INBORD = 2 * IHINGE - 2
            ITHISB = INBORD + 1
            qin    = .TRUE.
C
C        NOW EXTRACT THE SAME DATA FOR Q FRAME ON THIS BODY
         ELSE
            INBODY = ITOPOL(2,IHINGE)
            ITHISB = 2 * IHINGE - 2
            INBORD = ITHISB + 1
            qin    = .FALSE.
         END IF
C
         LEN = LENU(ICBODY)
         NM  = IRGFLX(ICBODY)


         icamu  = iamuptr(icbody)    ! amu pointer
         icrm   = irm_ptr(icbody)    ! rmbar pointer
         useHATS = .FALSE.
         if (nm .GT. 0) then
            if (qin) then
               if (ihpvt(ihinge) .EQ. 0) then
                  ibh_ic = ihthptr(ithisb-1) + 1 ! point to hats, this
                  useHATS = .TRUE.               ! is what is in bh here 
               else
                  ibh_ic = ibh_ptr(ithisb) + 18
               end if
            else
               if (ihpvt(ihinge) .EQ. 0) then
                  ibh_ic = ibh_ptr(ithisb) + 9
               else
                  ibh_ic = ibh_ptr(ithisb) + 18
               end if
            end if
         else
            ibh_ic = BADADDR
         end if
c
c     Pass heap_mb location of amu, rmbar, and bh to cjmpls_1
c
         if (useHATS) then 
           call cjmpls_1(HEAP_MB(icamu),HEAP_MB(icrm),HATS(ibh_ic),
     &                   len,nm,ihinge,icbody,inbody,ithisb,inbord,qin,
     &		         HEAP_MB(ipsiptr),HEAP_MB(iyptr),
     &                   HEAP_MB(iydtptr),
     &                   intHEAP_MB(ikmbpvtptr),HEAP_MB(ipptr),
     &                   HEAP_MB(ibtildeptr),
     &                   LocalHeap(ibhinbptr_cjmpls),
     &                   LocalHeap(idbetxiptr_cjmpls_1),
     &                   LocalHeap(itempptr_cjmpls_1),
     &                   LocalHeap(itemp1ptr_cjmpls_1),
     &                   LogicLoopHeap(iihpathptr),
     &                   LoopHeap(irinvptr),intLoopHeap(iiselptr),
     &                   intLoopHeap(iisdofptr),intLoopheap(iibetdtptr),
     &                   intLoopHeap(iihcutjptr),Loopheap(irlamdaptr))
         else
           call cjmpls_1(HEAP_MB(icamu),HEAP_MB(icrm),BH(ibh_ic),
     &                   len,nm,ihinge,icbody,inbody,ithisb,inbord,qin,
     &		         HEAP_MB(ipsiptr),HEAP_MB(iyptr),
     &                   HEAP_MB(iydtptr),
     &                   intHEAP_MB(ikmbpvtptr),HEAP_MB(ipptr),
     &                   HEAP_MB(ibtildeptr),
     &                   LocalHeap(ibhinbptr_cjmpls),
     &                   LocalHeap(idbetxiptr_cjmpls_1),
     &                   LocalHeap(itempptr_cjmpls_1),
     &                   LocalHeap(itemp1ptr_cjmpls_1),
     &                   LogicLoopHeap(iihpathptr),
     &                   LoopHeap(irinvptr),intLoopHeap(iiselptr),
     &                   intLoopHeap(iisdofptr),intLoopheap(iibetdtptr),
     &                   intLoopHeap(iihcutjptr),Loopheap(irlamdaptr))
         end if
C
 600  CONTINUE
C
      IF (LEQU) THEN
         WRITE (MBOUT,*) ' Y LEAVING CJMPLS '
         CALL WRITES (Y,1,NEQ,1)
         WRITE (MBOUT,*) ' P LEAVING CJMPLS'
         CALL WRITES(P,1,LOCU(NB+1)-1,1)
      ENDIF
C
      RETURN
C
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C     Beginning of CJMPLS_1
C 
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC 
      SUBROUTINE CJMPLS_1(amu,rmbar,bh47,len,nm,ihinge,icbody,
     &                    inbody,ithisb,inbord,qin,psi,y,ydt,
     &                    kmbpvt,p,btilde,bhinb,dbetxi,temp,
     &                    temp1,ihpath,rinv,isel,isdof,ibetdt,
     &                    ihcutj,rlamda)
C
      IMPLICIT NONE
 
#include "PARAM.FOR"
C
C     COMMON BLOCKS FROM DISCOS
C
#include "AMUBW.INC"
#include "BHBSRD.INC"
#include "CLOOP.INC"
#include "CONSTR.INC"
#include "CPATHS.INC"
#include "F1BKF2.INC"
#include "HANDS2.INC"      
#include "HEAPMB.INC"
#include "IVCONS.INC"
#include "JILFLG.INC"
#include "LAMBDA.INC"
#include "MISCNO.INC"
#include "MISCN2.INC"
#include "MOMENG.INC"
#include "ORDERN.INC"
#include "PARTCL.INC"
#include "SELECT.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
#include "VECTOR.INC"
C
C     PASSED VARIABLES
C
      integer len,nm,ihinge,icbody,inbody,ithisb,inbord
      integer isel(6*cL02)
      integer isdof(9,cL02)
      integer ibetdt(cL02)
      integer ihcutj(cL63)
      logical qin
      logical ihpath(cL63+1,cL02)
      double precision amu(len,len),rmbar(len,len)
      double precision bh47(3,*)  ! mode section only
      double precision psi(6,cL06,MAXBOD)
      integer KMBPVT(cL08,L01)
      double precision y(cL07),ydt(cL07)
      double precision p(cL10)
      double precision btilde(cL11,6,L01,cL63)
      double precision rinv(6,6,cL02)
      double precision rlamda(cl64)
C
C     LOCAL VARIABLES
C
      INTEGER I, J, IROW, ICUT, IHINGC
      INTEGER IBTDT
      INTEGER LENI, NFREE, NCONS, NDOF, NCONC
      INTEGER LOCF, LOCC, LOCUIN, LOCUIC
      DOUBLE PRECISION SUM
C
C     LOCAL ARRAYS
C
      DOUBLE PRECISION BOU(6)
      DOUBLE PRECISION DBETXI(cL11)
      DOUBLE PRECISION TEMP(cL11), TEMP1(cL11)
      DOUBLE PRECISION DUMPSI,DUMBH(6)  
      DOUBLE PRECISION BHINB(6,cL08)
C
#include "LDEBUG.INC"
      LOGICAL LEQU
      EQUIVALENCE (LEQU,DEBUG(87))
C
      IF(LEQU) THEN
         WRITE (MBOUT,1000)
         WRITE (MBOUT,*) ' P ENTERING CJMPLS'
         CALL WRITES(P,1,LOCU(NB+1)-1,1)
      END IF
 1000 FORMAT (' SUBROUTINE CJMPLS ')

C
         LOCF  = ISDOF(1,IHINGE)
         LOCC  = ISDOF(2,IHINGE)
         NFREE = ISDOF(3,IHINGE)
         NCONS = ISDOF(4,IHINGE)
         NDOF  = NFREE + NCONS
C
         LOCUIN = LOCU(INBODY)
         LOCUIC = LOCU(ICBODY)
         LENI   = LENU(INBODY)
C
C                 -1
C        COMPUTE R   B    DU
C                 I1  OI-1  I-1
C
CCC
CCC MULT3 BHINB(1,1), YDT(LOCUIN), BOU, NDOF, LENI, 1, 6, LENI, 6
CCC
         CALL BHMULT(qin,ihinge,1,ydt(locuin),bou,leni,leni,6,
     .               intLoopHeap(iibhtypeptr),intLoopheap(
     .               iitopolptr),intLoopheap(iibh_ptrptr))
C
CC@CC
CC@CC ...MULT3 RINV(1,1,IHINGE), BOU, YDT(LOCUIC)
CC@CC ...NDOF, NDOF, 1
CC@CC ...6, 6, 6
      CALL DGEMV ('N',NDOF,NDOF,1.0d0,RINV(1,1,IHINGE),6,BOU,1,0.0d0,YDT
     .(LOCUIC),1)
CC@CC end of expanded call
CC@CC
C
C        MAKE SURE THAT M-BAR EXISTS FOR THIS HINGE/BODY
C
         IF (NFREE + NM .GT. 0) THEN
C
C         _  _
C        |   F |
C        | DB  |                    _                  _
C        |   I |    _-1    T   ~   |  -1                |   ~T
C        |     | =  M   PSI  ( M   | R    B     DU      | + b   h  )
C        |     |     I     I    I  |  I    OI-1   I-1   |    Ic  c
C        | DXI |                   |___________________ |
C        |    I|                   |         0          |
C        |_   _|                   |          NM        |
C                                  |_                  _|
C
CC@CC
CC@CC ......MULT3 AMU, YDT(LOCUIC), TEMP1
CC@CC ......LEN, NDOF, 1
CC@CC ......LEN, 6, L11
      CALL DGEMV ('N',LEN,NDOF,1.0d0,AMU,LEN,YDT(LOCUIC),1,0.0d0,TEMP1,1
     .)
CC@CC end of expanded call
CC@CC
C
C           ADD IN THE CUT JOINT TERMS
C
            IROW = 1
            DO 889 ICUT = 1, NCUT
               IHINGC = IHCUTJ(ICUT)
               NCONC  = ISDOF(4,IHINGC)
               IF ((NCONC .GT. 0) .AND. (IHPATH(ICUT,IHINGE))) THEN
CC@CC
CC@CC ............MULTAD BTILDE(1,1,ICBODY,ICUT), RLAMDA(IROW), TEMP1
CC@CC ............LEN, NCONC, 1
CC@CC ............L11, 6, L11
      CALL DGEMV('N',LEN,NCONC,1.0d0,BTILDE(1,1,ICBODY,ICUT),cL11,RLAMDA
     .(IROW),1,1.0d0,TEMP1,1)
CC@CC end of expanded call
CC@CC
               END IF
               IROW = IROW + NCONC
 889        CONTINUE
C
            if (nbdy .GT. 0) then  ! 1st body is a body
               CALL PSITX (PSI(1,1,ICBODY), RINV(1,1,IHINGE),ISEL(LOCF),
     +                  NDOF,NFREE,NM,TEMP1,DBETXI)
            else
               CALL PSITX (DUMPSI, RINV(1,1,IHINGE),ISEL(LOCF),NDOF,
     +                     NFREE,NM,TEMP1,DBETXI)
            end if
            CALL DSISL (rmbar,LEN,NFREE+NM,
     +              KMBPVT(1,ICBODY),DBETXI)
C
            IF (LEQU .AND. NFREE+NM .GT. 0) THEN
               WRITE (MBOUT,1023) IHINGE
               CALL WRITES(DBETXI,1,NFREE+NM,1)
            END IF
 1023    FORMAT(' DBETXI FOR HINGE',I3)
C
C                      -1              f
C          Dgamma  =  R   ( PHI   DBeta   - b    DU    - F   Dxi  )
C                i     Ii      Ii      Ii    Oi-1  i-1    Ii    i
C
            DO J = 1, NDOF
               TEMP1(J) = - BOU(J)
            END DO
            DO J = 1, NFREE
               I = ISEL(LOCF+J-1)
               TEMP1(I) = TEMP1(I) + DBETXI(J)
            END DO
C
 139        IF (NM .GT. 0) THEN
CC
CC    Original: MULT3 BH(4,7,ithisb),DBETXI(NFREE+1),TEMP,3,NM,1,6,NM,6
CC
c
               if (ihinge.GT.1 .AND. ndof.EQ.6) then
c     This section is only used if the leading edge of BH is 6
CC@CC
CC@CC MULT3 BH47, dbetxi(nfree+1), temp
CC@CC 3, nm, 1
CC@CC 3, nm, 6
      CALL DGEMV ('N',3,nm,1.0d0,BH47,3,dbetxi(nfree+1),1,0.0d0,temp,1)
CC@CC end of expanded call
CC@CC
               else      ! Mode section is = 0
                  do j = 1,3
                     temp(j) = 0.0d0
                  end do
               end if
c
               CALL MSUB  (TEMP1(4),TEMP,TEMP1(4),3,1,6)
            END IF
C
C           FINISH COMPUTING DGAMMA.
CC@CC
CC@CC ......MULT3 RINV(1,1,IHINGE), TEMP1, YDT(LOCUIC)
CC@CC ......NDOF, NDOF, 1
CC@CC ......6, 6, 6
      CALL DGEMV ('N',NDOF,NDOF,1.0d0,RINV(1,1,IHINGE),6,TEMP1,1,0.0d0,Y
     .DT(LOCUIC),1)
CC@CC end of expanded call
CC@CC
C
C           NOW APPLY THE CORRECTIONS
C
            IBTDT = IBETDT(IHINGE)
            DO 301 I = 1, NFREE
               Y(IBTDT) = Y(IBTDT) + DBETXI(I)
               IBTDT    = IBTDT + 1
 301        CONTINUE
C
            DO I = 0, NDOF-1
               Y(LOCUIC+I) = Y(LOCUIC+I) + YDT(LOCUIC+I)
            END DO
C
            DO 401 I = 1, NM
               Y(LOCUIC+5+I)   = Y(LOCUIC+5+I) + DBETXI(NFREE+I)
               YDT(LOCUIC+5+I) = DBETXI(NFREE+I)
 401        CONTINUE
         ELSE
            DO J = 0, NDOF-1
               YDT(LOCUIC+J) = - YDT(LOCUIC+J)
               Y(LOCUIC+J)   =   Y(LOCUIC+J) + YDT(LOCUIC+J)
            END DO
         END IF
C
         IF (LEQU) THEN
            WRITE (MBOUT,1070) ICBODY
            CALL WRITES(YDT(LOCUIC),1,NDOF+NM,1)
            WRITE (MBOUT,1080) INBORD
            CALL WRITES(BOU,1,NDOF,1)
         END IF
 1070    FORMAT (' DGAMXI FOR BODY',I3)
 1080    FORMAT (' INBORD =', I3, ' BOU :')
C
C     APPLY CORRECTIONS TO THE INBOARD BODY'S MOMENTA
C
         IF (NCONS .GT. 0) THEN
            if (qin) then
               call getbh(ihinge,1,qin,bhinb,inbody,irgflx(inbody),
     &                     dumbh,0,0,intLoopHeap(iibhtypeptr),
     &                     intLoopHeap(iihthptrptr),
     &                     intLoopheap(iibh_ptrptr))
            else
               call getbh(ihinge,1,qin,dumbh,0,0,bhinb,inbody,
     &                     irgflx(inbody),intLoopHeap(iibhtypeptr),
     &                     intLoopHeap(iihthptrptr),
     &                     intLoopheap(iibh_ptrptr))
            end if
            DO I = 1, NCONS
               BOU(I) = BOU(ISEL(LOCC+I-1))
            END DO
            CALL DSISL (RJUPPR(1,1,ICBODY),6,NCONS,JPVT(1,ICBODY),
     +           BOU)
            DO I = 1, LENI
               SUM = P(LOCUIN+I-1)
               DO J = 1, NCONS
                  SUM = SUM - BHINB(ISEL(LOCC+J-1),I)*BOU(J)
               END DO
               P(LOCUIN+I-1) = SUM
            END DO
         END IF
C
C     APPLY CORRECTIONS TO THE CURRENT BODY'S MOMENTA
C
CC@CC
CC@CC ...MULTAD AMU, YDT(LOCUIC), P(LOCUIC)
CC@CC ...LEN, LEN, 1
CC@CC ...LEN, L11, L08
      CALL DGEMV ('N',LEN,LEN,1.0d0,AMU,LEN,YDT(LOCUIC),1,1.0d0,P(LOCUIC
     .),1)
CC@CC end of expanded call
CC@CC
C
         IF (LEQU) THEN
            WRITE (MBOUT,1010) LOCUIC,LOCUIC-1+NDOF+NM,ICBODY
            CALL WRITES(Y(LOCUIC),1,NDOF+NM,1)
            IF (NFREE .GT. 0) THEN
               WRITE (MBOUT,1020) IBETDT(IHINGE),IBETDT(IHINGE)+NFREE-1,
     +              IHINGE
               CALL WRITES(Y(IBETDT(IHINGE)),1,NFREE,1)
            END IF
         ENDIF
 1010 FORMAT (' Y(',I3,'...',I3,'), NEW U FOR BODY ',I3)
 1020 FORMAT (' Y(',I3,'...',I3,'), NEW BETA DOT FOR HINGE ',I3)
C
C
      RETURN
C
      END    ! End of cjmpls_1
