C $Header: /export/cvs/c34a1/source/moldyn/clfor3.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      SUBROUTINE CLFOR3(GTILDE,PSI,YDT,KMBPVT,BTILDE,KPVT,TEMP,TEMP1,
     &                  RINV,ZETA,IHTHPTR,IV,IHPVT,PIN,ISEL,ISDOF,
     &                  IBETDT,ITOPOL,ALAM,ibh_ptr,ihcutj,rlamda)
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      IMPLICIT NONE
CPS
C     PURPOSE:
C
C     This subroutine is used to make the second forward pass for the
C     Order N algorithm for closed loop topologies.  During this pass relative
C     hinge and modal accelerations are computed.  The operations are similar
C     to those performed by subroutine FRWRD2, except that there are
C     additional terms in the recursion relation.  The recursion begins at
C     the base body and terminates with the end bodies.
C
CPE
#include "PARAM.FOR"
C
#include "AMUBW.INC"
#include "BHBSRD.INC"
#include "CLOOP.INC"
#include "CONSTR.INC"
#include "CPATHS.INC"
#include "ERRHDL.INC"
#include "F1BKF2.INC"
#include "HANDS2.INC"
#include "HEAPMB.INC"
#include "IVCONS.INC"
#include "JILFLG.INC"
#include "LAMBDA.INC"
#include "MISCNO.INC"
#include "MISCN2.INC"
#include "NUMBRS.INC"
#include "ORDERN.INC"
#include "PARTCL.INC"
#include "PINRP.INC"      
#include "SELECT.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
#include "VECTOR.INC"
C
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: clfor3.f,v $$Revision: 1.1.1.1 $'/

c     Passed variables
c
      DOUBLE PRECISION PSI(6,cL06,MAXBOD)
      DOUBLE PRECISION YDT(cL07)
      integer KMBPVT(cL08,L01)
      DOUBLE PRECISION BTILDE(cL11,6,L01,cL63)
      DOUBLE PRECISION RINV(6,6,cL02)
      DOUBLE PRECISION ZETA(6,cL02)
      DOUBLE PRECISION PIN(3,3,cL02)
      DOUBLE PRECISION ALAM(cL09)
      DOUBLE PRECISION RLAMDA(cL64)
      INTEGER IHTHPTR(2*cL02)
      INTEGER IV(6,cL02)
      INTEGER IHPVT(cL02)
      INTEGER ISEL(6*cL02)
      INTEGER ISDOF(9,cL02)
      INTEGER IBETDT(cL02)
      INTEGER ITOPOL(2,cL02)
      INTEGER ibh_ptr(cL12+1)
      INTEGER ihcutj(cl63)
c
C     Local Variables
C
      INTEGER MTSIZE,NDOF,NM,N0
      INTEGER IROW,ICUT,IHINGE,IHINGC,ISROW
      INTEGER IBTDT,NCONC,NERROR,INFO
      INTEGER IC,IBODY,ICBODY,INBODY
      INTEGER LOCF,NFREE
      INTEGER INBORD,LOCC, NCONS,ITHISB
      INTEGER I,J
      INTEGER icamu,icrm,icbh    ! Pointers to heap
      INTEGER KPVT(cL08)
      DOUBLE PRECISION SUM
      DOUBLE PRECISION  GTILDE(cL10)
      DOUBLE PRECISION  ZMBOIU(6)
      DOUBLE PRECISION  TEMP (cL11)
      DOUBLE PRECISION  TEMP1(cL11)
      DOUBLE PRECISION  DUMPSI    ! To pass to psitx if prtcl
      LOGICAL qot,qin             ! which frame is out/in
      LOGICAL useHATS 
      
C
#include "LDEBUG.INC"
      LOGICAL LEQU
      EQUIVALENCE (LEQU,DEBUG(87))

      data icbh/BADADDR/
C
      IF(LEQU) WRITE (MBOUT,1000)
 1000 FORMAT (' SUBROUTINE CLFOR3 ')
C
C     FIRST DO THE REFERENCE BODY, BODY 1
C
      NM     = IRGFLX(1)
      LOCF   = ISDOF(1,1)
      NFREE  = ISDOF(3,1)
      NDOF   = ISDOF(4,1) + NFREE
      MTSIZE = LENU(1)
      icamu  = iamuptr(1)
      icrm   = irm_ptr(1)
C
CC@CC
CC@CC MULT3 RINV(1,1,1), ZETA(1,1), YDT
CC@CC NDOF, NDOF, 1
CC@CC 6, 6, 6
      CALL DGEMV ('N',NDOF,NDOF,1.0d0,RINV(1,1,1),6,ZETA(1,1),1,0.0d0,YD
     .T,1)
CC@CC end of expanded call
CC@CC
C
      IF (NM + NFREE .GT. 0) THEN
C
CC@CC
CC@CC ...MULT3 HEAP_MB(icamu), YDT, TEMP1
CC@CC ...MTSIZE, NDOF, 1
CC@CC ...MTSIZE, 6, 6
      CALL DGEMV ('N',MTSIZE,NDOF,1.0d0,HEAP_MB(icamu),MTSIZE,YDT,1,0.0d
     .0,TEMP1,1)
CC@CC end of expanded call
CC@CC
C
         CALL MSUB  (GTILDE,TEMP1,TEMP1,MTSIZE,1,MTSIZE)
C
C        ADD IN THE CUT JOINT TERMS
C
         IROW = 1
         DO 888 ICUT = 1, NCUT
            IHINGE = IHCUTJ(ICUT)
            NCONS  = ISDOF(4,IHINGE)
            IF (NCONS .GT. 0) THEN
CC@CC
CC@CC .........MULTAD BTILDE(1,1,1,ICUT), RLAMDA(IROW), TEMP1
CC@CC .........MTSIZE, NCONS, 1
CC@CC .........L11, 6, L11
      CALL DGEMV ('N',MTSIZE,NCONS,1.0d0,BTILDE(1,1,1,ICUT),cL11,RLAMDA(
     .IROW),1,1.0d0,TEMP1,1)
CC@CC end of expanded call
CC@CC
               IROW = IROW + NCONS
            END IF
 888     CONTINUE
         IF(LEQU) CALL MWRITE(RLAMDA,1,IROW-1,'RLAMDA',1)
C
         IF (nbdy .gt. 0) THEN
            CALL PSITX (PSI,RINV,ISEL(LOCF),NDOF,
     +               NFREE,NM,TEMP1,TEMP)
         ELSE
            CALL PSITX (DUMPSI,RINV,ISEL(LOCF),NDOF,
     +               NFREE,NM,TEMP1,TEMP)
         END IF
         CALL DSISL (HEAP_MB(icrm),MTSIZE,NFREE+NM,KMBPVT,TEMP)
C
C        NOW COMPUTE GAMMA DOUBLE DOT.
         DO  J = 1, NDOF
            ZMBOIU(J) = ZETA(J,1)
         END DO
         DO 200 J = 1, NFREE
            ISROW = ISEL(LOCF+J-1)
            ZMBOIU(ISROW) = ZMBOIU(ISROW) + TEMP(J)
 200     CONTINUE
C
CC@CC
CC@CC ...MULT3 RINV(1,1,1), ZMBOIU, YDT
CC@CC ...NDOF, NDOF, 1
CC@CC ...6, 6, 6
      CALL DGEMV ('N',NDOF,NDOF,1.0d0,RINV(1,1,1),6,ZMBOIU,1,0.0d0,YDT,1
     .)
CC@CC end of expanded call
CC@CC
C
C        NOW COPY TEMP TO ITS TARGET YDT LOCATIONS
C        FIRST THE BETAS
C
         IBTDT = IBETDT(1)
         DO 300 I = 1, NFREE
            YDT(IBTDT) = TEMP(I)
            IBTDT      = IBTDT + 1
 300     CONTINUE
C
C        AND NOW THE XIS
C
         DO 400 I = 1, NM
            YDT(6 + I) = TEMP(NFREE + I)
 400     CONTINUE
C
      END IF
C
C     (RE)COMPUTE AND SAVE QUANTITIES TO ENABLE LAMDA OUTPUT
C
      NCONS = ISDOF(4,1)
      IF ((IPRNT .EQ. NOPRNT) .AND. (JIL .EQ. 4)
     +    .AND. (NCONS .GT. 0)) THEN
C
         DO I = 1, cL11
            TEMP(I) = 0.0D0
         END DO
C
         IROW = 1
         DO ICUT = 1, NCUT
            IHINGC = IHCUTJ(ICUT)
            NCONC  = ISDOF(4,IHINGC)
            IF (NCONC .GT. 0) THEN
CC@CC
CC@CC .........MULTAD BTILDE(1,1,1,ICUT), RLAMDA(IROW), TEMP
CC@CC .........MTSIZE, NCONC, 1
CC@CC .........L11, 6, L11
      CALL DGEMV ('N',MTSIZE,NCONC,1.0d0,BTILDE(1,1,1,ICUT),cL11,RLAMDA(
     .IROW),1,1.0d0,TEMP,1)
CC@CC end of expanded call
CC@CC
               IROW = IROW + NCONC
            END IF
         END DO
                                                           NERROR = 1
         CALL DSIFA (HEAP_MB(icamu),MTSIZE,MTSIZE,KPVT,INFO) !amu(icbody)
         IF (INFO .NE. 0) GO TO 999
C
         CALL DSISL (HEAP_MB(icamu),MTSIZE,MTSIZE,KPVT,TEMP) !amu(icbody)
C
         LOCC  = ISDOF(2,1) - 1
C
c     Use inline logic here instead of assembling BH(1)
         DO I = 1, NCONS
            ISROW = ISEL(LOCC + I)
            SUM = VLAM(I,1)
            if (nbdy .EQ. 0) then
               if (isrow .LE. 3) then
                  sum = sum - temp(isrow)
               else
                  write(mbout,*) 'Bad size for hinge 1 in clfor3'
               end if
            else
               if (isrow .LE. 3) then
                  if (ndof .GE. 3) then
                     DO J = 1, 3
                        SUM = SUM - pin(ISROW,J,1)*TEMP(J)
                     END DO
                  else
                     write(mbout,*) 'Bad size for hinge 1 in clfor3'
                  end if
               else             ! isrow > 3
                  if (ndof .GE. 6) then
                     DO j = 1, 3
                        sum = sum - r0l(isrow-3,j,1)*temp(j+3)
                     END DO
                  else
                     write(mbout,*) 'Bad size for hinge 1 in clfor3'
                  end if
               end if
            end if
            VLAM(I,1) = SUM
         END DO
C
C           NOW MULTIPLY BY J INVERSE AND STORE IN ALAM
C
         CALL DSISL (RJUPPR,6,NCONS,JPVT,VLAM)
         N0 = 6 - NDOF
         DO I = 1, NCONS
            ISROW = ISEL(LOCC + I)
            IC = IV(ISROW+N0,1)
            ALAM(IC) = VLAM(I,1)
         END DO
      END IF
C
      IF(LEQU) THEN
         WRITE (MBOUT,1010) 1,MTSIZE,1
 1010    FORMAT (' YDT(',I3,'...',I3,'), U(dot) FOR BODY ',I3)
         WRITE (MBOUT,1030) (YDT(I),I=1,MTSIZE)
         WRITE (MBOUT,1020) IBETDT(1),IBETDT(1)-1+NFREE,1
 1020    FORMAT (' YDT(',I3,'...',I3,
     *                    '), Beta(double dot) FOR HINGE ',I3)
         WRITE (MBOUT,1030) (YDT(IBETDT(1)-1+I),I=1,NFREE)
 1030    FORMAT (20X,1P6E15.5)
      ENDIF
C
C     NOW FOR THE REST OF THE BODIES
C
      DO 600 IBODY = 2, NB
C
         IHINGE = ITOPW(1,IBODY)
         ICBODY = ITOPW(2,IBODY)
C
         IF (IHINGE .LT. 0) THEN     ! P frame is on this body
            IHINGE = -IHINGE
            INBODY = ITOPOL(1,IHINGE)
            INBORD = 2 * IHINGE - 2
            ITHISB = INBORD + 1
            qot    = .FALSE.
            qin    = .TRUE.
         ELSE                        ! Q frame is on this body
            INBODY = ITOPOL(2,IHINGE)
            ITHISB = 2 * IHINGE - 2
            INBORD = ITHISB + 1
            qot    = .TRUE.
            qin    = .FALSE.
         END IF
C
         NM     = IRGFLX(ICBODY)    
         icamu  = iamuptr(icbody)   ! amu pointer
         icrm   = irm_ptr(icbody)   ! rmbar pointer
         MTSIZE = LENU(ICBODY)      ! amu/rmbar size
         useHATS= .FALSE. 
c
c     Get pointer to mode section of BH
c
         if (nm .GT. 0) then
            if (qot) then
               if (ihpvt(ihinge) .EQ. 0) then
                  icbh = ibh_ptr(ithisb) + 9
               else
                  icbh = ibh_ptr(ithisb) + 18
               end if
            else                ! P-frame is outboard
               if (ihpvt(ihinge) .EQ. 0) then
c          this mode section of BH = -hats
                  icbh = ihthptr(2*ihinge-2) + 1   ! Part of HATS stores the same info as BH. 
                  useHATS = .TRUE.                 ! Refer to HATS for BH info.
               else
                  icbh = ibh_ptr(ithisb) + 18
               end if
            end if
         end if
c
c     Pass heap_mb location of amu, rmbar, and bh to clfor3_1
c
         if (useHATS) then
           call clfor3_1(GTILDE,HEAP_MB(icamu),HEAP_MB(icrm),
     &                 HATS(icbh),icbody,inbody,ithisb,inbord,
     &                 qin,qot,mtsize,nm,ihinge,HEAP_MB(ipsiptr),
     &                 HEAP_MB(iydtptr),intHEAP_MB(ikmbpvtptr),
     &                 HEAP_MB(ibtildeptr),
     &                 intLocalHeap(ikpvtptr_clfor3_1),
     &                 LocalHeap(ibhoutptr_clfor3_1),
     &                 LocalHeap(itempptr_clfor3_1),
     &                 LocalHeap(itemp1ptr_clfor3_1),
     &                 LogicLoopHeap(iihpathptr),
     &                 LoopHeap(irinvptr),LoopHeap(izetaptr),
     &                 intLoopHeap(iivptr),intLoopheap(iiselptr),
     &                 intLoopHeap(iisdofptr),intLoopheap(iibetdtptr),
     &                 Loopheap(ialamptr),intLoopheap(iihcutjptr),
     &                 Loopheap(irlamdaptr))
         else
           call clfor3_1(GTILDE,HEAP_MB(icamu),HEAP_MB(icrm),
     &                 BH(icbh),icbody,inbody,ithisb,inbord,
     &                 qin,qot,mtsize,nm,ihinge,HEAP_MB(ipsiptr),
     &                 HEAP_MB(iydtptr),intHEAP_MB(ikmbpvtptr),
     &                 HEAP_MB(ibtildeptr),
     &                 intLocalHeap(ikpvtptr_clfor3_1),
     &                 LocalHeap(ibhoutptr_clfor3_1),
     &                 LocalHeap(itempptr_clfor3_1),
     &                 LocalHeap(itemp1ptr_clfor3_1),
     &                 LogicLoopHeap(iihpathptr),
     &                 LoopHeap(irinvptr),LoopHeap(izetaptr),
     &                 intLoopHeap(iivptr),intLoopheap(iiselptr),
     &                 intLoopHeap(iisdofptr),intLoopheap(iibetdtptr),
     &                 Loopheap(ialamptr),intLoopheap(iihcutjptr),
     &                 Loopheap(irlamdaptr))
         end if
C
 600  CONTINUE
C
      IF(LEQU) THEN
         WRITE (MBOUT,*) ' YDT LEAVING CLFOR3 '
         CALL WRITES (YDT,1,NEQ,1)
         WRITE (MBOUT,*) ' ALAM LEAVING CLFOR3 '
         CALL WRITES (ALAM,1,NLAM,1)
      ENDIF
C
      RETURN
C
 999  CALL CLEARERR()
      WRITE (ERRMSG,2034) 'Matrix signular ', NERROR
 2034 FORMAT(1X,A,I2)
      CALL ERRHDL(-5,'<CLFOR3>')
C
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C     Beginning of clfor_1
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC 
      SUBROUTINE CLFOR3_1(GTILDE,amu,rmbar,bh17,icbody,inbody,ithisb,
     &           inbord,qin,qot,mtsize,nm,ihinge,psi,ydt,kmbpvt,
     &           btilde,kpvt,bhout,temp,temp1,ihpath,rinv,zeta,
     &           iv,isel,isdof,ibetdt,alam,ihcutj,rlamda)
C                                                          DEBUG #  87
      IMPLICIT NONE
CPE
#include "PARAM.FOR"
C
#include "AMUBW.INC"
#include "BHBSRD.INC"
#ifdef CHARMM
#include "CHARMM.INC"
#endif
#include "CLOOP.INC"
#include "CONSTR.INC"
#include "CPATHS.INC"
#include "ERRHDL.INC"
#include "F1BKF2.INC"
#include "HANDS2.INC"
#include "IVCONS.INC"
#include "JILFLG.INC"
#include "LAMBDA.INC"
#include "HEAPMB.INC"
#include "MISCNO.INC"
#include "MISCN2.INC"
#include "ORDERN.INC"
#include "PARTCL.INC"
#include "PINRP.INC"      
#include "SELECT.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
#include "VECTOR.INC"
C
C     Passed Variables
C
      INTEGER ihinge,mtsize,icbody,inbody
      INTEGER ithisb,inbord,nm
      LOGICAL qot,qin
      LOGICAL ihpath(cL63+1,cL02)
      DOUBLE PRECISION AMU(mtsize,mtsize),rmbar(mtsize,mtsize)
      DOUBLE PRECISION BH17(3,*)
      DOUBLE PRECISION PSI(6,cL06,MAXBOD)
      DOUBLE PRECISION YDT(cL07)
      integer KMBPVT(cL08,L01)
      DOUBLE PRECISION BTILDE(cL11,6,L01,cL63)
      DOUBLE PRECISION RINV(6,6,cL02)
      DOUBLE PRECISION ZETA(6,cL02)
      DOUBLE PRECISION ALAM(cL09)
      DOUBLE PRECISION RLAMDA(cL64)
      INTEGER IV(6,cL02)
      INTEGER ISEL(6*cL02)
      INTEGER ISDOF(9,cL02)
      INTEGER IBETDT(cL02)
      INTEGER IHCUTJ(cL63)
C
C     Local Variables
C
      INTEGER NDOF,NMI,N0
      INTEGER IROW,ICUT,IHINGC,ISROW
      INTEGER IBTDT,NCONC,NERROR,INFO
      INTEGER IC
      INTEGER IHC,IHI,LOCF,NFREE
      INTEGER LOCC, NCONS
      INTEGER LOCUIC,LOCUIN,MTISIZ
      INTEGER I,J
      INTEGER KPVT(cL08)
      DOUBLE PRECISION SUM
      DOUBLE PRECISION  GTILDE(cL10)
      DOUBLE PRECISION  ZMBOIU(6), BOU(6)
      DOUBLE PRECISION  TEMP (cL11)
      DOUBLE PRECISION  TEMP1(cL11)
      DOUBLE PRECISION  bhout(6,cL08),dumbh(6)
      DOUBLE PRECISION  DUMPSI    ! To pass to psitx if prtcl
C
#include "LDEBUG.INC"
      LOGICAL LEQU
      EQUIVALENCE (LEQU,DEBUG(87))
C
      IF(LEQU) WRITE (MBOUT,1000)
 1000 FORMAT (' SUBROUTINE CLFOR3 ')
C
C
         LOCF   = ISDOF(1,IHINGE)
         NFREE  = ISDOF(3,IHINGE)
         NDOF   = NFREE + ISDOF(4,IHINGE)
         N0     = 6 - NDOF
         NM     = IRGFLX(ICBODY)
         NMI    = IRGFLX(INBODY)
         LOCUIC = LOCU(ICBODY)
         LOCUIN = LOCU(INBODY)
         MTISIZ = LENU(INBODY)
C
C                 -1               .
C        COMPUTE R   (ZETA  - B    U   ) (= GAMMA, IFF NM+NFREE=0)
C                 I1      1    OI-1 I-1
C
CCC
CCC MULT3 BHINB(1,1), YDT(LOCUIN), BOU, NDOF, MTISIZ, 1, 6, MTISIZ, 6
CCC
         CALL BHMULT(qin,ihinge,1,YDT(LOCUIN),BOU,MTISIZ,MTISIZ,6,
     *              intLoopHeap(iibhtypeptr),intLoopHeap(iitopolptr),
     *              intLoopHeap(iibh_ptrptr))
C
         IF(LEQU) WRITE (MBOUT,1070) LOCUIN,(YDT(LOCUIN+I-1),I=1,NDOF)
 1070    FORMAT (' LOCUIN, YDT(LOCUIN...)    = ',I10,6(1PE15.5))
         IF(LEQU) WRITE (MBOUT,1080) INBORD,(BOU(I),I=1,NDOF)
 1080    FORMAT (' INBORD, BOU               = ',I10,6(1PE15.5))
C     
         CALL MSUB  (ZETA(1,IHINGE),BOU,ZMBOIU,NDOF,1,6)
C
         IF(LEQU) WRITE (MBOUT,1090) IHINGE,(ZMBOIU(I),I=1,NDOF)
 1090    FORMAT (' IHINGE, ZMBOIU            = ',I10,6(1PE15.5))
C
CC@CC
CC@CC ...MULT3 RINV(1,1,IHINGE), ZMBOIU, YDT(LOCUIC)
CC@CC ...NDOF, NDOF, 1
CC@CC ...6, 6, 6
      CALL DGEMV ('N',NDOF,NDOF,1.0d0,RINV(1,1,IHINGE),6,ZMBOIU,1,0.0d0,
     .YDT(LOCUIC),1)
CC@CC end of expanded call
CC@CC
         IF(LEQU) WRITE (MBOUT,1100) LOCUIC,(YDT(LOCUIC+I-1),I=1,NDOF)
 1100    FORMAT (' LOCUIC, YDT(LOCUIC...)    = ',I10,6(1PE15.5))
C
C        MAKE SURE THAT M-BAR EXISTS FOR THIS HINGE/BODY
         IF (NFREE + NM .GT. 0) THEN
C
C         _  _
C        | ..F|
C        | B  |                         _                            _
C        |  I |    _-1    T  ~     ~   |  -1                  .       |
C        |    | =  M   PSI  (G  -  M   | R   ( ZETA  -  B     U    )  |
C        | .. |     I     I   I     I  |  I        I     OI-1  I-1    |
C        | XI |                        |_____________________________ |
C        |   I|                        |             0                |
C        |_  _|                        |              NM              |
C                                      |_                            _|
C
CC@CC
CC@CC ......MULT3 AMU, YDT(LOCUIC), TEMP1
CC@CC ......MTSIZE, NDOF, 1
CC@CC ......MTSIZE, 6, L11
      CALL DGEMV ('N',MTSIZE,NDOF,1.0d0,AMU,MTSIZE,YDT(LOCUIC),1,0.0d0,T
     .EMP1,1)
CC@CC end of expanded call
CC@CC
C
            CALL MSUB  (GTILDE(LOCUIC),TEMP1,TEMP1,MTSIZE,1,MTSIZE)
            IF(LEQU)
     +           WRITE (MBOUT,1110) LOCUIC,(GTILDE(LOCUIC+I-1),I=1,NDOF)
 1110       FORMAT (' LOCUIC, GTILDE(LOCUIC...) = ',I10,6(1PE15.5))
C
C           ADD IN THE CUT JOINT TERMS
C
            IROW = 1
            DO 889 ICUT = 1, NCUT
               IHINGC = IHCUTJ(ICUT)
               NCONS  = ISDOF(4,IHINGC)
               IF ((NCONS .GT. 0) .AND. (IHPATH(ICUT,IHINGE))) THEN
                  IF(LEQU) THEN
                     WRITE (MBOUT,1120) ICBODY,ICUT
 1120                FORMAT (' BTILDE(',I3,',',I3,')')
                     CALL WRITES(BTILDE,MTSIZE,NCONS,cL11)
                     WRITE (MBOUT,1130) IROW,(RLAMDA(IROW+I-1),I=1,
     &                      NCONS)
 1130                FORMAT (' IROW, RLAMDA(IROW...)     = ',I10,
     +                    6(1PE15.5))
                  END IF
CC@CC
CC@CC ............MULTAD BTILDE(1,1,ICBODY,ICUT), RLAMDA(IROW), TEMP1
CC@CC ............MTSIZE, NCONS, 1
CC@CC ............L11, 6, L11
      CALL DGEMV('N',MTSIZE,NCONS,1.0d0,BTILDE(1,1,ICBODY,ICUT),cL11,RLA
     .MDA(IROW),1,1.0d0,TEMP1,1)
CC@CC end of expanded call
CC@CC
               END IF
               IROW = IROW + NCONS
 889        CONTINUE
C
            IF (icbody .le. nbdy) THEN
               CALL PSITX (PSI(1,1,ICBODY), RINV(1,1,IHINGE),ISEL(LOCF),
     +                  NDOF,NFREE,NM,TEMP1,TEMP)
            ELSE
               CALL PSITX (DUMPSI, RINV(1,1,IHINGE),ISEL(LOCF),NDOF,
     +                  NFREE,NM,TEMP1,TEMP)
            END IF
            CALL DSISL (RMBAR,MTSIZE,NFREE+NM,
     +              KMBPVT(1,ICBODY),TEMP)
C
C             ..       -1          .. f                 .          ..
C           gamma  =  R   ( PHI   Beta   + zeta  - b    U    - F   xi  )
C                i     Ii      Ii     Ii       i    Oi-1 i-1    Ii   i
C
            DO 201 J = 1, NFREE
               ISROW = ISEL(LOCF+J-1)
               ZMBOIU(ISROW) = ZMBOIU(ISROW) + TEMP(J)
 201        CONTINUE
C
            IF (NM .GT. 0) THEN
CCC
CCC MULT3 BH(1,7,ithisb), TEMP(NFREE + 1), TEMP1, NDOF, NM, 1, 6, NM, 6
CCC
               if (ihinge .GT. 1) then
                  if (ndof .EQ. 3) then
                     j = 1
                  else
                     j = 4
                     do i = 1,3
                        temp1(i) = 0.0d0
                     end do
                  end if
CC@CC
CC@CC MULT3 bh17, temp(nfree+1), temp1(j)
CC@CC 3, nm, 1
CC@CC 3, nm, 6
      CALL DGEMV ('N',3,nm,1.0d0,bh17,3,temp(nfree+1),1,0.0d0,temp1(j),1
     .)
CC@CC end of expanded call
CC@CC
               else    ! 1st hinge mode section = 0
                  do i = 1, ndof
                     temp1(i) = 0.0d0
                  end do
               end if
C
               CALL MSUB  (ZMBOIU,TEMP1,ZMBOIU,NDOF,1,6)
            END IF
C                             ..
C           FINISH COMPUTING GAMMA AND STORE IN YDT.
CC@CC
CC@CC ......MULT3 RINV(1,1,IHINGE), ZMBOIU, YDT(LOCUIC)
CC@CC ......NDOF, NDOF, 1
CC@CC ......6, 6, 6
      CALL DGEMV ('N',NDOF,NDOF,1.0d0,RINV(1,1,IHINGE),6,ZMBOIU,1,0.0d0,
     .YDT(LOCUIC),1)
CC@CC end of expanded call
CC@CC
            IF(LEQU) WRITE (MBOUT,1090) IHINGE,(ZMBOIU(I),I=1,NDOF)
            IF(LEQU) WRITE (MBOUT,1100) LOCUIC,(YDT(LOCUIC+I-1),I=1,
     &                      NDOF)
C
C           NOW COPY TEMP TO ITS TARGET YDT LOCATIONS
            IBTDT = IBETDT(IHINGE)
            DO 301 I = 1, NFREE
               YDT(IBTDT) = TEMP(I)
               IBTDT      = IBTDT + 1
 301        CONTINUE
C
            DO 401 I = 1, NM
               YDT(LOCUIC + 5 + I) = TEMP(NFREE + I)
 401        CONTINUE
         END IF
C
         NCONS = ISDOF(4,IHINGE)
         IF ((IPRNT .EQ. NOPRNT) .AND. (JIL .EQ. 4)
     +        .AND. (NCONS .GT. 0)) THEN
C     (RE)COMPUTE QUANTITIES NEEDED FOR LAMBDA OUTPUT
C
            DO I = 1, cL11
               TEMP(I) = 0.0D0
            END DO
C
            IROW = 1
            DO ICUT = 1, NCUT
               IHC   = IHCUTJ(ICUT)
               NCONC = ISDOF(4,IHC)
               IF (NCONC .GT. 0 .AND. IHPATH(ICUT,IHINGE)) THEN
CC@CC
CC@CC ............MULTAD BTILDE(1,1,ICBODY,ICUT), RLAMDA(IROW), TEMP
CC@CC ............MTSIZE, NCONC, 1
CC@CC ............L11, 6, L11
      CALL DGEMV('N',MTSIZE,NCONC,1.0d0,BTILDE(1,1,ICBODY,ICUT),cL11,RLA
     .MDA(IROW),1,1.0d0,TEMP,1)
CC@CC end of expanded call
CC@CC
               END IF
               IROW = IROW + NCONC
            END DO
                                                           NERROR = 2
               CALL DSIFA (AMU,MTSIZE,MTSIZE,KPVT,INFO) 
               IF (INFO .NE. 0) GO TO 999
C
               CALL DSISL (AMU,MTSIZE,MTSIZE,KPVT,TEMP)
C
            LOCC  = ISDOF(2,IHINGE) - 1
            IF (NCONS .GT. 0) THEN
               if (qot) then
                  CALL getbh(ihinge,1,qot,bhout,icbody,nm,dumbh,0,0,
     *                 intLoopHeap(iibhtypeptr),intLoopHeap(
     *                 iihthptrptr),intLoopheap(iibh_ptrptr))
               else
                  CALL getbh(ihinge,1,qot,dumbh,0,0,bhout,icbody,nm,
     *                 intLoopHeap(iibhtypeptr),intLoopHeap(
     *                 iihthptrptr),intLoopheap(iibh_ptrptr))
               end if
            END IF
            DO I = 1, NCONS
               ISROW = ISEL(LOCC + I)
               IF(LEQU) WRITE (MBOUT,1060) I,ICBODY,VLAM(I,ICBODY)
               SUM = VLAM(I,ICBODY) - BOU(ISROW)
               DO J = 1, MTSIZE
                  SUM = SUM - BHOUT(ISROW,J) * TEMP(J)
               END DO
               VLAM(I,ICBODY) = SUM
               IF(LEQU) THEN
                  WRITE (MBOUT,1060) I,ICBODY,VLAM(I,ICBODY)
 1060             FORMAT (' I,ICBODY,VLAM(I,ICBODY) = ',2I10,1PE15.5)
               ENDIF
            END DO
C
C           NOW MULTIPLY BY J INVERSE TO GET THE LAMBDA'S AND STORE IN ALAM
            CALL DSISL (RJUPPR(1,1,ICBODY),6,NCONS,JPVT(1,ICBODY),
     *           VLAM(1,ICBODY))
            DO I = 1, NCONS
               ISROW = ISEL(LOCC + I)
               IC = IV(ISROW+N0,IHINGE)
               ALAM(IC) = VLAM(I,ICBODY)
               IF(LEQU) THEN
                  WRITE (MBOUT,1050) I,ISROW,IC,ICBODY,ALAM(IC)
 1050             FORMAT (' I,ISROW,IC,ICBODY,ALAM(IC) = ',4I10,1PE15.5)
               ENDIF
            END DO
C
         END IF             ! Test for lambda calculation
C
         IF (LEQU) THEN
            WRITE (MBOUT,1010) LOCUIC,LOCUIC+NDOF-1+NM,ICBODY
            WRITE (MBOUT,1030) (YDT(LOCUIC+I-1),I=1,MTSIZE)
            WRITE (MBOUT,1020) IBETDT(IHINGE),IBETDT(IHINGE)+NFREE-1,IHINGE
            WRITE (MBOUT,1030) (YDT(IBETDT(IHINGE)-1+I),I=1,NFREE)
         ENDIF
C
C
      RETURN
 999  CALL CLEARERR()
      WRITE (ERRMSG,2034) 'Matrix singular.', NERROR
 2034 FORMAT(1X,A,I2)
      CALL ERRHDL(-5,'<CLFOR3_1>')
C
 1010 FORMAT (' YDT(',I3,'...',I3,'), U(dot) FOR BODY ',I3)
 1020 FORMAT (' YDT(',I3,'...',I3,
     *                    '), Beta(double dot) FOR HINGE ',I3)
 1030 FORMAT (20X,1P6E15.5)
c
      END    ! End of clfor3_1
