C $Header: /export/cvs/c34a1/source/moldyn/clfr2b.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      SUBROUTINE CLFR2B(Y,BTILDE,SU,BRN,BHINB,TEMP,TEMP1,BDTQ,
     *                  BDTP,USTAR,IHPATH,IHTHPTR,IV,ISEL,ISDOF,
     *                  ITOPOL,IHDATA,ALAM,ibh_ptr,ihcutj,
     *                  rlamda,aclmat,iclpvt,zetac)
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
CPS
C     PURPOSE:
C
C         This subroutine is used to make the second forward pass for the
C     closed loop order N algorithm.  In this subroutine the variable
C     {U}_star is recursively propagated from the base body
C     towards each of the cut joint end bodies.  The equations for the cut
C     joint Lagrange multipliers are obtained at the end of the recursion,
C     at which point a linear equation solver is invoked to solve for the
C     unknown multipliers.
CPE
CAS                     ARGUMENT LIST
C
C     VC      =  CUT JOINT LAGRANGE MULTIPLIERS STORED IN /CLOOP/
C     RLAMDA  =  VC, NAME CHANGE IN /CLOOP/ OUTSIDE OF SUBROUTINE CLFOR2
C
C             If there is only one closed loop, the cut joint Lagrange
C    multipliers can be sovled for via equation 15.  However if there are
C    multiple closed loops then each of the resulting equations will have
C    terms involving the Lagrange multipliers from each of the cut joints.
C    In such a case, all sets of equations must be solved together to obtain
C    the Lagrange multipliers.  This is done by utlization of Singular Value
C    decomposition methods for the solution of eqaution 21.
C
C  Reference equation numbers from Cambridge Research Memo: Hon Chun to
C    James D. Turner, "Preliminary Order (N) Algorithm for Multiple
C    Closed-Loop Topologies," 16 May 1989
C
CAE
#include "PARAM.FOR"
C
C     DISCOS COMMON BLOCKS
C
#include "BHBSRD.INC"
#include "CLOOP.INC"
#include "CPATHS.INC"
#include "ERRHDL.INC"
#include "HANDS2.INC"
#include "HEAPMB.INC"
#include "IVCONS.INC"
#include "LAMBDA.INC"
#include "MISCNO.INC"
#include "NOUTPT.INC"
#include "NUMBRS.INC"
#include "ORDERN.INC"
#include "SELECT.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
#include "TIMESS.INC"
#include "VECTOR.INC"
C
c     Passed Variable
      DOUBLE PRECISION Y(cL07)
      DOUBLE PRECISION BTILDE(cL11,6,L01,cL63)
      DOUBLE PRECISION SU(L01*cL11)
      DOUBLE PRECISION BRN(cL11,6,MAXBOD)
      DOUBLE PRECISION ALAM(cL09)
      DOUBLE PRECISION RLAMDA(cL64)
      DOUBLE PRECISION ACLMAT(cL64,cL64)
      INTEGER IHTHPTR(2*cL02)
      INTEGER IV(6,cL02)
      INTEGER ISEL(6*cL02)
      INTEGER ISDOF(9,cL02)
      INTEGER ITOPOL(2,cL02)
      INTEGER IHDATA(7,cL02)
      INTEGER ibh_ptr(cL12+1)
      INTEGER ihcutj(cL63)
      INTEGER iclpvt(cL64)
      LOGICAL IHPATH(cL63+1,cL02)   
c
C     LOCAL VARIABLES
C
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: clfr2b.f,v $$Revision: 1.1.1.1 $'/
      INTEGER I, IBODY, ICBODY, INBODY, IBODY1, IBODY2,inbord
      INTEGER IHINGE, IHINGC, IROW, ISROW, ISCOL
      INTEGER ICUT, ICUTC, IC
      INTEGER IBODYP, IBODYQ, MTSIZP, MTSIZQ, LOCP, LOCQ
      INTEGER MTISIZ, MTSIZE, MTSIZ1, MTSIZ2, LOC1, LOC2
      INTEGER LOCC, NCONS, NCONC, NDOF, N0, LOCUIN, LOCUIC
      INTEGER icprt            ! Pointer for particle arrays
      INTEGER ibhq,ibhp,ihatq,ihatp  ! heap_mb pointers
      DOUBLE PRECISION VAR1
      LOGICAL qin
c      LOGICAL    BCKSLV
C
C     LOCAL ARRAYS
C
      DOUBLE PRECISION  TEMP(cL11),TEMP1(cL11),BDTQ(6,cL11)
      DOUBLE PRECISION  BDTP(6,cL11)
      DOUBLE PRECISION  USTAR(L01*cL11)
      DOUBLE PRECISION  ZETAC(6,cL63)
      DOUBLE PRECISION  bhinb(6,cL08),dumbh(6)
C
C     EXTERNAL FUNCTIONS
C
      DOUBLE PRECISION DDOT, ADDT
C
#include "LDEBUG.INC"
      LOGICAL LEQU
      EQUIVALENCE (LEQU,DEBUG(86))
C
      IF(LEQU) WRITE (MBOUT,1000)
 1000 FORMAT (' SUBROUTINE CLFR2B ')
 1025 FORMAT (//10X,'AT SIMULATION TIME, T = ',1PD10.4,' ps ',32('* '))
C
C     FIRST DO THE REFERENCE BODY, BODY 1
C     COPY SU (SCRIPT U) TO USTAR FOR BODY 1 TO INITIALIZE ITERATION.
C
      DO 100 I = 1, LENU(1)
         USTAR(I) = SU(I)
 100  CONTINUE
C
C     NOW FOR THE REST OF THE BODIES
C
      DO 600 IBODY = 2, NB
C
         IHINGE = ITOPW(1,IBODY)
         ICBODY = ITOPW(2,IBODY)
         MTSIZE = LENU(ICBODY)
C
         IF (IHINGE .LT. 0) THEN   ! P frame is on this body
            IHINGE = -IHINGE
            INBODY = ITOPOL(1,IHINGE)
            inbord = 2*ihinge - 2
            qin    = .TRUE.
         ELSE                      ! Q frame is on this body
            INBODY = ITOPOL(2,IHINGE)
            inbord = 2*ihinge - 1
            qin    = .FALSE.
         END IF
C
         LOCC   = ISDOF(2,IHINGE) - 1
         NDOF   = NCONS + ISDOF(3,IHINGE)
         NCONS  = ISDOF(4,IHINGE)
         LOCUIN = LOCU(INBODY)
         LOCUIC = LOCU(ICBODY)
         MTISIZ = LENU(INBODY)
         icprt  = icbody - nbdy
C                                                         *
C        IF THIS HINGE IS ON ANY CUT JOINT PATH, COMPUTE U
C                                                         i
         IF (IHPATH(ICOMP,IHINGE)) THEN
C
C            *               ___T               *
C           U   =  SU  -  N  PHI    * b     *  U
C            i       i     i    Ii     O,i-1    i-1
C
            IF (NCONS .GT. 0) THEN  ! Get bhinb if it's used
               if (qin) then
                  CALL getbh(ihinge,1,qin,bhinb,inbody,irgflx(inbody),
     &                     dumbh,0,0,intLoopHeap(iibhtypeptr),
     &                     intLoopHeap(iihthptrptr),
     &                     intLoopheap(iibh_ptrptr))
               else
                  CALL getbh(ihinge,1,qin,dumbh,0,0,bhinb,inbody,
     &                     irgflx(inbody),intLoopHeap(iibhtypeptr),
     &                     intLoopHeap(iihthptrptr),
     &                     intLoopheap(iibh_ptrptr))
               end if
            END IF

            DO IROW = 1, NCONS
               ISROW = ISEL(LOCC + IROW)
CC@CC
CC@CC .........MULT3 BHINB(ISROW,1), USTAR(LOCUIN), TEMP(IROW)
CC@CC .........1, MTISIZ, 1
CC@CC .........6, MTISIZ, 6
      TEMP(IROW) = DDOT (MTISIZ,BHINB(ISROW,1),6,USTAR(LOCUIN),1)
CC@CC end of expanded call
CC@CC
            END DO
C
            IF (icbody .le. nbdy) THEN
CC@CC
CC@CC ......MULT3 BRN(1,1,ICBODY), TEMP, TEMP1
CC@CC ......MTSIZE, NCONS, 1
CC@CC ......L11, L11, L11
      CALL DGEMV('N',MTSIZE,NCONS,1.0d0,BRN(1,1,ICBODY),cL11,TEMP,1,0.0d
     .0,TEMP1,1)
CC@CC end of expanded call
CC@CC
            ELSE
               IF (ncons .gt. 3) THEN
                  CALL CLEARERR()
                  WRITE(ERRMSG,110) '> NCONS for particle', icprt,
     $                ', is greater than 3.'
                  CALL ERRHDL(-5,'<CLFR2B>')
               END IF
 110           FORMAT(1X,A,I9,A) 
CC@CC
CC@CC MULT3 PRN(1,1,ICPRT), TEMP, TEMP1
CC@CC MTSIZE, NCONS, 1
CC@CC 3, L11, L11
      CALL DGEMV ('N',MTSIZE,NCONS,1.0d0,PRN(1,1,ICPRT),3,TEMP,1,0.0d0,T
     .EMP1,1)
CC@CC end of expanded call
CC@CC
            END IF
C
            CALL MSUB(SU(LOCUIC),TEMP1,USTAR(LOCUIC),MTSIZE,1,cL11)
         END IF
 600  CONTINUE
C
C     NOW COMPUTE ZETA FOR ALL CUT JOINTS
C
C              ___   ..      .1    1    .2    2
C        Z  =  Phi  Alpha  - b    U   - b    U
C         c       c      c    Oec  ec    Oec  ec
C
      DO 400 ICUT = 1, NCUT
         IHINGE = IHCUTJ(ICUT)
         LOCC   = ISDOF(2,IHINGE) - 1
         NCONS  = ISDOF(4,IHINGE)
         NDOF   = NCONS + ISDOF(3,IHINGE)
         N0     = 6 - NDOF
C     
         IBODYQ = ITOPOL(1,IHINGE)
         MTSIZQ = LENU(IBODYQ)
         LOCQ   = LOCU(IBODYQ)
C
         IBODYP = ITOPOL(2,IHINGE)
         MTSIZP = LENU(IBODYP)
         LOCP   = LOCU(IBODYP)
C
C     get pointers to the heap
         ihatq = ihthptr(2*ihinge-3) + 1
         ihatp = ihthptr(2*ihinge-2) + 1
         ibhq  = ibh_ptr(2*ihinge-2)
         ibhp  = ibh_ptr(2*ihinge-1)
c     
         CALL BDOTQP (IHINGE,BDTQ,BDTP,BH(ibhq),BH(ibhp),
     &                HATS(ihatq),HATS(ihatp))
C
C        NOW DO THE LEADING SELECTIONS FOR CONSTRAINED DOF.
         DO 401 I = 1, NCONS
            ISROW = ISEL(LOCC + I)
CC@CC
CC@CC ......MULT3 bdtq(isrow,1), y(locq), var1
CC@CC ......1, mtsizq, 1
CC@CC ......6, l11, 6
      var1 = DDOT (mtsizq,bdtq(isrow,1),6,y(locq),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC ......MULTAD bdtp(isrow,1), y(locp), var1
CC@CC ......1, mtsizp, 1
CC@CC ......6, L11, 6
      var1 = var1 + DDOT (mtsizp,bdtp(isrow,1),6,y(locp),1)
CC@CC end of expanded call
CC@CC
            IF (IHDATA(1+ISROW+N0,IHINGE) .EQ. 2) THEN
               ZETAC(ISROW,ICUT) = ADDT(6*(IHINGE-1) + ISROW+N0,T)
     +                           - VAR1
            ELSE
               ZETAC(ISROW,ICUT) = - VAR1
            END IF
 401     CONTINUE
 400  CONTINUE
C
C     NOW COMPUTE VC.
C
      IROW = 1
      DO 500 ICUTC = 1, NCUT
         IHINGC = IHCUTJ(ICUTC)
         IBODY1 = ITOPOL(1,IHINGC)
         IBODY2 = ITOPOL(2,IHINGC)
         MTSIZ1 = LENU(IBODY1)
         MTSIZ2 = LENU(IBODY2)
         LOC1   = LOCU(IBODY1)
         LOC2   = LOCU(IBODY2)
C
         LOCC   = ISDOF(2,IHINGC) - 1
         NCONC  = ISDOF(4,IHINGC)
C
         IF (NCONC .GT. 0) THEN
C
C                  ___ T       ~1   1*     ~2   2*
C           v   =  Phi   Z  -  b   U    -  b   U
C            c        c   c     ec  ec      ec  ec
C
C           WHERE THE SUPERSCRIPTS 1 AND 2 STAND FOR THE BODIES AT
C           THE ENDS OF CUT JOINT C.
C
CC@CC
CC@CC ......MULT3T BTILDE(1,1,IBODY1,ICUTC), USTAR(LOC1), TEMP
CC@CC ......NCONC, MTSIZ1, 1
CC@CC ......L11, L11, L11
      CALL DGEMV('T',MTSIZ1,NCONC,1.0d0,BTILDE(1,1,IBODY1,ICUTC),cL11,US
     .TAR(LOC1),1,0.0d0,TEMP,1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC ......MLTTAD BTILDE(1,1,IBODY2,ICUTC), USTAR(LOC2), TEMP
CC@CC ......NCONC, MTSIZ2, 1
CC@CC ......L11, L11, L11
      CALL DGEMV('T',MTSIZ2,NCONC,1.0d0,BTILDE(1,1,IBODY2,ICUTC),cL11,US
     .TAR(LOC2),1,1.0d0,TEMP,1)
CC@CC end of expanded call
CC@CC
C
            DO I = 1, NCONC
               ISROW = ISEL(LOCC + I)
               RLAMDA(IROW+I-1) = ZETAC(ISROW,ICUTC) - TEMP(I)
            END DO
C
            IROW = IROW + NCONC
C
         END IF
 500  CONTINUE
C
C     NOW USE A AND VC TO COMPUTE THE LAGRANGE MULTIPLIER VECTOR RLAMDA
C
C     A   ...  A       RL          v
C      11       1m       1          1
C     .  .     .       .           .
C     .    .   .       .      =    .
C     .      . .       .           .
C     A   ...  A       RL          v
C      m1       mm       m          m
C
C        SOLVE FOR LAMDA USING GAUSS ELIMINATION
C
      CALL DGESL (ACLMAT,cL64,NCTCON,ICLPVT,RLAMDA,0)
C
      IROW = 1
      DO ICUT = 1, NCUT
         IHINGE = IHCUTJ(ICUT)
         NCONS  = ISDOF(4,IHINGE)
         N0     = 6 - NCONS - ISDOF(3,IHINGE)
         LOCC   = ISDOF(2,IHINGE) - 1
         DO I = 1, NCONS
            ISCOL = ISEL(LOCC + I)
            IC = IV(ISCOL+N0,IHINGE)
            ALAM(IC) = RLAMDA(IROW)
            IROW = IROW + 1
         END DO
      END DO
C
      IF (LEQU) THEN
         CALL MWRITE(RLAMDA,1,IROW-1,'RLAMDA',1)
         CALL MWRITE(ALAM,1,cL09,'ALAM',1)
      ENDIF
C
      RETURN
      END
