C $Header: /export/cvs/c34a1/source/moldyn/cmpic3.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C ========================================================================
C
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER 
C STATE AND FEDERAL LAWS.  USE, DISCLOSURE, REPRODUCTION OR DUPLICATION 
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS 
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT 
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      subroutine cmpic3(amdamp,y,gvec,iscut,iaconn,ibconn,iconnh,
     &                  ihpvt,pin,betah,betahd,itopol,ihdata)
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     This subroutine initializes the Y vector elements using the
c     coordinates and velocities computed in cmpic2
c
c     theta(*,ibod) = 1-2-3 Euler angles from inertial to body frame
c
c     cgadj(*,ibod) = Translation of fragment cg from nominal location,
c                     expressed in inertial coordinates
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      IMPLICIT NONE
 
c      CHARACTER*128  RCSID
c      DATA           RCSID
c     &/'$RCSfile: cmpic3.f,v $$Revision: 1.1.1.1 $'/
c
#include "PARAM.FOR"
c
#include "BHBSRD.INC"
#include "CPATHS.INC"
#include "CSTIFF.INC"
#include "HEAPMB.INC"
#include "HANDS2.INC"
#include "MISCNO.INC"
#include "NUMBRS.INC"
#include "ORDERN.INC"
#include "PARTCL.INC"
#include "PINRP.INC"
#include "SPECIF.INC"
#include "VECTOR.INC"
#include "MOMENG.INC"
#include "SELECT.INC"
c
c
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: cmpic3.f,v $$Revision: 1.1.1.1 $'/
c
c     Passed variables
      DOUBLE PRECISION amdamp(cL06,L01)
      DOUBLE PRECISION Y(cL07)
      DOUBLE PRECISION GVEC(cL72)
      DOUBLE PRECISION pin(3,3,cl02)
      DOUBLE PRECISION betah(6,cl02)
      DOUBLE PRECISION betahd(6,cl02)
      LOGICAL iscut(cl02)
      INTEGER iaconn(2,cL02)
      INTEGER ibconn(2,cL02)
      INTEGER iconnh(cL02)
      INTEGER ihpvt(cL02)
      INTEGER itopol(2,cL02)
      INTEGER ihdata(7,cL02)
c
      INTEGER itype, ifb,ih,idof1,ndof
      INTEGER ibodq,ibodp,iconn,jointp,jointq
      INTEGER imb,inb,ip1,lp,lq,lbe,nmp,nmq
      INTEGER i,i0,i1,i2,j,j0,j1
      DOUBLE PRECISION bondlen, dum
      DOUBLE PRECISION tmat(3,3),s(3),s2(3),r1(3,3),r2(3,3)
c
c     Load U for each fragment into Y vector
c     Also load modal amplitudes into Y vector
c
      itype = 1
      do ifb = 1, nb
         i0 = k0(ifb) + 1
         j0 = locu(ifb)
         j1 = locu(NB+ifb) - 1
         if (iatoms(3,ifb) .ne. 1) then
            call rottr(3,itype,theta(1,ifb),tmat,dum,dum)
CC@CC
CC@CC ......MULT3T tmat, gvec(i0), Y(j0)
CC@CC ......3, 3, 1
CC@CC ......3, 1, 1
      Y(j0+0) = tmat(1,1)*gvec(i0+0) + tmat(2,1)*gvec(i0+1) + tmat(3,1)*
     .gvec(i0+2)
      Y(j0+1) = tmat(1,2)*gvec(i0+0) + tmat(2,2)*gvec(i0+1) + tmat(3,2)*
     .gvec(i0+2)
      Y(j0+2) = tmat(1,3)*gvec(i0+0) + tmat(2,3)*gvec(i0+1) + tmat(3,3)*
     .gvec(i0+2)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC ......MULT3T tmat, gvec(i0+3), Y(j0+3)
CC@CC ......3, 3, 1
CC@CC ......3, 1, 1
      Y(j0+3+0) = tmat(1,1)*gvec(i0+3+0) + tmat(2,1)*gvec(i0+3+1) + tmat
     .(3,1)*gvec(i0+3+2)
      Y(j0+3+1) = tmat(1,2)*gvec(i0+3+0) + tmat(2,2)*gvec(i0+3+1) + tmat
     .(3,2)*gvec(i0+3+2)
      Y(j0+3+2) = tmat(1,3)*gvec(i0+3+0) + tmat(2,3)*gvec(i0+3+1) + tmat
     .(3,3)*gvec(i0+3+2)
CC@CC end of expanded call
CC@CC
         else
            do i1 = 1, 3
               Y(j0-1+i1) = gvec(i0+i1-1)
            end do
         end if
         do j = 1, IRGFLX(ifb)
            Y(j0+5+j) = gvec(i0+5+j)
            Y(j1+j)   = amdamp(j,ifb)
         end do
      end do
c
cccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Compute initial hinge angles and displacements
c
cccccccccccccccccccccccccccccccccccccccccccccccccccc
C
C     Re-initialize IHDATA, BETAH and BETAHD

      do i = 1, nh
         do j = 1,6
            betah(j,i) = ZRO
            betahd(j,i) = ZRO
         end do
         if (ihdata(1,i) .gt. 0) ihdata(1,i) = 1
      end do
c
c     First do Body 1
c
      if (nbdy .EQ. 0) then  ! !st body is a particle
         betah(4,1) = cgnom(1,1) + cgadj(1,1)
         betah(5,1) = cgnom(2,1) + cgadj(2,1)
         betah(6,1) = cgnom(3,1) + cgadj(3,1)
      else
         do i1 = 1, 3
            BETAH(i1,1)   = theta(i1,1)
            BETAH(i1+3,1) = cgnom(i1,1) + cgadj(i1,1)
         end do
      end if
c
      do ih = 2, nh
c
         ibodq = itopol(1,ih)
         ibodp = itopol(2,ih)
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Find the atom number where hinge frame is to be attached
c     First, search through bond list.  If match not found, the
c     hinge must be between a pair of non-bonded atoms.
c
c     Find atom numbers of the p- and q-frame origins for bonded hinge
c
         if (ihpvt(ih) .ne. 0) then
            iconn = iconnh(ih)
            if (ibconn(1,iconn) .eq. ibodp) then
               jointp = iaconn(1,iconn)
               jointq = iaconn(2,iconn)
            else
               jointp = iaconn(2,iconn)
               jointq = iaconn(1,iconn)
            end if
         else
c
c     Find atom numbers of the p- and q-frame origins for non-bonded hinge
c
            if (ibodp .lt. ibodq) then
               jointp = iatoms(2,ibodp)
               jointq = iatoms(1,ibodq)
            else
               jointp = iatoms(1,ibodp)
               jointq = iatoms(2,ibodq)
            end if
         end if
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Compute transformation matrices and displacements from inertial
c     to hinge frames
c
c     R1 = transformation from body p to inertial frame
c     R2 = Transformation from body q to inertial frame
c
         if (ibodp .GT. nbdy) then  ! P is a particle
            s(1) = cgnom(1,ibodp) + cgadj(1,ibodp)
            s(2) = cgnom(2,ibodp) + cgadj(2,ibodp)
            s(3) = cgnom(3,ibodp) + cgadj(3,ibodp)
         else
            call rottr(3,1,theta(1,ibodp),r1,dum,dum)
            i2 = iatoms(1,ibodp) - 1
            i = jointp - i2
            call cmposn(i,i2,IRGFLX(ibodp),ibodp,1,r1,dum,s,
     &                  HEAP_MB(iamdampptr),HEAP_MB(ipptr))
         end if
c
         if (ibodq .GT. nbdy) then  ! Q is a particle
            s2(1) = cgnom(1,ibodq) + cgadj(1,ibodq)
            s2(2) = cgnom(2,ibodq) + cgadj(2,ibodq)
            s2(3) = cgnom(3,ibodq) + cgadj(3,ibodq)
         else
            call rottr(3,1,theta(1,ibodq),r2,dum,dum)
            i2 = iatoms(1,ibodq) - 1
            i = jointq - i2
            call cmposn(i,i2,IRGFLX(ibodq),ibodq,1,r2,dum,s2,
     &                  HEAP_MB(iamdampptr),HEAP_MB(ipptr))
         end if
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Compute relative angles at the hinge
c
         if (ibodp .GT. nbdy) then   ! P is a particle
            if (ihdata(1,ih) .ne. 0) then
                                !  q frame object is rigid/flex.
               betah(1,ih) = theta(1,ibodq)
               betah(2,ih) = theta(2,ibodq)
               betah(3,ih) = theta(3,ibodq)
            end if
         else
c
c     Compute the transformation matrix from p-frame to q-frame
c
CC@CC
CC@CC ......MULT3T r2, r1, tmat
CC@CC ......3, 3, 3
CC@CC ......3, 3, 3
      tmat(1,1) = r2(1,1)*r1(1,1) + r2(2,1)*r1(2,1) + r2(3,1)*r1(3,1)
      tmat(2,1) = r2(1,2)*r1(1,1) + r2(2,2)*r1(2,1) + r2(3,2)*r1(3,1)
      tmat(3,1) = r2(1,3)*r1(1,1) + r2(2,3)*r1(2,1) + r2(3,3)*r1(3,1)
      tmat(1,2) = r2(1,1)*r1(1,2) + r2(2,1)*r1(2,2) + r2(3,1)*r1(3,2)
      tmat(2,2) = r2(1,2)*r1(1,2) + r2(2,2)*r1(2,2) + r2(3,2)*r1(3,2)
      tmat(3,2) = r2(1,3)*r1(1,2) + r2(2,3)*r1(2,2) + r2(3,3)*r1(3,2)
      tmat(1,3) = r2(1,1)*r1(1,3) + r2(2,1)*r1(2,3) + r2(3,1)*r1(3,3)
      tmat(2,3) = r2(1,2)*r1(1,3) + r2(2,2)*r1(2,3) + r2(3,2)*r1(3,3)
      tmat(3,3) = r2(1,3)*r1(1,3) + r2(2,3)*r1(2,3) + r2(3,3)*r1(3,3)
CC@CC end of expanded call
CC@CC
c
c     Extract the hinge Euler angles
c
            dum = DSQRT(tmat(1,1)**2 + tmat(2,1)**2)
            betah(1,ih) = atan2(-tmat(3,2),tmat(3,3))
            betah(2,ih) = atan2( tmat(3,1),dum)
            betah(3,ih) = atan2(-tmat(2,1),tmat(1,1))
         end if
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Compute the relative displacement in inertial coordinates
c     and map to p-frame, if p frame is not on a particle
c
         s(1) = s2(1) - s(1)
         s(2) = s2(2) - s(2)
         s(3) = s2(3) - s(3)
         if (ibodp .le. nbdy) then
CC@CC
CC@CC ......MULT3T r1, s, s2
CC@CC ......3, 3, 1
CC@CC ......3, 3, 6
      s2(1) = r1(1,1)*s(1) + r1(2,1)*s(2) + r1(3,1)*s(3)
      s2(2) = r1(1,2)*s(1) + r1(2,2)*s(2) + r1(3,2)*s(3)
      s2(3) = r1(1,3)*s(1) + r1(2,3)*s(2) + r1(3,3)*s(3)
CC@CC end of expanded call
CC@CC
            s(1) = s2(1)
            s(2) = s2(2)
            s(3) = s2(3)
c
         end if
         if (ihdata(5,ih) .eq. 0) then ! Non-bonded atom pair
c
c     Set up Cartesian coordinates
c
            betah(4,ih) = s(1)
            betah(5,ih) = s(2)
            betah(6,ih) = s(3)
c
         else                   ! Hinge is a bonded atom-pair
c
c     Set up Spherical coordinates
c
            bondlen = 0d0
            do i = 1, 3
               bondlen = bondlen + s(i)**2
            end do
            bondlen = sqrt(bondlen)
            betah(4,ih) = bondlen
            if (abs(s(3)) .gt. EULER_THRESHOLD*bondlen) then
                                ! Use type 2 azimuth/elevation
               ihpvt(ih) = 2
               betah(5,ih) = atan2(s(3),s(2))
               betah(6,ih) = asin(s(1)/bondlen)
            else                ! Use type 1 azimuth/elevation
               ihpvt(ih) = 1
               betah(5,ih) = atan2(s(2),s(1))
               betah(6,ih) = asin(s(3)/bondlen)
            end if
         end if            !  End of test for bond/non-bond between bodies
      end do               !  End of hinge loop     
c
 1000 continue
c
c     Load hinge angles and displacements into Y vector
c
      LBE = LOCU(2*NB+1) - 1
      DO 134 J = 1, NH
         if (iscut(j)) go to 134
         if (ihdata(1,j) .eq. 0) then
            idof1 = 4
         else
            idof1 = 1
         end if
         DO I = idof1, 6
            IP1 = I + 1
            IF (IHDATA(IP1,J) .ne. 1) then
               LBE = LBE + 1
               Y(LBE) = BETAH(I,J)
            end if
         end do
 134  continue
c
c     Compute hinge rates
c
      call ROTDH(HEAP_MB(iyptr),logicLoopHeap(iiscutptr),
     *          intLoopHeap(iihthptrptr),LoopHeap(ipimatptr),
     *          intLoopHeap(iihpvtptr),LoopHeap(ipinptr),
     *          LoopHeap(irp2ptr),LoopHeap(irp3ptr),
     *          intLoopHeap(iibetdtptr),LoopHeap(ibetahptr),
     *          intLoopHeap(iitopolptr),intLoopheap(iihdataptr),
     *          LoopHeap(irhptr),Loopheap(idhptr),
     *          intLoopheap(iihcutjptr))
c     Generate BH array
      call BHGENR(LocalHeap(ibhqptr_bhgenr),
     *            LocalHeap(ibhpptr_bhgenr),
     *            intLoopHeap(iibhtypeptr),
     *            intLoopHeap(iihthptrptr),
     *            intLoopHeap(iihpvtptr),
     *            intLoopHeap(iisdofptr),
     *            intLoopHeap(iitopolptr),
     *            intLoopHeap(iihdataptr),
     *            intLoopHeap(iibh_ptrptr))
c
CCC
CCC MULT3 bh(1,1,1), y(1), betahd(4,1), 3, 3, 1, 6, 3, 6
CCC
      if (nbdy .EQ. 0) then  ! 1st body is a particle
         nmp = 3
c     BH is a 3x3 identity matrix
      betahd(4,1) = y(1)
      betahd(5,1) = y(2)
      betahd(6,1) = y(3)
c
      else
c
         nmp = 6 + IRGFLX(1)
c
c     The BH array for Hinge 1 has no flexible partitions! 
c     (BH is pin in the (1,1) section, and r0l in the (4,4) section)
c
CC@CC
CC@CC MULT3 pin(1,1,1), Y(1), BETAHD(1,1)
CC@CC 3, 3, 1
CC@CC 3, 3, 6
      BETAHD(1,1) = pin(1,1,1)*Y(1) + pin(1,2,1)*Y(2) + pin(1,3,1)*Y(3)
      BETAHD(2,1) = pin(2,1,1)*Y(1) + pin(2,2,1)*Y(2) + pin(2,3,1)*Y(3)
      BETAHD(3,1) = pin(3,1,1)*Y(1) + pin(3,2,1)*Y(2) + pin(3,3,1)*Y(3)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC MULT3 r0l(1,1,1), Y(4), BETAHD(4,1)
CC@CC 3, 3, 1
CC@CC 3, 3, 6
      BETAHD(4,1) = r0l(1,1,1)*Y(4) + r0l(1,2,1)*Y(5) + r0l(1,3,1)*Y(6)
      BETAHD(5,1) = r0l(2,1,1)*Y(4) + r0l(2,2,1)*Y(5) + r0l(2,3,1)*Y(6)
      BETAHD(6,1) = r0l(3,1,1)*Y(4) + r0l(3,2,1)*Y(5) + r0l(3,3,1)*Y(6)
CC@CC end of expanded call
CC@CC
c
      end if
c
      do ih = 2, nh
         lq = 2*ih - 2
         lp = 2*ih - 1
         inb = ITOPOL(1,ih)
         imb = ITOPOL(2,ih)
         nmq = lenu(inb)
         nmp = lenu(imb)
         if (ihdata(1,ih) .eq. 0) then
            idof1 = 4
            ndof  = 3
         else
            idof1 = 1
            ndof  = 6
         end if
CCC
CCC MULT3 bh(1,1,lp),y(locu(imb)),betahd(idof1,ih),ndof,nmp,1,6,nmp,6
CCC
         CALL BHMULT(.FALSE.,ih,1,y(locu(imb)),betahd(idof1,ih),
     &               nmp,nmp,6,intLoopHeap(iibhtypeptr),
     &               intLoopheap(iitopolptr),intLoopHeap(iibh_ptrptr))
CCC
CCC MULTAD bh(1,1,lq),y(locu(inb)),betahd(idof1,ih),ndof,nmq,1,6,nmq,6
CCC
         CALL BHMULT(.TRUE.,ih,0,y(locu(inb)),betahd(idof1,ih),
     &               nmq,nmq,6,intLoopHeap(iibhtypeptr),
     &               intLoopheap(iitopolptr),intLoopHeap(iibh_ptrptr))
c
      end do
c

      return
      end
