C $Header: /export/cvs/c34a1/source/moldyn/cmposn.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      SUBROUTINE cmposn(i,i2,im,ifb,job,tmat,cmat,s,amdamp,p)
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     This subroutine computes deformed atom positions, and the C matrix
c
      IMPLICIT NONE
c
#include "PARAM.FOR"
c     Argument List
c
      INTEGER i                   ! i-th atom of body ifb
      INTEGER i2                  ! Offset in atom list
      INTEGER im                  ! Number of modes
      INTEGER ifb                 ! Body number
      INTEGER job                 ! Job selection
      DOUBLE PRECISION tmat(3,3)  ! Transformation matrix
      DOUBLE PRECISION cmat(3,*)  ! C matrix for fitting
      DOUBLE PRECISION s(3)       ! Particle position
      DOUBLE PRECISION amdamp(cL06, L01)
      DOUBLE PRECISION P(*) 
c
c     MBO(N)D COMMON blocks
c
#include "CSTIFF.INC"
#include "HANDS2.INC"
#include "HEAPMB.INC"
#include "SPECIF.INC"
c
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: cmposn.f,v $$Revision: 1.1.1.1 $'/

c
c     Local Variables
c
      INTEGER i1, j1            ! DO loop indices 
      INTEGER j                 ! Array pointer
C     DOUBLE PRECISION p(3)     ! Position in body frame 
      DOUBLE PRECISION tp(3)    ! Transformed position vector 
c
c     Compute the position of i-th atom of the ifb-th fragment 
c     relative to the body origin
c
      IF (im .EQ. 0) THEN
         j = 2 * (i2+i)
      ELSE
         j = 2*(i2+i) - 1
      END IF
      do i1 = 1, 3
         p(i1) = ds(i1,j)
      end do
c
c     Add the effects of deformation
c
      IF (im .NE. 0) THEN
C Original: MULTAD hats(htsptr(i2+i)+1),amdamp(1,ifb),p,3,im,1,3,L06,3
CC@CC
CC@CC ...MULTAD HATS(ihtsptr(i2+i)+1), amdamp(1,ifb), p
CC@CC ...3, im, 1
CC@CC ...3, L06, 3
      CALL DGEMV ('N',3,im,1.0d0,HATS(ihtsptr(i2+i)+1),3,amdamp(1,ifb),1
     .,1.0d0,p,1)
CC@CC end of expanded call
CC@CC
      end if
c
c     Add the effects of rigid body rotation of the fragment.
c
CC@CC
CC@CC MULT3 tmat, p, tp
CC@CC 3, 3, 1
CC@CC 3, 3, 3
      tp(1) = tmat(1,1)*p(1) + tmat(1,2)*p(2) + tmat(1,3)*p(3)
      tp(2) = tmat(2,1)*p(1) + tmat(2,2)*p(2) + tmat(2,3)*p(3)
      tp(3) = tmat(3,1)*p(1) + tmat(3,2)*p(2) + tmat(3,3)*p(3)
CC@CC end of expanded call
CC@CC
c
c     Form the C matrix
c
c     C =  [  SK(tp)  |  I  |  T*phi  ]
c
      if (job .ne. 1) then
         call skewv3(tp,cmat,1,3)
         do i1 = 1, 3
            do j1 = 4, 6
               cmat(i1,j1) = 0.
            end do
            cmat(i1,i1+3) = 1.
         end do
         if (im .ne. 0) then
C Original: MULT3 tmat,hats(htsptr(i2+i)+1),cmat(1,7),3,3,im,3,3,3
CC@CC
CC@CC ......MULT3 tmat, HATS(ihtsptr(i2+i)+1), cmat(1,7)
CC@CC ......3, 3, im
CC@CC ......3, 3, 3
      CALL DGEMM ('N','N',3,im,3,1.0d0,tmat,3,HATS(ihtsptr(i2+i)+1),3,0.
     .0d0,cmat(1,7),3)
CC@CC end of expanded call
CC@CC
         end if
      end if
c
c     Add the effects of rigid translation of the fragment
c
      if (job .ne. 2) then
         do i1 = 1, 3
            s(i1) = cgnom(i1,ifb) + cgadj(i1,ifb) + tp(i1)
         end do
      end if
c
      return
      end
