C $Header: /export/cvs/c34a1/source/moldyn/dyns20.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C ========================================================================
C
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER 
C STATE AND FEDERAL LAWS.  USE, DISCLOSURE, REPRODUCTION OR DUPLICATION 
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS 
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT 
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

#ifdef AMBER
      SUBROUTINE DYNS20(erstop)
#else
      SUBROUTINE DYNS20
#endif
c
      IMPLICIT NONE
c
#include "PARAM.FOR"

#include "HEAPMB.INC"
#include "VECTOR.INC"
#include "CPATHS.INC"
#include "MOMENG.INC"
#include "SPECIF.INC"

#ifdef AMBER
C
c     Argument list
c
      LOGICAL erstop
c
      CALL DYNS20_1(erstop,HEAP_MB(iyptr),HEAP_MB(iydtptr),
     *              HEAP_MB(ipptr),logicLoopHeap(iiscutptr),
     *              Loopheap(ibetahdptr),intLoopheap(iihdataptr))
#else
      CALL DYNS20_1(HEAP_MB(iyptr),HEAP_MB(iydtptr),
     *              HEAP_MB(ipptr),logicLoopHeap(iiscutptr),
     *              Loopheap(ibetahdptr),intLoopheap(iihdataptr))
#endif

      RETURN
      END

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

#ifdef AMBER
      SUBROUTINE DYNS20_1(erstop,Y,YDT,P,ISCUT,BETAHD,IHDATA)
#else
      SUBROUTINE DYNS20_1(Y,YDT,P,ISCUT,BETAHD,IHDATA)
#endif
CSE
C                                                          DEBUG #  37
CPS        PURPOSE:
C
C                1) READ NTAPE1 ON WHICH ALL TIME INDEPENDENT RIGID AND
C                    FLEXIBLE BODY DATA HAS BEEN WRITTEN.
C                2) LOAD INITIAL CONDITIONS INTO STATE VECTOR.
C                3) COMPUTE INITIAL KINEMATIC DATA (BHGENR,ROTDH)
C                4) INITIALIZE TIME DERIVATIVE OF STATE VECTOR (YDOT)
C                5) COMPUTE RESULTANT SYSTEM MASS PROPERTIES
C                6) COMPUTE ENERGY AND MOMENTUM FOR BODIES AND TOTAL
C                    SYSTEM (ENGMOM)
C                7) INTEGRATE NON-LINEAR EQUATIONS OF MOTION (RKADAM)
C                8) LINEARIZE COUPLED EQUATIONS OF MOTION (LINEAR)
C                9) OUTPUT DATA ON PRINTER OR PLOTTER (PRNTOU,PLOTWR)
C
CPE
CAS
C         INTEGRATION CONTROL
C         -------------------
C     JIL    = 1,2,3 OR 4; DEFINES THE CYCLE NUMBER WITHIN THE FOUR STEP
C              RUNGE KUTTA INTEGRATION ROUTINE THAT COMPUTATION IS
C              CURRENTLY AT; UPDATED IN RKADAM AND STORED IN /JILFLG/.
C    #########  GET JIL OUT OF CODE, IT TIES GENERAL PURPOSE DYNAMICS
C    #########  FORMULATION TO A SPECIFIC FIXED STEP INTEGRATOR
C
C     THE FOLLOWING ARE REAL*8 PARAMETERS STORED IN /TIMESS/ AND USED
C      TO DEFINE DIFFERENT TIME PARAMETERS
C     ST     = STARTT = INPUT PARAMETER TMDATA(1) READ IN, IN DYNS10;
C                       USED TO DEFINE THE STARTING TIME FOR TIME
C                       HISTORY SIMULATION
C     DT     = DELTAT = INPUT PARAMETER TMDATA(2) READ IN, IN DYNS10;
C                       USED TO DEFINE THE INTEGRATION STEP SIZE
C     ET     = ENDT   = INPUT PARAMETER TMDATA(3) READ IN, IN DYNS10;
C                       USED TO DEFINE THE END OF SIMULATION TIME
C     T      = TIME PARAMETER, INCREMENTED IN RKADAM, COMPUTATION
C              STARTS AT T=ST AND IS STOPPED AT T=ET
C
C
C         OUTPUT DATA CONTROL
C         -------------------
C     NOPRNT = INPUT PARAMETER IPDATA(1) READ IN, IN DYNS10 AND STORED
C              IN /MISCNO/. PRINT OUTPUT DATA EVERY NOPRNT MULTIPLES
C              OF THE INTEGRATION STEP
C     NOPLOT = INPUT PARAMETER IPDATA(2) READ IN, IN DYSN1O AND STORED
C              IN /MISCNO/. PLOT OUTPUT DATA EVERY NOPLOT MULTIPLES
C              OF THE INTEGRATION STEP
C     KSAVE  = TOTAL NUMBER OF DATA POINTS TO BE SAVED IN THE /PSTUFF/
C              ARRAYS, WHICH ARE EXCLUSIVELY RESERVED FOR THE STORAGE OF
C              FREQUENCY RESPONSE DATA COMPUTED IN SFREQ2
C
C
C         STABILITY ANALYSIS
C         ------------------     WHICH DEFINE THE FREQUENCY RESPONSE
C                                CHARACTERISTICS OF ANY USER DEFINED
C                                OUTPUT 'TORQUE SIGNAL' TO ANY USER
C                                DEFINED INPUT 'SENSOR SIGNAL')
C
C
C     USER SUPPLIED SUBROUTINES
C------------------------------
C
C     RATHER THAN ATTEMPT THE IMPOSSIBLE TASK OF FORESEEING ALL POSSIBLE
C         SIMULATION NEEDS OF ALL POTENTIAL USERS
C
C                   'DISCOS DEMANDS USER INTERFACE'
C
C     THE USER MUST CODE IN FORTRAN ALL EQUATIONS REQUIRED TO DESCRIBE
C         ALL NON-GYROSCOPIC AND NON-GRAVITY GRADIENT EFFECTS REQUIRED
C         FOR SIMULATION PURPOSES
C
C     DISCOS ATTEMPTS TO PROVIDE THE USER WITH A CLEAN INTERFACE BETWEEN
C         PARAMETERS WHICH WOULD NORMALLY BE CONSIDERED TO BE PHYSICALLY
C         REALIZABLE AND THE GENERALIZED FORCE AND TORQUE PARAMETERS
C         USED FOR ACTUAL COMPUTATION. THIS IS DONE VIA A SET OF
C         FUNCTIONS AND SUBROUTINES WHICH REQUIRE THE USER TO DEFINE
C         CERTIAN PHYSICALLY REALIZABLE PARAMETERS; THESE PARAMETERS
C         ARE THEN AUTOMATICALLY TRANSFORMED INTO THE APPROPRIATE
C         GENERALIZED PARAMETERS REQUIRED FOR COMPUTATION.
C
C     ALL USER REQUIRED INPUT DATA IS NORMALLY READ FROM CARDS BY
C         FORMATTED READ STATEMENTS IN SUBROUTINE DYNS10. IT IS HERE
C         THAT THE USER DEFINES
C          1) NDELTA - TOTAL NUMBER OF ADDITIONAL FIRST ORDER
C                      DIFFERENTIAL EQUATIONS WHICH WILL BE USER
C                      DEFINED IN SUBROUTINE CONTRL
C          2) CNTDTA(I),I.LE.NDELTA - INITIAL CONDITIONS FOR THE USER
C                                     DEFINED DIFFERENTIAL EQUATIONS
C          3) CNTDTA(I),I.GT.NDELTA - ALL OTHER PARAMETERIC MAGNITUDES
C                                     OF PARAMETERS USED IN THE USER
C                                     DEFINED EQUATIONS
C
C     ALL USER REQUIRED STATE VARIABLE DATA CAN BE OBTAINED BY SIMPLY
C         INCLUDING THE APPROPRIATE COMMON BLOCKS IN THE SUBROUTINES
C         BEING USER MODIFIED. DATA MAY BE TRANSFERED BETWEEN THE
C         USER MODIFIABLE ROUTINES BY EITHER USING AVAILABLE SPACE
C         IN /CONPAR/ OR BY DEFINING NEW SPECIAL PURPOSE COMMON BLOCKS
C
C
C
C     MODE DEPENDENT PARAMETERS
C------------------------------
C
Cblink:  Modify/remove the following comments:
C
C         MASS MATRIX WITH ASSOCIATED MODE DEPENDENT PARAMETERS
C         -----------------------------------------------------
C
C     AMU    = MASS MATRIX ARRAY, REAL*8 TIME VARYING PARAMETERS STORED
C              IN /AMUBW/, DIMENSIONED(L08,L08,L01)
C               UPON ENTRY INTO DYNS20
C              ((AMU(I,J,N),I=1,LV),J=1,LV) = MASS MATRIX FOR BODY N
C                                  IN ITS UNDEFORMED STATE WHERE
C                                    LV = 6 + IRGFLX(N) + NMOW(2,N)
C               THEREAFTER
C              ((AMU(I,J,N),I=1,LV),J=1,LV) =MASS MATRIX FOR BODY N
C                                  AT TIME T IN THE DEFOMRED STATE
C                                  (COMPUTED IN MGEN), WHERE
C                                    LV = 6 + IRGFLX(N) + NMOW(2,N)
C              DETAILS SEE EQUATIONS II-39 AND 86 IN VOL I
C        ((AMU(I,J,N),I=1,3),J=1,3)   = INERTIA TENSOR FOR BODY N
C                                       RELATIVE TO BODY N REF POINT WRT
C                                       BODY N REFERENCE FRAME
C        ((AMU(I,J,N),I=1,3),J=4,6)   = SKEW TENSOR FORM OF THE BODY N
C                                       MASS MOMENT VECTOR RELATIVE TO
C                                       BODY N REF POINT WRT BODY N
C                                       REFERENCE FRAME
C        ((AMU(I,J,N),I=4,6),J=4,6)   = DIAGONAL MASS MATRIX, TOTAL MASS
C                                       OF BODY N ON DIAGONAL, ZERO OFF
C                                       THE DIAGONAL
C                  FOR THE FOLLOWING LET
C                    LE = 6+IRGFLX(N)
C                    LV = 6+IRGFLX(N)+NMOW(2,N)
C        ((AMU(I,J,N),I=1,3),J=7,LE)  = INERTIAL COUPLING TERMS BETWEEN
C                                       ANGULAR AND MODAL ACCELERATION
C                                       COORDINATES FOR BODY N
C        ((AMU(I,J,N),I=4,6),J=7,LE)  = INERTIAL COUPLING TERMS BETWEEN
C                                       LINEAR AND MODAL ACCELERATION
C                                       COORDINATES FOR BODY N
C        ((AMU(I,J,N),I=7,LE),J=7,LE) = INERTIAL COUPLING TERMS BETWEEN
C                                       MODAL ACCELERATION COORDINATES
C                                       FOR BODY N (DIAGONAL FOR
C                                       ORTHOGONAL MODES)
C        ((AMU(I,J,N),I=1,LE),J=LE+1,LV)    = INERTIAL COUPLING TERMS
C                                             BETWEEN BODY N ACCEL.
C                                             COORD. AND WHEEL ACCEL.
C        ((AMU(I,J,N),I=LE+1,LV),J=LE+1,LV) = INERTIAL COUPLING BETWEEN
C                                             VARIABLE SPEED WHEELS ON
C                                             BODY N
C              IN SUBROUTINE YDOT THE MASS MATRIX INVERSE IS NEEDED. IT
C              IS COMPUTED IN INV1NP AND STORED IN THE AMU ARRAY
C              THUS DESTROYING ALL MASS MATRIX DATA DEFINED BELOW
C              ** NOTE IT MAY BE RECOVERED BY REINVERTING AMU ARRAY
C
C     THE FOLLOWING PARAMETERS ARE REAL*8 ARRAYS STORED IN /INTGRL/.
C        THEIR ELEMENT MAGNITUDES ARE EVALUATED IN EITHER MRIGID, MSMODC
C        OR MSMODL AND STORED ON NTAPE1 (TO CONSERVE COMPUTE STORAGE).
C        UPON ENTRY INTO DYNS20 A READ(NTAPE1) INSTRUCTION IS EXECUTED
C        AND THE APPROPRIATE TIME INVARIANT ARRAYS LOADED.
C        THESE ARRAY WILL BE USED IN MGEN TO COMPUTE THE ELEMENTS OF THE
C        TIME VARYING MASS MATRIX DEFINED BY EQUATION II-86, VOL 1
C     AM     = UNDEFORMED MASS MATRIX ARRAY (M SUB 0 IN II-86)
C              DIMENSIONED (((6+NMDBOD)*(7+NMDBOD))/2,NBMAX). UPON ENTRY
C              INTO DYNS20 IT IS SET BY THE FOLLOWING CODE
C                     DO 3 N=1,NB
C                     NXE = IRGFLX(N)
C                     NP6 = 6+NXE
C                     KNT = 0
C                     DO 6 I=1,NP6
C                     DO 6 J=I,NP6
C                     KNT = KNT+1
C                   6 AM(KNT,N) = AMU(I,J,N)
C                   3 CONTINUE
C              SINCE THE MASS MATRIX IS SYMMETRIC
C              ONLY THE UPPER TRIANGULAR PORTION NEED BE SAVED
C                  (AM(I,N),I=1,(NP6*(NP6+1))/2) = UNDEFORMED MASS
C                                                  MATRIX FOR BODY N
C     ACOF   = COEFFICIENTS WHICH DEFINE THE LINEAR DEPENDENCE OF THE
C              MASS MOMENT ON FLEXURAL DEFORMATION,
C              DIMENSIONED (9,NMDBOD,NBMAX). THAT IS
C              (ACOF(I,M,N),I=1,9) = 9 ALPHA COEFFICIENTS IN EQ II-88
C                                    WHICH DEFINED THE LINEAR DEPENDENCE
C                                    OF BODY N MASS MOMENT ON BODY N
C                                    MODE M DEFORMATION.
C     BCOF   = COEFFICIENTS WHICH DEFINE THE LINEAR DEPENDENCE OF THE
C              INERTIA TENSOR ON FLEXURAL DEFORMATION,
C              DIMENSIONED (6,NMDBOD,NBMAX). THAT IS
C              (BCOF(I,M,N),I=1,6) = 6 LOWER CASE B COEFFICIENTS IN
C                                    EQ II-88 WHICH DEFINE THE LINEAR
C                                    DEPENDENCE OF BODY N INERTIA TENSOR
C                                    ON BODY N MODE M DEFORMATION
C     COFYZ  = COEFFICIENTS WHICH DEFINE THE LINEAR DEPENDENCE OF THE
C     COFXZ  = INERTIAL COUPLING TERMS BETWEEN ANGULAR AND MODAL
C     COFXY  = ACCELERATION COEFFICIENTS, EACH OF THE THREE ARRAYS ARE
C              DIMENSIONED (NMDBOD,NMDBOD,NBMAX)
C              (COFYZ(I,M,N),I=1,IRGFLX(N))= IRGFLX(N) C SUB YZ COUPLING
C                                    COEFFICIENTS IN EQ II-88. DEFINES
C                                    THE LINEAR DEPENDENCE OF BODY N
C                                    X-AXIS ROTATION - MODE M COUPLING
C                                    COEFFICIENTS ON MODE I,I=1,...,
C                                    IRGFLX(N) DEFORMATION
C              (COFXZ(I,M,N),I=1,IRGFLX(N))= IRGFLX(N) C SUB XZ COUPLING
C                                    COEFFICIENTS IN EQ II-88. COUPLING
C                                    Y-AXIS ROTATION - MODE M BODY N
C              (COFXY(I,M,N),I=1,IRGFLX(N))= IRGFLX(N) C SUB XY COUPLING
C                                    COEFFICIENTS IN EQ II-88. COUPLING
C                                    Z-AXIS ROTATION - MODE M BODY N
C     COF11  = COEFFICIENTS WHICH DEFINE THE QUADRATIC DEPENDENCE OF THE
C     COF12  = INERTIA TENSOR ON FLEXURAL DEFORMATION,
C     COF13  = DIMENSIONED (NMDBOD,NMDBOD,NBMAX)
C     COF22  = COF11(I,J,N) = COEFFICIENTS WHICH DEFINE THE QUADRATIC
C     COF23  = COF22(I,J,N)   DEPENDENCE OF PRINCIPAL XX, YY, ZZ MOMENTS
C     COF33  = COF33(I,J,N)   OF INERTIA RESP. OF BODY N ON MODE I AND
C                             MODE J FLEXURAL DEFORMATION, SEE EQ II-89
C              COF12(I,J,N) = COEFFICIENTS WHICH DEFINE THE QUADRATIC
C              COF13(I,J,N)   DEPENDENCE OF PRODUCTS XY, XZ, YZ
C              COF23(I,J,N)   OF INERTIA RESP. OF BODY N ON MODE I AND
C                             MODE J FLEXURAL DEFORMATION, SEE EQ II-89
C
C         MODAL COMPONENTS AT HINGE AND SENSOR POINTS
C         -------------------------------------------
C     THE FOLLOWING PARAMETERS ARE REAL*8 ARRAYS STORED IN /HANDS/ THE
C       ACTUAL DATA TO BE LOADED INTO THESE ARRAYS IS INPUTTED EITHER
C       VIA MSMODL OR MSMODC, IT IS STORED TEMPORARILY ON NTAPE1 THEN
C       UNLOADED IN DYNS20 INTO THE APPROPRIATE ARRAYS
C     HATH   = HINGE POINT MODAL DISPLACEMENT ARRAY,
C              DIMENSIONED (3,NMDBOD,2*NHMAX-1).
C                AT HINGE POINT N0H, N0H=2,3,...,NH
C              THE Q-FRAME IS CONTAINED IN BODY N=ITOPOL(1,N0H) AND
C              THE P-FRAME IS CONTAINED IN BODY M=ITOPOL(2,N0H)
C        (HATH(I,NN,2*N0H-3),I=1,3) = 3 DISPLACEMENT COMPONENTS OF MODE
C                                     NN AT THE Q-FRAME ORIGIN WRT THE
C                                     BODY N FIXED REFERENCE
C        (HATH(I,MM,2*N0H-2),I=1,3) = 3 DISPLACEMENT COMPONENTS OF MODE
C                                     MM AT THE P-FRAME ORIGIN WRT THE
C                                     BODY M FIXED REFERENCE
C     HATS   = SENSOR POINT MODAL DISPLACEMENT ARRAY,
C              DIMENSIONED (L21)
C                AT SENSOR POINT N0S WHICH IS ON BODY N=IFTSMW(N0S)
C                ACCESSED BY POINTER HTSPTR(NOS)
C        (HATS(HTSPTR(NOS)+I+3*(NN-1)),I=1,3) = 3 DISPLACEMENT COMPONENTS OF 
C                                 MODE NN AT SENSOR POINT N0S WRT BODY N REF
C
C         MODAL STIFFNESS AND DAMPING MATRICES
C         ------------------------------------
C
C     THE FOLLOWING PARAMETERS ARE REAL*8 ARRAYS STORED IN /INTGRL/,
C        THESE ARRAYS ARE LOADED IN DYNS20 BY A READ(NTAPE1) STATEMENT.
C        THE DATA ON NTAPE1 WAS GENERATED IN AND BY CALLS FROM THE
C        FLEXIBLE BODY INPUT ROUTINES MSMODL AND MSMODC
C     AK     = MODAL STIFFNESS MATRIX, DIMENSIONED (NMDBOD,NMDBOD,NBMAX)
C              LET
C                  NM =IRGFLX(N) = NUMBER OF MODES USED FOR BODY N
C              THEN
C             ((AK(I,J,N),I=1,NM),J=1,NM) = NM BY NM MODAL STIFFNESS
C                             MATRIX FOR BODY N. NON-ORTHOGONAL MODES
C                             MAY BE USED; IF SO, THIS MATRIX WILL BE
C                             SYMMETRIC BUT NON-DIAGONAL.
C              FOR ORTHOGONAL MODES
C              AK(M,M,N) = (GENERALIZED MASS OF MODE M BODY N) * (MODE M
C                           NATURAL FREQUENCY)**2
C      AD    = MODAL DAMPING MATRIX, DIMENSIONED (NMDBOD,NMDBOD,NBMAX)
C              LET
C                  NM = IRGFLX(N) = NUMBER OF MODES USED FOR BODY N
C              THEN
C             ((AD(I,J,N),I=1,NM),J=1,NM) = NM BY NM MODAL DAMPING
C                             MATRIX FOR BODY N. IF THE DAMPING MATRIX
C                             IS NOT PROPORTIONAL TO A LINEAR FUNCTION
C                             OF THE MASS AND STIFFNESS MATRICES THIS
C                             MODAL DAMPING MATRIX WILL BE SYMMETRIC AND
C                             NON-DIAGONAL
C              FOR PROPORTIONAL DAMPING IN BODY N
C              AD(M,M,N) = 2 * (GENERALIZED MASS OF MODE M)
C                            * (DAMPING ZETA FOR MODE M)
C                            * (NATURAL FREQUENCY OF MODE M)
C
C
C     GRAVITY GRADIENT DATA, INPUTTED AND COMPUTED
C-------------------------------------------------
C
C     WV     = GRAVITY GRADIENT INPUT DATA ARRAY. THESE REAL*8 CONSTANTS
C              ARE USED TO COMPUTE DATA TO BE STORED IN /GGDATA/
C              (WV(I),I=1,3) = 3 COMPONENTS OF THE GRAVITY VECTOR WRT
C                              INERTIAL REFERENCE (UNITS OF ACC)
C              WV(4)         = DISTANCE FROM GRAVITY SOURCE TO VICINITY
C                              OF BODY CLUSTER CENTER OF MASS
C
C     THE FOLLOWING PARAMETERS ARE REAL*8 VARIABLES STORED IN /GGDATA/
C        THE USER MAY, IN CONTRL, DEFINE THESE PARAMETERS TO BE TIME
C        FUNCTIONS SO THAT MOTION IN ORBIT MAY BE SIMULATED
C     RCMAG  = WV(4) DISTANCE FROM GRAVITY SOURCE TO VICINITY OF SYSTEM
C     GMAG   = RESULTANT GRAVITATIONAL ACCELERATION
C                 GMAG = SQRT(WV(1)**2 + WV(2)**2 + WV(3)**2)
C     GAMGI  = COMPONENTS OF A UNIT VECTOR FROM THE GRAVITY SOURCE TO
C              THE VICINITY OF THE SYSTEM CENTER OF MASS WRT INERTIAL
C              REFERENCE, DIMENSIONED (3). FROM DYNS10
C               GAMGI(I) = WV(I)/GMAG; I=1,2,3
C                (NOT COMPUTE IF (GMAG.EQ.0))
C     GGS    = GRAVITY GRADIENT EFFECTS ON ELASTIC COORDINATES, A REAL*8
C              ARRAY DIMENSIONED (NMDBOD,9,NBMAX) AND STORED IN /GGSAVE/
C              THE ELEMENTS OF THIS ARRAY ARE COMPUTED IN MGEN BASED
C              UPON THEORY ON PAGES 48-52, VOL I.  THEY ARE
C              DEFORMATION DEPENDENT TERMS REQUIRED FOR COMPUTATION
C              OF GRAVITY GRADIENT FORCES AND TORQUES
C                  FOR BODY N LET
C                     L0 = LOCU(NB+N) = LOCATION OF FIRST ELASTIC COORD.
C                                       IN STATE VECTOR
C                     LE = LENU(NB+N) = NUMBER OF ELASTIC COORD. IN Y
C         (GGS(J,1,N),J=1,LE) = ROW J OF COF11(1,1,N)*Y(L0)
C         (GGS(J,2,N),J=1,LE) = ROW J OF COF22(1,1,N)*Y(L0)
C         (GGS(J,3,N),J=1,LE) = ROW J OF COF33(1,1,N)*Y(L0)
C         (GGS(J,4,N),J=1,LE) = ROW J OF COF12(1,1,N)*Y(L0)
C         (GGS(J,5,N),J=1,LE) = ROW J OF COF13(1,1,N)*Y(L0)
C         (GGS(J,6,N),J=1,LE) = ROW J OF COF23(1,1,N)*Y(L0)
C         (GGS(J,7,N),J=1,LE) = COL J OF Y(L0)**T*COF12(1,1,N)
C         (GGS(J,8,N),J=1,LE) = COL J OF Y(L0)**T*COF13(1,1,N)
C         (GGS(J,9,N),J=1,LE) = COL J OF Y(L0)**T*COF23(1,1,N)
C
C
C     KINEMATIC DATA INPUTTED AND COMPUTED
C-----------------------------------------
C
C     BETAH  = CONTIGUOUS HINGE FRAME ORIENTATION DATA ARRAY, REAL*8
C              PARAMETERS STORED IN /SPECIF/, DIMENSIONED (6,NHMAX)
C              INITIAL VALUES INPUTTED IN DYNS10
C              INSTANTANEOUS VALUES ARE STRIPPED FROM THE STATE VECTOR
C              ARRAY Y IN ROTDH
C              (BETAH(I,N),I=1,3) = 3 SUCCESSIVE EULER ANGLES REQUIRED
C                                   TO ORIENT Q-FRAME RELATIVE TO
C                                   P-FRAME AT HINGE POINT N
C              (BETAH(I,N),I=4,6) = 3 POSITION COORDINATES OF THE ORIGIN
C                                   OF THE Q-FRAME RELATIVE TO THE
C                                   P-FRAME AT HINGE POINT N
C     BETAHD = CONTIGUOUS HINGE FRAME RELATIVE RATE DATA ARRAY, REAL*8
C              PARAMETERS STORED IN /SPECIF/, DIMENSIONED (6,NHMAX)
C              INITIAL VALUES INPUTTED IN DYNS10
C              INSTANTANEOUS VALUES ARE STRIPPED FROM THE STATE VECTOR
C              DOT ARRAY YDT IN YDOT
C                BETAHD(I,N) = FIRST TIME DERIVATIVE OF BETAH(I,N)
C                              ((I=1,6),N=1,NH)
C     AMO    = MOMENTUM WHEEL DATA ARRAY, REAL*8 PARAMETERS STORED IN
C              /SPECIF/, DIMENSIONED (2,NMWMAX), INPUT DATA FROM DYNS10
C              THESE PARAMETERS ARE NOT FUNCTIONS OF TIME
C                   AMO(1,M) = INITIAL SPIN RATE FOR WHEEL M
C                   AMO(2,M) = SPIN INERTIA FOR WHEEL M
C
CAE
COS
C
C      SUBROUTINE DYNS20 OUTPUT
C      ------------------------
C
C
C              THE T=0  PRINT OUT IS ALWAYS GIVEN
C                       (EVEN FOR A LINEARIZED ANALYSIS)
C
C
C              THE DATA ARE PRESENTED IN VECTOR FORM AND
C              ORDERED AS FOLLOWS---
C
C---------THE STATE VECTOR Y =
C
C---------THE STATE VECTOR TIME DERIVATIVE YDT =
C
C---------THE BETAS (EULER ANGLES, POSITION COORDINATES) ARE
C
C---------THE BETA TIME DERIVATIVES ARE
C
C---------THE DELTAS (CONTROL SYSTEM VARIABLES) ARE
C
C---------THE DELTA TIME DERIVATIVES ARE
C
C
C
C
C---------
C           THE FOLLOWING INFORMATION IS TYPICAL FOR BODY I.
C
C
C---------FOR BODY I  THE VELOCITIES ARE
C
C            ORDER IS    OMGX
C                        OMGY    BODY ANGULAR VELOCITY
C                        OMGZ
C
C                           U
C                           V    BODY TRANSLATIONAL VELOCITY
C                           W
C
C                        XID(1)
C                        XID(2)
C                          .     BODY MODAL VELOCITIES
C                          .
C                          .
C                        XID(NE)
C
C                       THETAD(1)
C                          .     MOMENTUM WHEEL ANGULAR VELOCITY
C                          .     (RELATIVE TO SENSOR POINT TRIAD)
C                          .          (ACTIVE WHEEL)
C
C
C---------FOR BODY I THE CORRESPONDING MOMENTA ARE
C
C              ORDER IS    HX
C                          HY  BODY AXES REF. ANGULAR MOMENTUM
C                          HZ   INCLS CONTRIBUTION OF CONST. SPEED WHEEL
C
C                          LX
C                          LY  BODY AXES REF. LINEAR MOMENTUM
C                          LZ
C
C                        P XI(1)
C                        P XI(2)
C                          .   BODY AXES REF. MODAL MOMENTUM
C                          .
C                          .
C                        P XI(NE)
C
C                        H MW(1)
C                          .   BODY AXES REF. MOM WHEEL MOMENTUM
C                          .   (ACTIVE WHEEL)
C                          .
C
C
C
C
C
C
C
C
C---------FOR BODY I ITS CONTRIBUTION TO TOTAL ANGULAR
C                    AND LINEAR MOMENTUM IS
C
C              ORDER IS    HX
C                          HY  ANGULAR MOMENTUM
C                          HZ
C                          (REFERENCED TO INERTIAL ORIGIN)
C                          LX
C                          LY  LINEAR MOMENTUM
C                          LZ
C
C
C---------FOR BODY I ITS CONTRIBUTION TO TOTAL KINETIC AND
C                    POTENTIAL ENERGIES IS
C
C
C---------FOR BODY I  THE ELASTIC DEFLECTIONS ARE
C
C
C---------FOR BODY I   TRANSFORMATION MATRIX TO BODY 1 COORDINATES IS
C
C                      USED TO TRANSFORM VECTORS AND TENSORS
C                      FROM BODY I FIXED REFERENCE
C                        TO BODY 1 FIXED REFERENCE
C
C
C---------FOR BODY I   CM LOCATION WRT BODY 1 REFERENCE POINT AND
C                      COORDINATES IS
C
C
C---------FOR BODY I   INERTIA TENSOR RELATIVE TO ITS CENTER OF MASS
C                      WRT BODY 1 COORDINATES IS
C
C
C---------THE INTERCONNECTION CONSTRAINT FORCES (LAMBDAS) ARE
C
C
C---------THE SYSTEM CENTER OF MASS RELATIVE TO BODY 1 REFERENCE POINT
C                      AND COORDINATES IS
C
C
C---------THE SYSTEM INERTIA TENSOR RELATIVE TO SYSTEM CENTER OF MASS
C                      IN BODY 1 COORDINATES IS
C
C
C---------THE TOTAL ANGULAR MOMENTUM VECTOR IS
C
C                   X,Y,Z  COMPONENTS IN INERTIAL REF. AXIS SYSTEM.
C
C
C---------THE TOTAL LINEAR MOMENTUM VECTOR IS
C
C                   X,Y,Z  COMPONENTS IN INERTIAL REF. AXIS SYSTEM.
C
C
C---------THE TOTAL ANGULAR MOMENTUM =
C---------THE TOTAL LINEAR MOMENTUM  =
C---------THE TOTAL KINETIC ENERGY   =
C---------THE TOTAL POTENTIAL ENERGY =
C---------THE TOTAL ENERGY (T+V)     =
C
C
C
COE
      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: dyns20.f,v $$Revision: 1.1.1.1 $'/
#ifdef AMBER
C
c     Argument list
c
c
      LOGICAL erstop
#endif
c
#include "PARAM.FOR"
C
#include "AMUBW.INC"
#include "BHBSRD.INC"
#include "CONPAR.INC"
#include "COREA.INC"
#include "CPATHS.INC"
#include "CSTIFF.INC"
#include "ILINER.INC"
#include "INTGRL.INC"
#include "LDEBUG.INC"
#include "MAXMUM.INC"
#include "MISCNO.INC"
#include "MISCN2.INC"
#include "MOMENG.INC"
#include "MULTIPOLE.INC"
#include "NUMBRS.INC"
#include "OPTION.INC"
#include "PARTCL.INC"
#include "PINRP.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
#include "TIMESS.INC"
#include "TIMING.INC"
#include "VECTOR.INC"
#include "GCOMP.INC"
#include "HEAPMB.INC"
C
C     CHARMM COMMON blocks
C
#ifdef CHARMM
#include "CHARMM.INC"
#endif
C
#include "ERRHDL.INC"
#include "MDTYPE.INC"
C
C     AMBER COMMON blocks
C
#ifdef AMBER
#include "INFOV.INC"
#include "MACRO.INC"
#include "MDCON.INC"
#include "MDINFO.INC"
#include "MDSOL.INC"
c
      DOUBLE PRECISION ener(51)
      COMMON /mdener/ ener
#endif
c
c     Other COMMON blocks
c
      DOUBLE PRECISION fac(3), enert(51), enert2(51), boltz2
      INTEGER nrx, nrv, nren, nrek
      common /bfac/ fac, enert, enert2, boltz2,
     +              nrx, nrv, nren, nrek
c
c     Passed variables
c
      DOUBLE PRECISION Y(cL07), YDT(cL07)
      DOUBLE PRECISION p(cL10)
      DOUBLE PRECISION betahd(6,cl02)
      INTEGER IHDATA(7,cL02)
      LOGICAL ISCUT(cL02)
c
c     Local Variables
c
      INTEGER i, j, l                ! Loop counters
      INTEGER lde                    ! Array pointer
      INTEGER ibtdt, idof1           ! Array pointers
      INTEGER ndf                    ! No. of dofs
      INTEGER ihd                    ! IHDATA element
      LOGICAL LEQU                   ! Debug output flag
      DOUBLE PRECISION eps
#ifdef HBMA
c
cHon
c     Don't these need to be declared for CHARMM use?
c
      DOUBLE PRECISION    tim1, tim2 ! Timing variables
#endif
#ifdef AMBER
      INTEGER ndfp, ndfs             ! No. of DOFs
      INTEGER nct, ncons             ! Constraint counters
      DOUBLE PRECISION pconv, ekin0, ekinp0, ekins0
#endif
c
c     External Functions
c
      DOUBLE PRECISION adt
c
C     DATA and EQUIVALENCE statements
c
      EQUIVALENCE (LEQU,DEBUG(37))
      EQUIVALENCE (cntdta(1),eps)
C
#ifdef AMBER
      erstop =.false.
      NCT = 0
c
      if(ntc.eq.3) then 
         nct   = mbona+nbonh
         ncons = nbsola+nbsolh
      endif
      if(ntc.eq.2) then
          nct   = nbonh
          ncons = nbsolh
      endif
      if(ntc.eq.1) then
         nct = 0 
         ncons = 0
      endif
C
c      IF (.NOT.belly) THEN
         NDFP = NPM*(3*NRP-(NCT-ncons))
         NDFS = NSM*(3*NRAM-ncons)
c      endif
C
      NDF = NDFP+NDFS-NDFMIN
      deltat = dtx * 10d0
#endif
C
      T = STARTT
C
      DO 2 I=1,KY
      Y(I) = ZRO
    2 YDT(I) = ZRO
C

c
c     Reset the Temperature conversion factor
C
c      NDF = 6
c      do i = 1, nb
c         ndf = ndf + irgflx(i)
c      end do
c      if (nconn .ne. 0) then
c         do j = 2, nh
c            do i = 1, 6
c               if (ihdata(i+1,j).eq.0) ndf = ndf + 1
c            end do
c         end do
c      end if 
c      write(6,*) ' NUMBER OF DOFS, NDF = ', ndf
cblink   Fix this up some time 
#ifdef CHARMM
      NDF = iparam(12)
#else
      NDF = 3*iatoms(2,nb)
#endif
      BOLTZ2 = 8.31441D-03/2D0
      IF(NTU.EQ.1) BOLTZ2 = BOLTZ2/4.184d0
      FAC(1) = BOLTZ2*NDF
#ifdef AMBER
      PCONV = 1.6604345d04
      IF(NTU.EQ.1) DELTAT = DELTAT*2.0455d00
      IF(NTU.EQ.1) STARTT = STARTT*20.455d00
      IF(NTU.EQ.1) T      = T * 20.455d00
      IF(NTU.EQ.1) PCONV = PCONV*4.184d0
      FAC(2) = BOLTZ2*NDFP
      IF(NDFP.EQ.0) FAC(2) = 1.d-6
      FAC(3) = BOLTZ2*NDFS
      IF(NDFS.EQ.0) FAC(3) = 1.d-6
      ekin0 =  fac(1)*temp0
      EKINP0 = FAC(2)*TEMP0
      EKINS0 = FAC(3)*TEMP0
C
      NREN = 37
      NREK = 4
C
      DO 17 I = 1,NREN
      ENER(I) = 0.0d0
      ENERT(I) = 0.0d0
      ENERT2(I) = 0.0d0
   17 CONTINUE
C
      ENER(5) = 1.d0
      ENER(6) = 1.d0
      ENER(5) = 1.d0
      ENER(6) = 1.d0
      ENER(7) = BOX(1)
      ENER(8) = BOX(2)
      ENER(9) = BOX(3)
#endif
C
C     LOAD INITIAL VALUES FOR CONTROL SYSTEM VARIABLES IN STATE VECTOR
c
      IF (NDELTA .EQ. 0) GO TO 25
      LDE  = LOCU(2*NB+2) - 1
      DO 26 J=1,NDELTA
      L = LDE + J
   26 Y(L) = CNTDTA(J)
 25   CONTINUE
C
c     The calls to ROTDH and BHGENR are now made from CMPIC3
c
      call cmpic3(HEAP_MB(iamdampptr),HEAP_MB(iyptr),
     .            HEAP_MB(igvecptr),logicLoopHeap(iiscutptr),
     .            intLoopHeap(iiaconnptr),intLoopHeap(iibconnptr),
     .            intLoopHeap(iiconnhptr),intLoopHeap(iihpvtptr),
     .            LoopHeap(ipinptr),Loopheap(ibetahptr),
     .            Loopheap(ibetahdptr),intLoopHeap(iitopolptr),
     .            intLoopheap(iihdataptr))
c
      call mgen
C
C Subroutine VFMA0: Initialize variables needed for VFMA routines.
C                   Call to vfma0 is included here after the modal 
C                   stiffness and damping matrices have been loaded
C                   into AK and AD in COMMON block /INTGRL/ in 
C                   INTGRL.INC
c
#ifdef HBMA
      IF (idovfma) THEN
         CALL msecond(tim1)
         CALL vfma0
         CALL print_grid
         CALL msecond(tim2)
         timer(ivf0) = tim2 - tim1
      END IF
#endif
c
c        Load the augmented part of the state vector Y with the
C        input beta dots and check the input beta dots for consistency
c        Skip the cut joint hinges since those are taken care of in CLFOR1.
c
      ibtdt = locu(2*nb + 3)
      DO 215 J=1,NH
         if (ihdata(1,j) .eq. 0) then
            idof1 = 4
         else
            idof1 = 1
         end if
         if (.not. iscut(j)) then
            DO 214 I = idof1, 6
               ihd = ihdata(i+1,j)
               if (ihd .eq. 0) then
                  y(ibtdt) = betahd(i,j)
                  ibtdt    = ibtdt + 1
               end if
               IF (IHD .EQ. 1) BETAHD(I,J) = ZRO
               IF (IHD .EQ. 2) BETAHD(I,J) = ADT(6*(j-1)+i,T)
 214        continue
         end if
 215  CONTINUE
#ifdef CHARMM
#ifdef ANALYZE_FORCE
      CALL mdloop_CHARMM(HEAP_MB(iyptr),HEAP_MB(iydtptr),
     &                   HEAP_MB(ig_chmptr),HEAP_MB(ig_gyroptr),
     &                   HEAP_MB(ig_deformptr),HEAP_MB(ipptr),
     &                   LocalHeap(izptr_mdloop_charmm),
     &                   LocalHeap(izdtptr_mdloop_charmm))
#else
      CALL mdloop_CHARMM(HEAP_MB(iyptr),HEAP_MB(iydtptr),
     &                   HEAP_MB(ipptr),
     &                   LocalHeap(izptr_mdloop_charmm),
     &                   LocalHeap(izdtptr_mdloop_charmm))
#endif
#else
      CALL mdloop
#endif

c     deallocate heap for langevin

#ifdef POINTER_KEYWORD
#ifdef CHARMM
      CALL mbfrePTR(mbdynaptr)
#endif
c     deallocate local heap for local variables
      CALL mbfrePTR(lhpptr)
      CALL mbfrePTR(ilhpptr)
#endif

      RETURN
 999  CALL CLEARERR()
      WRITE(ERRMSG,200) '1ERROR IN ITOPOL'
      CALL ERRHDL(-5,'<DYNS20>')
 200  FORMAT(1X,A)
      END
