C $Header: /export/cvs/c34a1/source/moldyn/engmom_ke.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C ========================================================================
C
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER 
C STATE AND FEDERAL LAWS.  USE, DISCLOSURE, REPRODUCTION OR DUPLICATION 
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS 
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT 
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      SUBROUTINE ENGMOM_KE(Y,P,PMOM)
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
CSE
C                                                          DEBUG #  58
CPS        PURPOSE:
C
C                   TO COMPUTE LINEAR AND ANGULAR MOMENTUM ALONG WITH
C                   KINETIC AND POTENTIAL ENERGY FOR EACH BODY AND
C                   FOR THE TOTAL SYSTEM
C
CPE
CAS
C
C     SYSTEM AND BODY ENERGY AND MOMENTUM
C----------------------------------------
C
C     THE FOLLOWING PARAMETERS ARE CONTINUALLY MONITORED FOR THE USER
C        TO CHECK TO DETERMINE IF ALL ENERGY AND MOMENTUM CONSERVATION
C        LAWS ARE HOLDING TRUE. THESE PARAMETERS ARE WITH THE EXCEPTION
C        OF ORDINARY MOMENTA COMPUTED IN SUBROUTINE ENGMOM, THEY ARE
C        ALL STORED IN /MOMENG/ AND PRINTED AS A FUNCTION OF TIME
C
C     P      = ORDINARY MOMENTA ARRAY, SEE EQUATION II-49 VOL 1
C              DIMENSIONED (NBMAX*(6+NMDBOD)+NMWMAX)
C        (P(I),I=1,NU)  = ORDINARY MOMENTA ASSOCIATED WITH VELOCITY
C                         COORDINATE I, I=1,...,NU
C     PMOM   = BODY ANGULAR AND LINEAR MOMENTUM ARRAY
C              DIMENSIONED (6*NBMAX)
C        (PMOM(I),I=6*(N-1)+1,6*(N-1)+3) = 3 COMPONENTS OF THE INERTIAL
C                         ANGULAR MOMENTUM VECTOR ASSOCIATED WITH THE
C                         MOTION OF BODY N WRT INERTIAL COORDINATES
C        (PMOM(I),I=6*(N-1)+4,6*(N-1)+6) = 3 COMPONENTS OF THE INERTIAL
C                         LINEAR MOMENTUM VECTOR ASSOCIATED WITH THE
C                         MOTION OF BODY N WRT INERTIAL COORDINATES
C     HTOT   = TOTAL SYSTEM ANGULAR MOMENTUM ARRAY DIMENSIONED (3) THE 3
C              COMPONENTS ARE WRT INERTIAL COORDINATES
C     TOTL   = TOTAL SYSTEM LINEAR MOMENTUM ARRAY DIMENSIONED (3) THE 3
C              COMPONENTS ARE WRT INERTIAL COORDINATES
C     ENGKE  = KINETIC ENERGY ARRAY, DIMENSIONED (NBMAX)
C              ENGKE(N) =KINETIC ENERGY OF BODY N
C     ENGPE  = POTENTIAL ENERGY ARRAY, DIMENSIONED (NBMAX)
C              ENGPE(N) = POTENTIAL ENERGY OF BODY M
C     TOTKE  = TOTAL SYSTEM KINETIC ENERGY
C     TOTPE  = TOTAL SYSTEM POTENTIAL ENERGY
C     TOTENG = TOTKE +TOTPE
C     ATOTL  = TOTAL SYSTEM LINEAR MOMENTUM (VECTOR MAGNITUDE)
C     AHTOT  = TOTAL SYSTEM ANGULAR MOMENTUM (VECTOR MAGNITUDE)
C
CAE
      IMPLICIT NONE
 
      DOUBLE PRECISION DDOT
C
C
C        FOR THEORY OF EQUATIONS PROGRAMMED SEE VOL 1 APPENDIX D
c
#include "PARAM.FOR"
#ifdef CHARMM
#include "CHARMM.INC"
#endif
#include "MOMENG.INC"
#include "NUMBRS.INC"
#include "SPECIF.INC"
#include "VECTOR.INC"
C
c
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: engmom_ke.f,v $$Revision: 1.1.1.1 $'/

      INTEGER n, lou, leu
      DOUBLE PRECISION Y(cL07)
      DOUBLE PRECISION P(cL10),PMOM(cL10)
C
      TOTKE = ZRO
      DO n = 1, nb
         lou = locu(n)
         leu = lenu(n)
#ifdef CHARMM
         IF (PrtCvel(n) .eq. 0) THEN ! Ignore dummy atoms
         else
c           print*,'engmom_ke ',n
            p(lou)   = ZRO
            p(lou+1) = ZRO
            p(lou+2) = ZRO
         ENDIF
#endif

CC@CC
CC@CC MULT3 Y(LOU), P(LOU), ENGKE(N)
CC@CC 1, LEU, 1
CC@CC 1, LEU, 1
      ENGKE(N) = DDOT (LEU,Y(LOU),1,P(LOU),1)
CC@CC end of expanded call
CC@CC
         engke(n) = engke(n)/TWO
         totke = totke + engke(n)
      END DO
C
      RETURN
      END
