C $Header: /export/cvs/c34a1/source/moldyn/getvel.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C ========================================================================
C
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER 
C STATE AND FEDERAL LAWS.  USE, DISCLOSURE, REPRODUCTION OR DUPLICATION 
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS 
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT 
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
c
c
c  This routine computes the inertial velocities of all atoms
c    based on the variables D0L and R0L, the modal data in the 
c    state vector, Y, and the mode shapes associated with the 
c    sensor points.
c
c
      subroutine getvel (v)
      implicit none
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: getvel.f,v $$Revision: 1.1.1.1 $'/
c
#include "PARAM.FOR"
c
#include "HEAPMB.INC"
#include "VECTOR.INC"
c
      double precision v(*)
c
      CALL GETVEL_1(v,HEAP_MB(iyptr))
c
      RETURN
      END
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      subroutine getvel_1(v,y)
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      implicit none
c
      double precision v(*)
c
#include "PARAM.FOR"
c
#include "BHBSRD.INC"
#include "HANDS2.INC"
#include "HEAPMB.INC"
#include "SPECIF.INC"
#include "VECTOR.INC"
c
#include "CSTIFF.INC"
c
      double precision v1(3)
      double precision y(cL07)
      integer le, lo, iloc, ipoint, lr2, i, ifb
c
      do ifb = 1, nb
c
         le = IRGFLX(ifb)
         lo = LOCU(NB+ifb)
         iloc = LOCU(ifb)
         ipoint = 3*(iatoms(1,ifb)-1) + 1
         do i = iatoms(1,ifb), iatoms(2,ifb)
            lr2 = 2*i
            v1(1) = Y(iloc+3) + Y(iloc+1)*DS(3,lr2)-Y(iloc+2)*DS(2,lr2)
            v1(2) = Y(iloc+4) + Y(iloc+2)*DS(1,lr2)-Y(iloc  )*DS(3,lr2)
            v1(3) = Y(iloc+5) + Y(iloc  )*DS(2,lr2)-Y(iloc+1)*DS(1,lr2)
            if (le .ne. 0) then
C
C Original: MULTAD HATS(htsptr(i)+1),Y(iloc+6),v1,3,le,1,3,le,3
CC@CC
CC@CC .....MULTAD HATS(ihtsptr(i)+1), Y(iloc+6), v1
CC@CC .....3, le, 1
CC@CC .....3, le, 3
      CALL DGEMV ('N',3,le,1.0d0,HATS(ihtsptr(i)+1),3,Y(iloc+6),1,1.0d0,
     .v1,1)
CC@CC end of expanded call
CC@CC
            end if
            IF (ifb .GT. nbdy) THEN  ! Its a particle
               v(ipoint)   = y(iloc)
               v(ipoint+1) = y(iloc+1)
               v(ipoint+2) = y(iloc+2)
            ELSE                     ! Its a body
CC@CC
CC@CC .........MULT3 r0l(1,1,ifb), v1, v(ipoint)
CC@CC .........3, 3, 1
CC@CC .........3, 3, 3
      v(ipoint+0) = r0l(1,1,ifb)*v1(1) + r0l(1,2,ifb)*v1(2) + r0l(1,3,if
     .b)*v1(3)
      v(ipoint+1) = r0l(2,1,ifb)*v1(1) + r0l(2,2,ifb)*v1(2) + r0l(2,3,if
     .b)*v1(3)
      v(ipoint+2) = r0l(3,1,ifb)*v1(1) + r0l(3,2,ifb)*v1(2) + r0l(3,3,if
     .b)*v1(3)
CC@CC end of expanded call
CC@CC
            END IF
            ipoint = ipoint + 3
         end do
      end do
c
      return
      end
