C $Header: /export/cvs/c34a1/source/moldyn/mbdyna.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1994 MOLDYN, INC.  ALL RIGHTS RESERVED
C ========================================================================
C
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER 
C STATE AND FEDERAL LAWS.  USE, DISCLOSURE, REPRODUCTION OR DUPLICATION 
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS 
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT 
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C
      SUBROUTINE mbdyna(matom,xx,yy,zz,amass,cg,xv,yv,zv,
     &     dx,dy,dz,LCoeff,rparm,iparm,FixedPrt,CvelPrt)
   
c     old subroutine mbdyna changed to mbdyna_1
c     this mbdyna create for passing variables into 
c     mbdyna_1 for heaps

      IMPLICIT NONE
#include "PARAM.FOR"

#include "CHARMM.INC"

#include "AMUBW.INC"
#include "CONPAR.INC"
#include "COREA.INC"
#include "CPATHS.INC"
#include "CSTIFF.INC"
#include "ERRHDL.INC"
#include "EXTRA.INC"
#include "HANDS2.INC"
#include "HEAPMB.INC"
#include "IFIRST.INC"
#include "INTGRL.INC"
#include "MAXMUM.INC"
#include "MISCNO.INC"
#include "MULTIPOLE.INC"
#include "NHNS.INC"
#include "OPTION.INC"
#include "PARTCL.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
#include "TIMESS.INC"
#include "TIMING.INC"
#include "NUMBRS.INC"
#include "GCOMP.INC"
#include "VECTOR.INC"
#include "MOMENG.INC"

C     Argument List
C
      DOUBLE PRECISION xx(*), yy(*), zz(*), xv(*), yv(*), zv(*)
      DOUBLE PRECISION amass(*), cg(*), dx(*), dy(*), dz(*)
      DOUBLE PRECISION rparm(*), LCoeff(*)
      INTEGER          iparm(*), FixedPrt(*), matom, CvelPrt(*)

      call mbdyna_1(matom,xx,yy,zz,amass,cg,xv,yv,zv,
     &     dx,dy,dz,LCoeff,rparm,iparm,FixedPrt,CvelPrt,
     &     intLoopHeap(iichpvtptr),LoopHeap(ibetahptr),
     &     LoopHeap(ibetahdptr),intLoopheap(iitopolptr),
     &     intLoopheap(iihdataptr),intLoopheap(iihcutjptr))
      
      RETURN
      END

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE mbdyna_1(matom,xx,yy,zz,amass,cg,xv,yv,zv,
     &     dx,dy,dz,LCoeff,rparm,iparm,FixedPrt,CvelPrt,ichpvt,
     &     betah,betahd,itopol,ihdata,ihcutj)
C
C     Interface with CHARMM for the passing of dynamics simulation information
C
      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: mbdyna.f,v $$Revision: 1.1.1.1 $'/
C
#include "PARAM.FOR"
c
C     Argument List
C
      DOUBLE PRECISION xx(*), yy(*), zz(*), xv(*), yv(*), zv(*)
      DOUBLE PRECISION amass(*), cg(*), dx(*), dy(*), dz(*)
      DOUBLE PRECISION rparm(*), LCoeff(*)
      DOUBLE PRECISION betah(6,cL02)
      DOUBLE PRECISION betahd(6,cL02)
      INTEGER          iparm(*), FixedPrt(*), matom, CvelPrt(*)
      INTEGER ichpvt(cl02)
      INTEGER itopol(2,cl02)
      INTEGER ihdata(7,cl02)
      INTEGER ihcutj(cL63)
c
c     CHARMM/MBO(N)D COMMON blocks
c
#include "CHARMM.INC"
c
C     MBO(N)D COMMON BLOCKS
C     
#include "AMUBW.INC"
#include "CONPAR.INC"
#include "COREA.INC"
#include "CPATHS.INC"
#include "CSTIFF.INC"
#include "ERRHDL.INC"
#include "EXTRA.INC"
#include "HANDS2.INC"
#include "HEAPMB.INC"
#include "IFIRST.INC"
#include "INTGRL.INC"
#include "MAXMUM.INC"
#include "MISCNO.INC"
#include "MULTIPOLE.INC"
#include "NHNS.INC"
#include "OPTION.INC"
#include "PARTCL.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
#include "TIMESS.INC"
#include "TIMING.INC"
#include "NUMBRS.INC"
#include "GCOMP.INC"
#include "VECTOR.INC"
#include "MOMENG.INC"
c
c     AMBER common blocks used in MBO(N)D
c
      INTEGER        M05,M10,M15,M20,M25,M30,M35,M40,M45,M50
      COMMON/MEMLB/  M05,M10,M15,M20,M25,M30,M35,M40,M45,M50
c
      INTEGER        natom,nres,nbonh,nbona,ntheth,ntheta,nphih,
     @ nphia,nnb,ntypes,nrcp,nconp,mbona,mtheta,mphia,natc,
     @ isegmt, natbel,ishake,nmxrs
      COMMON/INFOV/  NATOM,NRES,NBONH,NBONA,NTHETH,NTHETA,NPHIH,
     @ NPHIA,NNB,NTYPES,NRCP,NCONP,MBONA,MTHETA,MPHIA,NATC,
     @ ISEGMT, NATBEL,ISHAKE,NMXRS
c
      INTEGER ntx, ntcx, ntxo, ntt, ntp, ntr, init, ntcm, nscm, ntu
      DOUBLE PRECISION tx, dtx
      COMMON/MDTYPE/NTX,NTCX,NTXO,NTT,NTP,NTR,INIT,NTCM,NSCM,NTU,
     @               TX,DTX
c
c     Local variables
c
      INTEGER i, j, n       !  DO loop index
      INTEGER ipoint        !  Pointer into X array
      INTEGER lr1, lr2      !  Pointers into ds array
      INTEGER nerror        !  Error flag
      INTEGER le, lastindx
      LOGICAL QOPEN         ! Check to see if units are open

      DOUBLE PRECISION tim1, tim2    !  Timing variables
c
c     compute the max number of flex modes per body
c     loop through verctor irgflx and get the largest
c     value
      MaxFlexMod = irgflx(1)  
      DO i = 2, L01
         IF (MaxFlexMod .lt. irgflx(i)) THEN
	        MaxFlexMod = irgflx(i)
         END IF      
      END DO
c
c     Set all the cL?? variables related to maxmod
      cL06 = MaxFlexMod
      cL07 = (18+2*cL06)*MAXBOD+9*MXPRTL
      cL08 = 6 + cL06
      cL10 = L01 * (6+cL06)
      cL11 = cL08
      cL45 = MAX(6,cl06)
      cL72 = L01*(6+cL06)+cL02+6
      KY = cL07
      NMDBOD = cL06
      KU = cL10
c     Find the Maximum number atoms per body
c     get the largest value int matrix iatoms(3,n)
      MaxPerBD = iatoms(3,1)
      DO i = 2, NB
         IF ( MaxPERBD .lt. iatoms(3,i)) THEN
                MaxPERBD = iatoms(3,i)
         END IF
      END DO
      cL43 = MaxPerBD
c
c     allocate memory for localheaps
      CALL initHeap
c
C     Initialize variables
c
      nrk4 = 0
      nfrc_call = 0
      DO j = 1, ioutput
         timer(j) = 0D0
      END DO
      CALL msecond(tim1)
      timer(imbond0) = tim1
      do j = 1, cL02          !  To count number of pivot changes
         ichpvt(j) = 0
      end do
      DO j = 1, MAXI1
         i1pass(j) = 0
      END DO
      
      MBBOMM = iparam(19)    ! constant
c
c     Rewind scratch units
c
      REWIND NTAPE2
      REWIND NTAPE3
c
c     Check the MATOM value that is passed through argument list with the
c     value in the COMMON block
c
      IF (natom .NE. matom) THEN
         WRITE(mbout,*) ' NATOM not consistent'
         nerror = 55
         go to 999
      END IF
C
C     DTX    = stepsize for fine timestep
C     TX     = starting time
C     NSTLIM = no. of fine steps in simulation
C     NENFRQ = "   "    "   "    per ener. printout
C     NSMFRQ = "   "    "   "     "  summary output file
C     NBDFRQ = "   "    "   "     "  body vector output
C     NOUTCH = Output unit for standard CHARMM
C     NOUTVC = Output unit for vector output
C     MBPLVL = MBO(N)D printout level
C     NDOFMB = No. of DOFs of multibody system
C     NDOFBB = No. of DOFs of bodies
C
      DO i = 1, 40
         iparam(i) = iparm(i)
         rparam(i) = rparm(i)
      END DO
c
      deltat = rparam(1)
      tx     = rparam(2)
      nstlim = iparam(1)
      nvlfrq = iparam(2)
      nenfrq = iparam(3)
      nsmfrq = iparam(4)
      nbdfrq = iparam(5)
C
C     Re-write CHARMM's set-up for MBO(N)D's MTS(L) 
C     into MBO(N)D's set-up
      nstages = iparam(28)
      mratio(1) = 1
      DO i = 2, nstages
         mratio(i) = iparam(27 + i)
      END DO
C
C     Set integrator flags
C
      IF (iparam(21) .NE. 4) THEN
C     Set flags for the "not Lobatto" integrators 
         IF (iparam(21) .EQ. 1) THEN        !  Settings for RK integrator
            runge_kutta = .TRUE.
            verlet      = .FALSE.
            v_verlet    = .FALSE.
            verl_cd     = .FALSE.
            lobatto     = .FALSE.
         ELSE IF (iparam(21) .EQ. 2) THEN   !  Settings for IVV integrator
            runge_kutta = .FALSE.
            verlet      = .TRUE.
            verl_cd     = .FALSE.
            v_verlet    = .TRUE.
            lobatto     = .FALSE.
         ELSE IF (iparam(21) .EQ. 3) THEN   !  Settings for VCD integrator
            runge_kutta = .FALSE.
            verlet      = .TRUE.
            v_verlet    = .FALSE.
            verl_cd     = .TRUE.
            lobatto     = .FALSE.
         END IF
      ELSE               
C     Set flags for Lobatto integrator (regular or MTSL)
         runge_kutta = .FALSE.
         verlet      = .TRUE.
         v_verlet    = .FALSE.
         verl_cd     = .FALSE.
         lobatto     = .TRUE.
      END IF
C
C     Set integrator parameters
C
      IF (verlet) THEN
         itmax = iparam(26)
         erat_vv = rparam(4)
      END IF
C
C     Set forcefield options
C
      IF (iparam(8) .EQ. 0) THEN
         idovfma = .FALSE.
      ELSE IF (iparam(8) .EQ. 1) THEN
         idovfma = .TRUE.
         CALL CLEARERR()
         WRITE(ERRMSG,2020) 'VFMA option currently disabled.'
         CALL ERRHDL(-5,'<MBDYNA>')
      END IF
c
      IF (iparam(18) .EQ. 0) THEN
         internal_atom = .FALSE.
      ELSE IF (iparam(18) .EQ. 1) THEN
         internal_atom = .TRUE.
      END IF
c
c     Test for inconsistent forcefield options
c
      IF (idovfma .AND. internal_atom) THEN
         CALL CLEARERR()
         WRITE(MBOUT,200)
     +   ' HBMA and atomistic body-internal interactions cannot',
     +   ' be selected simultaneously'
         WRITE(ERRMSG,2020) 'Error in subroutine.'
         CALL ERRHDL(-5,'<MBDYNA>')
      END IF
 200  FORMAT(A,/,A)
c
      noutCH = iparam(9)
      noutvc = iparam(10)
      mbplvl = iparam(11)
      ndofmb = iparam(12)
      ndofbb = iparam(13)
      IF (nvlfrq .EQ. 0) nvlfrq = nstlim + 1
      IF (nenfrq .EQ. 0 .OR. mbplvl .LT. 0) nenfrq = nstlim + 1
      IF (nsmfrq .EQ. 0 .OR. mbplvl .LT. 9) nsmfrq = nstlim + 1
      IF (nbdfrq .EQ. 0 .OR. mbplvl .LT. 1) nbdfrq = nstlim + 1
c
c     Note which particles are fixed
      DO i = 1, nb
         PrtFix(i) = FixedPrt(i)
         PrtCvel(i)= CvelPrt(i)
c         print*,'mbdyna PrtCvel',PrtCvel(i)
      ENDDO
C
C     Set Threshold for Euler sequence switching
      Euler_threshold = rparm(23)

c
      startt = tx
      dtx    = deltat * 4.88882129D-02
      endt   = tx + nstlim*dtx
      noprnt = nenfrq
      ndelta = 0
      nlong  = 4   !  Pass this through CHARMM input, eventually
C
C     M30 is Start of Atom Positions
C
      M30 = 1
      ipoint = 0
      do 10 i = 1, nb
        do 15 j = pointr(i),pointr(i+1)-1
        ipoint = ipoint + 1
        x(ipoint) = xx(list(j))
        ipoint = ipoint + 1
        x(ipoint) = yy(list(j))
        ipoint = ipoint + 1
        x(ipoint) = zz(list(j))
   15 CONTINUE
   10 CONTINUE
C
C     M20 is Start of inverse masses
C
      M20 = IPOINT + 1
      DO 20 I = 1, nb
        DO 25 J = POINTR(I),POINTR(I+1)-1
        IPOINT = IPOINT + 1
        X(IPOINT) = 1.0/AMASS(LIST(J))
   25 CONTINUE
   20 CONTINUE
C
C     M40 is Start of velocities
C


      M40 = IPOINT + 1
      DO 30 I = 1, nb
c           print*,'mbdyna m40 nb ',i 
        DO 35 J = POINTR(I),POINTR(I+1)-1
        IPOINT = IPOINT + 1
        X(IPOINT) = XV(LIST(J))
c        print*,'mbdyna m40 velx ',X(IPOINT)
        IPOINT = IPOINT + 1
        X(IPOINT) = YV(LIST(J))
c        print*,'mbdyna m40 vely ',X(IPOINT)
        IPOINT = IPOINT + 1
        X(IPOINT) = ZV(LIST(J))
c        print*,'mbdyna m40 velz ',X(IPOINT)
   35 CONTINUE
c        print*,'exiting m40a'
   30 CONTINUE
c        print*,'exiting m40b'
C
C     M35 is Start of Gradient
C
      M35 = IPOINT + 1
      DO 40 I = 1, nb
        DO 45 J = POINTR(I),POINTR(I+1)-1
        IPOINT = IPOINT + 1
        X(IPOINT) = DX(LIST(J))
        IPOINT = IPOINT + 1
        X(IPOINT) = DY(LIST(J))
        IPOINT = IPOINT + 1
        X(IPOINT) = DZ(LIST(J))
   45 CONTINUE
   40 CONTINUE
C
C     M15 is Start of charges
C
      M15 = IPOINT + 1
      DO 50 I = 1, nb
        DO 55 J = POINTR(I),POINTR(I+1)-1
        IPOINT = IPOINT + 1
        X(IPOINT) = CG(LIST(J))
   55 CONTINUE
   50 CONTINUE
C
C******************* SET UP POINTERS FOR BEST-FIT INITIALIZATION IN CMPIC2
c                    DATA ALSO USED IN CMPIC3 AND VELRMS
      k0(1)=0
      do i = 1, nb-1
         if (iatoms(3,i) .eq. 1) then
            k0(i+1) = k0(i) + 3
         else
            k0(i+1) = k0(i) + 6 + IRGFLX(i)
         end if
      end do
      if (iatoms(3,nb) .eq. 1) then
         koff = k0(nb) + 3
      else
         koff = k0(nb) + 6 + IRGFLX(nb)
      end if
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cblink  This section should go into the flex initialization
c
c     Copy nominal coordinates into appropriate COMMON block locations
c     We assume that nominal coordinates are given in a global frame
c
c     Check to see if all bodies are flexible or if all bodies are rigid
c
cblink  Warning!! The logic has not been set up yet for mixed rigid and flex
c     models.  We are assuming here that 'ds' for all bodies is in the same
c     frame, and are consistent with the molecular conformation.
c
c      if (irgflx(1) .eq. 0) then
c         iflg2 = 0
c      else
c         iflg2 = 1
c      end if
cc
c      do ifb = 2, nb
c         if ((iflg2.eq.0 .and. irgflx(ifb).gt.0) .or.
c     *        (iflg2.eq.1 .and. irgflx(ifb).eq.0)) THEN
c            WRITE(MBOUT,*) ' Error in interface1 - coords copy'
c            STOP
c         END IF
c      end do
cc
c      if (iflg2 .eq. 1) then
c         do j = 1, natom
c            do i = 1, 3
c               ds(i,2*j) = coordn(i,j)
c            end do
c         end do
c      else
c         lx = M30
c         do i = 1, NATOM
c            do j = 1, 3
c               ds(j,2*i) = X(lx)
c               lx = lx + 1
c            end do
c         end do
c      end if
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c******************* Process molecular modal data and find best rigid body fit
c                      to physical coordinates
c
c     Copy 'ds' from lr2 to lr1 for flexible bodies
c
      DO n = 1, nb
         IF (irgflx(n) .GT. 0) THEN
            DO j = iatoms(1,n), iatoms(2,n)
               lr2 = 2*j
               lr1 = lr2 - 1
               DO i = 1, 3
                  ds(i,lr2) = ds(i,lr1)
               END DO
            END DO
         ELSE
            ipoint = M30 + 3*iatoms(1,n) - 3
            DO j = iatoms(1,n), iatoms(2,n)
               lr2 = 2*j
               DO i = 1, 3
                  ds(i,lr2) = x(ipoint)
                  ipoint = ipoint + 1
               END DO
            END DO
         END IF
      END DO
c
      CALL zero(cgadj,3,nb,3)
      CALL cmpic1
                                                            NERROR = 10
      DO 620 J=1,NB
      IF (IRGFLX(J).LT.0 .OR. IRGFLX(J).GT.NMDBOD) GO TO 999
  620 CONTINUE
                                                            NERROR = 11
      DO 625 J=1,NSPT
      IF (IFTSMW(J).LT.1 .OR. IFTSMW(J).GT.NB) GO TO 999
  625 CONTINUE
                                                            NERROR = 12
      DO 630 J=1,NH
      IF (IHDATA(1,J).LT.0 .OR. IHDATA(1,J).GT.12) GO TO 999
      DO 630 I=2,7
      IF (IHDATA(I,J).LT.0 .OR. IHDATA(I,J).GT.2) GO TO 999
      IF (IHDATA(I,J).EQ.2) THEN
         WRITE(mbout,2116)
         GO TO 999
      ENDIF
  630 CONTINUE
C
C     NHPOI(N) = NUMBER OF HINGES ON BODY N
C     NSPOI(N) = NUMBER OF SENSORS ON BODY N
C
      do N = 1, NB
         NHPOI(N) = 0
         NSPOI(N) = 0
         do I = 1, 2
            do J = 2, NH
               IF (ITOPOL(I,J) .EQ. N) NHPOI(N) = NHPOI(N) + 1
            end do
         end do
         do J = 1, NSPT
            IF (IFTSMW(J) .EQ. N) NSPOI(N) = NSPOI(N) + 1
         end do
      end do
C
C     INITIALIZE THE ITOPW ARRAY, BETA AND BETA DOT POINTERS, LOCU, LENU,
C     NEQ, NU, NBETA, AND NLAM.
c
      call rotdh1_CHARMM(intLoopHeap(iihpvtptr),intLoopHeap(
     &                   iitopolptr),intLoopheap(iihdataptr),
     &                   intLocalHeap(iiopptr_rotdh1_CHARMM))
      IF (neq .GT. cL07) THEN
         CALL CLEARERR()
         WRITE(MBOUT,2099) ' Number of Y vector elements (', neq, 
     &        ') is larger than ',
     &        'dimensioned storage of ', cL07
         WRITE(ERRMSG,2020) 'Error in subroutine.'
         CALL ERRHDL(-5,'<MBDYNA>')
      END IF
 2099 FORMAT (A,I7,A,/,A,I7)
C
C     If LANGEVIN allocate memory for Langevin arrays.
      LANGEVIN = (iParam(33) .EQ. 1)
      if (LANGEVIN) then
         ilangevinptr = 1
         irfptr = ilangevinptr + NU
         igamlngptr = irfptr + NU
         lastindx = 3*NU
#ifdef POINTER_KEYWORD
         CALL mbalcPTR(mbdynaptr,dbpresz*lastindx)
         if ( mbdynaptr .LE. 0 ) then
             CALL CLEARERR()
             WRITE(ERRMSG,201)
     *       'Do not have enough memory to allocate
     *        mbdynaHeap'
              CALL ERRHDL(-5,'<MBDYNA>')
         end if
 201     FORMAT(1X,A)
#else
C        Check if enough memory is statically allocated
         IF ( lastindx .GT. MAX_mbdynaHeap ) THEN
        WRITE(MBOUT,*)
     *          'NOT ENOUGH MEMORY ALLOCATED FOR mbdynaHeap
     *  in source/moldyn/PARAM.FOR'
            CALL CLEARERR()
            WRITE(ERRMSG,211)
     *           'Increase MAX_mbdynaHeap to > ', lastindx,
     *           ' in PARAM.FOR'
            CALL ERRHDL(-5,'<MBDYNA>')
         ENDIF
 211     FORMAT(1X,A,I9,A)
#endif

C        Set LANGEVIN options
         iSeed = iParam(34)
         tBath = rParam(21)
         kBoltz = rParam(22)
         iPoint = 1
         do i = 1, nb
            do j = 1, lenu(i)
               mbdynaHeap(igamlngptr+iPoint-1) = LCoeff(iPoint)
               iPoint = iPoint + 1
            end do
         end do
      end if
C
C******************* INITIALIZE ALL DISCOS OPTION FLAGS
      IPDATA(96) =  1
      IPDATA(97) = -1
      IPDATA(98) = -1
c
c     Initialize all adaptive integrator parameters
c
      cntdta(1) = rparam(3)
      cntdta(2) = rparam(4)
C
   75 if (mbplvl .ge. 9) then
         CALL  PAGEHD
         WRITE (MBOUT,2001) NB,NBMAX,STARTT,NOPRNT,NH,NHMAX,
     *  DELTAT,NOPLOT,NSPT,NSPMAX,ENDT,
     *  NDELTA,NU,NMDBOD,NBETA,
     *  NLAM,KY,NEQ,KU
         WRITE (MBOUT,2017)
         CALL WRITIS (IPDATA,1,L22,1)
         WRITE (MBOUT,2002)
         CALL WRITIS (ITOPOL,2,NH,2)
         IF(NCUT.GT.0) THEN
            WRITE (MBOUT,2021)
            CALL WRITIS (IHCUTJ,1,NCUT,1)
         ENDIF
         WRITE (MBOUT,2003)
         CALL WRITIS (IHDATA,7,NH,7)
         WRITE (MBOUT,2004)
         CALL WRITES (BETAH,6,NH,6)
         WRITE (MBOUT,2005)
         CALL WRITES (BETAHD,6,NH,6)
         CALL PAGEHD
         WRITE (MBOUT,2006)
         CALL WRITIS (IRGFLX,1,NB,1)
         WRITE (MBOUT,2007)
         CALL WRITIS (NHPOI,1,NB,1)
         WRITE (MBOUT,2008)
         CALL WRITIS (NSPOI,1,NB,1)
         WRITE (MBOUT,2010)
         n = 2*nb + 3
         CALL WRITIS (LENU,1,n,1)
         WRITE (MBOUT,2011)
         CALL WRITIS (LOCU,1,n,1)
         WRITE (MBOUT,2012)
         CALL WRITIS (IFTSMW,1,NSPT,1)
      endif
c
c******************* GET BODY DATA FOR EACH OF THE NB BODIES
c
C     LOAD UNDEFORMED INERTIA MATRIX INTO THE AM ARRAY.
C     HEREAFTER AMU ARRAY WILL CONTAIN THE DEFORMED INERTIA MATRICES
c
      call asnmem    ! Set up pointers to MB_HEAP
c
c     assign mass directly to am (on heap_mb) through msmodf/msmodf
cblink all of am is now stored, not just upper triangle, fix this

      DO n = 1, nb
         le   = lenu(n)   ! NM+6 or 3
         IF (irgflx(n) .EQ. 0) THEN
            if (n .LE. nbdy) then        ! rigid body
               CALL msmodr(n,HEAP_MB(iam_ptr(n)),le,
     &                  intLoopHeap(iiaconnptr),
     &                  intLoopHeap(iibconnptr),
     &                  intLoopHeap(iiconnhptr),
     &                  intLoopHeap(iihpvtptr),
     &                  intLoopHeap(iitopolptr),
     &                  Loopheap(idhptr))
            else                         ! particle
               CALL msmodr(n,HEAP_MB(iam_ptr(n)),1,
     &                  intLoopHeap(iiaconnptr),
     &                  intLoopHeap(iibconnptr),
     &                  intLoopHeap(iiconnhptr),
     &                  intLoopHeap(iihpvtptr),
     &                  intLoopHeap(iitopolptr),
     &                  Loopheap(idhptr))
            endif
         ELSE                            ! flex body
c            CALL msmodf(n,HEAP_MB(iam_ptr(n)),le)
            CALL msmodf(LocalHeap(Aptr),LocalHeap(Bptr),
     &		        LocalHeap(Cptr),LocalHeap(WSptr),
     &			LocalHeap(UVECptr), 
     &			n,HEAP_MB(iam_ptr(n)),le,
     &                  HEAP_MB(ifreqptr),HEAP_MB(iyptr),
     &                  intLoopHeap(iiaconnptr),
     &                  intLoopHeap(iibconnptr),
     &                  intLoopHeap(iiconnhptr),
     &                  intLoopHeap(iihthptrptr),
     &                  intLoopHeap(iihpvtptr),
     &                  intLoopHeap(iitopolptr),
     &                  LoopHeap(idhptr))
         ENDIF
C        If using Langevin dynamics, set up the covarience matrix: AM_langevin
C        Currently using only the diagonal terms of the covarience matrix.
#ifdef CHARMM
         IF (LANGEVIN)
     &      CALL AMlngvn_init(n, HEAP_MB(iam_ptr(n)), le,
     &                           mbdynaHeap(ilangevinptr),
     &                           mbdynaHeap(igamlngptr))
#endif
      ENDDO
C
C Now close the units used (if any) by msmodf (and what it calls)

      INQUIRE(UNIT=NTAPE2,OPENED=QOPEN)
      if (QOPEN) CLOSE(NTAPE2,STATUS='DELETE')
      INQUIRE(UNIT=NTAPE3,OPENED=QOPEN)
      if (QOPEN) CLOSE(NTAPE3,STATUS='DELETE')

c
C******************* Adjust fragment I.C.'s and establish bond vectors
cblink  The following statement must be made more robust/general
cblink
      CALL zero(theta,3,nb,3)
c     If more than 2 bodies AND NOT all particles
      IF (.NOT.(nb .EQ. 2 .AND. nbdy.EQ.0))
     &     call cmpic2(HEAP_MB(iamdampptr),HEAP_MB(ipptr),
     &                 HEAP_MB(igvecptr),
     &                 LocalHeap(icmatptr_cmpic2),
     &                 LocalHeap(icmat2ptr_cmpic2),
     &                 LocalHeap(ifmatptr_cmpic2),
     &                 intLocalHeap(ikpvtmptr_cmpic2),
     &                 LocalHeap(igmxptr_cmpic2),
     &                 LocalHeap(ismptr_cmpic2),   
     &                 intLocalHeap(ikpvtalptr_cmpic2),
     &                 LocalHeap(ivsavptr_cmpic2),
     &                 intLoopHeap(iiaconnptr),
     &                 intLoopHeap(iibconnptr),
     &                 intLoopHeap(iihconnptr),
     &                 LoopHeap(irvecptr),
     &                 LocalHeap(irotcoorptr),
     &                 LocalHeap(imodevctrptr),
     &                 LocalHeap(ixmassptr),
     &                 intloopheap(iitopolptr),
     &                 intLocalHeap(iidblptr_cmpic2),
     &                 intLocalHeap(iicblptr_cmpic2))
C
C
C     CALL DYNS20 TO DERIVE AND INTEGRATE THE NON-LINEAR
C     COUPLED BODY EQUATIONS OF MOTION OR CALL THE ROUTINES
C     WHICH WILL NUMERICALLY LINEARIZE THE EQUATIONS.
c
c     Turn on debugging flags here
c
      CALL DYNS20
C
C     Restore the arrays for restart purposes
      DO i = 1, 40
         iparm(i) = iparam(i)
         rparm(i) = rparam(i)
      END DO
C
C Restore Atom Positions     
      do i = 1, nb
         j = 3*(i-1)+ M30
         xx(List(i)) = x(j)
         yy(List(i)) = x(j+1)
         zz(List(i)) = x(j+2)
      end do
C
C And then velocities
      do i = 1, nb
         j = 3*(i-1)+ M40
         xv(List(i)) = x(j)
         yv(List(i)) = x(j+1)
         zv(List(i)) = x(j+2)
      end do
      
C
C     STOP THE CPU TIMER AND REPORT COMPUTATION TIME
C
      CALL msecond(tim2)
c
      if (mbplvl .ge. 1) then
         WRITE(MBOUT,*) ' '
         WRITE(MBOUT,*) ' *****************************************'
         WRITE(MBOUT,*) ' '
         WRITE(MBOUT,*) ' Total MBO(N)D setup =', timer(imbond0)
         IF (idovfma) WRITE(MBOUT,*)
     *        '                                 ',
     *        'VFMA setup time    =', timer(ivf0)
c     
         WRITE(MBOUT,*) ' Integration time    =', timer(irk4)
         WRITE(MBOUT,*) '                                 ',
     *        'Number of RK steps =', nrk4
         WRITE(MBOUT,*) '                                 ',
     *        'CPU per time step  =', timer(irk4) / nrk4
         WRITE(MBOUT,*) '                                 ',
     *        'Avg sim time/step  =', (endt-startt) / nrk4
         IF (idovfma) WRITE(MBOUT,*)
     *        '                                 ',
     *        'Recurring vfma time=', timer(ivfma)
         WRITE(MBOUT,*) '                                 ',
     *        'No. of force calls =', nfrc_call
         IF (idovfma) THEN
            WRITE(MBOUT,*) '                                 ',
     *           'VFMA time/call     =', timer(ivfma) / DBLE(nfrc_call)
            WRITE(MBOUT,*) '                                 ',
     *           'Non-VFMA force     =', timer(inon_vfma)
            WRITE(MBOUT,*) '                                 ',
     *           'Non-VFMA time/call =', timer(inon_vfma) /
     *           DBLE(nfrc_call)
         ELSE
            WRITE(MBOUT,*) '                                 ',
     *           'Force evaluation   =', timer(inon_vfma)
            WRITE(MBOUT,*) '                                 ',
     *           'Frc eval time/call =', timer(inon_vfma) /
     *           DBLE(nfrc_call)
         END IF
         WRITE(MBOUT,*) ' Output time % steps =', timer(ioutput)
         IF (idovfma) THEN
            WRITE(MBOUT,*) ' Minus non-VFMA time =', -timer(inon_vfma)
         ELSE
            WRITE(MBOUT,*) ' Minus Frc eval time =', -timer(inon_vfma)
         END IF
c     
         WRITE(MBOUT,*) ' -----------------------------------------'
         WRITE(MBOUT,*) ' Total MBO(N)D time  =',
     *        tim2 - tim1 - timer(inon_vfma)
         WRITE(MBOUT,*) ' '
         WRITE(MBOUT,*) ' '
         IF (idovfma) THEN
            WRITE(MBOUT,*) ' BREAKDOWN OF VFMA TIME: '
            WRITE(MBOUT,*) ' ggv init and accum  =', timer(iggv)
            WRITE(MBOUT,*) ' System geometry time=', timer(icenter)
            WRITE(MBOUT,*) ' Separations & sizes =', timer(ilocate)
            WRITE(MBOUT,*) ' Optimize tree (grab)=', timer(igrab)
            WRITE(MBOUT,*) ' Build up MEs        =', timer(ibuild)
            WRITE(MBOUT,*) ' Monkey algorithm    =', timer(imonkey)
            WRITE(MBOUT,*) ' Sweep down the tree =', timer(iclean)
            WRITE(MBOUT,*) ' '
            WRITE(MBOUT,*) ' '
            WRITE(MBOUT,*) ' BREAKDOWN OF MONKEY TIME:'
            WRITE(MBOUT,*) ' Total lemer time    =', timer(ilemer)
            WRITE(MBOUT,*) ' ME-based fbmi time  =',
     $           timer(ifbmi) - timer(ifbatom)
            WRITE(MBOUT,*) ' Atomistic fbmi time =', timer(ifbatom)
            WRITE(MBOUT,*) ' Tree traversal time =',
     *           timer(imonkey) - timer(ilemer) - timer(ifbmi)
            WRITE(MBOUT,*) ' '
            WRITE(MBOUT,*) ' '
         END IF
         write(MBOUT,2520) 'MBDYN>', 'Changes in Hinges'
         write(MBOUT,2521) 'MBDYN>', 'Hinge No.', 'Changes'
         do j = 1, cL02
            if (ichpvt(j) .gt. 0) then
               write(MBOUT,2522) 'MBDYN>', j, ichpvt(j)
            end if
         end do
         write(MBOUT,*) ' '
      endif
C
      RETURN
 2001 FORMAT (//15X,'SUMMARY OF DYNAMIC-SIMULATION-PROGRAM INPUT DATA',
     *  10(' *')//3X,'ACTUAL SIZES',5X,'MAXIMUM SIZES',4X,'INTEGRATION',
     *  ' DATA',50X,'MISC. DATA'
     *  /3X,13('-'),4X,13('-'),4X,18('-'),48X,11('-')
     *  /3X,'NB     = ',I4,4X,'NBMAX  = ',I4,4X,'STARTT = ',1P,D10.3,
     *  47X,'NOPRNT = ',I5
     *  /3X,'NH     = ',I4,4X,'NHMAX  = ',I4,4X,'DELTAT = ',1P,D10.3,
     *  47X,'NOPLOT = ',I5
     *  /3X,'NSPT   = ',I4,4X,'NSPMAX = ',I4,4X,'ENDT   = ',1P,D10.3,
     *  /3X,'NDELTA = ',I4,
     *  /3X,'NU     = ',I4,4X,'NMDBOD = ',I4,
     *  /3X,'NBETA  = ',I4,4X,
     *  /3X,'NLAM   = ',I4,4X,'KY     = ',I4,
     *  /3X,'NEQ    = ',I4,4X,'KU     = ',I4)
 2002 FORMAT (//1X,'THE TOPOLOGY ARRAY (ITOPOL) FOR THIS CASE FOLLOWS')
 2003 FORMAT (//1X,'THE CONSTRAINT SPECIFICATIONS FOR THIS CASE FOLLOW')
 2004 FORMAT (//1X,'THE SPECIFIED INITIAL HINGE ANGLES AND ',
     *    'DISPLACEMENTS (BETAH) FOLLOW')
 2005 FORMAT (//1X,'THE SPECIFIED INITIAL HINGE RATES (BETAHD) FOLLOW')
 2006 FORMAT (//1X,'THE NO. OF ELASTIC MODES/BODY ARRAY (IRGFLX) ',
     * 'FOLLOWS')
 2007 FORMAT (//1X,'THE NO. OF P/Q HINGE POINTS/BODY ARRAY (NHPOI) ',
     * 'FOLLOWS')
 2008 FORMAT (//1X,'THE NO. OF SENSOR POINTS/BODY ARRAY (NSPOI) ',
     * 'FOLLOWS')
 2010 FORMAT (//1X,'THE STATE VECTOR LENGTH ARRAY (LENU) FOLLOWS')
 2011 FORMAT (//1X,'THE STATE VECTOR LOCATION ARRAY (LOCU) FOLLOWS')
 2012 FORMAT (//1X,'THE SPECIFIED SENSOR POINT/BODY CORRELATION ',
     * 'ARRAY (IFTSMW) FOLLOWS')
 2017 FORMAT (//' THE OPTION CONTROL DATA ARRAY (IPDATA) FOR THIS ',
     * ' CASE FOLLOWS')
 2020 FORMAT(1X,A)
 2021 FORMAT (//,' LIST OF CUT JOINTS FOR TOPOLOGICAL LOOPS')
 2050 format(//a,i3,a,i3,a,i3//)
 2110 FORMAT (1X,'1INPUT DATA ERROR, NERROR = ',I3)
 2113 FORMAT (//' DYNS10, IPDATA OPTION NUMBER ',I3,' NOT '
     *           ,'YET IMPLEMENTED IN ORDER N DISCOS')
 2115 FORMAT (//' DYNS10, WHEELS WITH RHEONOMIC CONTRAINT CAPABILITY'
     *           ,' NOT YET IMPLEMENTED IN ORDER N DISCOS')
 2116 FORMAT (//' DYNS10, HINGE POINT RHEONOMIC CONTRAINT CAPABILITY'
     *           ,' NOT YET IMPLEMENTED IN ORDER N DISCOS')
 2510 FORMAT(1X,A/A)
 2520 format(a6,a20)
 2521 format(a6,a12,a10)
 2522 format(a6,i8,i11)
c
 999  CALL CLEARERR()
      WRITE (ERRMSG,2110) NERROR
      CALL ERRHDL(-5,'<MBDYNA>')
C
      END



        SUBROUTINE AMlngvn_init(iBod, AM_tmp, nVrbls,
     &                          AM_langevin,gamLng)

C       Saves the square root of the diagonal elements of the
C       covarience matrix in AM_langevin.  It is assumed that
C       the bath temperature will remain constant during the run.
C       AM_tmp is the section of HEAP_MB that contains the AM
C       matrix (inertia matrix)
C       kBoltz is the Boltzman constant.
C       tBath is the bath temperature.
C       gamLng is the diagonal elements of the diffusion matrix.
C       nVrbls is the number of variables {= LENU(nBody) for body nBody}
C 
        IMPLICIT NONE     

#include "PARAM.FOR"

#include "CHARMM.INC"
#include "SPECIF.INC"

        INTEGER iBod, nVrbls, iPtr, I
        REAL*8 AM_tmp(nVrbls,nVrbls), twoKbT
        DOUBLE PRECISION AM_langevin(cL10),gamLng(cL10)

        iPtr = LOCU(iBod)
        twoKbT = 2.D+0 * kBoltz * tBath

        IF (iBod .LE. nbdy) THEN              ! body
           DO I = 1, nVrbls
              AM_langevin(iPtr) = DSQRT(AM_tmp(I,I)
     &          * gamLng(iPtr) * twoKbT / rparam(1))
              iPtr = iPtr + 1
           ENDDO
        ELSE                                  ! particle
           DO I = 1, nVrbls
              AM_langevin(iPtr) = DSQRT(AM_tmp(1,1)
     &          * gamLng(iPtr) * twoKbT / rparam(1))
              iPtr = iPtr + 1
           ENDDO
        ENDIF

        RETURN
        END



