C $Header: /export/cvs/c34a1/source/moldyn/memory.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C ========================================================================
C
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER 
C STATE AND FEDERAL LAWS.  USE, DISCLOSURE, REPRODUCTION OR DUPLICATION 
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS 
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT 
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C
C     Collection of HEAP_MB related subroutines including:
C     asnmem,chkmem,newptr
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      SUBROUTINE asnmem
C
C     PURPOSE:
C     Allocate memory on HEAP_MB and assign indexes for arrays that
C     will be stored.
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      IMPLICIT NONE
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: memory.f,v $$Revision: 1.1.1.1 $'/
c
#include "PARAM.FOR"
c
#include "AMUBW.INC"
#include "CHARMM.INC"
#include "CSTIFF.INC"
#include "ERRHDL.INC"
#include "HANDS2.INC"
#include "HEAPMB.INC"
#include "INTGRL.INC"
#include "IFIRST.INC"
#include "F1BKF2.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
#include "GGSAVE.INC"
#include "GCOMP.INC"
#include "MOMENG.INC"
#include "VECTOR.INC"
#include "CLOOP.INC"
#include "NOUTPT.INC"
c
c     External Variables
C subroutines mbfrePTR and mbalcPTR are declared in source/mbond/memory.f
#ifdef POINTER_KEYWORD
      EXTERNAL mbfrePTR
      EXTERNAL mbalcPTR
#endif
c
      integer nextindex
      integer lastelement
c
c     Local Variables
      integer n,len1,len2,le,li
      integer nprt
      integer isza,iszc
      integer isum1,isum2,isum3,isum4,isum6,isum7
      integer idim        ! dimension and
#ifdef POINTER_KEYWORD
      integer nbytes      ! number of bytes of HEAP_MB.
#endif
      integer i1HPMB      ! logical variable to test whether it is the first time
                          ! to allocate space for HEAP_MB.
c
c     Equivalences
      EQUIVALENCE (i1HPMB,i1pass(9))  
c
c     keep track of:
c
c     1)  sum of lenu(nb+n)    (sum of modes, for acof & bcof)
c     2)  sum of lenu(nb+n)^2  (sum of nm^2, for other cofs)
c
c     3)  sum of lenu(n)^2     (sum of nm+6/3 for particles)
c     4)  sum of lenu(n)^2 for bodies + 1 for each particle (am)
c     5)  total size of hats (3*NM(body) section for each atom in
c             each body
c     6)  sum of atoms in bodies
c     7)  sum of lenu(n)
c
      isum1 = 0.0d0
      isum2 = 0.0d0
      isum3 = 0.0d0
      isum4 = 0.0d0
      isum6 = 0.0d0
      isum7 = 0.0d0
      idim  = 0.0d0
c
c     get the sizes
c
      do n = 1,nbdy
         len1 = lenu(nb+n)
         len2 = lenu(n)
         isum1 = isum1+len1
         isum2 = isum2+len1*len1
         isum7 = isum7+len2
         isum3 = isum3+len2*len2
         isum6 = isum6+iatoms(3,n)
      end do
c
      nprt = nb - nbdy
      isum4 = isum3 + nprt
      isum3 = isum3 + 9*nprt
c
c     get heap_mb index to the first element of each array index
      iam_ptr(1) = 1
      iamuptr(1) = iam_ptr(1) + isum4
      irm_ptr(1) = iamuptr(1) + isum3
      idim = idim + isum4 + 2*isum3
c
c     get cofs if there are modes
      if (isum1 .GT. 0) then
         iacfptr(1) = irm_ptr(1) + isum3
         ibcfptr(1) = iacfptr(1) + isum1*9
         ic11ptr(1) = ibcfptr(1) + isum1*6
         ic22ptr(1) = ic11ptr(1) + isum2
         ic33ptr(1) = ic22ptr(1) + isum2
         ic12ptr(1) = ic33ptr(1) + isum2
         ic13ptr(1) = ic12ptr(1) + isum2
         ic23ptr(1) = ic13ptr(1) + isum2
         icxyptr(1) = ic23ptr(1) + isum2
         icxzptr(1) = icxyptr(1) + isum2
         icyzptr(1) = icxzptr(1) + isum2
         idim = idim + isum1*15 + isum2*9
      end if
      
      if ( MAXFLEXMOD .NE. 0 ) THEN
         ifreqptr = idim + 1 
         iamdampptr = ifreqptr + (cL06 * L01)
         ipsiptr = iamdampptr + (cL06 * L01)
         iggsptr = ipsiptr + (6 * cL06 * MAXBOD)
         iyptr = iggsptr + (cL06 * 9 * MAXBOD)
      else 
         iyptr = idim + 1
      end if
      iydtptr = iyptr + (cL07)
      igposptr = iydtptr + (cl07)
      igpos_stageptr = igposptr + cL10
      ipptr = igpos_stageptr + cL10 
      ipmomptr = ipptr + cL10
c 
      if ( MAXLOOP .NE. 0 ) then
         ibtildeptr = ipmomptr + cL10
         ibicdstptr = ibtildeptr + cL11*6*L01*cL63
         isuptr = ibicdstptr + cL11*6*L01*cL63*cL63
         isbtptr = isuptr + L01*cL11
         ibrnptr = isbtptr + cL11*6*L01*cL63
         igvecptr = ibrnptr + cL11*6*MAXBOD
      else
         isuptr = ipmomptr + cL10
         ibrnptr = isuptr + L01*cL11
         igvecptr = ibrnptr + cL11*6*MAXBOD
      end if

c     integer heap_mb
      ikmbpvtptr = 1

#ifdef ANALYZE_FORCE
      ig_chmptr = igvecptr + cL72
      ig_gyroptr = ig_chmptr + cL10
      ig_deformptr = ig_gyroptr + 6 * MAXBOD
c  next index to be used 
      nextindex = ig_deformptr + 6 * MAXBOD 
#else
c  next index to be used 
      nextindex = igvecptr + cL72
#endif
c  Last index in HEAPMB
      lastelement = nextindex - 1
      idim = lastelement
c

      IF (i1HPMB .EQ. 1) THEN
#ifdef POINTER_KEYWORD
         CALL mbfrePTR(ihpmbptr)
         CALL mbfrePTR(hpmbptr)
#endif
         i1HPMB = 0
      ENDIF
C     If compiling on SGI allocate memory for Heaps
      IF (idim .GT. 0) THEN
#ifdef POINTER_KEYWORD
        nbytes = DBPRESZ * lastelement
        CALL mbalcPTR(hpmbptr, nbytes)
        CALL mbalcPTR(ihpmbptr, cL08 * L01 * INTGRSZ)
        IF (hpmbptr .LT. 1 .OR. ihpmbptr .LT. 1) THEN
          CALL CLEARERR()
          WRITE(ERRMSG,200) 
     +     'Do not have enough memory to allocate HEAP_MB.'
          CALL ERRHDL(-5,'<ASNMEM>')
 200  FORMAT(1X,A)
        END IF   
#endif
        i1HPMB = 1
      ENDIF
#ifndef POINTER_KEYWORD
      IF(lastelement .GT. MAX_HEAP_MB) THEN
        WRITE(MBOUT,*)
     *     ' NOT ENOUGH MEMORY ALLOCATED FOR HEAP_MB
     *  in source/moldyn/PARAM.FOR'
         CALL CLEARERR()
         WRITE(ERRMSG,201)
     *      'Increase MAX_HEAP_MB to > ', lastelement,
     *      ' in PARAM.FOR'
         CALL ERRHDL(-5,'<ASNMEM>')
      ENDIF

      lastelement = cL08 * L01
      IF(lastelement .GT. MAX_intHEAP_MB) THEN
        WRITE(MBOUT,*)
     *    ' NOT ENOUGH MEMORY ALLOCATED FOR intHEAP_MB
     *  in source/moldyn/PARAM.FOR'
         CALL CLEARERR()
         WRITE(ERRMSG,201)
     *      'Increase MAX_intHEAP_MB to > ', lastelement,
     *      ' in PARAM.FOR'
         CALL ERRHDL(-5,'<ASNMEM>')
      ENDIF
 201  FORMAT(1X,A,I9,A)
#endif
c
c     assign the rest of the indexes
      DO n = 1,nb
         le   = lenu(n)
         isza = le*le
         li   = lenu(nb+n)
         iszc = li*li
         iamuptr(n+1) = iamuptr(n) + isza
         irm_ptr(n+1) = irm_ptr(n) + isza
         iam_ptr(n+1) = iam_ptr(n) + isza
         if (n .LE. nbdy) then
            if (isum1 .GT. 0) then ! body w/ modes
               iacfptr(n+1) = iacfptr(n) + 9*li
               ibcfptr(n+1) = ibcfptr(n) + 6*li
               ic11ptr(n+1) = ic11ptr(n) + iszc
               ic22ptr(n+1) = ic22ptr(n) + iszc
               ic33ptr(n+1) = ic33ptr(n) + iszc
               ic12ptr(n+1) = ic12ptr(n) + iszc
               ic13ptr(n+1) = ic13ptr(n) + iszc
               ic23ptr(n+1) = ic23ptr(n) + iszc
               icxyptr(n+1) = icxyptr(n) + iszc
               icxzptr(n+1) = icxzptr(n) + iszc
               icyzptr(n+1) = icyzptr(n) + iszc
            end if
         else                   ! particle
            iam_ptr(n+1) = iam_ptr(n) + 1
         endif
      END DO

      call chkmem(isum1,isum6)

      if (mbplvl.GE.2) then   
         WRITE(MBOUT,1000) 
         WRITE(MBOUT,1001) idim
         WRITE(MBOUT,1003)
 1000    format('HEAPMB>      ******** HEAP_MB Report********')
 1001    format('HEAPMB>   Last stored element in HEAP_MB is',
     &              i10)
 1003    format('HEAPMB>      *******************************')
      end if

      return
      end
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      SUBROUTINE chkmem(modesum,natmbod)
C
C     PURPOSE:
C     Check that indexes to HEAP_MB do not overlap
C     (ibh_ptr is done in bhgenr)
C
C     the last index of each section should be less than or equal 
C     to the first element of the next section on HEAP_MB
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      IMPLICIT NONE
C
c
#include "PARAM.FOR"
#include "AMUBW.INC"
#include "ERRHDL.INC"
#include "HANDS2.INC"
#include "HEAPMB.INC"
#include "INTGRL.INC"
#include "F1BKF2.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
c
c     Passed Variables
c
      INTEGER modesum,natmbod
c
c     Local Variables
c
      INTEGER iend,ibde,itmp
      
      iend = nb + 1
      ibde = nbdy + 1
      itmp = 1
      if (itmp .GT. iam_ptr(1)) goto 999
      if (iam_ptr(iend) .GT. iamuptr(1)) goto 999
      if (iamuptr(iend) .GT. irm_ptr(1)) goto 999
c
      if (modesum .GT. 0) then
         if (iacfptr(ibde) .GT. ibcfptr(1)) goto 999
         if (ibcfptr(ibde) .GT. ic11ptr(1)) goto 999
         if (ic11ptr(ibde) .GT. ic22ptr(1)) goto 999
         if (ic22ptr(ibde) .GT. ic33ptr(1)) goto 999
         if (ic33ptr(ibde) .GT. ic12ptr(1)) goto 999
         if (ic12ptr(ibde) .GT. ic13ptr(1)) goto 999
         if (ic13ptr(ibde) .GT. ic23ptr(1)) goto 999
         if (ic23ptr(ibde) .GT. icxyptr(1)) goto 999
         if (icxyptr(ibde) .GT. icxzptr(1)) goto 999
         if (icxzptr(ibde) .GT. icyzptr(1)) goto 999
      end if
c
      return
 999  CALL CLEARERR()
      WRITE(ERRMSG,200)
     +  '>  Corrupt HEAP_MB index!!!'
      CALL ERRHDL (-5,'<CHKMEM>')
 200  FORMAT(1X,A) 
      end

C compile this part only for compilers which do support POINTER
C construct

#ifdef POINTER_KEYWORD
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      SUBROUTINE mbfrePTR(ptr) 
C  
C     PURPOSE: 
C     Free allocated memory assiocates with PTR.
C     
C     PTR         a pointer that is declared in HEAPMB.INC
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      IMPLICIT NONE

C Passed variables
      POINTER (ptr, dummy)
      DOUBLE PRECISION dummy(*)

      CALL FREE(ptr)

      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      SUBROUTINE mbalcPTR(ptr, nbytes) 
C  
C     PURPOSE:
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      IMPLICIT NONE

#include "TAPENO.INC"

C Passed variables
      INTEGER nbytes
      POINTER (ptr, dummy)
      DOUBLE PRECISION dummy(*)

#ifdef IBMRS
      INTEGER FMALLOC
      EXTERNAL FMALLOC
      
      ptr=FMALLOC(nbytes)
#else
      ptr=MALLOC(nbytes)
#endif

      IF (ptr .LT. 1) THEN
        WRITE(MBOUT,*) 'MALLOC failed.'
      END IF

      RETURN
      END
#endif
