C $Header: /export/cvs/c34a1/source/moldyn/mgen.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C 
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
      SUBROUTINE MGEN
CSE
C                                                          DEBUG #  49
CPS      PURPOSE:
C
C        GENERATE DEFORMATION DEPENDENT MASS MATRIX CONTAINED IN
C        EQUATION II-86 VOL 1 VIA EQUATIONS II-87,88,89
C
CPE
C
      IMPLICIT NONE
 
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: mgen.f,v $$Revision: 1.1.1.1 $'/
C
#include "PARAM.FOR"
C
C
#include "AMUBW.INC"
#include "HEAPMB.INC"
#include "INTGRL.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
#include "GGSAVE.INC"
#include "VECTOR.INC"
C
C     Local Variables
C
      INTEGER LE,LM
      INTEGER N
      INTEGER iamu,i_am  !  Pointer for particle am/amu
      INTEGER ic11,ic22,ic33,ic12,ic13,ic23,icxy,icxz,icyz
      INTEGER iacf,ibcf
C
#include "LDEBUG.INC"
      LOGICAL LEQU
      EQUIVALENCE (LEQU,DEBUG(49))
      IF(LEQU) WRITE (MBOUT,1000)
 1000 FORMAT (' SUBROUTINE MGEN')
C
      DO 10 N=1,NB
         LE   = LENU(NB+N)
         LM   = LENU(N)
         i_am = iam_ptr(n)      ! Pointer to am
         iamu = iamuptr(n)      ! Pointer to amu
         iacf = iacfptr(n)      ! Pointer to acof
         ibcf = ibcfptr(n)      ! Pointer to bcof
         ic11 = ic11ptr(n)      ! Pointer to cof11
         ic22 = ic22ptr(n)      ! Pointer to cof22
         ic33 = ic33ptr(n)      ! Pointer to cof33
         ic12 = ic12ptr(n)      ! Pointer to cof12
         ic13 = ic13ptr(n)      ! Pointer to cof13
         ic23 = ic23ptr(n)      ! Pointer to cof23
         icxy = icxyptr(n)      ! Pointer to cofxy
         icxz = icxzptr(n)      ! Pointer to cofxz
         icyz = icyzptr(n)      ! Pointer to cofyz
c
c     call mgen_1 to pass heap_mb locations of am, amu, and
c     the cofs
c
         call mgen_1(HEAP_MB(iamu),HEAP_MB(i_am),HEAP_MB(iacf),
     &               HEAP_MB(ibcf),HEAP_MB(ic11),HEAP_MB(ic22),
     &               HEAP_MB(ic33),HEAP_MB(ic12),HEAP_MB(ic13),
     &               HEAP_MB(ic23),HEAP_MB(icxy),HEAP_MB(icxz),
     &               HEAP_MB(icyz),le,lm,n,HEAP_MB(iggsptr),
     &               HEAP_MB(iyptr),LocalHeap(irwptr_mgen),
     &               LocalHeap(icwptr_mgen))
C
   10 CONTINUE
C
      RETURN
      END
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C     Beginning of mgen_1
C 
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE MGEN_1(amu,am,acof,bcof,cof11,cof22,cof33,cof12,cof13,
     &                 cof23,cofxy,cofxz,cofyz,le,LEU,nbod,ggs,y,rw,
     &                 cw)
CSE
C                                                          DEBUG #  49
CPS      PURPOSE:
C
C        GENERATE DEFORMATION DEPENDENT MASS MATRIX CONTAINED IN
C        EQUATION II-86 VOL 1 VIA EQUATIONS II-87,88,89
C
CPE
C
      IMPLICIT NONE
C
#include "PARAM.FOR"
C
C
#include "BHBSRD.INC"
#include "GGSAVE.INC"
#include "ILINER.INC"
#include "MAXMUM.INC"
#include "NUMBRS.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
#include "VECTOR.INC"
C
C     Passed Variables
C
      INTEGER le,LEU,nbod
      DOUBLE PRECISION AMU(LEU,LEU),AM(LEU,LEU)
      DOUBLE PRECISION ACOF(9,le),BCOF(6,le)
      DOUBLE PRECISION COF11(le,le),COF22(le,le),COF33(le,le)
      DOUBLE PRECISION COF12(le,le),COF13(le,le),COF23(le,le)
      DOUBLE PRECISION COFXY(le,le),COFXZ(le,le),COFYZ(le,le)
      DOUBLE PRECISION GGS(cL06,9,MAXBOD),Y(cL07)
C
C     Local Variables
C
      INTEGER LO
      INTEGER IJ,JP3
      INTEGER I,J
      DOUBLE PRECISION RW(3,cL06),CW(cL06,3),VW(9),WV(6)
      DOUBLE PRECISION AMASS
C
#include "LDEBUG.INC"
      LOGICAL LEQU
      EQUIVALENCE (LEQU,DEBUG(49))
      IF(LEQU) WRITE (MBOUT,1000)
 1000 FORMAT (' SUBROUTINE MGEN')
C
      LO   = LOCU(NB+NBOD)
c
      if (NBOD .GT. nbdy) then     ! A particle
         amass = am(1,1)      
         amu(1,1) = amass
         amu(2,1) = 0d0
         amu(3,1) = 0d0
         amu(1,2) = 0d0
         amu(2,2) = amass
         amu(3,2) = 0d0
         amu(1,3) = 0d0
         amu(2,3) = 0d0
         amu(3,3) = amass
      else                      ! A body
         DO I = 1, LEU
            DO J = I, LEU
               AMU(I,J) = AM(I,J)
            END DO
         END DO
      end if
C
      IF (LE .EQ. 0) GO TO 50   ! No modes
CC@CC
CC@CC MULT3 BCOF(1,1), Y(LO), VW
CC@CC 6, LE, 1
CC@CC 6, 1, 1
      CALL DGEMV ('N',6,LE,1.0d0,BCOF(1,1),6,Y(LO),1,0.0d0,VW,1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC MULT3 COF11(1,1), Y(LO), CW(1,1)
CC@CC LE, LE, 1
CC@CC LE, 1, L06
      CALL DGEMV ('N',LE,LE,1.0d0,COF11(1,1),LE,Y(LO),1,0.0d0,CW(1,1),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC MULT3 COF22(1,1), Y(LO), CW(1,2)
CC@CC LE, LE, 1
CC@CC LE, 1, L06
      CALL DGEMV ('N',LE,LE,1.0d0,COF22(1,1),LE,Y(LO),1,0.0d0,CW(1,2),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC MULT3 COF33(1,1), Y(LO), CW(1,3)
CC@CC LE, LE, 1
CC@CC LE, 1, L06
      CALL DGEMV ('N',LE,LE,1.0d0,COF33(1,1),LE,Y(LO),1,0.0d0,CW(1,3),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC MULT3 Y(LO), COF12(1,1), RW(1,1)
CC@CC 1, LE, LE
CC@CC 1, LE, 3
      CALL DGEMV ('T',LE,LE,1.0d0,COF12(1,1),LE,Y(LO),1,0.0d0,RW(1,1),3)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC MULT3 Y(LO), COF13(1,1), RW(2,1)
CC@CC 1, LE, LE
CC@CC 1, LE, 3
      CALL DGEMV ('T',LE,LE,1.0d0,COF13(1,1),LE,Y(LO),1,0.0d0,RW(2,1),3)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC MULT3 Y(LO), COF23(1,1), RW(3,1)
CC@CC 1, LE, LE
CC@CC 1, LE, 3
      CALL DGEMV ('T',LE,LE,1.0d0,COF23(1,1),LE,Y(LO),1,0.0d0,RW(3,1),3)
CC@CC end of expanded call
CC@CC
C
C  PEEL OFF DATA FOR GRAVITY GRADIENT EFFECTS ON ELASTIC COORDINATES
C
      DO 8 J=1,LE
      GGS(J,1,NBOD) = CW(J,1)
      GGS(J,2,NBOD) = CW(J,2)
      GGS(J,3,NBOD) = CW(J,3)
      GGS(J,7,NBOD) = RW(1,J)
      GGS(J,8,NBOD) = RW(2,J)
    8 GGS(J,9,NBOD) = RW(3,J)
C
CC@CC
CC@CC MULT3 Y(LO), CW, WV(1)
CC@CC 1, LE, 3
CC@CC 1, L06, 1
      CALL DGEMV ('T',LE,3,1.0d0,CW,cL06,Y(LO),1,0.0d0,WV(1),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC MULT3 RW, Y(LO), WV(4)
CC@CC 3, LE, 1
CC@CC 3, 1, 1
      CALL DGEMV ('N',3,LE,1.0d0,RW,3,Y(LO),1,0.0d0,WV(4),1)
CC@CC end of expanded call
CC@CC
      DO 15 I=1,3
   15 AMU(I,I) = AMU(I,I) + TWO*VW(I) + WV(I)
      AMU(1,2) = AMU(1,2) - VW(4) - WV(4)
      AMU(1,3) = AMU(1,3) - VW(5) - WV(5)
      AMU(2,3) = AMU(2,3) - VW(6) - WV(6)
CC@CC
CC@CC MULT3 ACOF(1,1), Y(LO), VW
CC@CC 9, LE, 1
CC@CC 9, 1, 1
      CALL DGEMV ('N',9,LE,1.0d0,ACOF(1,1),9,Y(LO),1,0.0d0,VW,1)
CC@CC end of expanded call
CC@CC
      DO 17 J=1,3
      JP3 = J + 3
      DO 17 I=1,3
      IJ = J + 3*(I-1)
   17 AMU(I,JP3) = AMU(I,JP3) + VW(IJ)
CC@CC
CC@CC MULTAD Y(LO), COFYZ(1,1), AMU(1,7)
CC@CC 1, LE, LE
CC@CC 1, LE, LEU
      CALL DGEMV ('T',LE,LE,1.0d0,COFYZ(1,1),LE,Y(LO),1,1.0d0,AMU(1,7),L
     .EU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC MULTAD Y(LO), COFXZ(1,1), AMU(2,7)
CC@CC 1, LE, LE
CC@CC 1, LE, LEU
      CALL DGEMV ('T',LE,LE,1.0d0,COFXZ(1,1),LE,Y(LO),1,1.0d0,AMU(2,7),L
     .EU)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC MULTAD Y(LO), COFXY(1,1), AMU(3,7)
CC@CC 1, LE, LE
CC@CC 1, LE, LEU
      CALL DGEMV ('T',LE,LE,1.0d0,COFXY(1,1),LE,Y(LO),1,1.0d0,AMU(3,7),L
     .EU)
CC@CC end of expanded call
CC@CC
C
CC@CC
CC@CC MULT3 COF12(1,1), Y(LO), CW(1,1)
CC@CC LE, LE, 1
CC@CC LE, 1, L06
      CALL DGEMV ('N',LE,LE,1.0d0,COF12(1,1),LE,Y(LO),1,0.0d0,CW(1,1),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC MULT3 COF13(1,1), Y(LO), CW(1,2)
CC@CC LE, LE, 1
CC@CC LE, 1, L06
      CALL DGEMV ('N',LE,LE,1.0d0,COF13(1,1),LE,Y(LO),1,0.0d0,CW(1,2),1)
CC@CC end of expanded call
CC@CC
CC@CC
CC@CC MULT3 COF23(1,1), Y(LO), CW(1,3)
CC@CC LE, LE, 1
CC@CC LE, 1, L06
      CALL DGEMV ('N',LE,LE,1.0d0,COF23(1,1),LE,Y(LO),1,0.0d0,CW(1,3),1)
CC@CC end of expanded call
CC@CC
C
C  FINISH PEELING OFF GRAVITY GRADIENT DATA
C
      DO 28 J=1,LE
      GGS(J,4,NBOD) = CW(J,1)
      GGS(J,5,NBOD) = CW(J,2)
   28 GGS(J,6,NBOD) = CW(J,3)
C
 50   continue
      if (NBOD .LE. nbdy) then
         DO 77 I=1,LEU
         DO 77 J=I,LEU
 77      AMU(J,I) = AMU(I,J)
      end if
C
      IF (LEQU) then
         WRITE (MBOUT,1002) NBOD
 1002    FORMAT (' AMU, MASS MATRIX FOR BODY',I3)
         CALL WRITES(AMU,LEU,LEU,LEU)
         IF(LE.EQ.0) RETURN
         WRITE (MBOUT,1004) NBOD
 1004    FORMAT (' GGS, GRAVITY GRADIENT EFFECTS ON MODAL COORDINATES',
     *        ' OF BODY',I3)
         CALL WRITES(GGS(1,1,NBOD),LE,9,NMDBOD)
      end if
C
      RETURN
      END    ! End of mgen_1
