C $Header: /export/cvs/c34a1/source/moldyn/msmodf.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C ========================================================================
C
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER 
C STATE AND FEDERAL LAWS.  USE, DISCLOSURE, REPRODUCTION OR DUPLICATION 
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS 
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT 
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      SUBROUTINE MSMODF(A,B,C,WS,UVEC,NBOD,AMU,NE6,freq,y,iaconn,
     *                  ibconn,iconnh,ihthptr,ihpvt,itopol,dh)
c
C     SUBROUTINE TO INPUT MOLECULAR NORMAL MODES FROM DATA FILE AND PROCESS TO
C     OBTAIN INERTIAL INTEGRALS
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      IMPLICIT NONE
c
#include "PARAM.FOR"
c
c     External function
c
      INTEGER irnd
c
#include "CSTIFF.INC"
#include "CHARMM.INC"
#include "COREA.INC"
#include "HANDS2.INC"
#include "INTGRL.INC"
#include "INFOV.INC"
#include "HEAPMB.INC"
#include "MEMLB.INC"
#include "NHNS.INC"
#include "NUMBRS.INC"
#include "OPTION.INC"
#include "PARTCL.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
#include "VECTOR.INC"
C
c
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: msmodf.f,v $$Revision: 1.1.1.1 $'/
C
C     Passed Variables
C     
      INTEGER nbod,ne6
      DOUBLE PRECISION amu(ne6,ne6)
      DOUBLE PRECISION freq(cL06*L01)
      DOUBLE PRECISION y(cL07)
      DOUBLE PRECISION dh(3,cL16)
      INTEGER iaconn(2,cL02)
      INTEGER ibconn(2,cL02)
      INTEGER iconnh(cL02)
      INTEGER ihthptr(2*cL02)
      INTEGER ihpvt(cL02)
      INTEGER itopol(2,cL02)

c     Local Variables
C
      INTEGER   lhs     !  Index into pointer array ihthptr
      integer i0, i02m1,IFLG
      INTEGER ic11,ic22,ic33,ic12,ic13,ic23  ! for cofs (crec)
      INTEGER icxy,icxz,icyz
      INTEGER iacof, ibcof                   ! for acof/bcof
      INTEGER ICONN,IBOD,JOINT,LD,LR
      INTEGER NE,NJ,NREC2,NREC3,NOH,NHB
      INTEGER NSB,NOS
      INTEGER KA,KB,KC,KWS
      INTEGER LOV,LOP
      INTEGER I,J,K,L

      DOUBLE PRECISION A(cL43,cL45),B(cL43,cL45),C(cL43,cL45)
      DOUBLE PRECISION WS(cL43,13),UVEC(cL43),WV(3)
      DOUBLE PRECISION TMAS,FACT,ANG
      DOUBLE PRECISION PI,PI2,TWOPI

      JOINT = BADADDR
C
C 1001 FORMAT(16I5)
C 1002 FORMAT(8D10.3)
C
      pi2   = 2d0 * atan(1d0)
      pi    = 2d0 * pi2
      twopi = 4d0 * pi2
      KA    = cL43
      KB    = cL43
      KC    = cL43
      KWS   = cL43
C
C***  INITIALIZE NTAPE2, NTAPE3
      REWIND NTAPE2
      REWIND NTAPE3
C
C*************************************************
C
C***  NJ = NUMBER OF MASS POINTS ON BODY I
C***  NE = NUMBER OF ELASTIC MODES RETAINED FOR BODY I
      NE = IRGFLX(NBOD)
      NJ = iatoms(3,NBOD)
      if (nj .eq. 1) then
         WRITE (MBOUT,*) 
     &       ' Only 1 atom defined for flexible body in MSMODF'
         stop
      end if
      IF (nj .GT. cL43) THEN
         WRITE (MBOUT,*) 
     &     ' The number of atoms,',nj, 
     &     ' exceeds max number for flex. body.'
         stop
      END IF
      i0 = iatoms(1,NBOD)
      i02m1 = 2*i0 - 1
      if (mbplvl .ge. 9) then
         WRITE (MBOUT,3050) NBOD
 3050    FORMAT(///,5X,'LUMPED MASS DATA USED TO DEFINE FLEXIBLE ',
     *   'BODY NUMBER ',I3,/)
      end if
C
C***  GET ATOMIC MASSES FROM COMMON BLOCK - CREATE NTAPE2
C
C     MASSES
      J = M20 + i0 - 2
      DO I = 1, NJ
         J = J + 1
         A(I,1) = ONE / X(J)
      END DO
      WRITE(NTAPE2) (A(I,1),I=1,NJ)
C
C     INERTIAS
cblink   This should be deleted in the future. Redo calls to FETCH.
      WRITE(NTAPE2) ((ZRO,J=1,6),I=1,NJ)
C
C     STATIC MOMENTS
cblink   This should be deleted in the future. Redo calls to FETCH.
      WRITE(NTAPE2) ((ZRO,J=1,3),I=1,NJ)
C
C     GEOMETRIC COORDINATES
c
c Compute CM offset
c
      call cgadji2(ds(1,i02m1),X(M20+i0-1),wv,tmas,NJ,1,0)
c
      WRITE(NTAPE2) ((ds(i,j)-wv(i),i=1,3),j=2*i0,
     .     2*(i0+NJ-1),2)
c
C     MODE SHAPES (Write hats to ntape2)
      DO k =1,3             
         WRITE(NTAPE2) (HATS(j),j=ihtsptr(i0)+k,
     $        ihtsptr(i0)+3*ne*nj-3+k,3)
      END DO
      DO K=1,3
         WRITE(NTAPE2) ((ZRO,J=1,NE),I=1,NJ)
      END DO
c
C     INITIAL MODAL AMPLITUDES
C
C     kB = 1.98717d-3 kcal/K/mole
C
      fact = sqrt(2d0 * 1.98717d-3 * rtemp)
      lov  = locu(nbod) + 5
      lop  = locu(nb+nbod) - 1
      DO I = 1, NE
         ang = DBLE(irnd(100000000))/1d8 * twopi
         if( abs(freq(i)).lt. EPSILON ) then
            y(lop+i) = fact / EPSILON * cos(ang)
         else
            y(lop+i) = fact / freq(i) * cos(ang)
         endif
         y(lov+i) = - fact * sin(ang)
      END DO
C
      DO 47 I=1,NJ
   47 UVEC(I) = ONE
C
      REWIND NTAPE2
      NREC2 = 0
C
C***  CREATE NTAPE3
      CALL CRET3 (NREC2,NJ,NE,A,B,WS,KA,KB,KWS)
C
      REWIND NTAPE3
      NREC3 = 0
C
C***  FORM MUZERO MATRIX
      CALL ZERO(AMU,ne6,ne6,ne6)
C
      CALL CREMU0(NREC3,NJ,UVEC,A,WS,AMU,KA,KWS,NE6)
C
C***  FORM A0 AND D0 COEFFICIENTS
      CALL CREAD0(NREC3,NJ,NE,UVEC,A,B,C,WS,AMU,
     &            KA,KB,KC,KWS,NE6)
C
C***  FORM E COEFFICIENTS
      CALL CREE  (NREC3,NREC2,NJ,NE,A,B,C,AMU,KA,KB,KC,NE6)
C
c
c
C***  SYMMETRIZE AMU
      DO 48 I=1,NE6
      DO 48 J=I,NE6                      
 48   amu(j,i)=amu(i,j)
      if (mbplvl .ge. 2) CALL MWRITE(AMU,NE6,NE6,'MUO',NE6)
C
C***  FORM ACOF
      iacof = iacfptr(nbod)
      CALL CREA  (NREC3,NJ,NE,UVEC,HEAP_MB(iacof),B,KB,KWS)
C
C***  FORM BCOF
      ibcof = ibcfptr(nbod)
      CALL CREB  (NREC3,NREC2,NJ,NE,A,HEAP_MB(ibcof),WS,KA,KWS)
C
C***  FORM CCOF  
      ic11 = ic11ptr(nbod)
      ic22 = ic22ptr(nbod)
      ic33 = ic33ptr(nbod)
      ic12 = ic12ptr(nbod)
      ic13 = ic13ptr(nbod)
      ic23 = ic23ptr(nbod)
      icxy = icxyptr(nbod)
      icxz = icxzptr(nbod)
      icyz = icyzptr(nbod)
      CALL CREC  (NREC3,NREC2,NJ,NE,A,B,C,HEAP_MB(ic11),
     &      HEAP_MB(ic22),HEAP_MB(ic33),HEAP_MB(ic12),HEAP_MB(ic13),
     &      HEAP_MB(ic23),HEAP_MB(icxy),HEAP_MB(icxz),HEAP_MB(icyz),
     &      KA,KB,KC,NE)
c
C***  HINGE LOOP  ******************************************
C
      NHB = NHPOI(NBOD)
C
C
      L = 0
      do noh = 2, nh
         iflg = 0
         if (itopol(1,noh) .eq. nbod .or. 
     +       itopol(2,noh) .eq. nbod) then
            iflg = 1
c
c              Find the atom number where hinge frame is to be attached
c
            if (ihpvt(noh) .ne. 0) then
c
c     Hinge is bonded.  Search inter-fragment bond list for hinge atom.
c
               iconn = iconnh(noh)
               if (ibconn(1,iconn) .eq. nbod) then
                  JOINT = iaconn(1,iconn) - i0 + 1
               else if (ibconn(2,iconn) .eq. nbod) then
                  JOINT = iaconn(2,iconn) - i0 + 1
               else
                  WRITE (MBOUT,*) ' Error in msmodf: ibconn'
                  CALL ERRHDL(-5,'<MSMODF>')
               end if
            else
c
c     Hinge is not bonded.
c
               if (itopol(1,noh) .eq. nbod) then
                  ibod = itopol(2,noh)
               else
                  ibod = itopol(1,noh)
               end if
               if (ibod .lt. nbod) then
                  JOINT = 1
               else
                  JOINT = NJ
               end if
            end if
         end if          ! End of ITOPOL test
c
c              Finally, compute the vector from body reference to hinge
c
         if (iflg.ne.0) then
c
            L = L + 1
            if (itopol(1,noh) .eq. nbod) then
               LD = 7*(NOH-2) + 1
               lhs = 2*noh - 3
            else
               LD = 7*(noh-2) + 2
               lhs = 2*noh - 2
            end if
C
            DH(1,LD) = WS(JOINT,11)
            DH(2,LD) = WS(JOINT,12)
            DH(3,LD) = WS(JOINT,13)
C
C           calculate hats pointer
            ihthptr(lhs) = ihtsptr(JOINT+i0-1)
C
         end if  
      end do     
c
      if (L .ne. NHB) then
         WRITE (MBOUT,*) 'Topology error in MSMODF.'
         stop
      end if
c
C***  SENSOR LOOP  *****************************************
C
      NSB = NSPOI(NBOD)
C
      if (NSB .ne. NJ) then
         WRITE (MBOUT,*) ' NUMBER OF SENSOR POINTS INCORRECT IN MSMODF'
         stop
      end if
      DO 160 L=1,NSB
      NOS   = i0 + L - 1
      JOINT = L
      IF(IFTSMW(NOS) .NE. NBOD) GO TO 996
      LR = 2*NOS - 1
      DS(1,LR) = WS(JOINT,11)
      DS(2,LR) = WS(JOINT,12)
      DS(3,LR) = WS(JOINT,13)
      DS(1,LR+1) = WS(JOINT,11)
      DS(2,LR+1) = WS(JOINT,12)
      DS(3,LR+1) = WS(JOINT,13)
C
  160 CONTINUE
C
      RETURN
C
  996 WRITE (MBOUT,2003)
 2003 FORMAT('1TOPOLOGY ERROR, PROGRAM STOPPED')
      STOP
C
      END




