C $Header: /export/cvs/c34a1/source/moldyn/prntou.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C ========================================================================
C
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER 
C STATE AND FEDERAL LAWS.  USE, DISCLOSURE, REPRODUCTION OR DUPLICATION 
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS 
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT 
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      SUBROUTINE PRNTOU
  
      IMPLICIT NONE

#include "PARAM.FOR"

#include "HEAPMB.INC"
#include "MOMENG.INC"
#include "VECTOR.INC"
#include "SPECIF.INC"
#include "LAMBDA.INC"

      call prntou_1(HEAP_MB(iyptr),HEAP_MB(iydtptr),
     *              HEAP_MB(ipptr),HEAP_MB(ipmomptr),
     *              LoopHeap(ibetahptr),LoopHeap(ibetahdptr),
     *              LoopHeap(ialamptr))

      RETURN
      END

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE PRNTOU_1(Y,YDT,P,PMOM,BETAH,BETAHD,ALAM)

CSE
C                                                          DEBUG #  60
CPS        PURPOSE:
C
C                   GENERAL PRINT ROUTINE FOR NON-LINEAR TIME
C                   HISTORY RESPONSE.
C
CPE
      IMPLICIT NONE
 
C
#include "PARAM.FOR"
C
#include "AMUBW.INC"
#include "BHBSRD.INC"
#include "COREA.INC"
#include "CSTIFF.INC"
#include "INFOV.INC"
#include "LAMBDA.INC"
#include "MAXMUM.INC"
#include "MDTYPE.INC"
#include "MEMLB.INC"
#include "MISCNO.INC"
#include "MOMENG.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
#include "TIMESS.INC"
#include "VECTOR.INC"
c
c
      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: prntou.f,v $$Revision: 1.1.1.1 $'/
c
c     Passed variables
c
      DOUBLE PRECISION Y(cL07),YDT(cL07)
      DOUBLE PRECISION P(cL10),PMOM(cL10)
      DOUBLE PRECISION BETAH(6,cL02)
      DOUBLE PRECISION BETAHD(6,cL02)
      DOUBLE PRECISION ALAM(cL09)
c
C     Local Variables
C
      INTEGER LO,LE,LOPM,N
C
C
 1000 FORMAT (//10X,'AT SIMULATION TIME, T = ',1PD10.4,' ps ',32('* '))
 1001 FORMAT ( 3X,'THE STATE VECTOR Y = ')
 1002 FORMAT ( 3X,'THE STATE VECTOR TIME DERIVATIVE YDT = ')
 1003 FORMAT ( 3X,'THE BETAS (EULER ANGLES, POSITION COORDINATES) ARE')
 1004 FORMAT ( 3X,'THE BETA TIME DERIVATIVES ARE')
 1007 FORMAT ( 3X,'FOR BODY ',I3,3X,'THE VELOCITIES ARE')
 1017 FORMAT ( 3X,'FOR BODY ',I3,3X,'THE CORRESPONDING MOMENTA ARE')
 1027 FORMAT ( 3X,'FOR BODY ',I3,3X,'ITS CONTRIBUTION TO TOTAL',
     * ' ANGULAR AND LINEAR MOMENTUM IS')
 1008 FORMAT ( 3X,'ITS CONTRIBUTION TO TOTAL KINETIC ENERGY IS ', 3X,
     * 1PD15.8)
 1009 FORMAT ( 3X,'FOR BODY ',I3,3X,'THE ELASTIC DEFLECTIONS ARE')
 1010 FORMAT ( 3X,'THE INTERCONNECTION CONSTRAINT FORCES(LAMBDAS) ARE')
 1011 FORMAT ( 3X,'THE TOTAL ANGULAR MOMENTUM VECTOR IS')
 1012 FORMAT ( 3X,'THE TOTAL LINEAR MOMENTUM VECTOR IS')
 1013 FORMAT (/3X,'THE TOTAL ANGULAR MOMENTUM = ',1PD15.8,
     *       / 3X,'THE TOTAL LINEAR MOMENTUM  = ',1PD15.8,
     *       / 3X,'THE TOTAL KINETIC ENERGY   = ',1PD15.8,
     *       / 3X,'THE TOTAL POTENTIAL ENERGY = ',1PD15.8,
     *       / 3X,'THE TOTAL ENERGY (T + V)   = ',1PD15.8)
C
      CALL PAGEHD
      WRITE (MBOUT,1000) TX
      WRITE (MBOUT,1001)
      CALL WRITES (Y,1,NEQ,1)
C
      WRITE (MBOUT,1000) TX
      WRITE (MBOUT,1002)
      CALL WRITES (YDT,1,NEQ,1)
C
      WRITE (MBOUT,1000) TX
      WRITE (MBOUT,1003)
      CALL WRITES (BETAH,6,NH,6)
C
      WRITE (MBOUT,1000) TX
      WRITE (MBOUT,1004)
      CALL WRITES (BETAHD,6,NH,6)
C
   10 DO 20 N=1,NB
      WRITE (MBOUT,1000) TX
      WRITE (MBOUT,1007) N
      LO = LOCU(N)
      LE = LENU(N)
      CALL WRITES (Y(LO),1,LE,1)
      WRITE (MBOUT,1017) N
      CALL WRITES (P(LO),1,LE,1)
      LOPM = 6*(N-1) + 1
      WRITE (MBOUT,1027) N
      CALL WRITES (PMOM(LOPM),1,6,1)
      WRITE (MBOUT,1008) ENGKE(N)
      LE = LENU(N+NB)
      IF (LE .NE. 0) then
         LO = LOCU(N+NB)
         WRITE (MBOUT,1009) N
         CALL WRITES (Y(LO),1,LE,1)
      end if
C
   20 CONTINUE
C
      WRITE (MBOUT,1000) TX
C
      IF (NLAM .NE. 0) THEN
         WRITE (MBOUT,1010)
         CALL WRITES (ALAM,1,NLAM,1)
      END IF
C
      WRITE (MBOUT,1011)
      CALL WRITES (HTOT,1,3,1)
      WRITE (MBOUT,1012)
      CALL WRITES (TOTL,1,3,1)
C
      WRITE (MBOUT,1013) AHTOT,ATOTL,TOTKE,TOTPE,TOTENG
C
      RETURN
      END
