C $Header: /export/cvs/c34a1/source/moldyn/ydot.f,v 1.1.1.1 2006/08/17 02:29:56 brooks Exp $
C
C COPYRIGHT (C) 1991-1998 MOLDYN, INC.  ALL RIGHTS RESERVED
C =====================================================================
C 
C THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOLDYN, INC.
C
C THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF
C MOLDYN, INC., AND IS PROTECTED BY COPYRIGHT, TRADE SECRET AND OTHER
C STATE AND FEDERAL LAWS. USE, DISCLOSURE, REPRODUCTION OR DUPLICATION
C IN WHOLE OR IN PART IS STRICTLY PROHIBITED WITHOUT THE PRIOR EXPRESS
C WRITTEN CONSENT OF MOLDYN, INC. THE ABOVE COPYRIGHT NOTICE DOES NOT
C EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE.
C 
C 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      SUBROUTINE YDOT(dum,z1,z2,z3,itflag,iextor,y,ydt,p,ggv,iscut,
     &                IV,IBETDT,BETAHD,itopol,ihdata,irh)
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
CSE
C                                                          DEBUG #  39
CPS        PURPOSE:
C
C            TO COMPUTE THE FIRST TIME DERIVATIVE OF THE STATE
C            VECTOR Y.  CALL BY USER SELECTED INTEGRATOR.
C            Z AND ZDT ARE SUBSETS OF Y AND YDT.  YDOT CALLING
C            SEQUENCE CONFORMS TO GENERAL PURPOSE INTEGRATORS.
C
CPE
CAS
C       YDOT CALLING SEQUENCE
C       ---------------------
C          OLD - SUBROUTINE YDOT(BCKSLV,RETRK,TZ,Z,ZDT,RPAR,NEQZ)
C                NEED TO BRING BACK
C
C        TZ  -  CURRENT TIME
C         Z  -  PARTITION OF STATE VECTOR Y, VARAIABLES TO BE INTEGRATED
C       ZDT  -  FIRST DERIVATIVE OF PARTITION Z
C      NEQZ  -  NUMBER OF EQUATIONS TO BE INTEGRATED
C
C
C
C     STATE VECTOR AND ITS FIRST TIME DERIVATIVE
C-----------------------------------------------
C
C     THE REAL*8 ARRAYS Y AND YDT ARE STORED IN /VECTOR/ AND
C        DIMENSIONED (KY). IN SEVERAL ROUTINES THE SYMBOLIC NAME YD
C        IS USED INSTEAD OF YDT. SET DEBUG(39)=.TRUE. TO PRINT
C        INSTANTANEOUS VALUES OF ELEMENTS IN Y AND YDT ARRAYS
C
C                              Y  = SYSTEM STATE VECTOR
C                             YD  = SYSTEM STATE VECTOR FIRST TIME
C                                   DERIVATIVE
C
C     (Y(I),I=LOCU(N),LOCU(N)+2)  = COMPONENTS OF INERTIAL ANGULAR
C                                   VELOCITY VECTOR OF BODY N WRT THE
C                                   BODY N REFERENCE
C     (Y(I),I=LOCU(N)+3,LOCU(N)+5)= COMPONENTS OF INERTIAL LINEAR
C                                   VELOCITY VECTOR OF BODY N WRT THE
C                                   BODY N REFERENCE
C     (Y(I),I=LOCU(N)+6,LOCU(N)+6 = GENERALIZED MODAL VELOCITIES
C              -1+IRGFLX(N))        ASSOCITATED WITH THE FLEXURAL MODES
C                                   OF BODY N, (IN ASCENDING ORDER AS
C                                   READ IN, NONE IF BODY N RIGID)
C     (Y(I),I=LOCU(N)+6+IRGFLX(N),= SPIN RATES OF THE ACTIVE WHEELS
C             LOCU(N)+6+IRGFLX(N)   IN BODY N, (IN ASCENDING ORDER AS
C               -1+NMOW(2,N))       READ IN, NONE IF NMOW(2,N)=0)
C     (Y(I),I=LOCU(NB+N),         = GENERALIZED MODAL DISPLACEMENTS
C         LOCU(NB+N)-1+IRGFLX(N))   ASSOCIATED WITH THE FLEXURAL MODES
C                                   OF BODY N, (IN ASCENDING ORDER AS
C                                   READ IN, NONE IF BODY N RIGID)
C     (Y(I),I=LOCU(2*NB+1),       = BETA COORDINATES USED TO DEFINE
C           LOCU(2*NB+1)-1+NBETA)   UNCONSTRAINED AND RHENOMICALLY
C                                   CONSTRAINED MOTION BETWEEN BODIES
C                                   WHICH ARE CONTIGUOUS.
C                                    LET
C                                        NUM=BETA COORDINATE NUMBER FOR
C                                            DEGREE OF FREEDOM I-1 AT
C                                            HINGE POINT N. THE
C                                            NUMBERING ALGORITHM IS
C                                       NUM = 0
C                                       DO 1 N=1,NH
C                                       DO 1 I=2,7
C                                       IF(IHDATA(I,N).EQ.1) GO TO 1
C                                       NUM = NUM+1
C                                     1 CONTINUE
C     (Y(I),I=LOCU(2*NB+2),       = STATE VARIABLE COORDINATES WHICH
C           LOCU(2*NB+2)-1+NDELTA)  ARE ASSOCIATED WITH THE NDELTA FIRST
C                                   ORDER DIFFENTIAL EQUATIONS CODED BY
C                                   THE USER IN CONTRL
C     (Y(I),I=LOCU(2*NB+3),       = ALL UNCONSTRAINED RELATIVE HINGE
C      LOCU(2*NB+3)-1+6*NH-NLAM)    VELOCITIES COORDINATES BETA^F(DOT) USED
C                                   BY THE RECURSIVE ALGORITHM
C     (YD(I),I=1,NEQ)             = FIRST TIME DERIVATIVE OF THE
C                                   COORDINATE Y(I) IN THE STATE VECTOR
C
C
C         YDOT - FIRST TIME DERIVATIVE OF STATE VECTOR
C         --------------------------------------------
C     SUBROUTINE YDOT DIRECTS THE COMPUTATION REQUIRED FOR THE
C        DETERMINATION OF THE YDT ARRAY.
C     GGV    = TORQUE ARRAY, DIMENSIONED (NBMAX*(6+NMDBOD)+NMWMAX)
C              THIS ARRAY IS NOT STORED IN COMMON. IN YDOT IT IS
C              INITIALIZED TO ZERO ON EACH PASS THROUGH. IN SUBROUTINE
C              GRVGRD THE GENERALIZED FORCE ASSOCIATED WITH GRAVITY
C              GRADIENT EFFECTS ACTING ON EACH STATE VECTOR
C              COORDINATE IS COMPUTED AND STORED IN GGV. IN SUBROUTINE
C              TORQUE ALL OTHER SYSTEM FORCE AND TORQUES ARE COMPUTED
C              AND ADDED ON TO GGV, DEBUG(50 AND 57) = .TRUE. TO PRINT
C         (GGV(J),J=1,NU) = TOTAL GENERALIZED FORCE ASSOCIATED WITH THE
C                           J-TH STATE VECTOR COORDINATE EQUATION
C     BDTP   = FIRST DERIVATIVE OF THE HINGE POINT KINEMATIC COEFFICIENT
C              MATRIX ASSOCIATED WITH THE P-FRAME, D/DT(EQ. C-1, VOL 1)
C              DIMENSIONED (6,6+NMDBOD), STORED LOCALLY
C              BDTP FOR EACH HINGE POINT PRINTED IF DEBUG(51)=.TRUE.
C     BDTQ   = FIRST DERIVATIVE OF THE HINGE POINT KINEMATIC COEFFICIENT
C              MATRIX ASSOCIATED WITH THE Q-FRAME, D/DT(EQ. C-2, VOL 1)
C              DIMENSIONED (6,6+NMDBOD), STORED LOCALLY
C              BDTQ FOR EACH HINGE POINT PRINTED IF DEBUG(51)=.TRUE.
C
CAE
CTS
C
C                     ORDER N RECURSIVE ALGORITHM
C
C      o  IMPULSE MOMENTUM HAS BEEN REMOVED.  IT MAY HAVE TO BE
C         REINTRODUCED IN ANOTHER FORM WHEN TOPOLOGICAL LOOPS AND
C         INTERMITTANT LOOP CLOSURE IS INTRODUCED.
C      o  COMPUTATION OF CONSTRIANT LOADING NOT NEEDED IN RECURSIVE
C         FORMULATION
C      o  SETI CAPABILITY REMOVED, WILL BE BROUGHT BACK LATER FOR THE TIME
C         VARYING KINEMATIC CONSTRAINT CAPABILITY
C      o  COMPUTE ALL KINEMATIC DATA IN ROTDH, BHGENR, ROTDS, BSGENR.  THIS
C         WORK BASICALLY SAME AS OLD DISCOS.
C      o  CALL MGEN TO DETERMINE DEFORMATION DEPENDENT MASS MATRIX
C      o  FIRST 6 ELEMENTS OF EACH U(I) ARE COMPUTED FROM THE NEW
C         BETA^F(DOT) DATA.  DONE IN FRWRD1
C      o  ALL CODE ASSOCIATED WITH EXPLICIT COMPUTATION OF CONSTRAINT
C         LOADS NOT REQUIRED.  SUBROUTINES GETBMB AND SETI NOT REQUIRED.
C      o  MASS MATRIX INVERSION NOW TAKES PLACE IN BCKWRD AS VECTOR OF
C         EQUIVALENT GENERALIZED FORCE VECTORS ARE COMPUTED
C      o  RECURSIVE ALGORITHM INTEGRATES BETA(DOUBLE DOT)'S TO GET BETA(DOT)'S
C         MORE OLD DISCOS CODE CAN BE REMOVED.
C      o  ALL CODE ASSOCIATED WITH CONSTRAIN COMPUTATION DELETED.  THE
C         RECURSIVE FORMULATION USES A DIFFERENT APPROACH.
C      o  AFTER CALL TO SUBROUTINE TORQUE TO OBTAIN A DEFINITION OF ALL
C         NONGYROSCOPIC EFFECTS, BCKWRD IS USED TO ACCUMULATE GYROSCOPIC
C         LOADING EFFECTS ON A BACKWARD SWEEP, THEN FRWRD2 IS USED TO
C         ACCUMULATE ALL REQUIRED ACCELERATIONS FOR THE STATE DERIVATIVE
C         VECTOR YDT ON A FORWARD SWEEP.
C
C         YDOT NOW CALLS SUBROUTINE DLMBRT TO DEFINE FORCES OF INERTIA WHICH
C            MUST BE INTRODUCED IF AN ACCELERATING FRAME OF REFERENCE IS TO
C            BE USED
C
CTE
      IMPLICIT NONE
 
C
#include "PARAM.FOR"
C
#include "AMUBW.INC"
#include "BHBSRD.INC"
#include "COMPOS.INC"
#include "COREA.INC"
#include "CSTIFF.INC"
#include "ERRHDL.INC"
#include "F1BKF2.INC"
#include "GCOMP.INC"
#include "HANDS2.INC"
#include "HEAPMB.INC"
#include "IFIRST.INC"
#include "ILINER.INC"
#include "INTGRL.INC"
#include "IVCONS.INC"
#include "JILFLG.INC"
#include "LAMBDA.INC"
#include "LDEBUG.INC"
#include "MAXMUM.INC"
#include "MEMLB.INC"
#include "MISCNO.INC"
#include "MISCN2.INC"
#include "MOMENG.INC"
#include "NUMBRS.INC"
#include "ORDERN.INC"
#include "PARTCL.INC"
#include "PINRP.INC"
#include "SPECIF.INC"
#include "TAPENO.INC"
#include "TIMESS.INC"
#include "TIMING.INC"
#include "VECTOR.INC"
#include "CLOOP.INC"
#include "NOUTPT.INC"
#ifdef CHARMM
#include "CHARMM.INC"
#endif
C
C     COMMON BLOCK FOR TOPOLOGICAL LOOPS
#include "CPATHS.INC"
C
C     COMMON BLOCK FOR RECURSIVE ALGORITHM
#include "SELECT.INC"
C

      CHARACTER*128  RCSID
      DATA           RCSID
     &/'$RCSfile: ydot.f,v $$Revision: 1.1.1.1 $'/
c
C     Argument List
      LOGICAL iscut(cL02)
      INTEGER IV(6,cL02)
      INTEGER IBETDT(cL02)
      INTEGER itopol(2,cL02)
      INTEGER ihdata(7,cL02)
C
      INTEGER itflag              !  Iteration flag for Verlet integrators
                                  !  (not including call for extor_CHARMM)
      INTEGER iextor              !  Indicator of call to extor_CHARMM
      DOUBLE PRECISION dum
      DOUBLE PRECISION z1(*), z2(*), z3(*)  !  State vector partitions
      DOUBLE PRECISION Y(cL07), YDT(cL07)
      DOUBLE PRECISION P(cL10)
      DOUBLE PRECISION BETAHD(6,cL02)
 
c
c     Local variables
C
      INTEGER i1st                !  Flag to indicate first pass through
      INTEGER nmdtot              !  Total # of modes in the system
c      INTEGER IFLAG,IC,IDOF1,I2C
      INTEGER IFLAG,IC,I2C
      INTEGER IHD,LOU,NSTEP
      INTEGER i, j, k, l, ih      !  DO loop indices
      INTEGER ibdy                !  Body counter
      INTEGER inb, imb            !  Body number for m and n bodies
      INTEGER nmp, nmq            !  U vector lengths for p and q bodies
      INTEGER lp, lq              !  Pointers to appropriate BH locations
      INTEGER ndof, idof1         !  Number of DOFs and starting DOF location
      INTEGER lo,ifx,le,n,loc
      LOGICAL LEQU
c w.s. young change
      integer i_mod_test
c end of change
      DOUBLE PRECISION GGV(cL10)
      DOUBLE PRECISION IRH(cL09)
      DOUBLE PRECISION tim1, tim2 !  Timing variables
#ifdef CHARMM
      DOUBLE PRECISION tscale     !  Temperature scaling factor
#endif
c
C     External Functions
C
      DOUBLE PRECISION ADT
C
c     Static variables
c
      INTEGER neqz                !  Number of z array variables
      COMMON /com_ydot/ neqz
C
C     Equivalences
C
      EQUIVALENCE (LEQU,DEBUG(39))
      EQUIVALENCE (i1st,i1pass(5))
C
C
      IF(LEQU) WRITE (MBOUT,1000)
 1000 FORMAT (' SUBROUTINE YDOT')
C
      nmdtot = BADADDR

      IF(I1ST .EQ. 0) THEN
         NSTEP = 0
         IFLAG = 1
         JIL = 4
         IC = 0
         DO J = 1, NH
            do i = 1, 6
               IV(I,J) = 0
            end do
            if (ihdata(1,j) .eq. 0) then
               idof1 = 4
            else
               idof1 = 1
            end if
            DO I = idof1, 6
               IF (IHDATA(I+1,J).NE.0) THEN
                  IC = IC + 1
                  IV(I,J) = IC
               END IF
            END DO
         END DO
         IF (IC.NE.NLAM) THEN
            CALL CLEARERR()
            WRITE(ERRMSG,200)
     +        ' YDOT - ERROR IN IV SET UP ***** '
            CALL ERRHDL(-5,'<YDOT>')
         END IF
 200     FORMAT(1X,A) 
C
C        DEFAULT, ALL CONSTRAINT DATA IN IHDATA IS OK
         DO 2 I=1,NLAM
    2    IRH(I) = 1
         IF (verlet) THEN
            neqz = locu(2*nb+2) - locu(nb+1)
         END IF
         go to 19
      END IF
c
c     UNPACK THE Z VECTOR (NOT DONE ON FIRST CALL TO YDOT)
c
      IF (verlet) THEN
c
c     Copy the modal coordinates and beta's
c
         IF (itflag .EQ. 0) THEN
            i = 0
            DO l = locu(nb+1), locu(2*nb+2)-1
               i = i + 1
               y(l) = z1(i)
            END DO
         END IF
C
C     COPY THE VELOCITIES
C
         I = 0
         DO L = 1, NB
            LO = LOCU(L) + 5
            DO IFX = 1, IRGFLX(L)
               I = I + 1
               Y(LO+IFX) = Z2(I)
            END DO
         END DO
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
cblink   Test the following two sections of code
c     Remember to skip the cut joints.  Not properly done yet.
c
c     The following block will need to be modified before
c     running cases with rheonomic constraints.
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c         lva = locu(2*nb+2) - 1   !  Copy the alpha dots
c         lvb = locu(2*nb+3) - 1   !  Copy the beta dots
c         DO l = 1, nh
c            IF (l.GT.nbdy) THEN
c               idof1 = 5
c            ELSE
c               idof1 = 2
c            END IF
c            DO ip1 = idof1, 7
c               IF (ihdata(ip1,l) .EQ. 0) THEN
c                  i   = i + 1
c                  lvb = lvb + 1
c                  y(lvb) = z2(i)
c               ELSE IF (ihdata(ip1,l) .EQ. 2) THEN
c                  i   = i + 1
c                  lva = lva + 1
c                  y(lva) = z2(i)
c               END IF
c            END DO
c         END DO
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     This section is capable of handling cut-
c     joints but NOT rheonomic constraints.
c
         nmdtot = i
         lo = locu(2*nb+3)
         DO l = lo, lo+nbeta-1
            i = i + 1
            y(l) = z2(i)
         END DO
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      ELSE       !  For Runge-Kutta
         i = 0
         DO l = 1, nb
            lo = locu(l) + 5
            DO ifx = 1, irgflx(l)
               i = i + 1
               y(lo+ifx) = z1(i)
            END DO
         END DO
         nmdtot = i
         DO l = locu(nb+1), neq
            i = i + 1
            y(l) = z1(i)
         END DO
      END IF
C
C       COUNT FUNCTION CALLS
c
 19   CONTINUE
c
c
      T = DUM
      NSTEP = NSTEP + 1
      IF (.NOT.LEQU) GO TO 21
      WRITE (MBOUT,1002)
 1002 FORMAT (' THE STATE VECTOR Y IS ')
      CALL WRITES(Y,1,NEQ,1)
   21 CONTINUE
C
C     GET DATA TO DEFINE HINGE AND BODY FIXED FRAME KINEMATICS
C
      IF (verlet) THEN
         IF (itflag .EQ. 0) THEN
            CALL rotdh(HEAP_MB(iyptr),logicLoopHeap(iiscutptr),
     *                 intLoopHeap(iihthptrptr),
     *                 LoopHeap(ipimatptr),intLoopHeap(iihpvtptr),
     *                 LoopHeap(ipinptr),LoopHeap(irp2ptr),
     *                 LoopHeap(irp3ptr),intLoopheap(iibetdtptr),
     *                 LoopHeap(ibetahptr),intloopheap(iitopolptr),
     *                 intloopheap(iihdataptr),Loopheap(irhptr),
     *                 Loopheap(idhptr),intloopheap(iihcutjptr))
         ELSE IF (itflag.EQ.itmax+1) THEN
C     Note: In MTSL, the Euler sequence check is performed
C           with the fastest time step.
            CALL check_sng1(seqflg,logicLoopHeap(iiscutptr),
     *                      intLoopHeap(iihpvtptr),
     *                      LoopHeap(ibetahptr),
     *                      intLoopHeap(iihdataptr))
            CALL check_sng2(seqflg,HEAP_MB(iyptr),
     *                      logicLoopHeap(iiscutptr),
     *                      intLoopHeap(iichpvtptr),
     *                      intLoopHeap(iihpvtptr),
     *                      intLoopheap(iibetdtptr),
     *                      LoopHeap(ibetahptr),
     *                      intLoopheap(iihdataptr),
     *                      Loopheap(irhptr),
     *                      Loopheap(idhptr))
         END IF
      ELSE
         seqflg = .FALSE.
         CALL rotdh(HEAP_MB(iyptr),logicLoopHeap(iiscutptr),
     *             intLoopHeap(iihthptrptr),
     *             LoopHeap(ipimatptr),intLoopHeap(iihpvtptr),
     *             LoopHeap(ipinptr),LoopHeap(irp2ptr),
     *             LoopHeap(irp3ptr),intLoopheap(iibetdtptr),
     *             LoopHeap(ibetahptr),intloopheap(iitopolptr),
     *             intloopheap(iihdataptr),Loopheap(irhptr),
     *             Loopheap(idhptr),intloopheap(iihcutjptr))
      END IF
C
      IF (verlet .AND. itflag.GT.0 .AND. 
     *        .NOT.(itflag.EQ.itmax+1 .AND. seqflg)) THEN
C
      ELSE
C
C        GENERATE BH ARRAY
c
cblink If the necessary calculations are done in check_sng*, the following
cblink call need not be done if itflag=itmax+1
c
         CALL BHGENR(LocalHeap(ibhqptr_bhgenr),
     *               LocalHeap(ibhpptr_bhgenr),
     *               intLoopHeap(iibhtypeptr),
     *               intLoopHeap(iihthptrptr),
     *               intLoopHeap(iihpvtptr),
     *               intLoopHeap(iisdofptr),
     *               intLoopHeap(iitopolptr),
     *               intLoopHeap(iihdataptr),
     *               intLoopHeap(iibh_ptrptr))
C
C        Compute atom coordinates
cblink Check whether the following call can be left out if itflag=itmax+1
c
         CALL ROTDS_1(HEAP_MB(iyptr))
      END IF
c
#ifdef CHARMM
c
c     Now that atom coordinates have been computed in ROTDS,
c     calculate forces on each atom
c
      IF ( (verlet .AND. iextor .EQ. 1) .OR.
     +     (.NOT. verlet) ) then
         CALL msecond(tim1)
         nfrc_call = nfrc_call + 1
#ifdef ANALYZE_FORCE
         CALL extor_CHARMM(HEAP_MB(igposptr),HEAP_MB(igpos_stageptr),
     +                     HEAP_MB(ig_chmptr),HEAP_MB(ipptr))
#else
         CALL extor_CHARMM(HEAP_MB(igposptr),HEAP_MB(igpos_stageptr),
     +                     HEAP_MB(ipptr))
#endif
         CALL msecond(tim2)
         timer(inon_vfma) = timer(inon_vfma) + tim2 - tim1
      end if
c
#endif
c
c     Call MGEN to generate deformation dependent mass matrices
c     for each body and and gravity gradient data.
c     Reference:  Vol. 1, Pages II-36,37
c
      CALL MGEN
c
c     Inertial body rates must be computed from relative rate
c     coordinates used in the recursive algorithm.  This is done
c     in the forward pass.  Rates are recursively computed 
c     sequentially from base to end bodies.  This is refered to
c     as the "First Forward Sweep."
c
      CALL FRWD1A(HEAP_MB(iyptr),LoopHeap(irinvptr),
     &            intLoopHeap(iihthptrptr),LoopHeap(ipimatptr),
     &            intLoopHeap(iihpvtptr),intLoopHeap(iibetdtptr),
     &            intloopheap(iitopolptr),intLoopheap(iihdataptr),
     &            intLoopHeap(iibh_ptrptr))
      IF(LEQU) WRITE (MBOUT,*) ' BACK IN YDOT FROM FRWD1A'
c
      DO 10 ibdy = 1, nb
         lo   = locu(ibdy)
         le   = lenu(ibdy)
c
c        Calculate ordinary momenta,
c        Reference:  Vol. 1, Equation II-49
c
c         if (ibdy.GT.nbdy) then          ! Body is a particle
c            amass = pamu(1,1,iprt)
c            do i = lo, lo+2
c               p(i) = amass * y(i)
c            end do
c         else                            ! Body is rigid/flex
c
cCC@CC
cCC@CC MULT3 BAMU(1,1,IBODY), Y(LO), P(LO)
cCC@CC LE, LE, 1
cCC@CC L08, LE, LE
c      CALL DGEMV ('N',LE,LE,1.0d0,BAMU(1,1,IBODY),L08,Y(LO),1,0.0d0,P(LO
c     .),1)
cCC@CC end of expanded call
cCC@CC
c         end if 
c
CC@CC
CC@CC ...MULT3 HEAP_MB(iamuptr(ibdy)), Y(LO), P(LO)
CC@CC ...LE, LE, 1
CC@CC ...LE, LE, LE
      CALL DGEMV ('N',LE,LE,1.0d0,HEAP_MB(iamuptr(ibdy)),LE,Y(LO),1,0.0d
     .0,P(LO),1)
CC@CC end of expanded call
CC@CC
c
 10   CONTINUE
c
#ifdef CHARMM
c
      IF (jil.EQ.4) THEN
c
c        Calculate total system mass and center of mass location
c
	 CALL compin_1
c
c        Calculate energy and momentum values
c
         CALL engmom(HEAP_MB(iyptr),HEAP_MB(ipptr),HEAP_MB(ipmomptr),
     .               LocalHeap(iwvptr_engmom))
c
c        Calculate the principal inertia properties.
c        (This will be "uncommented" when prntbd.f is fixed.)
c
c        if (iprnt .EQ. noprnt) CALL compin_2
c
c        CALL MBCtrl for output and velocity re-scaling, if needed
c
         IF ((ivprt.eq.1) .OR. (iparam(7) .EQ. 1) .OR. 
     .        (iparam(22) .GT. 0) .OR.
     .        (iparam(23) .GT. 0)) CALL getvel(x(m40))
         rparam(7)  = ONE
         rparam(9)  = totpe - rparam(8)
         rparam(10) = totke
         rparam(11) = atotl
         CALL MBCtrl(x(m40),rparam,iparam,engke)
c
c        Scale the velocities, if needed 
c        (for thermostat/heating/equilibration)
c
         tscale = rparam(7)
         IF ((iparam(7) .EQ. 1 .OR. iparam(22) .GT. 0 
     &        .OR. iparam(23) .GT. 0)
     &        .AND. dabs(tscale - one) .GE. eps_mach) THEN
c
c
c           Do the velocity portions of the input z vectors
c
            IF (verlet) THEN
               DO i = 1, neqz
                  z2(i) = tscale * z2(i)
               END DO
            ELSE
               l = locu(2*nb+1) - locu(nb+1)
               DO i = 1, l
                  z1(i) = tscale * z1(i)
               END DO
               k = 2*l + nbeta
               DO i = k+1, k+nbeta
                  z1(i) = tscale * z1(i)
               END DO
            END IF
c
c           Do the U vectors and momentum vectors
c
            DO i = 1, nu
               y(i) = tscale * y(i)
               p(i) = tscale * p(i)
            END DO
c
c           Do the beta dot partition of y
c
            lo = locu(2*nb+3)
            DO i = lo, lo+nbeta-1
               y(i) = tscale * y(i)
            END DO
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c           Un-do the scaling for constant velocity atoms
c
            DO i = nbdy+1, nb
               IF (PrtCvel(i) .EQ. 1) THEN
                  lo = locu(i) - 1
                  DO j = 1, 3
                     y(lo+j) = y(lo+j) / tscale
                     p(lo+j) = p(lo+j) / tscale
                  ENDDO
               ENDIF
            ENDDO
c
c           Correct the beta dot vector for constant velocity atoms
c
            do ih = 2, nh
               inb = ITOPOL(1,ih)
               imb = ITOPOL(2,ih)
               IF (PrtCvel(inb).EQ.1 .OR. PrtCvel(imb).EQ.1) THEN
                  lq = 2*ih - 2
                  lp = 2*ih - 1
                  nmq = lenu(inb)
                  nmp = lenu(imb)
                  idof1 = 4
                  ndof  = 3
C
C MULT3 bh(1,1,lp),y(locu(imb)),betahd(idof1,ih),ndof,nmp,1,6,nmp,6
C
                  CALL BHMULT(.FALSE.,ih,1,y(locu(imb)),
     &                 betahd(idof1,ih),nmp,nmp,6,
     &                 intLoopHeap(iibhtypeptr),
     &                 intLoopHeap(iitopolptr),
     &                 intLoopHeap(iibh_ptrptr))
C
C MULTAD bh(1,1,lq),y(locu(inb)),betahd(idof1,ih),ndof,nmq,1,6,nmq,6
C
                  CALL BHMULT(.TRUE.,ih,0,y(locu(inb)),
     &                 betahd(idof1,ih),nmq,nmq,6,
     &                 intLoopHeap(iibhtypeptr),
     &                 intLoopHeap(iitopolptr),
     &                 intLoopHeap(iibh_ptrptr))
c
c     Move the corrected beta dot into the appropriate Y vector partition
c
                  lo = ibetdt(ih) - 1
                  j  = idof1 - 1
                  DO i = 1, ndof
                     y(lo+i) = betahd(j+i,ih)
                  ENDDO
c
c     Move the corrected beta dot into the appropriate Z vector partition
c
                  j  = idof1 - 1
                  IF (verlet) THEN
                     lo = nmdtot + ibetdt(ih) - ibetdt(1)
                     DO i = 1, ndof
                        z2(lo+i) = betahd(j+i,ih)
                     ENDDO
                  ELSE
                     lo = 2*nmdtot + nbeta + ibetdt(ih) - ibetdt(1)
                     DO i = 1, ndof
                        z1(lo+i) = betahd(j+i,ih)
                     ENDDO
                  END IF
c
               ENDIF
c
            end do
c
         END IF
c
c        Stop the center of mass motion every ntrfrq steps
c        or during rescaling step
c        iparam(25) = NTRFRQ
c        iparam(16) = Current step
c        iparam(7)  = Temperature rescale control
c
         if( iparam(25) .GT. 0 ) then 
             i_mod_test = mod(iparam(16),iparam(25))
         else
             i_mod_test = -1
         end if

	 IF ((((iparam(25) .GT. 0 ) .AND. (i1st .NE. 0))
     &      .AND. i_mod_test .EQ. 0)
     &      .OR. (iparam(7) .NE. 1 
     &      .AND. dabs(tscale - one) .GE. eps_mach)) THEN 
c
            CALL delta_v(T,HEAP_MB(iyptr),HEAP_MB(ipptr),
     &                   HEAP_MB(ipmomptr),
     &                   logicLoopHeap(iiscutptr),
     &                   LoopHeap(ipinptr),LoopHeap(ibetahdptr),
     &                   intloopheap(iitopolptr),
     &                   intloopheap(iihdataptr))
c
c           Correct the appropriate z vector of the argument list
c
            IF (verlet) THEN
               i = nmdtot
               lo = locu(2*nb+3)
               DO l = lo, lo+nbeta-1
                  i = i + 1
                  z2(i) = y(l)
               END DO
            ELSE       !  For Runge-Kutta
	       j = nbeta + 2*nmdtot
	       loc = locu(2*nb+3) - 1
	       DO i = 1, nbeta
                  z1(j+i) = Y(loc+i)
               END DO
            END IF
c
         END IF
         if (ivprt .eq. 1) then
            call getvel(x(m40))
            call mbrestart(x(m30), x(m40), iparam, rparam)
         end if
c
c     End jil = 4 if
c

      END IF
#endif
C
C     COMPUTE BETA DOTS FOR CLOSED-LOOP TOPOLOGIES
C
      IF (NH .GT. NB) THEN
C
C        COMPUTE THE CUT-JOINT BETA DOTS
C
         CALL CLFOR1(HEAP_MB(iyptr),LocalHeap(ibhqptr_clfor1),
     &               LocalHeap(ibhpptr_clfor1),
     &               intLoopHeap(iisdofptr),LoopHeap(
     &               ibetahdptr),intloopheap(iitopolptr),
     &               intLoopHeap(iihcutjptr))
         IF(LEQU) WRITE (MBOUT,*) ' BACK IN YDOT FROM CLFOR1'
C
C        PERFORM BACKWARD AND FORWARD RECURSIONS TO OBTAIN SOLUTION MATRICES
C
         CALL CLBCK1(HEAP_MB(ibtildeptr),LocalHeap(ibhqptr_clbck1),
     &               LocalHeap(ibhpptr_clbck1),intLoopHeap(
     &               iihthptrptr),intLoopHeap(iihpvtptr),
     &               intLoopHeap(iiselptr),intLoopHeap(iisdofptr),
     &               intLoopHeap(iitopolptr),intLoopHeap(iibh_ptrptr),
     &               intLoopheap(iihcutjptr))
C
         IF (NCTCON .GT. 0) THEN
C
            CALL CLFR2A(HEAP_MB(ibtildeptr),HEAP_MB(ibicdstptr),
     &                  HEAP_MB(isbtptr),HEAP_MB(ibrnptr),
     &                  LocalHeap(ibhinbptr_clfr2a),
     &                  logicLoopHeap(iihpathptr),
     &                  intLoopHeap(iiselptr),intLoopheap(iisdofptr),
     &                  Loopheap(ibetahdptr),intloopheap(iitopolptr),
     &                  intLoopHeap(iihdataptr),intLoopheap(
     &                  iihcutjptr),Loopheap(irlamdaptr),
     &                  LoopHeap(iaclmatptr),intloopheap(iiclpvtptr),
     &                  LocalHeap(iacopyptr_clfr2a),
     &                  LocalHeap(izptr_clfr2a),LocalHeap(
     &                  itempvptr_clfr2a))
C
C        APPLY THE IMPULSE LAGRANGE MULTIPLIERS TO CORRECT THE BETA DOTS,
C        XI DOTS, AND ORDINARY MOMENTA
C
            CALL CJMPLS(HEAP_MB(ipsiptr),HEAP_MB(iyptr),
     &                  HEAP_MB(iydtptr),intHEAP_MB(ikmbpvtptr),
     &                  HEAP_MB(ipptr),HEAP_MB(ibtildeptr),
     &                  LocalHeap(idbetxiptr_cjmpls),
     &                  LocalHeap(itemp1ptr_cjmpls),
     &                  LoopHeap(irinvptr),intLoopHeap(iihthptrptr),
     &                  intLoopHeap(iihpvtptr),intLoopHeap(iiselptr),
     &                  intLoopHeap(iisdofptr),intLoopHeap(iibetdtptr),
     &                  intLoopheap(iitopolptr),intLoopHeap(
     &                  iibh_ptrptr),intLoopheap(iihcutjptr),
     &                  Loopheap(irlamdaptr))
C
C        COMPUTE THE NEW CUT-JOINT BETA DOTS
C
            CALL CLFOR1(HEAP_MB(iyptr),LocalHeap(ibhqptr_clfor1),
     &               LocalHeap(ibhpptr_clfor1),intLoopheap(iisdofptr),
     &               LoopHeap(ibetahdptr),intloopheap(iitopolptr),
     &               intLoopHeap(iihcutjptr))
            IF (JIL .GE. 4 .AND. .NOT. verlet) SEQFLG = .TRUE.
C
         END IF
C
      END IF    ! NH > NB IF TEST
C
C     THIS SECTION OF CODE EXTRACTS THE DERIVATIVES OF BETA VECTOR FROM
C     THE APPROPRIATE PARTITIONS OF Y AND PUTS THEM INTO YDT AND BETAHD
C
      IC = LOCU(2*NB+1) - 1
      I2C = LOCU(2*NB+3) -1
      DO L = 1, NH
         if (.not. iscut(l)) then
            if (ihdata(1,L) .eq. 0) then
               idof1 = 4
            else
               idof1 = 1
            end if
            DO I = idof1, 6
               IHD = IHDATA(I+1,L)
               IF (IHD .EQ. 1) GO TO 55
               IC = IC + 1
               IF (IHD .EQ. 0) THEN
                  I2C = I2C + 1
                  YDT(IC) = Y(I2C)
               ELSE IF (IHD .EQ. 2) THEN
                  YDT(IC) = ADT(6*(L-1) + I,T)
               END IF
               BETAHD(I,L) = YDT(IC)
 55            continue
            end do
         end if
      end do
C
C     Compute vector of intermediate accelerations ZETA  
      CALL FRWD1B(HEAP_MB(iyptr),LocalHeap(ibdoticptr_frwd1b),
     *            LocalHeap(ibdotinptr_frwd1b),
     *            LoopHeap(izetaptr),intLoopHeap(iihthptrptr),
     *            intLoopHeap(iisdofptr),intLoopHeap(iitopolptr),
     *            intLoopheap(iihdataptr),intLoopheap(iibh_ptrptr))
C
C  PUT MODAL VELOCITIES (XI(DOT)) INTO YDOT
C        THESE GO AFTER BODY ACCLERATIONS. THEY CAN BE FOUND IN THE
C        STATE VECTOR SEE ARRANGEMENT OF U VECTOR
C
      DO 65 N=1,NB
      LE = IRGFLX(N)
      IF (LE .EQ. 0) GO TO 65
      LOU = LOCU(N) + 5
      LO = LOCU(N+NB) - 1
      DO 66 J=1,LE
   66 YDT(LO+J) = Y(LOU+J)
   65 CONTINUE
C
C        BRANCH TO TORQUE TO COMPUTE ALL TIME DEPENDENT FORCES FOR ALL
C        BODIES. GGV ARRAY CONTAINS SUM OF ALL FORCES SEE PAGE II-2 VOL1
C
      DO i = 1, nu
         ggv(i) = 0D0
      END DO
C
      IF (LEQU) THEN
         CALL MWRITE(P,1,NU,' P ',1)
         CALL MWRITE(GGV,1,NU,'GGV_B4',1)
      END IF
      CALL torque(ggv,itflag,iextor,HEAP_MB(igposptr),
     &            HEAP_MB(ipptr))
      IF (LEQU) CALL MWRITE(GGV,1,NU,'GGV_AF',1)
C
C        THE EXPLICIT CALCULATION OF THE CONSTRAINT FORCES IS ELIMINATED
C        AND IS REPLACED BY CALCULATIONS FOR THE ACCELERATIONS OF THE
C        RELATIVE HINGE DEGREES-OF-FREEDOM
C
      IF (NH .EQ. NB) THEN
         CALL BCKWRD (GGV,
     &                LocalHeap(irmttmp_bckwrd),LocalHeap(ikpvtm
     &                ptr_bckwrd),LocalHeap(itempptr_bckwrd),
     $                LocalHeap(itemp2ptr_bckwrd),
     $                LocalHeap(izwkptr_bckwrd),
     $                LoopHeap(izetaptr),intLoopHeap(iihthptrptr),
     $                intLoopHeap(iihpvtptr),Loopheap(ipinptr),
     $                intLoopHeap(iiselptr),intLoopHeap(iisdofptr),
     $                intLoopHeap(iitopolptr),intLoopHeap(iibh_ptrptr))
         IF(LEQU) CALL MWRITE(GGV,1,NU,'GGV_BK',1)
C
C           NOW CALL FRWRD2 TO FINISH DEVELOPMENT OF THE YDT ARRAY.
C           ABSOLUTE ACCELERATION VECTORS ASSOCIATED WITH EACH BODY
C           ARE COMPUTED RECURSIVELY AND STORED IN THE LOCATIONS
C           EARMARKED BY LOCU(1,...,NB).
C           THE ACCELERATION OF EACH UNCONSTRAINED HINGE DEGREE OF
C           FREEDOM IS STORED IN THE LOCATIONS EARMARKED BY THE INTEGER
C           LOCATOR ARRAYS LOCU, ISDOF, AND IBETDT
C
         CALL FRWRD2 (GGV,HEAP_MB(ipsiptr),HEAP_MB(iydtptr),
     &                intLocalHeap(ikpvtptr_frwrd2),
     &                LocalHeap(itempptr_frwrd2),
     &                LocalHeap(itemp1ptr_frwrd2),
     &                LocalHeap(izwkptr_frwrd2),
     &                LoopHeap(irinvptr),LoopHeap(izetaptr),
     &                intLoopHeap(iihthptrptr),
     &                intLoopHeap(iivptr),intLoopHeap(iihpvtptr),
     &                intLoopHeap(iiselptr),intLoopHeap(iisdofptr),
     &                intLoopHeap(iibetdtptr),intLoopHeap(iitopolptr),
     &                Loopheap(ialamptr),intLoopheap(iibh_ptrptr))
      ELSE
         CALL CLBCK2 (GGV,HEAP_MB(isuptr),HEAP_MB(isbtptr),
     &                HEAP_MB(ibrnptr),LocalHeap(ibhinbptr_clbck2),
     &                LocalHeap(ibhoutptr_clbck2),
     &                intLocalHeap(ikpvtmptr_clbck2),
     &                LocalHeap(irmttmpptr_clbck2),
     &                LoopHeap(izetaptr),intLoopheap(iiselptr),
     &                intLoopHeap(iisdofptr),intLoopHeap(
     &                iitopolptr))
         IF (NCTCON .GT. 0) CALL CLFR2B(HEAP_MB(iyptr),
     &                                  HEAP_MB(ibtildeptr),
     &                                  HEAP_MB(isuptr),
     &                                  HEAP_MB(ibrnptr),
     &                                  LocalHeap(ibhinbptr_clfr2b),
     &                                  LocalHeap(itempptr_clfr2b),
     &                                  LocalHeap(itemp1ptr_clfr2b),
     &                                  LocalHeap(ibdtqptr_clfr2b),
     &                                  LocalHeap(ibdtpptr_clfr2b),
     &                                  LocalHeap(iustarptr_clfr2b),
     &                                  logicLoopHeap(iihpathptr),
     &                                  intLoopHeap(iihthptrptr),
     &                                  intLoopHeap(iivptr),
     &                                  intLoopHeap(iiselptr),
     &                                  intLoopHeap(iisdofptr),
     &                                  intloopheap(iitopolptr),
     &                                  intloopheap(iihdataptr),
     &                                  Loopheap(ialamptr),
     &                                  intLoopHeap(iibh_ptrptr),
     &                                  intLoopHeap(iihcutjptr),
     &                                  LoopHeap(irlamdaptr),
     &                                  LoopHeap(iaclmatptr),
     &                                  intLoopHeap(iiclpvtptr),
     &                                  LocalHeap(izetacptr_clfr2b))
         CALL CLFOR3 (GGV,HEAP_MB(ipsiptr),HEAP_MB(iydtptr),
     &                intHEAP_MB(ikmbpvtptr),HEAP_MB(ibtildeptr),
     &                intLocalHeap(ikpvtptr_clfor3),
     &                LocalHeap(itempptr_clfor3),
     &                LocalHeap(itemp1ptr_clfor3),
     &                LoopHeap(irinvptr),LoopHeap(izetaptr),
     &                intLoopHeap(iihthptrptr),
     &                intLoopHeap(iivptr),intLoopHeap(iihpvtptr),
     &                LoopHeap(ipinptr),intLoopheap(iiselptr),
     &                intLoopHeap(iisdofptr),intLoopheap(iibetdtptr),
     &                intLoopHeap(iitopolptr),Loopheap(ialamptr),
     &                intLoopHeap(iibh_ptrptr),
     &                intLoopHeap(iihcutjptr),
     &                Loopheap(irlamdaptr))
      END IF
C
      IF(LEQU) THEN
        WRITE (MBOUT,1003)
 1003   FORMAT (' THE YDT ARRAY IS ')
        CALL WRITES (YDT,1,NEQ,1)
      ENDIF
c
c     PACK THE YDT VECTOR INTO THE ZDT VECTOR
c
      IF (verlet) THEN
         I = 0
         DO L = 1, NB
            LO = LOCU(L) + 5
            DO IFX = 1, IRGFLX(L)
               I = I + 1
               z3(i) = ydt(lo+ifx)
            END DO
         END DO
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
cblink   Test the following two sections of code
c     Remember to skip the cut joints.  Not properly done yet.
c
c     The following block will need to be modified before
c     running cases with rheonomic constraints.
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c         lva = locu(2*nb+2) - 1   !  Copy the alpha dots
c         lvb = locu(2*nb+3) - 1   !  Copy the beta dots
c         DO l = 1, nh
c            IF (l.GT.nbdy) THEN !l is a particle
c               idof1 = 5
c            ELSE
c               idof1 = 2
c            END IF
c            DO ip1 = idof1, 7
c               IF (ihdata(ip1,l) .EQ. 0) THEN
c                  i   = i + 1
c                  lvb = lvb + 1
c                  z3(i) = ydt(lvb)
c               ELSE IF (ihdata(ip1,l) .EQ. 2) THEN
c                  i   = i + 1
c                  lva = lva + 1
c                  z3(i) = ydt(lva)
c               END IF
c            END DO
c         END DO
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     This section is capable of handling cut-
c     joints but NOT rheonomic constraints.
c
         lo = locu(2*nb+3)
         DO l = lo, lo+nbeta-1
            i = i + 1
            z3(i) = ydt(l)
         END DO
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      ELSE    !  For Runge-Kutta
         I = 0
         DO L = 1, NB
            LO = LOCU(L) + 5
            DO IFX = 1, IRGFLX(L)
               I = I + 1
               z2(I) = YDT(LO+IFX)
            END DO
         END DO
         DO L = LOCU(NB+1), NEQ
            I = I + 1
            z2(I) = YDT(L)
         END DO
      END IF
C
C     If Euler sequence has changed the Z vector must be re-packed.
C     ONLY if seqflg is true and iter=0 (at start of md step), 
C     OR if there are closed loops with constraints (redundant DOFs).
C
      IF (i1st .EQ. 0) THEN
         i1st = 1
      ELSE IF (verlet) THEN
         IF (itflag.EQ.itmax+1 .AND. seqflg) THEN
c
c     Copy the modal coordinates and beta's
c
            neqz = 0
            DO l = locu(nb+1), locu(2*nb+2)-1
               neqz = neqz + 1
               z1(neqz) = y(l)
            END DO
         END IF
C
C     COPY THE VELOCITIES
C
         IF ((itflag.EQ.itmax+1 .AND. seqflg) .OR. (nctcon .GT. 0)) THEN
            I = 0
            DO L = 1, NB
               LO = LOCU(L) + 5
               DO IFX = 1, IRGFLX(L)
                  I = I + 1
                  z2(i) = Y(LO+IFX)
               END DO
            END DO
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
cblink   Test the following two sections of code
c     Remember to skip the cut joints.  Not properly done yet.
c
c     The following block will need to be modified before
c     running cases with rheonomic constraints.
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c            lva = locu(2*nb+2) - 1 !  Copy the alpha dots
c            lvb = locu(2*nb+3) - 1 !  Copy the beta dots
c            DO l = 1, nh
c               IF (l.GT.nbdy) THEN
c                  idof1 = 5
c               ELSE
c                  idof1 = 2
c               END IF
c               DO ip1 = idof1, 7
c                  IF (ihdata(ip1,l) .EQ. 0) THEN
c                     i   = i + 1
c                     lvb = lvb + 1
c                     z2(i) = y(lvb)
c                  ELSE IF (ihdata(ip1,l) .EQ. 2) THEN
c                     i   = i + 1
c                     lva = lva + 1
c                     z2(i) = y(lva)
c                  END IF
c               END DO
c            END DO
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     This section is capable of handling cut-
c     joints but NOT rheonomic constraints.
c
         lo = locu(2*nb+3)
         DO l = lo, lo+nbeta-1
            i = i + 1
            z2(i) = y(l)
         END DO
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
         END IF
      ELSE IF (.NOT. verlet .and. SEQFLG) THEN !  For RK
         i = 0
         do l = 1, nb
            lo = locu(l) + 5
            do ifx = 1, irgflx(l)
               i = i + 1
               z1(i) = y(lo+ifx)
            end do
         end do
         do l = locu(nb+1), neq
            i = i + 1
            z1(i) = y(l)
         end do
      END IF
c
      jil = 1
c
      RETURN
      END

